DROP TABLE IF EXISTS `xx_avatar`;
CREATE TABLE `xx_avatar` (
  `avatar_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `avatar_file` varchar(30) NOT NULL DEFAULT '',
  `avatar_name` varchar(100) NOT NULL DEFAULT '',
  `avatar_mimetype` varchar(30) NOT NULL DEFAULT '',
  `avatar_created` int(10) NOT NULL DEFAULT '0',
  `avatar_display` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `avatar_weight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `avatar_type` char(1) NOT NULL DEFAULT '',
  PRIMARY KEY (`avatar_id`),
  KEY `avatar_type` (`avatar_type`,`avatar_display`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_avatar_user_link`;
CREATE TABLE `xx_avatar_user_link` (
  `avatar_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  KEY `avatar_user_id` (`avatar_id`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_banner`;
CREATE TABLE `xx_banner` (
  `bid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `cid` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `imptotal` int(10) unsigned NOT NULL DEFAULT '0',
  `impmade` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `clicks` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `imageurl` varchar(255) NOT NULL DEFAULT '',
  `clickurl` varchar(255) NOT NULL DEFAULT '',
  `date` int(10) NOT NULL DEFAULT '0',
  `htmlbanner` tinyint(1) NOT NULL DEFAULT '0',
  `htmlcode` text,
  PRIMARY KEY (`bid`),
  KEY `idxbannercid` (`cid`),
  KEY `idxbannerbidcid` (`bid`,`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_banner` (`bid`, `cid`, `imptotal`, `impmade`, `clicks`, `imageurl`, `clickurl`, `date`, `htmlbanner`, `htmlcode`) VALUES
(1,	1,	0,	190,	0,	'http://localhost/images/banners/xoops_flashbanner2.swf',	'http://www.xoops.org/',	1008813250,	0,	''),
(2,	1,	0,	189,	0,	'http://localhost/images/banners/xoops_banner_2.gif',	'http://www.xoops.org/',	1008813250,	0,	''),
(3,	1,	0,	196,	0,	'http://localhost/images/banners/banner.swf',	'http://www.xoops.org/',	1008813250,	0,	'');

DROP TABLE IF EXISTS `xx_bannerclient`;
CREATE TABLE `xx_bannerclient` (
  `cid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL DEFAULT '',
  `contact` varchar(60) NOT NULL DEFAULT '',
  `email` varchar(60) NOT NULL DEFAULT '',
  `login` varchar(10) NOT NULL DEFAULT '',
  `passwd` varchar(10) NOT NULL DEFAULT '',
  `extrainfo` text,
  PRIMARY KEY (`cid`),
  KEY `login` (`login`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_bannerclient` (`cid`, `name`, `contact`, `email`, `login`, `passwd`, `extrainfo`) VALUES
(1,	'XOOPS',	'XOOPS Dev Team',	'webmaster@xoops.org',	'',	'',	'');

DROP TABLE IF EXISTS `xx_bannerfinish`;
CREATE TABLE `xx_bannerfinish` (
  `bid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `cid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `impressions` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `clicks` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `datestart` int(10) unsigned NOT NULL DEFAULT '0',
  `dateend` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`bid`),
  KEY `cid` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_block_module_link`;
CREATE TABLE `xx_block_module_link` (
  `block_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `module_id` smallint(5) NOT NULL DEFAULT '0',
  PRIMARY KEY (`module_id`,`block_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_block_module_link` (`block_id`, `module_id`) VALUES
(13,	-1),
(15,	-1),
(16,	-1),
(17,	-1),
(18,	-1),
(20,	-1),
(54,	-1),
(55,	-1),
(56,	-1),
(58,	-1),
(60,	-1),
(1,	0),
(2,	0),
(3,	0),
(4,	0),
(5,	0),
(6,	0),
(7,	0),
(8,	0),
(9,	0),
(10,	0),
(11,	0),
(12,	0),
(14,	0),
(19,	0),
(57,	0),
(61,	0);

DROP TABLE IF EXISTS `xx_cache_model`;
CREATE TABLE `xx_cache_model` (
  `cache_key` varchar(64) NOT NULL DEFAULT '',
  `cache_expires` int(10) unsigned NOT NULL DEFAULT '0',
  `cache_data` text,
  PRIMARY KEY (`cache_key`),
  KEY `cache_expires` (`cache_expires`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_config`;
CREATE TABLE `xx_config` (
  `conf_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `conf_modid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `conf_catid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `conf_name` varchar(25) NOT NULL DEFAULT '',
  `conf_title` varchar(255) NOT NULL DEFAULT '',
  `conf_value` text,
  `conf_desc` varchar(255) NOT NULL DEFAULT '',
  `conf_formtype` varchar(15) NOT NULL DEFAULT '',
  `conf_valuetype` varchar(10) NOT NULL DEFAULT '',
  `conf_order` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`conf_id`),
  KEY `conf_mod_cat_id` (`conf_modid`,`conf_catid`),
  KEY `conf_order` (`conf_order`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_config` (`conf_id`, `conf_modid`, `conf_catid`, `conf_name`, `conf_title`, `conf_value`, `conf_desc`, `conf_formtype`, `conf_valuetype`, `conf_order`) VALUES
(1,	0,	1,	'sitename',	'_MD_AM_SITENAME',	'XOOPS網站輕鬆架',	'_MD_AM_SITENAMEDSC',	'textbox',	'text',	0),
(2,	0,	1,	'slogan',	'_MD_AM_SLOGAN',	'歡迎光臨',	'_MD_AM_SLOGANDSC',	'textbox',	'text',	2),
(3,	0,	1,	'language',	'_MD_AM_LANGUAGE',	'tchinese_utf8',	'_MD_AM_LANGUAGEDSC',	'language',	'other',	4),
(4,	0,	1,	'startpage',	'_MD_AM_STARTPAGE',	'--',	'_MD_AM_STARTPAGEDSC',	'startpage',	'other',	6),
(5,	0,	1,	'server_TZ',	'_MD_AM_SERVERTZ',	'8',	'_MD_AM_SERVERTZDSC',	'timezone',	'float',	8),
(6,	0,	1,	'default_TZ',	'_MD_AM_DEFAULTTZ',	'8',	'_MD_AM_DEFAULTTZDSC',	'timezone',	'float',	10),
(7,	0,	1,	'theme_set',	'_MD_AM_DTHEME',	'school2015',	'_MD_AM_DTHEMEDSC',	'theme',	'other',	12),
(8,	0,	1,	'anonymous',	'_MD_AM_ANONNAME',	'訪客',	'_MD_AM_ANONNAMEDSC',	'textbox',	'text',	15),
(9,	0,	1,	'gzip_compression',	'_MD_AM_USEGZIP',	'0',	'_MD_AM_USEGZIPDSC',	'yesno',	'int',	16),
(10,	0,	1,	'usercookie',	'_MD_AM_USERCOOKIE',	'xoops_user',	'_MD_AM_USERCOOKIEDSC',	'textbox',	'text',	18),
(11,	0,	1,	'session_expire',	'_MD_AM_SESSEXPIRE',	'15',	'_MD_AM_SESSEXPIREDSC',	'textbox',	'int',	22),
(12,	0,	1,	'banners',	'_MD_AM_BANNERS',	'1',	'_MD_AM_BANNERSDSC',	'yesno',	'int',	26),
(13,	0,	1,	'debug_mode',	'_MD_AM_DEBUGMODE',	'0',	'_MD_AM_DEBUGMODEDSC',	'select',	'int',	24),
(14,	0,	1,	'my_ip',	'_MD_AM_MYIP',	'127.0.0.1',	'_MD_AM_MYIPDSC',	'textbox',	'text',	29),
(15,	0,	1,	'use_ssl',	'_MD_AM_USESSL',	'0',	'_MD_AM_USESSLDSC',	'yesno',	'int',	30),
(16,	0,	1,	'session_name',	'_MD_AM_SESSNAME',	'xoops_session',	'_MD_AM_SESSNAMEDSC',	'textbox',	'text',	20),
(17,	0,	2,	'minpass',	'_MD_AM_MINPASS',	'5',	'_MD_AM_MINPASSDSC',	'textbox',	'int',	1),
(18,	0,	2,	'minuname',	'_MD_AM_MINUNAME',	'3',	'_MD_AM_MINUNAMEDSC',	'textbox',	'int',	2),
(19,	0,	2,	'new_user_notify',	'_MD_AM_NEWUNOTIFY',	'1',	'_MD_AM_NEWUNOTIFYDSC',	'yesno',	'int',	4),
(20,	0,	2,	'new_user_notify_group',	'_MD_AM_NOTIFYTO',	'1',	'_MD_AM_NOTIFYTODSC',	'group',	'int',	6),
(21,	0,	2,	'activation_type',	'_MD_AM_ACTVTYPE',	'0',	'_MD_AM_ACTVTYPEDSC',	'select',	'int',	8),
(22,	0,	2,	'activation_group',	'_MD_AM_ACTVGROUP',	'1',	'_MD_AM_ACTVGROUPDSC',	'group',	'int',	10),
(23,	0,	2,	'uname_test_level',	'_MD_AM_UNAMELVL',	'0',	'_MD_AM_UNAMELVLDSC',	'select',	'int',	12),
(24,	0,	2,	'avatar_allow_upload',	'_MD_AM_AVATARALLOW',	'0',	'_MD_AM_AVATARALWDSC',	'yesno',	'int',	14),
(27,	0,	2,	'avatar_width',	'_MD_AM_AVATARW',	'120',	'_MD_AM_AVATARWDSC',	'textbox',	'int',	16),
(28,	0,	2,	'avatar_height',	'_MD_AM_AVATARH',	'120',	'_MD_AM_AVATARHDSC',	'textbox',	'int',	18),
(29,	0,	2,	'avatar_maxsize',	'_MD_AM_AVATARMAX',	'35000',	'_MD_AM_AVATARMAXDSC',	'textbox',	'int',	20),
(30,	0,	1,	'adminmail',	'_MD_AM_ADMINML',	'tad0616@gmail.com',	'_MD_AM_ADMINMLDSC',	'textbox',	'text',	3),
(31,	0,	2,	'self_delete',	'_MD_AM_SELFDELETE',	'0',	'_MD_AM_SELFDELETEDSC',	'yesno',	'int',	22),
(32,	0,	1,	'com_mode',	'_MD_AM_COMMODE',	'flat',	'_MD_AM_COMMODEDSC',	'select',	'text',	34),
(33,	0,	1,	'com_order',	'_MD_AM_COMORDER',	'0',	'_MD_AM_COMORDERDSC',	'select',	'int',	36),
(34,	0,	2,	'bad_unames',	'_MD_AM_BADUNAMES',	'a:3:{i:0;s:9:\"webmaster\";i:1;s:6:\"^xoops\";i:2;s:6:\"^admin\";}',	'_MD_AM_BADUNAMESDSC',	'textarea',	'array',	24),
(35,	0,	2,	'bad_emails',	'_MD_AM_BADEMAILS',	'a:1:{i:0;s:10:\"xoops.org$\";}',	'_MD_AM_BADEMAILSDSC',	'textarea',	'array',	26),
(36,	0,	2,	'maxuname',	'_MD_AM_MAXUNAME',	'10',	'_MD_AM_MAXUNAMEDSC',	'textbox',	'int',	3),
(37,	0,	1,	'bad_ips',	'_MD_AM_BADIPS',	'a:1:{i:0;s:9:\"127.0.0.1\";}',	'_MD_AM_BADIPSDSC',	'textarea',	'array',	42),
(38,	0,	3,	'meta_keywords',	'_MD_AM_METAKEY',	'xoops , 教育 , 快速',	'_MD_AM_METAKEYDSC',	'textarea',	'text',	0),
(39,	0,	3,	'footer',	'_MD_AM_FOOTER',	'<a href=\"modules/system/admin.php?fct=preferences&op=show&confcat_id=3\">請點此或右邊的設定符號，以編輯此處的頁尾資訊。<br>\r\n您可以在此輸入學校電話、地址、傳真電話、管理員Email等資訊</a>。\r\n<div style=\"font-size:12px;color:#CC9900;margin:10px auto;\" target=\"_blank\">本系統使用<a href=\"http://campus-xoops.tn.edu.tw\">XOOPS校園網站輕鬆架</a></div>',	'_MD_AM_FOOTERDSC',	'textarea',	'text',	20),
(40,	0,	4,	'censor_enable',	'_MD_AM_DOCENSOR',	'0',	'_MD_AM_DOCENSORDSC',	'yesno',	'int',	0),
(41,	0,	4,	'censor_words',	'_MD_AM_CENSORWRD',	'a:2:{i:0;s:4:\"fuck\";i:1;s:4:\"shit\";}',	'_MD_AM_CENSORWRDDSC',	'textarea',	'array',	1),
(42,	0,	4,	'censor_replace',	'_MD_AM_CENSORRPLC',	'#OOPS#',	'_MD_AM_CENSORRPLCDSC',	'textbox',	'text',	2),
(43,	0,	3,	'meta_robots',	'_MD_AM_METAROBOTS',	'index,follow',	'_MD_AM_METAROBOTSDSC',	'select',	'text',	2),
(44,	0,	5,	'enable_search',	'_MD_AM_DOSEARCH',	'1',	'_MD_AM_DOSEARCHDSC',	'yesno',	'int',	0),
(45,	0,	5,	'keyword_min',	'_MD_AM_MINSEARCH',	'2',	'_MD_AM_MINSEARCHDSC',	'textbox',	'int',	1),
(46,	0,	2,	'avatar_minposts',	'_MD_AM_AVATARMP',	'0',	'_MD_AM_AVATARMPDSC',	'textbox',	'int',	15),
(47,	0,	1,	'enable_badips',	'_MD_AM_DOBADIPS',	'0',	'_MD_AM_DOBADIPSDSC',	'yesno',	'int',	40),
(48,	0,	3,	'meta_rating',	'_MD_AM_METARATING',	'general',	'_MD_AM_METARATINGDSC',	'select',	'text',	4),
(49,	0,	3,	'meta_author',	'_MD_AM_METAAUTHOR',	'XOOPS',	'_MD_AM_METAAUTHORDSC',	'textbox',	'text',	6),
(50,	0,	3,	'meta_copyright',	'_MD_AM_METACOPYR',	'Copyright @ 2001-2012',	'_MD_AM_METACOPYRDSC',	'textbox',	'text',	8),
(51,	0,	3,	'meta_description',	'_MD_AM_METADESC',	'XOOPS校園網站輕鬆架（http://campus-xoops.tn.edu.tw）',	'_MD_AM_METADESCDSC',	'textarea',	'text',	1),
(52,	0,	2,	'allow_chgmail',	'_MD_AM_ALLWCHGMAIL',	'0',	'_MD_AM_ALLWCHGMAILDSC',	'yesno',	'int',	3),
(53,	0,	1,	'use_mysession',	'_MD_AM_USEMYSESS',	'0',	'_MD_AM_USEMYSESSDSC',	'yesno',	'int',	19),
(54,	0,	2,	'reg_dispdsclmr',	'_MD_AM_DSPDSCLMR',	'1',	'_MD_AM_DSPDSCLMRDSC',	'yesno',	'int',	30),
(55,	0,	2,	'reg_disclaimer',	'_MD_AM_REGDSCLMR',	'請仔細閱讀並遵守下列註冊條款：\r\n\r\n1、註冊會員必須遵守中華民國的各項法律法規。\r\n2、不得發佈任何有關色情、違法、以及危害國家安全的言論。\r\n3、嚴禁連接有關政治、色情、宗教迷信等違法訊息。\r\n4、承擔一切因您的行為而直接或間接導致的民事或刑事法律責任。\r\n5、互相尊重、遵守網際網路道德，嚴禁互相惡意攻擊、漫罵。\r\n6、管理員及版主有權保留或刪除討論區中的任意內容。\r\n7、本站網管擁有一切管理權力。\r\n\r\n系統將會把部分訊息以 cookies 方式儲存在您的電腦中（不包含您的密碼及個人訊息）；此外您的電子只是用來作為確認註冊身份及傳送密碼使用，將不會作為商業用途。',	'_MD_AM_REGDSCLMRDSC',	'textarea',	'text',	32),
(56,	0,	2,	'allow_register',	'_MD_AM_ALLOWREG',	'1',	'_MD_AM_ALLOWREGDSC',	'yesno',	'int',	0),
(57,	0,	1,	'theme_fromfile',	'_MD_AM_THEMEFILE',	'1',	'_MD_AM_THEMEFILEDSC',	'yesno',	'int',	13),
(58,	0,	1,	'closesite',	'_MD_AM_CLOSESITE',	'0',	'_MD_AM_CLOSESITEDSC',	'yesno',	'int',	26),
(59,	0,	1,	'closesite_okgrp',	'_MD_AM_CLOSESITEOK',	'a:1:{i:0;s:1:\"1\";}',	'_MD_AM_CLOSESITEOKDSC',	'group_multi',	'array',	27),
(60,	0,	1,	'closesite_text',	'_MD_AM_CLOSESITETXT',	'系統維護中，請稍後造訪。',	'_MD_AM_CLOSESITETXTDSC',	'textarea',	'text',	28),
(61,	0,	1,	'sslpost_name',	'_MD_AM_SSLPOST',	'xoops_ssl',	'_MD_AM_SSLPOSTDSC',	'textbox',	'text',	31),
(62,	0,	1,	'module_cache',	'_MD_AM_MODCACHE',	'a:2:{i:4;s:1:\"0\";i:5;s:1:\"0\";}',	'_MD_AM_MODCACHEDSC',	'module_cache',	'array',	50),
(63,	0,	1,	'template_set',	'_MD_AM_DTPLSET',	'default',	'_MD_AM_DTPLSETDSC',	'tplset',	'other',	14),
(64,	0,	6,	'mailmethod',	'_MD_AM_MAILERMETHOD',	'mail',	'_MD_AM_MAILERMETHODDESC',	'select',	'text',	4),
(65,	0,	6,	'smtphost',	'_MD_AM_SMTPHOST',	'a:1:{i:0;s:0:\"\";}',	'_MD_AM_SMTPHOSTDESC',	'textarea',	'array',	6),
(66,	0,	6,	'smtpuser',	'_MD_AM_SMTPUSER',	'',	'_MD_AM_SMTPUSERDESC',	'textbox',	'text',	7),
(67,	0,	6,	'smtppass',	'_MD_AM_SMTPPASS',	'',	'_MD_AM_SMTPPASSDESC',	'password',	'text',	8),
(68,	0,	6,	'sendmailpath',	'_MD_AM_SENDMAILPATH',	'/usr/sbin/sendmail',	'_MD_AM_SENDMAILPATHDESC',	'textbox',	'text',	5),
(69,	0,	6,	'from',	'_MD_AM_MAILFROM',	'',	'_MD_AM_MAILFROMDESC',	'textbox',	'text',	1),
(70,	0,	6,	'fromname',	'_MD_AM_MAILFROMNAME',	'',	'_MD_AM_MAILFROMNAMEDESC',	'textbox',	'text',	2),
(71,	0,	1,	'sslloginlink',	'_MD_AM_SSLLINK',	'https://',	'_MD_AM_SSLLINKDSC',	'textbox',	'text',	33),
(72,	0,	1,	'theme_set_allowed',	'_MD_AM_THEMEOK',	'a:1:{i:0;s:10:\"school2015\";}',	'_MD_AM_THEMEOKDSC',	'theme_multi',	'array',	13),
(73,	0,	6,	'fromuid',	'_MD_AM_MAILFROMUID',	'1',	'_MD_AM_MAILFROMUIDDESC',	'user',	'int',	3),
(74,	0,	7,	'auth_method',	'_MD_AM_AUTHMETHOD',	'xoops',	'_MD_AM_AUTHMETHODDESC',	'select',	'text',	1),
(75,	0,	7,	'ldap_port',	'_MD_AM_LDAP_PORT',	'389',	'_MD_AM_LDAP_PORT',	'textbox',	'int',	2),
(76,	0,	7,	'ldap_server',	'_MD_AM_LDAP_SERVER',	'your directory server',	'_MD_AM_LDAP_SERVER_DESC',	'textbox',	'text',	3),
(77,	0,	7,	'ldap_base_dn',	'_MD_AM_LDAP_BASE_DN',	'dc=xoops,dc=org',	'_MD_AM_LDAP_BASE_DN_DESC',	'textbox',	'text',	4),
(78,	0,	7,	'ldap_manager_dn',	'_MD_AM_LDAP_MANAGER_DN',	'manager_dn',	'_MD_AM_LDAP_MANAGER_DN_DESC',	'textbox',	'text',	5),
(79,	0,	7,	'ldap_manager_pass',	'_MD_AM_LDAP_MANAGER_PASS',	'manager_pass',	'_MD_AM_LDAP_MANAGER_PASS_DESC',	'password',	'text',	6),
(80,	0,	7,	'ldap_version',	'_MD_AM_LDAP_VERSION',	'3',	'_MD_AM_LDAP_VERSION_DESC',	'textbox',	'text',	7),
(81,	0,	7,	'ldap_users_bypass',	'_MD_AM_LDAP_USERS_BYPASS',	'a:1:{i:0;s:5:\"admin\";}',	'_MD_AM_LDAP_USERS_BYPASS_DESC',	'textarea',	'array',	8),
(82,	0,	7,	'ldap_loginname_asdn',	'_MD_AM_LDAP_LOGINNAME_ASDN',	'uid_asdn',	'_MD_AM_LDAP_LOGINNAME_ASDN_D',	'yesno',	'int',	9),
(83,	0,	7,	'ldap_loginldap_attr',	'_MD_AM_LDAP_LOGINLDAP_ATTR',	'uid',	'_MD_AM_LDAP_LOGINLDAP_ATTR_D',	'textbox',	'text',	10),
(84,	0,	7,	'ldap_filter_person',	'_MD_AM_LDAP_FILTER_PERSON',	'',	'_MD_AM_LDAP_FILTER_PERSON_DESC',	'textbox',	'text',	11),
(85,	0,	7,	'ldap_domain_name',	'_MD_AM_LDAP_DOMAIN_NAME',	'mydomain',	'_MD_AM_LDAP_DOMAIN_NAME_DESC',	'textbox',	'text',	12),
(86,	0,	7,	'ldap_provisionning',	'_MD_AM_LDAP_PROVIS',	'0',	'_MD_AM_LDAP_PROVIS_DESC',	'yesno',	'int',	13),
(87,	0,	7,	'ldap_provisionning_group',	'_MD_AM_LDAP_PROVIS_GROUP',	'a:1:{i:0;s:1:\"2\";}',	'_MD_AM_LDAP_PROVIS_GROUP_DSC',	'group_multi',	'array',	14),
(88,	0,	7,	'ldap_mail_attr',	'_MD_AM_LDAP_MAIL_ATTR',	'mail',	'_MD_AM_LDAP_MAIL_ATTR_DESC',	'textbox',	'text',	15),
(89,	0,	7,	'ldap_givenname_attr',	'_MD_AM_LDAP_GIVENNAME_ATTR',	'givenname',	'_MD_AM_LDAP_GIVENNAME_ATTR_DSC',	'textbox',	'text',	16),
(90,	0,	7,	'ldap_surname_attr',	'_MD_AM_LDAP_SURNAME_ATTR',	'sn',	'_MD_AM_LDAP_SURNAME_ATTR_DESC',	'textbox',	'text',	17),
(91,	0,	7,	'ldap_field_mapping',	'_MD_AM_LDAP_FIELD_MAPPING_ATTR',	'email=mail|name=displayname',	'_MD_AM_LDAP_FIELD_MAPPING_DESC',	'textarea',	'text',	18),
(92,	0,	7,	'ldap_provisionning_upd',	'_MD_AM_LDAP_PROVIS_UPD',	'1',	'_MD_AM_LDAP_PROVIS_UPD_DESC',	'yesno',	'int',	19),
(93,	0,	7,	'ldap_use_TLS',	'_MD_AM_LDAP_USETLS',	'0',	'_MD_AM_LDAP_USETLS_DESC',	'yesno',	'int',	20),
(94,	0,	1,	'cpanel',	'_MD_AM_CPANEL',	'default',	'_MD_AM_CPANELDSC',	'cpanel',	'other',	11),
(95,	0,	2,	'welcome_type',	'_MD_AM_WELCOMETYPE',	'1',	'_MD_AM_WELCOMETYPE_DESC',	'select',	'int',	3),
(268,	1,	0,	'users_pager',	'_MI_SYSTEM_PREFERENCE_USERS_PAGER',	'20',	'',	'textbox',	'int',	29),
(267,	1,	0,	'userranks_pager',	'_MI_SYSTEM_PREFERENCE_USERRANKS_PAGER',	'20',	'',	'textbox',	'int',	28),
(266,	1,	0,	'smilies_pager',	'_MI_SYSTEM_PREFERENCE_SMILIES_PAGER',	'20',	'',	'textbox',	'int',	27),
(265,	1,	0,	'images_pager',	'_MI_SYSTEM_PREFERENCE_IMAGES_PAGER',	'15',	'',	'textbox',	'int',	26),
(264,	1,	0,	'groups_pager',	'_MI_SYSTEM_PREFERENCE_GROUPS_PAGER',	'15',	'',	'textbox',	'int',	25),
(263,	1,	0,	'comments_pager',	'_MI_SYSTEM_PREFERENCE_COMMENTS_PAGER',	'20',	'',	'textbox',	'int',	24),
(262,	1,	0,	'banners_pager',	'_MI_SYSTEM_PREFERENCE_BANNERS_PAGER',	'10',	'',	'textbox',	'int',	23),
(261,	1,	0,	'avatars_pager',	'_MI_SYSTEM_PREFERENCE_AVATARS_PAGER',	'10',	'',	'textbox',	'int',	22),
(260,	1,	0,	'break3',	'_MI_SYSTEM_PREFERENCE_BREAK_PAGER',	'head',	'',	'line_break',	'textbox',	21),
(259,	1,	0,	'active_users',	'_MI_SYSTEM_PREFERENCE_ACTIVE_USERS',	'1',	'',	'yesno',	'int',	20),
(258,	1,	0,	'active_userrank',	'_MI_SYSTEM_PREFERENCE_ACTIVE_USERRANK',	'1',	'',	'yesno',	'int',	19),
(257,	1,	0,	'active_tplsets',	'_MI_SYSTEM_PREFERENCE_ACTIVE_TPLSETS',	'1',	'',	'hidden',	'int',	18),
(256,	1,	0,	'active_smilies',	'_MI_SYSTEM_PREFERENCE_ACTIVE_SMILIES',	'1',	'',	'yesno',	'int',	17),
(255,	1,	0,	'active_preferences',	'_MI_SYSTEM_PREFERENCE_ACTIVE_PREFERENCES',	'1',	'',	'hidden',	'int',	16),
(254,	1,	0,	'active_modulesadmin',	'_MI_SYSTEM_PREFERENCE_ACTIVE_MODULESADMIN',	'1',	'',	'hidden',	'int',	15),
(253,	1,	0,	'active_maintenance',	'_MI_SYSTEM_PREFERENCE_ACTIVE_MAINTENANCE',	'1',	'',	'yesno',	'int',	14),
(252,	1,	0,	'active_mailusers',	'_MI_SYSTEM_PREFERENCE_ACTIVE_MAILUSERS',	'1',	'',	'yesno',	'int',	13),
(251,	1,	0,	'active_images',	'_MI_SYSTEM_PREFERENCE_ACTIVE_IMAGES',	'1',	'',	'yesno',	'int',	12),
(250,	1,	0,	'active_groups',	'_MI_SYSTEM_PREFERENCE_ACTIVE_GROUPS',	'1',	'',	'hidden',	'int',	11),
(249,	1,	0,	'active_filemanager',	'_MI_SYSTEM_PREFERENCE_ACTIVE_FILEMANAGER',	'1',	'',	'hidden',	'int',	10),
(248,	1,	0,	'active_comments',	'_MI_SYSTEM_PREFERENCE_ACTIVE_COMMENTS',	'1',	'',	'yesno',	'int',	9),
(247,	1,	0,	'active_blocksadmin',	'_MI_SYSTEM_PREFERENCE_ACTIVE_BLOCKSADMIN',	'1',	'',	'hidden',	'int',	8),
(246,	1,	0,	'active_banners',	'_MI_SYSTEM_PREFERENCE_ACTIVE_BANNERS',	'1',	'',	'yesno',	'int',	7),
(245,	1,	0,	'active_avatars',	'_MI_SYSTEM_PREFERENCE_ACTIVE_AVATARS',	'1',	'',	'yesno',	'int',	6),
(244,	1,	0,	'break2',	'_MI_SYSTEM_PREFERENCE_BREAK_ACTIVE',	'head',	'',	'line_break',	'textbox',	5),
(243,	1,	0,	'jquery_theme',	'_MI_SYSTEM_PREFERENCE_JQUERY_THEME',	'base',	'',	'select',	'text',	4),
(241,	1,	0,	'typeicons',	'_MI_SYSTEM_PREFERENCE_ICONS',	'default',	'',	'select',	'text',	2),
(242,	1,	0,	'typebreadcrumb',	'_MI_SYSTEM_PREFERENCE_BREADCRUMB',	'default',	'',	'select',	'text',	3),
(239,	1,	0,	'break1',	'_MI_SYSTEM_PREFERENCE_BREAK_GENERAL',	'head',	'',	'line_break',	'textbox',	0),
(240,	1,	0,	'usetips',	'_MI_SYSTEM_PREFERENCE_TIPS',	'1',	'_MI_SYSTEM_PREFERENCE_TIPS_DSC',	'yesno',	'int',	1),
(134,	0,	1,	'redirect_message_ajax',	'_MD_AM_CUSTOM_REDIRECT',	'1',	'_MD_AM_CUSTOM_REDIRECT_DESC',	'yesno',	'int',	12),
(348,	3,	0,	'show_sitename',	'_MI_TADTHEMES_SHOW_SITENAME',	'0',	'_MI_TADTHEMES_SHOW_SITENAME_DESC',	'yesno',	'int',	1),
(346,	5,	0,	'block_id_temp',	'_MI_TADADM_BLOCK_ID_TEMP',	'',	'_MI_TADADM_BLOCK_ID_TEMP_DESC',	'textarea',	'text',	3),
(269,	1,	0,	'break4',	'_MI_SYSTEM_PREFERENCE_BREAK_EDITOR',	'head',	'',	'line_break',	'textbox',	30),
(270,	1,	0,	'blocks_editor',	'_MI_SYSTEM_PREFERENCE_BLOCKS_EDITOR',	'dhtmltextarea',	'_MI_SYSTEM_PREFERENCE_BLOCKS_EDITOR_DSC',	'select',	'text',	31),
(271,	1,	0,	'comments_editor',	'_MI_SYSTEM_PREFERENCE_COMMENTS_EDITOR',	'dhtmltextarea',	'_MI_SYSTEM_PREFERENCE_COMMENTS_EDITOR_DSC',	'select',	'text',	32),
(272,	1,	0,	'general_editor',	'_MI_SYSTEM_PREFERENCE_GENERAL_EDITOR',	'dhtmltextarea',	'_MI_SYSTEM_PREFERENCE_GENERAL_EDITOR_DSC',	'select',	'text',	33),
(273,	1,	0,	'redirect',	'_MI_SYSTEM_PREFERENCE_REDIRECT',	'admin.php?fct=preferences',	'',	'hidden',	'textbox',	34),
(274,	1,	0,	'com_anonpost',	'_MI_SYSTEM_PREFERENCE_ANONPOST',	'0',	'',	'hidden',	'int',	35),
(342,	4,	0,	'syntaxhighlighter_version',	'_MI_TADTOOLS_TITLE7',	'syntaxhighlighter',	'_MI_TADTOOLS_DESC7',	'select',	'text',	3),
(344,	5,	0,	'login',	'_MI_TADADM_LOGIN',	'',	'_MI_TADADM_LOGIN_DESC',	'textbox',	'text',	1),
(345,	5,	0,	'module_id_temp',	'_MI_TADADM_MODULE_ID_TEMP',	'',	'_MI_TADADM_MODULE_ID_TEMP_DESC',	'textarea',	'text',	2),
(343,	5,	0,	'list_amount',	'_MI_TADADM_LIST_AMOUNT',	'10',	'_MI_TADADM_LIST_AMOUNT_DESC',	'textbox',	'int',	0),
(339,	4,	0,	'use_pin',	'_MI_TADTOOLS_TITLE4',	'1',	'_MI_TADTOOLS_DESC4',	'yesno',	'int',	0),
(340,	4,	0,	'auto_charset',	'_MI_TADTOOLS_TITLE5',	'1',	'_MI_TADTOOLS_DESC5',	'yesno',	'int',	1),
(341,	4,	0,	'syntaxhighlighter_themes',	'_MI_TADTOOLS_TITLE6',	'shThemeMonokai',	'_MI_TADTOOLS_DESC6',	'select',	'text',	2),
(347,	3,	0,	'auto_mainmenu',	'_MI_TADTHEMES_AUTO_MENU',	'1',	'_MI_TADTHEMES_AUTO_MENU_DESC',	'yesno',	'int',	0);

DROP TABLE IF EXISTS `xx_configcategory`;
CREATE TABLE `xx_configcategory` (
  `confcat_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `confcat_name` varchar(255) NOT NULL DEFAULT '',
  `confcat_order` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`confcat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_configcategory` (`confcat_id`, `confcat_name`, `confcat_order`) VALUES
(1,	'_MD_AM_GENERAL',	0),
(2,	'_MD_AM_USERSETTINGS',	0),
(3,	'_MD_AM_METAFOOTER',	0),
(4,	'_MD_AM_CENSOR',	0),
(5,	'_MD_AM_SEARCH',	0),
(6,	'_MD_AM_MAILER',	0),
(7,	'_MD_AM_AUTHENTICATION',	0);

DROP TABLE IF EXISTS `xx_configoption`;
CREATE TABLE `xx_configoption` (
  `confop_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `confop_name` varchar(255) NOT NULL DEFAULT '',
  `confop_value` varchar(255) NOT NULL DEFAULT '',
  `conf_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`confop_id`),
  KEY `conf_id` (`conf_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_configoption` (`confop_id`, `confop_name`, `confop_value`, `conf_id`) VALUES
(1,	'_MD_AM_DEBUGMODE1',	'1',	13),
(2,	'_MD_AM_DEBUGMODE2',	'2',	13),
(3,	'_NESTED',	'nest',	32),
(4,	'_FLAT',	'flat',	32),
(5,	'_THREADED',	'thread',	32),
(6,	'_OLDESTFIRST',	'0',	33),
(7,	'_NEWESTFIRST',	'1',	33),
(8,	'_MD_AM_USERACTV',	'0',	21),
(9,	'_MD_AM_AUTOACTV',	'1',	21),
(10,	'_MD_AM_ADMINACTV',	'2',	21),
(11,	'_MD_AM_STRICT',	'0',	23),
(12,	'_MD_AM_MEDIUM',	'1',	23),
(13,	'_MD_AM_LIGHT',	'2',	23),
(14,	'_MD_AM_DEBUGMODE3',	'3',	13),
(15,	'_MD_AM_INDEXFOLLOW',	'index,follow',	43),
(16,	'_MD_AM_NOINDEXFOLLOW',	'noindex,follow',	43),
(17,	'_MD_AM_INDEXNOFOLLOW',	'index,nofollow',	43),
(18,	'_MD_AM_NOINDEXNOFOLLOW',	'noindex,nofollow',	43),
(19,	'_MD_AM_METAOGEN',	'general',	48),
(20,	'_MD_AM_METAO14YRS',	'14 years',	48),
(21,	'_MD_AM_METAOREST',	'restricted',	48),
(22,	'_MD_AM_METAOMAT',	'mature',	48),
(23,	'_MD_AM_DEBUGMODE0',	'0',	13),
(24,	'PHP mail()',	'mail',	64),
(25,	'sendmail',	'sendmail',	64),
(26,	'SMTP',	'smtp',	64),
(27,	'SMTPAuth',	'smtpauth',	64),
(28,	'_MD_AM_AUTH_CONFOPTION_XOOPS',	'xoops',	74),
(29,	'_MD_AM_AUTH_CONFOPTION_LDAP',	'ldap',	74),
(30,	'_MD_AM_AUTH_CONFOPTION_AD',	'ads',	74),
(31,	'_NO',	'0',	95),
(32,	'_MD_AM_WELCOMETYPE_EMAIL',	'1',	95),
(33,	'_MD_AM_WELCOMETYPE_PM',	'2',	95),
(34,	'_MD_AM_WELCOMETYPE_BOTH',	'3',	95),
(122,	'south-street',	'south-street',	243),
(121,	'smoothness',	'smoothness',	243),
(120,	'redmond',	'redmond',	243),
(119,	'cupertino',	'cupertino',	243),
(118,	'base',	'base',	243),
(117,	'default',	'default',	242),
(116,	'default',	'default',	241),
(128,	'dhtmltextarea',	'dhtmltextarea',	271),
(127,	'tinymce',	'tinymce',	270),
(126,	'textarea',	'textarea',	270),
(125,	'dhtmltextarea',	'dhtmltextarea',	270),
(124,	'ui-lightness',	'ui-lightness',	243),
(123,	'ui-darkness',	'ui-darkness',	243),
(129,	'textarea',	'textarea',	271),
(130,	'tinymce',	'tinymce',	271),
(131,	'dhtmltextarea',	'dhtmltextarea',	272),
(132,	'textarea',	'textarea',	272),
(133,	'tinymce',	'tinymce',	272),
(239,	'shThemeDefault',	'shThemeDefault',	341),
(240,	'shThemeDjango',	'shThemeDjango',	341),
(241,	'shThemeEclipse',	'shThemeEclipse',	341),
(242,	'shThemeEmacs',	'shThemeEmacs',	341),
(243,	'shThemeFadeToGrey',	'shThemeFadeToGrey',	341),
(244,	'shThemeMDUltra',	'shThemeMDUltra',	341),
(245,	'shThemeMidnight',	'shThemeMidnight',	341),
(246,	'shThemeRDark',	'shThemeRDark',	341),
(247,	'shThemeMonokai',	'shThemeMonokai',	341),
(248,	'syntaxhighlighter 2',	'syntaxhighlighter_2',	342),
(249,	'syntaxhighlighter 3',	'syntaxhighlighter',	342);

DROP TABLE IF EXISTS `xx_groups`;
CREATE TABLE `xx_groups` (
  `groupid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `description` text,
  `group_type` varchar(10) NOT NULL DEFAULT '',
  PRIMARY KEY (`groupid`),
  KEY `group_type` (`group_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_groups` (`groupid`, `name`, `description`, `group_type`) VALUES
(1,	'管理員',	'管理員群組',	'Admin'),
(2,	'註冊會員',	'註冊會員群組',	'User'),
(3,	'訪客',	'訪客群組',	'Anonymous');

DROP TABLE IF EXISTS `xx_groups_users_link`;
CREATE TABLE `xx_groups_users_link` (
  `linkid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `groupid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`linkid`),
  KEY `groupid_uid` (`groupid`,`uid`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_groups_users_link` (`linkid`, `groupid`, `uid`) VALUES
(4,	2,	1),
(3,	1,	1);

DROP TABLE IF EXISTS `xx_group_permission`;
CREATE TABLE `xx_group_permission` (
  `gperm_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `gperm_groupid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `gperm_itemid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `gperm_modid` mediumint(5) unsigned NOT NULL DEFAULT '0',
  `gperm_name` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`gperm_id`),
  KEY `groupid` (`gperm_groupid`),
  KEY `itemid` (`gperm_itemid`),
  KEY `gperm_modid` (`gperm_modid`,`gperm_name`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_group_permission` (`gperm_id`, `gperm_groupid`, `gperm_itemid`, `gperm_modid`, `gperm_name`) VALUES
(1,	1,	1,	1,	'module_admin'),
(2,	1,	1,	1,	'module_read'),
(3,	2,	1,	1,	'module_read'),
(4,	3,	1,	1,	'module_read'),
(5,	1,	1,	1,	'system_admin'),
(6,	1,	2,	1,	'system_admin'),
(7,	1,	3,	1,	'system_admin'),
(8,	1,	4,	1,	'system_admin'),
(9,	1,	5,	1,	'system_admin'),
(10,	1,	6,	1,	'system_admin'),
(11,	1,	7,	1,	'system_admin'),
(12,	1,	8,	1,	'system_admin'),
(13,	1,	9,	1,	'system_admin'),
(14,	1,	10,	1,	'system_admin'),
(15,	1,	11,	1,	'system_admin'),
(16,	1,	12,	1,	'system_admin'),
(17,	1,	13,	1,	'system_admin'),
(18,	1,	14,	1,	'system_admin'),
(19,	1,	15,	1,	'system_admin'),
(20,	1,	16,	1,	'system_admin'),
(21,	1,	17,	1,	'system_admin'),
(22,	1,	1,	1,	'block_read'),
(23,	2,	1,	1,	'block_read'),
(24,	3,	1,	1,	'block_read'),
(25,	1,	2,	1,	'block_read'),
(26,	2,	2,	1,	'block_read'),
(27,	3,	2,	1,	'block_read'),
(28,	1,	3,	1,	'block_read'),
(29,	2,	3,	1,	'block_read'),
(30,	3,	3,	1,	'block_read'),
(31,	1,	4,	1,	'block_read'),
(32,	2,	4,	1,	'block_read'),
(33,	3,	4,	1,	'block_read'),
(34,	1,	5,	1,	'block_read'),
(35,	2,	5,	1,	'block_read'),
(36,	3,	5,	1,	'block_read'),
(37,	1,	6,	1,	'block_read'),
(38,	2,	6,	1,	'block_read'),
(39,	3,	6,	1,	'block_read'),
(40,	1,	7,	1,	'block_read'),
(41,	2,	7,	1,	'block_read'),
(42,	3,	7,	1,	'block_read'),
(43,	1,	8,	1,	'block_read'),
(44,	2,	8,	1,	'block_read'),
(45,	3,	8,	1,	'block_read'),
(46,	1,	9,	1,	'block_read'),
(47,	2,	9,	1,	'block_read'),
(48,	3,	9,	1,	'block_read'),
(49,	1,	10,	1,	'block_read'),
(50,	2,	10,	1,	'block_read'),
(51,	3,	10,	1,	'block_read'),
(52,	1,	11,	1,	'block_read'),
(53,	2,	11,	1,	'block_read'),
(54,	3,	11,	1,	'block_read'),
(55,	1,	12,	1,	'block_read'),
(62,	1,	3,	1,	'module_admin'),
(63,	1,	3,	1,	'module_read'),
(64,	1,	13,	1,	'block_read'),
(65,	1,	4,	1,	'module_admin'),
(66,	1,	4,	1,	'module_read'),
(67,	1,	14,	1,	'block_read'),
(80,	3,	18,	1,	'block_read'),
(79,	1,	18,	1,	'block_read'),
(70,	1,	15,	1,	'block_read'),
(71,	2,	15,	1,	'block_read'),
(72,	3,	15,	1,	'block_read'),
(73,	1,	16,	1,	'block_read'),
(74,	2,	16,	1,	'block_read'),
(75,	3,	16,	1,	'block_read'),
(76,	1,	17,	1,	'block_read'),
(81,	1,	19,	1,	'block_read'),
(82,	1,	5,	1,	'module_admin'),
(83,	1,	5,	1,	'module_read'),
(84,	1,	20,	1,	'block_read'),
(85,	2,	5,	1,	'module_read'),
(86,	2,	20,	1,	'block_read'),
(87,	3,	5,	1,	'module_read'),
(88,	3,	20,	1,	'block_read'),
(221,	3,	19,	1,	'block_read'),
(220,	2,	19,	1,	'block_read'),
(222,	1,	54,	1,	'block_read'),
(223,	1,	55,	1,	'block_read'),
(224,	1,	56,	1,	'block_read'),
(243,	3,	4,	1,	'module_read'),
(242,	2,	4,	1,	'module_read'),
(229,	1,	57,	1,	'block_read'),
(232,	1,	58,	1,	'block_read'),
(233,	2,	58,	1,	'block_read'),
(234,	3,	58,	1,	'block_read'),
(235,	1,	4,	1,	'module_read'),
(236,	2,	4,	1,	'module_read'),
(237,	3,	4,	1,	'module_read'),
(241,	1,	4,	1,	'module_read'),
(244,	1,	60,	1,	'block_read'),
(245,	2,	60,	1,	'block_read'),
(246,	3,	60,	1,	'block_read'),
(247,	1,	4,	1,	'module_read'),
(248,	2,	4,	1,	'module_read'),
(249,	3,	4,	1,	'module_read'),
(250,	1,	61,	1,	'block_read'),
(251,	2,	61,	1,	'block_read'),
(252,	3,	61,	1,	'block_read'),
(253,	1,	4,	1,	'module_read'),
(254,	2,	4,	1,	'module_read'),
(255,	3,	4,	1,	'module_read');

DROP TABLE IF EXISTS `xx_image`;
CREATE TABLE `xx_image` (
  `image_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `image_name` varchar(30) NOT NULL DEFAULT '',
  `image_nicename` varchar(255) NOT NULL DEFAULT '',
  `image_mimetype` varchar(30) NOT NULL DEFAULT '',
  `image_created` int(10) unsigned NOT NULL DEFAULT '0',
  `image_display` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `image_weight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `imgcat_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`image_id`),
  KEY `imgcat_id` (`imgcat_id`),
  KEY `image_display` (`image_display`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_imagebody`;
CREATE TABLE `xx_imagebody` (
  `image_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `image_body` mediumblob,
  KEY `image_id` (`image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_imagecategory`;
CREATE TABLE `xx_imagecategory` (
  `imgcat_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `imgcat_name` varchar(100) NOT NULL DEFAULT '',
  `imgcat_maxsize` int(8) unsigned NOT NULL DEFAULT '0',
  `imgcat_maxwidth` smallint(3) unsigned NOT NULL DEFAULT '0',
  `imgcat_maxheight` smallint(3) unsigned NOT NULL DEFAULT '0',
  `imgcat_display` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `imgcat_weight` smallint(3) unsigned NOT NULL DEFAULT '0',
  `imgcat_type` char(1) NOT NULL DEFAULT '',
  `imgcat_storetype` varchar(5) NOT NULL DEFAULT '',
  PRIMARY KEY (`imgcat_id`),
  KEY `imgcat_display` (`imgcat_display`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_imgset`;
CREATE TABLE `xx_imgset` (
  `imgset_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `imgset_name` varchar(50) NOT NULL DEFAULT '',
  `imgset_refid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`imgset_id`),
  KEY `imgset_refid` (`imgset_refid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_imgset` (`imgset_id`, `imgset_name`, `imgset_refid`) VALUES
(1,	'default',	0);

DROP TABLE IF EXISTS `xx_imgsetimg`;
CREATE TABLE `xx_imgsetimg` (
  `imgsetimg_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `imgsetimg_file` varchar(50) NOT NULL DEFAULT '',
  `imgsetimg_body` blob,
  `imgsetimg_imgset` smallint(5) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`imgsetimg_id`),
  KEY `imgsetimg_imgset` (`imgsetimg_imgset`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_imgset_tplset_link`;
CREATE TABLE `xx_imgset_tplset_link` (
  `imgset_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `tplset_name` varchar(50) NOT NULL DEFAULT '',
  KEY `tplset_name` (`tplset_name`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_imgset_tplset_link` (`imgset_id`, `tplset_name`) VALUES
(1,	'default');

DROP TABLE IF EXISTS `xx_modules`;
CREATE TABLE `xx_modules` (
  `mid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(150) NOT NULL DEFAULT '',
  `version` smallint(5) unsigned NOT NULL DEFAULT '100',
  `last_update` int(10) unsigned NOT NULL DEFAULT '0',
  `weight` smallint(3) unsigned NOT NULL DEFAULT '0',
  `isactive` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dirname` varchar(25) NOT NULL DEFAULT '',
  `hasmain` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hasadmin` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hassearch` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hasconfig` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hascomments` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `hasnotification` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`mid`),
  KEY `hasmain` (`hasmain`),
  KEY `hasadmin` (`hasadmin`),
  KEY `hassearch` (`hassearch`),
  KEY `hasnotification` (`hasnotification`),
  KEY `dirname` (`dirname`),
  KEY `name` (`name`(15)),
  KEY `isactive` (`isactive`),
  KEY `weight` (`weight`),
  KEY `hascomments` (`hascomments`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_modules` (`mid`, `name`, `version`, `last_update`, `weight`, `isactive`, `dirname`, `hasmain`, `hasadmin`, `hassearch`, `hasconfig`, `hascomments`, `hasnotification`) VALUES
(1,	'系統管理',	211,	1403235685,	0,	1,	'system',	0,	1,	0,	1,	0,	0),
(3,	'佈景管理',	370,	1436803398,	1,	1,	'tad_themes',	0,	1,	0,	1,	0,	0),
(4,	'Tad Tools 工具包',	270,	1436803340,	0,	1,	'tadtools',	1,	1,	0,	1,	0,	0),
(5,	'站長工具箱',	240,	1436803368,	1,	1,	'tad_adm',	1,	1,	0,	1,	0,	0);

DROP TABLE IF EXISTS `xx_newblocks`;
CREATE TABLE `xx_newblocks` (
  `bid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `mid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `func_num` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `options` varchar(255) NOT NULL DEFAULT '',
  `name` varchar(150) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL DEFAULT '',
  `content` text,
  `side` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `visible` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `block_type` char(1) NOT NULL DEFAULT '',
  `c_type` char(1) NOT NULL DEFAULT '',
  `isactive` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dirname` varchar(50) NOT NULL DEFAULT '',
  `func_file` varchar(50) NOT NULL DEFAULT '',
  `show_func` varchar(50) NOT NULL DEFAULT '',
  `edit_func` varchar(50) NOT NULL DEFAULT '',
  `template` varchar(50) NOT NULL DEFAULT '',
  `bcachetime` int(10) unsigned NOT NULL DEFAULT '0',
  `last_modified` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`bid`),
  KEY `mid` (`mid`),
  KEY `visible` (`visible`),
  KEY `isactive_visible_mid` (`isactive`,`visible`,`mid`),
  KEY `mid_funcnum` (`mid`,`func_num`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_newblocks` (`bid`, `mid`, `func_num`, `options`, `name`, `title`, `content`, `side`, `weight`, `visible`, `block_type`, `c_type`, `isactive`, `dirname`, `func_file`, `show_func`, `edit_func`, `template`, `bcachetime`, `last_modified`) VALUES
(1,	1,	0,	'',	'會員選單',	'會員選單',	'',	0,	2,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_user_show',	'',	'system_block_user.html',	0,	1403235686),
(2,	1,	2,	'',	'會員登入',	'會員登入',	'',	0,	0,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_login_show',	'',	'system_block_login.html',	0,	1403235686),
(3,	1,	3,	'',	'搜尋',	'搜尋',	'',	0,	3,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_search_show',	'',	'system_block_search.html',	0,	1403235686),
(4,	1,	4,	'',	'等待驗證',	'等待驗證',	'',	0,	4,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_waiting_show',	'',	'system_block_waiting.html',	0,	1403235686),
(5,	1,	5,	'',	'主選單',	'主選單',	'',	0,	0,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_main_show',	'',	'system_block_mainmenu.html',	0,	1404029070),
(6,	1,	6,	'320|190|s_poweredby.gif|1',	'本站資訊',	'本站資訊',	'',	0,	5,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_info_show',	'b_system_info_edit',	'system_block_siteinfo.html',	0,	1403235686),
(7,	1,	7,	'',	'線上使用者',	'線上使用者',	'',	0,	6,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_online_show',	'',	'system_block_online.html',	0,	1403235686),
(8,	1,	8,	'10|1',	'積分排行榜',	'積分排行榜',	'',	0,	7,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_topposters_show',	'b_system_topposters_edit',	'system_block_topusers.html',	0,	1403235686),
(9,	1,	9,	'10|1',	'歡迎新會員',	'歡迎新會員',	'',	0,	8,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_newmembers_show',	'b_system_newmembers_edit',	'system_block_newusers.html',	0,	1403235686),
(10,	1,	10,	'10',	'最新評論',	'最新評論',	'',	0,	9,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_comments_show',	'b_system_comments_edit',	'system_block_comments.html',	0,	1403235686),
(11,	1,	11,	'',	'通知選項',	'通知選項',	'',	0,	10,	0,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_notification_show',	'',	'system_block_notification.html',	0,	1403235686),
(12,	1,	12,	'0|80',	'網站佈景',	'網站佈景[hide]',	'',	1,	0,	1,	'S',	'H',	1,	'system',	'system_blocks.php',	'b_system_themes_show',	'b_system_themes_edit',	'system_block_themes.html',	0,	1431398511),
(14,	0,	0,	'',	'自訂區塊（PHP）',	'初始化設定[hide]',	'global $xoopsDB,$xoopsUser;\r\n$isAdmin=$xoopsUser->isAdmin(1);\r\nif($xoopsUser and $isAdmin){\r\n  if($_POST[\'xoops_op\']==\"change_admin_passwd\"){\r\n\r\n    $pass=md5($_POST[\'new_admin_passwd\']);\r\n\r\n    //修改XOOPS密碼\r\n    $sql=\"update \".$xoopsDB->prefix(\"users\").\" set pass =\'{$pass}\' where uname=\'admin\' and uid=\'1\'\";\r\n    $xoopsDB->query($sql) or redirect_header($_SERVER[\'PHP_SELF\'],3, \"密碼修改失敗！！\");\r\n\r\n    //修改資料庫密碼\r\n    $sql=\"SET PASSWORD FOR \'root\'@\'127.0.0.1\' = PASSWORD( \'{$_POST[\'new_admin_passwd\']}\' )\";\r\n    $xoopsDB->queryF($sql) or redirect_header($_SERVER[\'PHP_SELF\'],3, \"修改資料庫密碼失敗！！\");\r\n\r\n    //修改 secure.php 密碼\r\n    $file=XOOPS_VAR_PATH . \'/data/secure.php\';\r\n    if (file_exists($file)) {\r\n      $content = file_get_contents($file);\r\n      $content=str_replace(\"define(\'XOOPS_DB_PASS\', \'\".XOOPS_DB_PASS.\"\');\",\"define(\'XOOPS_DB_PASS\', \'{$_POST[\'new_admin_passwd\']}\');\",$content);\r\n      if(!file_put_contents($file,$content)){\r\n        redirect_header($_SERVER[\'PHP_SELF\'],3, \"儲存設定失敗！\");\r\n      }\r\n    }\r\n\r\n    //修改UniServer密碼\r\n    $path_array = explode(\"\\\\www\",dirname(__FILE__));\r\n    $file2=\"{$path_array[0]}\\\\uni_con\\\\includes\\\\mysql_password\";\r\n    if (file_exists($file2)) {\r\n      if(!file_put_contents($file2,$_POST[\'new_admin_passwd\'])){\r\n        redirect_header($_SERVER[\'PHP_SELF\'],3, \"儲存UniServer密碼設定失敗！\");\r\n      }\r\n    }\r\n\r\n    //關閉修改密碼區塊\r\n    $sql=\"update \".$xoopsDB->prefix(\"newblocks\").\" SET `visible`=0 WHERE `bid`=14 or `bid`=18\";\r\n    $xoopsDB->query($sql) or redirect_header($_SERVER[\'PHP_SELF\'],3, \"關閉修改密碼區塊失敗！！\");\r\n\r\n    redirect_header($_SERVER[\'PHP_SELF\'],3, \"密碼修改成功！日後請以新密碼登入！\");\r\n  }else{\r\n    $main=\"\r\n    <form action=\'{$_SERVER[\'PHP_SELF\']}\' method=\'post\' style=\'background-color:red;color:white;padding:6px;-webkit-border-radius: 5px;-moz-border-radius: 5px;border-radius: 5px;\'>\r\n    <img src=\'\".XOOPS_URL.\"/modules/tad_themes/images/waring.png\' alt=\'請重新輸入一個密碼\' title=\'請重新輸入一個密碼\' style=\'float:left;margin-right:10px;\'>\r\n    請修改密碼：<input type=\'text\' name=\'new_admin_passwd\' value=\'\'>\r\n    <input type=\'hidden\' name=\'xoops_op\' value=\'change_admin_passwd\'>\r\n    <input type=\'submit\' value=\'重設密碼\'>\r\n    <div>預設密碼是公開的，因此，請重新輸入一個密碼，並重設密碼，以策安全</div>\r\n    </form>\";\r\n  }\r\n  echo $main;\r\n}',	5,	0,	0,	'C',	'P',	1,	'',	'',	'',	'',	'',	0,	1341656772),
(15,	0,	0,	'',	'自訂區塊（HTML）',	'臺南市教育局最新公告[pic]images/tn_news_block_title.png',	'<style>\r\ntable.sub td{\r\npadding:4px 0px;\r\n}\r\n</style>\r\n<div id=edu_center_C></div><script language=JavaScript src=http://bulletin.tn.edu.tw/GetNews.aspx?stype=edu_center_C&fontsize=1 charset=utf-8 defer=defer ></script> ',	9,	0,	0,	'C',	'H',	1,	'',	'',	'',	'',	'',	0,	1341592251),
(16,	0,	0,	'',	'自訂區塊（HTML）',	'logo[hide]',	'<a href=\"http://campus-xoops.tn.edu.tw\" target=\'_blank\'><img src=\"http://120.115.2.90/logo.php\" alt=\"本站以XOOPS校園網站輕鬆架建置\"></a>',	1,	1,	1,	'C',	'H',	1,	'',	'',	'',	'',	'',	0,	1388716961),
(17,	0,	0,	'',	'自訂區塊（HTML）',	'首次安裝時您該做的事',	'<style>\r\nol#first_time_note ,#first_time_note li{\r\n  margin: 0;\r\n  padding: 0;\r\n  line-height:180%;\r\n}\r\n\r\nol#first_time_note  ,ol#first_time_note li  ,#first_time_note li ol li {\r\n  list-style: decimal outside none;\r\n}\r\n#first_time_note li {\r\n  margin-left: 2em;\r\n  color:rgb(80,80,80);\r\n}\r\n#first_time_note  li ol {\r\n  margin-bottom: 0;\r\n}\r\n</style>\r\n<div class=\"alert alert-warning\">底下是您應該要做的幾件事情，請依序完成吧！（本區塊僅管理員看得見）</div>\r\n<ol id=\"first_time_note\">\r\n  <li><a href=\"{X_SITEURL}modules/tad_adm/admin/main.php\" target=\"_blank\">請先把所有模組更新到最新版，強烈建議優先更新 tadtools 後，再更新其他模組或佈景。</a>\r\n  <li><a href=\"{X_SITEURL}modules/tad_adm/admin/phpini.php\" target=\"_blank\">若是使用不含伺服器的XOOPS輕鬆架架站包者，請檢查一下 php.ini 的設定是否符合建議值，若不符建議改善之。</a>\r\n  <li><a href=\"{X_SITEURL}modules/system/admin.php?fct=preferences&amp;op=show&amp;confcat_id=3\" target=\"_blank\">設定頁尾，可將整個「頁尾註腳」清空，自己輸入相關的資訊，如學校電話、地址...等。 </a></li>\r\n  <li><a href=\"{X_SITEURL}modules/system/admin.php?fct=modulesadmin\" target=\"_blank\">調整模組，把模組改成喜好的名稱，或者把不需要的模組停用或移除。</a></li>\r\n  <li><a href=\"{X_SITEURL}modules/system/admin.php?fct=blocksadmin\" target=\"_blank\">調整區塊，自行啟用新區塊或刪除不需要的區塊。</a></li>\r\n  <li><a href=\"{X_SITEURL}modules/tad_themes/admin/main.php\" target=\"_blank\">修改佈景：請做個幾張固定比例的圖到「logo圖」進行上傳，首頁的標題圖便會煥然一新。</a></li>\r\n  <li><a href=\"{X_SITEURL}modules/system/admin.php?fct=blocksadmin&op=edit&bid=17\" target=\"_blank\">請停用本區塊吧！將「僅顯示啟用？」選「否」即可</a></li>\r\n</ol>\r\n\r\n<div class=\"alert alert-info\">本系統由臺南市教育局資訊中心吳弘凱老師製作維護，若有任何使用上的問題或建議，歡迎來信 tad@tn.edu.tw。</div>',	5,	2,	1,	'C',	'H',	1,	'',	'',	'',	'',	'',	0,	1431397282),
(20,	5,	1,	'10',	'新的垃圾帳戶',	'新的垃圾帳戶',	'',	0,	0,	0,	'M',	'H',	1,	'tad_adm',	'tad_adm_new.php',	'tad_adm_new',	'tad_adm_new_edit',	'tad_adm_new.html',	0,	1436803369),
(18,	0,	0,	'',	'自訂區塊（PHP）',	'登入帳號密碼[hide]',	'\nglobal $xoopsDB,$xoopsUser;\nif(empty($xoopsUser)){\n  $sql=\"select `pass` from \".$xoopsDB->prefix(\"users\").\" where `uname` = \'admin\'\";\n  $result = $xoopsDB->queryF($sql) ;\n  list($passwd)=$xoopsDB->fetchRow($result);\n\n  if(md5(\'2130669#33\')==$passwd){\n      echo \'\n      <style>\n      .triangle-border {\n      	position:relative;\n      	padding:15px;\n      	margin:1em 0 3em;\n      	border:5px solid #5a8f00;\n      	color:#333;\n      	background:#fff;\n      	/* css3 */\n      	-webkit-border-radius:10px;\n      	-moz-border-radius:10px;\n      	border-radius:10px;\n      }\n\n      .triangle-border.left {\n      	margin-left:140px;\n      	font-size:11pt;\n      }\n\n      .triangle-border:before {\n      	content:\"\";\n      	position:absolute;\n      	bottom:-20px; /* value = - border-top-width - border-bottom-width */\n      	left:40px; /* controls horizontal position */\n          border-width:20px 20px 0;\n      	border-style:solid;\n          border-color:#5a8f00 transparent;\n          /* reduce the damage in FF3.0 */\n          display:block;\n          width:0;\n      }\n\n      .triangle-border:after {\n      	content:\"\";\n      	position:absolute;\n      	bottom:-13px; /* value = - border-top-width - border-bottom-width */\n      	left:47px; /* value = (:before left) + (:before border-left) - (:after border-left) */\n      	border-width:13px 13px 0;\n      	border-style:solid;\n      	border-color:#fff transparent;\n          /* reduce the damage in FF3.0 */\n          display:block;\n          width:0;\n      }\n\n\n      .triangle-border.left:before {\n      	top:10px; /* controls vertical position */\n      	bottom:auto;\n      	left:-30px; /* value = - border-left-width - border-right-width */\n      	border-width:15px 30px 15px 0;\n      	border-color:transparent #5a8f00;\n      }\n\n      .triangle-border.left:after {\n      	top:16px; /* value = (:before top) + (:before border-top) - (:after border-top) */\n      	bottom:auto;\n      	left:-20px; /* value = - border-left-width - border-right-width */\n      	border-width:9px 21px 9px 0;\n      	border-color:transparent #fff;\n      }\n\n      </style>\n      <p>\n        <img src=\"\'.XOOPS_URL.\'/modules/tad_themes/images/boy.png\" alt=\"首次登入之帳號密碼說明\" title=\"首次登入之帳號密碼說明\" style=\"float:left;margin-top:20px;margin-right:10px;\">\n        <div class=\"triangle-border left\">\n          您好：\n          <p>歡迎使用本系統，這是您第一次登入，站長首次登入之帳號密碼如下：</p>\n          <p>\n          帳號為：\n          <span style=\"background-color: rgb(255, 255, 153);font-weight:bold;\">admin</span>\n          </p>\n          <p>密碼為：\n          <span style=\"background-color: rgb(255, 255, 153);font-weight:bold;\">2130669#33</span>\n          </p>\n          <p>\n          <span style=\"color: rgb(128, 0, 0);\">\n          登入後，本區塊會消失，並請您立即修改密碼！\n          </span>\n          </p>\n        </div>\n      </p>\';\n  }\n}',	5,	1,	0,	'C',	'P',	1,	'',	'',	'',	'',	'',	0,	1341645585),
(19,	3,	1,	'',	'佈景首頁滑動區塊',	'佈景首頁滑動區塊[hide]',	'',	5,	0,	1,	'M',	'H',	1,	'tad_themes',	'tad_themes_responsive_slider.php',	'tad_themes_responsive_slider',	'',	'tad_themes_responsive_slider.html',	0,	1436803402),
(54,	3,	2,	'',	'上方隱藏選單',	'上方隱藏選單',	'',	0,	0,	0,	'M',	'',	1,	'tad_themes',	'tad_themes_top_menu.php',	'tad_themes_top_menu',	'tad_themes_top_menu_edit',	'tad_themes_top_menu.html',	0,	1436803402),
(55,	3,	3,	'',	'垂直BootStrap選單',	'垂直BootStrap選單',	'',	0,	0,	0,	'M',	'',	1,	'tad_themes',	'vertical_bootstrap_menu.php',	'vertical_bootstrap_menu',	'vertical_bootstrap_menu_edit',	'vertical_bootstrap_menu.html',	0,	1436803402),
(56,	3,	4,	'|0',	'垂直選單',	'垂直選單',	'',	0,	0,	0,	'M',	'',	1,	'tad_themes',	'vertical_menu.php',	'vertical_menu',	'vertical_menu_edit',	'vertical_menu.html',	0,	1436803402),
(57,	0,	0,	'',	'自訂區塊（PHP）',	'初始化設定[hide]',	'global $xoopsDB,$xoopsUser;\r\n$isAdmin=$xoopsUser->isAdmin(1);\r\nif($xoopsUser and $isAdmin ){\r\n  if($_POST[\'xoops_op\']==\"change_admin_passwd\"){\r\n\r\n    $pass=md5($_POST[\'new_admin_passwd\']);\r\n\r\n    //修改資料庫密碼\r\n    $sql=\"SET PASSWORD FOR \'root\'@\'127.0.0.1\' = PASSWORD( \'{$_POST[\'new_admin_passwd\']}\' )\";\r\n    $xoopsDB->queryF($sql) or redirect_header($_SERVER[\'PHP_SELF\'],3, \"修改資料庫密碼失敗！！\");\r\n\r\n    //修改 secure.php 密碼\r\n    $file=XOOPS_VAR_PATH . \'/data/secure.php\';\r\n    if (file_exists($file)) {\r\n      $content = file_get_contents($file);\r\n      $content=str_replace(\"define(\'XOOPS_DB_PASS\', \'\".XOOPS_DB_PASS.\"\');\",\"define(\'XOOPS_DB_PASS\', \'{$_POST[\'new_admin_passwd\']}\');\",$content);\r\n      if(!file_put_contents($file,$content)){\r\n        redirect_header($_SERVER[\'PHP_SELF\'],3, \"儲存設定失敗！\");\r\n      }\r\n    }\r\n\r\n    //修改UniServer密碼\r\n    $path_array = explode(\"\\\\www\",dirname(__FILE__));\r\n    $file2=\"{$path_array[0]}\\\\uni_con\\\\includes\\\\mysql_password\";\r\n    if (file_exists($file2)) {\r\n      if(!file_put_contents($file2,$_POST[\'new_admin_passwd\'])){\r\n        redirect_header($_SERVER[\'PHP_SELF\'],3, \"儲存UniServer密碼設定失敗！\");\r\n      }\r\n    }\r\n\r\n    //關閉修改密碼區塊\r\n    $sql=\"update \".$xoopsDB->prefix(\"newblocks\").\" SET `visible`=0 WHERE `bid`=14 or `bid`=18\";\r\n    $xoopsDB->query($sql) or redirect_header($_SERVER[\'PHP_SELF\'],3, \"關閉修改密碼區塊失敗！！\");\r\n\r\n    redirect_header($_SERVER[\'PHP_SELF\'],3, \"密碼修改成功！日後請以新密碼登入！\");\r\n  }elseif(XOOPS_DB_PASS==\'2130669#33\'){\r\n\r\n    $row=($_SESSION[\'bootstrap\']==\'3\')?\'row\':\'row-fluid\';\r\n    $span=($_SESSION[\'bootstrap\']==\'3\')?\'col-md-\':\'span\';\r\n    $error=($_SESSION[\'bootstrap\']==\'3\')?\'danger\':\'error\';\r\n    $main=\"\r\n    <form action=\'{$_SERVER[\'PHP_SELF\']}\' method=\'post\' >\r\n      <div class=\'alert alert-{$error}\'>\r\n        <div class=\'{$row}\'>\r\n          <div class=\'{$span}1 text-right\'>\r\n            <img src=\'\".XOOPS_URL.\"/modules/tad_themes/images/waring.png\' alt=\'請重新輸入一個密碼\' title=\'請重新輸入一個密碼\'>\r\n          </div>\r\n          <div class=\'{$span}11\'>\r\n            請修改密碼：<input type=\'text\' name=\'new_admin_passwd\' value=\'\'>\r\n            <input type=\'hidden\' name=\'xoops_op\' value=\'change_admin_passwd\'>\r\n            <button type=\'submit\' class=\'btn btn-danger\'>重設資料庫密碼</button>\r\n            <div>預設資料庫密碼是公開的，因此，請重新輸入一個密碼，並重設資料庫密碼，以策安全</div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </form>\";\r\n  }\r\n  echo $main;\r\n}',	5,	0,	1,	'C',	'P',	1,	'',	'',	'',	'',	'',	0,	1431396505),
(61,	4,	0,	'',	'QR Code 區塊',	'QR Code 區塊[hide]',	'',	1,	0,	1,	'M',	'H',	1,	'tadtools',	'tadtools_qrcode.php',	'tadtools_qrcode',	'',	'tadtools_qrcode.html',	0,	1436804150);

DROP TABLE IF EXISTS `xx_online`;
CREATE TABLE `xx_online` (
  `online_uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `online_uname` varchar(25) NOT NULL DEFAULT '',
  `online_updated` int(10) unsigned NOT NULL DEFAULT '0',
  `online_module` smallint(5) unsigned NOT NULL DEFAULT '0',
  `online_ip` varchar(15) NOT NULL DEFAULT '',
  KEY `online_module` (`online_module`),
  KEY `online_updated` (`online_updated`),
  KEY `online_uid` (`online_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_priv_msgs`;
CREATE TABLE `xx_priv_msgs` (
  `msg_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `msg_image` varchar(100) DEFAULT NULL,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `from_userid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `to_userid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `msg_time` int(10) unsigned NOT NULL DEFAULT '0',
  `msg_text` text,
  `read_msg` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `from_delete` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `from_save` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `to_delete` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `to_save` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`msg_id`),
  KEY `to_userid` (`to_userid`),
  KEY `touseridreadmsg` (`to_userid`,`read_msg`),
  KEY `msgidfromuserid` (`from_userid`,`msg_id`),
  KEY `prune` (`msg_time`,`read_msg`,`from_save`,`to_delete`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_ranks`;
CREATE TABLE `xx_ranks` (
  `rank_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `rank_title` varchar(50) NOT NULL DEFAULT '',
  `rank_min` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rank_max` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `rank_special` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `rank_image` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`rank_id`),
  KEY `rank_min` (`rank_min`),
  KEY `rank_max` (`rank_max`),
  KEY `rankminrankmaxranspecial` (`rank_min`,`rank_max`,`rank_special`),
  KEY `rankspecial` (`rank_special`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_ranks` (`rank_id`, `rank_title`, `rank_min`, `rank_max`, `rank_special`, `rank_image`) VALUES
(1,	'新會員',	0,	20,	0,	'rank3e632f95e81ca.gif'),
(2,	'初級會員',	21,	40,	0,	'rank3dbf8e94a6f72.gif'),
(3,	'中級會員',	41,	70,	0,	'rank3dbf8e9e7d88d.gif'),
(4,	'高級會員',	71,	150,	0,	'rank3dbf8ea81e642.gif'),
(5,	'資深會員',	151,	10000,	0,	'rank3dbf8eb1a72e7.gif'),
(6,	'版主',	0,	0,	1,	'rank3dbf8edf15093.gif'),
(7,	'管理員',	0,	0,	1,	'rank3dbf8ee8681cd.gif');

DROP TABLE IF EXISTS `xx_session`;
CREATE TABLE `xx_session` (
  `sess_id` varchar(32) NOT NULL DEFAULT '',
  `sess_updated` int(10) unsigned NOT NULL DEFAULT '0',
  `sess_ip` varchar(15) NOT NULL DEFAULT '',
  `sess_data` text,
  PRIMARY KEY (`sess_id`),
  KEY `updated` (`sess_updated`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_smiles`;
CREATE TABLE `xx_smiles` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `code` varchar(50) NOT NULL DEFAULT '',
  `smile_url` varchar(100) NOT NULL DEFAULT '',
  `emotion` varchar(75) NOT NULL DEFAULT '',
  `display` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_smiles` (`id`, `code`, `smile_url`, `emotion`, `display`) VALUES
(1,	':-D',	'smil3dbd4d4e4c4f2.gif',	'高興',	1),
(2,	':-)',	'smil3dbd4d6422f04.gif',	'微笑',	1),
(3,	':-(',	'smil3dbd4d75edb5e.gif',	'悲傷',	1),
(4,	':-o',	'smil3dbd4d8676346.gif',	'驚訝',	1),
(5,	':-?',	'smil3dbd4d99c6eaa.gif',	'疑惑',	1),
(6,	'8-)',	'smil3dbd4daabd491.gif',	'冷酷',	1),
(7,	':lol:',	'smil3dbd4dbc14f3f.gif',	'嘲笑',	1),
(8,	':-x',	'smil3dbd4dcd7b9f4.gif',	'生氣',	1),
(9,	':-P',	'smil3dbd4ddd6835f.gif',	'戲弄',	1),
(10,	':oops:',	'smil3dbd4df1944ee.gif',	'害羞',	0),
(11,	':cry:',	'smil3dbd4e02c5440.gif',	'哭泣',	0),
(12,	':evil:',	'smil3dbd4e1748cc9.gif',	'氣憤',	0),
(13,	':roll:',	'smil3dbd4e29bbcc7.gif',	'眼珠一轉',	0),
(14,	';-)',	'smil3dbd4e398ff7b.gif',	'眨眼',	0),
(15,	':pint:',	'smil3dbd4e4c2e742.gif',	'乾杯',	0),
(16,	':hammer:',	'smil3dbd4e5e7563a.gif',	'看這裡',	0),
(17,	':idea:',	'smil3dbd4e7853679.gif',	'好主意！',	0);

DROP TABLE IF EXISTS `xx_tadtools_setup`;
CREATE TABLE `xx_tadtools_setup` (
  `tt_theme` varchar(255) NOT NULL DEFAULT '',
  `tt_use_bootstrap` varchar(255) NOT NULL DEFAULT '',
  `tt_bootstrap_color` varchar(255) NOT NULL DEFAULT '',
  `tt_theme_kind` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`tt_theme`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tadtools_setup` (`tt_theme`, `tt_use_bootstrap`, `tt_bootstrap_color`, `tt_theme_kind`) VALUES
('default',	'0',	'bootstrap',	'html'),
('school2015',	'0',	'bootstrap3',	'bootstrap3');

DROP TABLE IF EXISTS `xx_tad_adm`;
CREATE TABLE `xx_tad_adm` (
  `uid` smallint(6) unsigned NOT NULL COMMENT 'uid',
  `email` varchar(255) NOT NULL COMMENT 'email',
  `result` varchar(255) NOT NULL COMMENT '檢查結果',
  `chk_date` datetime NOT NULL COMMENT '檢查日',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tad_adm` (`uid`, `email`, `result`, `chk_date`) VALUES
(1,	'tad0616@gmail.com',	'0',	'2013-10-22 11:10:08');

DROP TABLE IF EXISTS `xx_tad_themes`;
CREATE TABLE `xx_tad_themes` (
  `theme_id` smallint(6) unsigned NOT NULL AUTO_INCREMENT COMMENT '佈景編號',
  `theme_name` varchar(255) NOT NULL COMMENT '佈景名稱',
  `theme_type` varchar(255) NOT NULL COMMENT '版面類型',
  `theme_width` varchar(255) NOT NULL DEFAULT '980',
  `lb_width` varchar(255) NOT NULL COMMENT '左區塊寬度',
  `rb_width` varchar(255) NOT NULL COMMENT '右區塊寬度',
  `clb_width` varchar(255) NOT NULL COMMENT '中左區塊寬度',
  `crb_width` varchar(255) NOT NULL COMMENT '中右區塊寬度',
  `base_color` varchar(255) NOT NULL DEFAULT 'transparent' COMMENT '基底顏色',
  `lb_color` varchar(255) NOT NULL COMMENT '左區域背景色',
  `cb_color` varchar(255) NOT NULL COMMENT '中區域背景色',
  `rb_color` varchar(255) NOT NULL COMMENT '右區域背景色',
  `margin_top` varchar(255) NOT NULL COMMENT '上邊界',
  `margin_bottom` varchar(255) NOT NULL COMMENT '下邊界',
  `bg_img` varchar(255) NOT NULL COMMENT '背景圖',
  `logo_img` varchar(255) NOT NULL COMMENT 'logo圖',
  `logo_position` varchar(255) NOT NULL DEFAULT 'slide',
  `navlogo_img` varchar(255) NOT NULL DEFAULT '',
  `bg_attachment` varchar(255) NOT NULL COMMENT '背景固定',
  `bg_color` varchar(255) NOT NULL COMMENT '背景顏色',
  `bg_position` varchar(255) NOT NULL COMMENT '背景位置',
  `bg_repeat` varchar(255) NOT NULL COMMENT '背景重複',
  `logo_top` smallint(5) unsigned NOT NULL COMMENT 'Logo離上方距離',
  `logo_right` smallint(5) unsigned NOT NULL COMMENT 'Logo離右邊距離',
  `logo_bottom` smallint(5) unsigned NOT NULL COMMENT 'Logo離下方距離',
  `logo_left` smallint(5) unsigned NOT NULL COMMENT 'Logo離左邊距離',
  `theme_enable` enum('1','0') NOT NULL COMMENT '使用狀況',
  `slide_width` varchar(255) NOT NULL COMMENT '佈景圖片寬度',
  `slide_height` varchar(255) NOT NULL COMMENT '佈景圖片高度',
  `font_size` varchar(255) NOT NULL COMMENT '文字大小',
  `font_color` varchar(255) NOT NULL COMMENT '文字顏色',
  `link_color` varchar(255) NOT NULL COMMENT '連結顏色',
  `hover_color` varchar(255) NOT NULL COMMENT '移致連結顏色',
  `theme_kind` varchar(255) NOT NULL DEFAULT 'html',
  `navbar_pos` varchar(255) NOT NULL DEFAULT 'default',
  `navbar_bg_top` varchar(255) NOT NULL DEFAULT '#54b4eb',
  `navbar_bg_bottom` varchar(255) NOT NULL DEFAULT '#2fa4e7',
  `navbar_hover` varchar(255) NOT NULL DEFAULT '#1684c2',
  `navbar_color` varchar(255) NOT NULL DEFAULT '#FFFFFF',
  `navbar_color_hover` varchar(255) NOT NULL DEFAULT 'yellow',
  `navbar_icon` varchar(255) NOT NULL DEFAULT '',
  `navbar_img` varchar(255) NOT NULL DEFAULT 'transparent' COMMENT 'navbar背景圖片',
  PRIMARY KEY (`theme_id`),
  UNIQUE KEY `theme_name` (`theme_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tad_themes` (`theme_id`, `theme_name`, `theme_type`, `theme_width`, `lb_width`, `rb_width`, `clb_width`, `crb_width`, `base_color`, `lb_color`, `cb_color`, `rb_color`, `margin_top`, `margin_bottom`, `bg_img`, `logo_img`, `logo_position`, `navlogo_img`, `bg_attachment`, `bg_color`, `bg_position`, `bg_repeat`, `logo_top`, `logo_right`, `logo_bottom`, `logo_left`, `theme_enable`, `slide_width`, `slide_height`, `font_size`, `font_color`, `link_color`, `hover_color`, `theme_kind`, `navbar_pos`, `navbar_bg_top`, `navbar_bg_bottom`, `navbar_hover`, `navbar_color`, `navbar_color_hover`, `navbar_icon`, `navbar_img`) VALUES
(6,	'school2015',	'theme_type_2',	'12',	'3',	'3',	'49%',	'49%',	'#FFFFFF',	'#F2F4FF',	'#FFFFFF',	'#F4F4F4',	'0',	'0',	'http://localhost/uploads/tad_themes/school2015/bg/dot.jpg',	'',	'slide',	'',	'scroll',	'#FFFFFF',	'',	'repeat',	0,	0,	0,	0,	'1',	'12',	'0',	'11pt',	'#202020',	'#005ca8',	'#a40019',	'bootstrap3',	'navbar-static-bottom',	'#dbefff',	'#dbefff',	'#f7ffd1',	'#3b3b3b',	'#5e003f',	'',	'');

DROP TABLE IF EXISTS `xx_tad_themes_blocks`;
CREATE TABLE `xx_tad_themes_blocks` (
  `theme_id` smallint(6) unsigned NOT NULL AUTO_INCREMENT COMMENT '佈景編號',
  `block_position` varchar(30) NOT NULL DEFAULT '' COMMENT '區塊位置',
  `block_config` enum('right','left') NOT NULL DEFAULT 'right' COMMENT '工具按鈕靠左/右',
  `bt_text` varchar(16) NOT NULL COMMENT '區塊標題字體顏色',
  `bt_text_padding` tinyint(4) NOT NULL DEFAULT '33' COMMENT '區塊標題文字縮排',
  `bt_text_size` varchar(16) NOT NULL COMMENT '區塊標題字體大小',
  `bt_bg_color` varchar(16) NOT NULL COMMENT '區塊標題背景顏色',
  `bt_bg_img` varchar(255) NOT NULL COMMENT '區塊標題背景圖',
  `bt_bg_repeat` enum('0','1') NOT NULL DEFAULT '0' COMMENT '以圖填滿區塊標題列',
  `bt_radius` enum('0','1') NOT NULL DEFAULT '1' COMMENT '區塊標題圓角',
  `block_style` text NOT NULL COMMENT '區塊整體樣式',
  `block_title_style` text NOT NULL COMMENT '區塊標題區樣式',
  `block_content_style` text NOT NULL COMMENT '區塊內容區樣式',
  PRIMARY KEY (`theme_id`,`block_position`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tad_themes_blocks` (`theme_id`, `block_position`, `block_config`, `bt_text`, `bt_text_padding`, `bt_text_size`, `bt_bg_color`, `bt_bg_img`, `bt_bg_repeat`, `bt_radius`, `block_style`, `block_title_style`, `block_content_style`) VALUES
(6,	'leftBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'rightBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerLeftBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerRightBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerBottomBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerBottomLeftBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	''),
(6,	'centerBottomRightBlock',	'right',	'#6bbdff',	0,	'1.5em',	'transparent',	'',	'0',	'1',	'',	'border:none;height:40px;line-height:40px;margin-bottom:10px;',	'');

DROP TABLE IF EXISTS `xx_tad_themes_config2`;
CREATE TABLE `xx_tad_themes_config2` (
  `theme_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `name` varchar(100) NOT NULL DEFAULT '',
  `type` varchar(255) NOT NULL DEFAULT '',
  `value` text NOT NULL,
  PRIMARY KEY (`theme_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tad_themes_config2` (`theme_id`, `name`, `type`, `value`) VALUES
(6,	'font_family',	'text',	'\"Helvetica Neue\",Helvetica,Arial,\"微軟正黑體\",sans-serif'),
(6,	'separate_style',	'text',	'1px dashed gray'),
(6,	'right_separate',	'yesno',	'0'),
(6,	'shadow_include_logo',	'yesno',	'1'),
(6,	'left_separate',	'yesno',	'0'),
(6,	'use_shadow',	'yesno',	'1'),
(6,	'show_var',	'yesno',	'0'),
(6,	'use_container',	'yesno',	'1'),
(6,	'logo_bgcolor',	'color',	'#FFFFFF'),
(6,	'footer_img',	'file',	'http://localhost/uploads/tad_themes/school2015/config2/foot.jpg'),
(6,	'foot_bg_css',	'text',	'background-size:cover;background-repeat:repeat;'),
(6,	'footer_height',	'text',	'180px'),
(6,	'footer_bgcolor',	'color',	'#0090d6'),
(6,	'footer_padding',	'text',	'40px 50px'),
(6,	'footer_color',	'color',	'#FFFFFF'),
(6,	'footer_style',	'textarea',	'line-height:180%;text-align:center;'),
(6,	'my_code',	'text',	'');

DROP TABLE IF EXISTS `xx_tad_themes_files_center`;
CREATE TABLE `xx_tad_themes_files_center` (
  `files_sn` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '檔案流水號',
  `col_name` varchar(255) NOT NULL COMMENT '欄位名稱',
  `col_sn` mediumint(9) unsigned NOT NULL DEFAULT '0',
  `sort` smallint(5) unsigned NOT NULL COMMENT '排序',
  `kind` enum('img','file') NOT NULL COMMENT '檔案種類',
  `file_name` varchar(255) NOT NULL COMMENT '檔案名稱',
  `file_type` varchar(255) NOT NULL COMMENT '檔案類型',
  `file_size` int(10) unsigned NOT NULL COMMENT '檔案大小',
  `description` text NOT NULL COMMENT '檔案說明',
  `counter` mediumint(8) unsigned NOT NULL COMMENT '下載人次',
  `original_filename` varchar(255) NOT NULL DEFAULT '',
  `hash_filename` varchar(255) NOT NULL DEFAULT '',
  `sub_dir` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`files_sn`),
  UNIQUE KEY `col_name` (`col_name`,`col_sn`,`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tad_themes_files_center` (`files_sn`, `col_name`, `col_sn`, `sort`, `kind`, `file_name`, `file_type`, `file_size`, `description`, `counter`, `original_filename`, `hash_filename`, `sub_dir`) VALUES
(268,	'bt_bg_centerBottomLeftBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'5dc630d2e3ee75ef13f7b4bc38ae21cf.gif',	'/school2015/bt_bg'),
(267,	'bt_bg_centerBottomBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'1c557505ed52aeee142fff316213dd1b.gif',	'/school2015/bt_bg'),
(266,	'bt_bg_centerBottomBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'0d100cb721a66977c3886e24c676e5c5.gif',	'/school2015/bt_bg'),
(265,	'bt_bg_centerBottomBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'14d5bf4a0a00abf98004bb6f60b716c1.gif',	'/school2015/bt_bg'),
(264,	'bt_bg_centerBottomBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'beb83fb5efe6a4f68479c6465566d72a.gif',	'/school2015/bt_bg'),
(263,	'bt_bg_centerRightBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'130ecbd8fe797001ef79301a5ca5c3a5.gif',	'/school2015/bt_bg'),
(262,	'bt_bg_centerRightBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'ecfc8ff083f1a1485aaac07ba9615a6f.gif',	'/school2015/bt_bg'),
(261,	'bt_bg_centerRightBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'34b31d67c238119a84b8bbc55df43682.gif',	'/school2015/bt_bg'),
(254,	'bt_bg_centerBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'08bfa1bafff23d7a92ae6ce017a703c8.gif',	'/school2015/bt_bg'),
(255,	'bt_bg_centerBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'89e7aa30513231f6cb32c1f5c5c7d48d.gif',	'/school2015/bt_bg'),
(256,	'bt_bg_centerLeftBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'4ea2ac59ff1828960eb67db0b569a342.gif',	'/school2015/bt_bg'),
(257,	'bt_bg_centerLeftBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'42a3466bfd02bc723c91e13e684e3d1f.gif',	'/school2015/bt_bg'),
(258,	'bt_bg_centerLeftBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'b014a19f8bd17d2dbeb81456d7f1e946.gif',	'/school2015/bt_bg'),
(259,	'bt_bg_centerLeftBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'6f67ffceff8c601573d1cc4156a4c95a.gif',	'/school2015/bt_bg'),
(260,	'bt_bg_centerRightBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'9f9d03d7b0f16704426173168133754d.gif',	'/school2015/bt_bg'),
(253,	'bt_bg_centerBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'95d6d6337a902198975b1875eb1eb1f0.gif',	'/school2015/bt_bg'),
(252,	'bt_bg_centerBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'1e2d390f7ce35e04921b881e24a3b4d8.gif',	'/school2015/bt_bg'),
(251,	'bt_bg_rightBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'7580d4f6cc22511182f2edd24fef4d8e.gif',	'/school2015/bt_bg'),
(250,	'bt_bg_rightBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'1e088cd4b1e98d84d6f6cda44795e133.gif',	'/school2015/bt_bg'),
(249,	'bt_bg_rightBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'5214419354b157c98da1897402b128a3.gif',	'/school2015/bt_bg'),
(248,	'bt_bg_rightBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'be3bb85293db988b7b198eb32c939d20.gif',	'/school2015/bt_bg'),
(247,	'bt_bg_leftBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'1c8ee5019cb03d9a3691dde3039fc184.gif',	'/school2015/bt_bg'),
(246,	'bt_bg_leftBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'bc4ffc98d34b36989952d5cb9f8c54d5.gif',	'/school2015/bt_bg'),
(245,	'bt_bg_leftBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'42a3466bfd02bc723c91e13e684e3d1f.gif',	'/school2015/bt_bg'),
(277,	'slide',	6,	1,	'img',	'slide_6_1.jpg',	'image/jpeg',	65761,	'',	0,	'2015_1.jpg',	'806b8f632c311aa4782460f1ba4ab20c.jpg',	'/school2015/slide'),
(244,	'bt_bg_leftBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'0d82e9a996d2b921c0a4e0a9abc83042.gif',	'/school2015/bt_bg'),
(278,	'slide',	6,	2,	'img',	'slide_6_2.jpg',	'image/jpeg',	165982,	'',	0,	'2015_2.jpg',	'723ae5b9cd96b32dd85b6770d5e5f95e.jpg',	'/school2015/slide'),
(279,	'slide',	6,	3,	'img',	'slide_6_3.jpg',	'image/jpeg',	81094,	'',	0,	'2015_3.jpg',	'ef7f16fa2082f70230f86bf7e1bc7497.jpg',	'/school2015/slide'),
(240,	'logo',	6,	1,	'img',	'logo.png',	'image/png',	37878,	'logo.png',	0,	'logo.png',	'd3be4e2a1aa4088f3ba6b2c202eefd03.png',	'/school2015/logo'),
(239,	'bg',	6,	11,	'img',	'ybg.png',	'image/png',	207,	'ybg.png',	0,	'ybg.png',	'aa8427059669ecea9a70fa4f2e39b041.png',	'/school2015/bg'),
(238,	'bg',	6,	10,	'img',	'retina_wood-300x300.png',	'image/png',	27221,	'retina_wood-300x300.png',	0,	'retina_wood-300x300.png',	'05d23cd8298834d4bdfad5ff086e8896.png',	'/school2015/bg'),
(237,	'bg',	6,	9,	'img',	'dot.jpg',	'image/jpeg',	574,	'dot.jpg',	0,	'dot.jpg',	'669d731cf8e6408abe2cec81736ad3b9.jpg',	'/school2015/bg'),
(236,	'bg',	6,	8,	'img',	'body-bg13.png',	'image/png',	222336,	'body-bg13.png',	0,	'body-bg13.png',	'aa3fc0bbdb5078428974cbe3c099b8bc.png',	'/school2015/bg'),
(235,	'bg',	6,	7,	'img',	'bg_body-top.jpg',	'image/jpeg',	11850,	'bg_body-top.jpg',	0,	'bg_body-top.jpg',	'e81551eef9184dfb13f68af33a8ba0c4.jpg',	'/school2015/bg'),
(234,	'bg',	6,	6,	'img',	'bg3.gif',	'image/gif',	367206,	'bg3.gif',	0,	'bg3.gif',	'aa5395c1724ab850b219b7d40d6e2fa0.gif',	'/school2015/bg'),
(233,	'bg',	6,	5,	'img',	'bg2.gif',	'image/gif',	76,	'bg2.gif',	0,	'bg2.gif',	'4ce172ff81f7ada2d9363fa9ea15c24e.gif',	'/school2015/bg'),
(232,	'bg',	6,	4,	'img',	'bg.jpg',	'image/jpeg',	112590,	'bg.jpg',	0,	'bg.jpg',	'2a41920a7bdf579f981c1c90c111e1d4.jpg',	'/school2015/bg'),
(231,	'bg',	6,	3,	'img',	'bg.gif',	'image/gif',	49,	'bg.gif',	0,	'bg.gif',	'79ede82f29a0ea66da178e959f773677.gif',	'/school2015/bg'),
(230,	'bg',	6,	2,	'img',	'419.png',	'image/png',	1616,	'419.png',	0,	'419.png',	'bd63b03112d21665ece7aa9b91121305.png',	'/school2015/bg'),
(229,	'bg',	6,	1,	'img',	'158.gif',	'image/gif',	145,	'158.gif',	0,	'158.gif',	'e0440b6623ca08d6f1e004cf9fd7794d.gif',	'/school2015/bg'),
(228,	'config2_footer_img',	5,	1,	'img',	'foot.jpg',	'image/jpeg',	7151,	'foot.jpg',	0,	'foot.jpg',	'cd86b2f051a7f7d4e9b718b80e0c94cd.jpg',	'/school2015/config2'),
(269,	'bt_bg_centerBottomLeftBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'd02910720493f906d3e0d33a10991f1f.gif',	'/school2015/bt_bg'),
(270,	'bt_bg_centerBottomLeftBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'16385d8c0a6e98beddb584fb48d016db.gif',	'/school2015/bt_bg'),
(271,	'bt_bg_centerBottomLeftBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'59a8ebda7633d9cae4509aece3df979f.gif',	'/school2015/bt_bg'),
(272,	'bt_bg_centerBottomRightBlock',	6,	1,	'img',	'blue.gif',	'image/gif',	1352,	'blue.gif',	0,	'blue.gif',	'24a6625a68ee78fa1d4ded4c3638315b.gif',	'/school2015/bt_bg'),
(273,	'bt_bg_centerBottomRightBlock',	6,	2,	'img',	'green.gif',	'image/gif',	1411,	'green.gif',	0,	'green.gif',	'01a9889d865c01b4d40913d95b8972da.gif',	'/school2015/bt_bg'),
(274,	'bt_bg_centerBottomRightBlock',	6,	3,	'img',	'orange.gif',	'image/gif',	1406,	'orange.gif',	0,	'orange.gif',	'63bf1797c8ba29dc56b54a85f5fdb37c.gif',	'/school2015/bt_bg'),
(275,	'bt_bg_centerBottomRightBlock',	6,	4,	'img',	'red.gif',	'image/gif',	1403,	'red.gif',	0,	'red.gif',	'b60089dfdbb133f4966beba473608a8d.gif',	'/school2015/bt_bg'),
(276,	'config2_footer_img',	6,	1,	'img',	'foot.jpg',	'image/jpeg',	7151,	'foot.jpg',	0,	'foot.jpg',	'd9519ceb405a0a2eea072bffeb505e31.jpg',	'/school2015/config2');

DROP TABLE IF EXISTS `xx_tad_themes_menu`;
CREATE TABLE `xx_tad_themes_menu` (
  `menuid` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `of_level` smallint(5) unsigned NOT NULL DEFAULT '0',
  `position` smallint(5) unsigned NOT NULL DEFAULT '0',
  `itemname` varchar(255) NOT NULL DEFAULT '',
  `itemurl` varchar(255) NOT NULL DEFAULT '',
  `membersonly` enum('0','1') NOT NULL,
  `status` enum('1','0') NOT NULL,
  `mainmenu` enum('0','1') NOT NULL DEFAULT '0',
  `target` varchar(255) NOT NULL DEFAULT '',
  `icon` varchar(255) NOT NULL DEFAULT 'icon-th-list',
  PRIMARY KEY (`menuid`),
  KEY `of_level` (`of_level`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_tplfile`;
CREATE TABLE `xx_tplfile` (
  `tpl_id` mediumint(7) unsigned NOT NULL AUTO_INCREMENT,
  `tpl_refid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `tpl_module` varchar(25) NOT NULL DEFAULT '',
  `tpl_tplset` varchar(50) NOT NULL DEFAULT '',
  `tpl_file` varchar(50) NOT NULL DEFAULT '',
  `tpl_desc` varchar(255) NOT NULL DEFAULT '',
  `tpl_lastmodified` int(10) unsigned NOT NULL DEFAULT '0',
  `tpl_lastimported` int(10) unsigned NOT NULL DEFAULT '0',
  `tpl_type` varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`tpl_id`),
  UNIQUE KEY `tpl_refid_module_set_file_type` (`tpl_refid`,`tpl_module`,`tpl_tplset`,`tpl_file`,`tpl_type`),
  KEY `tpl_refid` (`tpl_refid`,`tpl_type`),
  KEY `tpl_tplset` (`tpl_tplset`,`tpl_file`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tplfile` (`tpl_id`, `tpl_refid`, `tpl_module`, `tpl_tplset`, `tpl_file`, `tpl_desc`, `tpl_lastmodified`, `tpl_lastimported`, `tpl_type`) VALUES
(1,	1,	'system',	'default',	'system_imagemanager.html',	'',	1403235685,	0,	'module'),
(2,	1,	'system',	'default',	'system_imagemanager2.html',	'',	1403235685,	0,	'module'),
(3,	1,	'system',	'default',	'system_userinfo.html',	'',	1403235685,	0,	'module'),
(4,	1,	'system',	'default',	'system_userform.html',	'',	1403235685,	0,	'module'),
(5,	1,	'system',	'default',	'system_rss.html',	'',	1403235685,	0,	'module'),
(6,	1,	'system',	'default',	'system_redirect.html',	'',	1403235685,	0,	'module'),
(7,	1,	'system',	'default',	'system_comment.html',	'',	1403235685,	0,	'module'),
(8,	1,	'system',	'default',	'system_comments_flat.html',	'',	1403235685,	0,	'module'),
(9,	1,	'system',	'default',	'system_comments_thread.html',	'',	1403235685,	0,	'module'),
(10,	1,	'system',	'default',	'system_comments_nest.html',	'',	1403235685,	0,	'module'),
(11,	1,	'system',	'default',	'system_siteclosed.html',	'',	1403235685,	0,	'module'),
(12,	1,	'system',	'default',	'system_dummy.html',	'',	1403235685,	0,	'module'),
(13,	1,	'system',	'default',	'system_notification_list.html',	'',	1403235685,	0,	'module'),
(14,	1,	'system',	'default',	'system_notification_select.html',	'',	1403235685,	0,	'module'),
(15,	1,	'system',	'default',	'system_block_dummy.html',	'',	1403235685,	0,	'module'),
(16,	1,	'system',	'default',	'system_homepage.html',	'',	1403235685,	0,	'module'),
(17,	1,	'system',	'default',	'system_bannerlogin.html',	'',	1403235685,	0,	'module'),
(18,	1,	'system',	'default',	'system_banner.html',	'',	1403235685,	0,	'module'),
(19,	1,	'system',	'default',	'system_bannerdisplay.html',	'',	1403235685,	0,	'module'),
(20,	1,	'system',	'default',	'system_header.html',	'',	1403235685,	0,	'admin'),
(21,	1,	'system',	'default',	'system_banners.html',	'',	1403235685,	0,	'admin'),
(22,	1,	'system',	'default',	'system_modules.html',	'',	1403235685,	0,	'admin'),
(23,	1,	'system',	'default',	'system_modules_confirm.html',	'',	1403235685,	0,	'admin'),
(24,	1,	'system',	'default',	'system_avatars.html',	'',	1403235685,	0,	'admin'),
(25,	1,	'system',	'default',	'system_smilies.html',	'',	1403235685,	0,	'admin'),
(26,	1,	'system',	'default',	'system_blocks.html',	'',	1403235685,	0,	'admin'),
(27,	1,	'system',	'default',	'system_blocks_item.html',	'',	1403235685,	0,	'admin'),
(28,	1,	'system',	'default',	'system_comments.html',	'',	1403235685,	0,	'admin'),
(29,	1,	'system',	'default',	'system_userrank.html',	'',	1403235685,	0,	'admin'),
(30,	1,	'system',	'default',	'system_users.html',	'',	1403235685,	0,	'admin'),
(31,	1,	'system',	'default',	'system_preferences.html',	'',	1403235685,	0,	'admin'),
(32,	1,	'system',	'default',	'system_mailusers.html',	'',	1403235685,	0,	'admin'),
(33,	1,	'system',	'default',	'system_groups.html',	'',	1403235685,	0,	'admin'),
(34,	1,	'system',	'default',	'system_images.html',	'',	1403235685,	0,	'admin'),
(35,	1,	'system',	'default',	'system_templates.html',	'',	1403235685,	0,	'admin'),
(36,	1,	'system',	'default',	'system_index.html',	'',	1403235685,	0,	'admin'),
(37,	1,	'system',	'default',	'system_maintenance.html',	'',	1403235686,	0,	'admin'),
(38,	1,	'system',	'default',	'system_help.html',	'',	1403235686,	0,	'admin'),
(39,	1,	'system',	'default',	'system_block_user.html',	'Shows user block',	1403235686,	0,	'block'),
(40,	2,	'system',	'default',	'system_block_login.html',	'Shows login form',	1403235686,	0,	'block'),
(41,	3,	'system',	'default',	'system_block_search.html',	'Shows search form block',	1403235686,	0,	'block'),
(42,	4,	'system',	'default',	'system_block_waiting.html',	'Shows contents waiting for approval',	1403235686,	0,	'block'),
(43,	5,	'system',	'default',	'system_block_mainmenu.html',	'Shows the main navigation menu of the site',	1403235686,	0,	'block'),
(44,	6,	'system',	'default',	'system_block_siteinfo.html',	'Shows basic info about the site and a link to Recommend Us pop up window',	1403235686,	0,	'block'),
(45,	7,	'system',	'default',	'system_block_online.html',	'Displays users/guests currently online',	1403235686,	0,	'block'),
(46,	8,	'system',	'default',	'system_block_topusers.html',	'Top posters',	1403235686,	0,	'block'),
(47,	9,	'system',	'default',	'system_block_newusers.html',	'Shows most recent users',	1403235686,	0,	'block'),
(48,	10,	'system',	'default',	'system_block_comments.html',	'Shows most recent comments',	1403235686,	0,	'block'),
(49,	11,	'system',	'default',	'system_block_notification.html',	'Shows notification options',	1403235686,	0,	'block'),
(50,	12,	'system',	'default',	'system_block_themes.html',	'Shows theme selection box',	1403235686,	0,	'block'),
(179,	4,	'tadtools',	'default',	'tadtools_adm_index_tpl.html',	'tadtools_adm_index_tpl.html',	1436803340,	0,	'module'),
(60,	19,	'tad_themes',	'default',	'tad_themes_responsive_slider.html',	'佈景首頁滑動區塊',	1436803402,	0,	'block'),
(174,	5,	'tad_adm',	'default',	'tad_adm_adm_phpini.html',	'tad_adm_adm_phpini.html',	1436803369,	0,	'module'),
(173,	5,	'tad_adm',	'default',	'tad_adm_adm_spam.html',	'tad_adm_adm_spam.html',	1436803369,	0,	'module'),
(172,	5,	'tad_adm',	'default',	'tad_adm_adm_main.html',	'tad_adm_adm_main.html',	1436803368,	0,	'module'),
(65,	20,	'tad_adm',	'default',	'tad_adm_new.html',	'新的垃圾帳戶區塊',	1436803369,	0,	'block'),
(177,	3,	'tad_themes',	'default',	'tad_themes_adm_main_tpl.html',	'tad_themes_adm_main_tpl.html',	1436803398,	0,	'module'),
(178,	3,	'tad_themes',	'default',	'tad_themes_adm_dropdown_tpl.html',	'tad_themes_adm_dropdown_tpl.html',	1436803401,	0,	'module'),
(180,	1,	'system',	'default',	'system_modules_install.html',	'',	1403235685,	0,	'admin'),
(181,	1,	'system',	'default',	'system_modules_result.html',	'',	1403235685,	0,	'admin'),
(182,	1,	'system',	'default',	'system_comments_list.html',	'',	1403235685,	0,	'admin'),
(183,	1,	'system',	'default',	'system_filemanager.html',	'',	1403235685,	0,	'admin'),
(184,	54,	'tad_themes',	'default',	'tad_themes_top_menu.html',	'上方隱藏選單區塊',	1436803402,	0,	'block'),
(185,	55,	'tad_themes',	'default',	'vertical_bootstrap_menu.html',	'垂直BootStrap選單',	1436803402,	0,	'block'),
(186,	56,	'tad_themes',	'default',	'vertical_menu.html',	'垂直選單',	1436803402,	0,	'block'),
(196,	60,	'tadtools',	'default',	'tadtools_qrcode.html',	'QR Code 區塊區塊 (tadtools_qrcode)',	1431679256,	1431679256,	'block'),
(189,	5,	'tad_adm',	'default',	'tad_adm_adm_main_b3.html',	'tad_adm_adm_main_b3.html',	1436803369,	0,	'module'),
(190,	5,	'tad_adm',	'default',	'tad_adm_adm_spam_b3.html',	'tad_adm_adm_spam_b3.html',	1436803369,	0,	'module'),
(191,	5,	'tad_adm',	'default',	'tad_adm_adm_phpini_b3.html',	'tad_adm_adm_phpini_b3.html',	1436803369,	0,	'module'),
(192,	4,	'tadtools',	'default',	'tadtools_adm_index_tpl_b3.html',	'tadtools_adm_index_tpl_b3.html',	1436803341,	0,	'module'),
(193,	58,	'tadtools',	'default',	'tadtools_qrcode.html',	'QR Code 區塊區塊 (tadtools_qrcode)',	1431678820,	1431396099,	'block'),
(194,	3,	'tad_themes',	'default',	'tad_themes_adm_main_tpl_b3.html',	'tad_themes_adm_main_tpl_b3.html',	1436803400,	0,	'module'),
(195,	3,	'tad_themes',	'default',	'tad_themes_adm_dropdown_tpl_b3.html',	'tad_themes_adm_dropdown_tpl_b3.html',	1436803402,	0,	'module'),
(197,	61,	'tadtools',	'default',	'tadtools_qrcode.html',	'QR Code 區塊區塊 (tadtools_qrcode)',	1436803341,	1436803341,	'block');

DROP TABLE IF EXISTS `xx_tplset`;
CREATE TABLE `xx_tplset` (
  `tplset_id` int(7) unsigned NOT NULL AUTO_INCREMENT,
  `tplset_name` varchar(50) NOT NULL DEFAULT '',
  `tplset_desc` varchar(255) NOT NULL DEFAULT '',
  `tplset_credits` text,
  `tplset_created` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`tplset_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tplset` (`tplset_id`, `tplset_name`, `tplset_desc`, `tplset_credits`, `tplset_created`) VALUES
(1,	'default',	'XOOPS Default Template Set',	'',	1341588017);

DROP TABLE IF EXISTS `xx_tplsource`;
CREATE TABLE `xx_tplsource` (
  `tpl_id` mediumint(7) unsigned NOT NULL DEFAULT '0',
  `tpl_source` mediumtext,
  KEY `tpl_id` (`tpl_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_tplsource` (`tpl_id`, `tpl_source`) VALUES
(1,	'<!DOCTYPE html PUBLIC \'-//W3C//DTD XHTML 1.0 Transitional//EN\' \'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\'>\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"<{$xoops_langcode}>\" lang=\"<{$xoops_langcode}>\">\r\n<head>\r\n<meta http-equiv=\"content-type\" content=\"text/html; charset=<{$xoops_charset}>\" />\r\n<meta http-equiv=\"content-language\" content=\"<{$xoops_langcode}>\" />\r\n<title><{$sitename}> <{$lang_imgmanager}></title>\r\n<script type=\"text/javascript\">\r\n<!--//\r\nfunction appendCode(addCode) {\r\n	var targetDom = window.opener.xoopsGetElementById(\'<{$target}>\');\r\n	if (targetDom.createTextRange && targetDom.caretPos){\r\n  		var caretPos = targetDom.caretPos;\r\n		caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == \' \' ? addCode + \' \' : addCode;  \r\n	} else if (targetDom.getSelection && targetDom.caretPos) {\r\n		var caretPos = targetDom.caretPos;\r\n		caretPos.text = caretPos.text.charat(caretPos.text.length - 1) == \' \' ? addCode + \' \' : addCode;\r\n	} else {\r\n		targetDom.value = targetDom.value + addCode;\r\n  	}\r\n	window.close();\r\n	return;\r\n}\r\n//-->\r\n</script>\r\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"<{xoAppUrl xoops.css}>\" />\r\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"<{xoAppUrl modules/system/css/imagemanager.css}>\" />\r\n\r\n<{php}> \r\n$language = $GLOBALS[\'xoopsConfig\'][\'language\'];\r\nif(file_exists(XOOPS_ROOT_PATH.\'/language/\'.$language.\'/style.css\')){ \r\necho \"<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"language/$language/style.css\" />\";\r\n}\r\n<{/php}>\r\n\r\n</head>\r\n\r\n<body onload=\"window.resizeTo(<{$xsize}>, <{$ysize}>);\">\r\n  <form action=\"imagemanager.php\" method=\"get\">\r\n    <table cellspacing=\"0\" id=\"imagenav\">\r\n      <tr>\r\n        <td>\r\n          <select name=\"cat_id\" onchange=\"location=\'<{$xoops_url}>/imagemanager.php?target=<{$target}>&cat_id=\'+this.options[this.selectedIndex].value\"><{$cat_options}></select> \r\n          <input type=\"hidden\" name=\"target\" value=\"<{$target}>\" />\r\n          <input type=\"submit\" value=\"<{$lang_go}>\" />\r\n        </td>\r\n\r\n        <{if $show_cat > 0}>\r\n        <td id=\"addimage\" class=\"txtright\"><a href=\"<{$xoops_url}>/imagemanager.php?target=<{$target}>&op=upload&imgcat_id=<{$show_cat}>\" title=\"<{$lang_addimage}>\"><{$lang_addimage}></a></td>\r\n        <{/if}>\r\n        \r\n      </tr>\r\n    </table>\r\n  </form>\r\n  <div id=\"pagenav\"><{$pagenav}></div>\r\n  <{if $image_total > 0}>\r\n  \r\n  <table cellspacing=\"0\" id=\"imagemain\">\r\n    <tr>\r\n      <th><{$lang_imagename}></th>\r\n      <th><{$lang_image}></th>\r\n      <th><{$lang_imagemime}></th>\r\n      <th><{$lang_align}></th>\r\n    </tr>\r\n\r\n    <{section name=i loop=$images}>\r\n    <tr class=\"txtcenter\">\r\n      <td><input type=\"hidden\" name=\"image_id[]\" value=\"<{$images[i].id}>\" /><{$images[i].nicename}></td>\r\n      <td><img style=\"max-width:200px;\" src=\"<{$images[i].src}>\" alt=\"\" /></td>\r\n      <td><{$images[i].mimetype}></td>\r\n      <td><a href=\"#\" title=\"\" onclick=\"javascript:appendCode(\'<{$images[i].lxcode}>\');\" title=\"\"><img src=\"<{xoAppUrl images/alignleft.gif}>\" alt=\"Left\" /></a> <a href=\"#\" title=\"\" onclick=\"javascript:appendCode(\'<{$images[i].xcode}>\');\" title=\"\"><img src=\"<{xoAppUrl images/aligncenter.gif}>\" alt=\"Center\" /></a> <a href=\"#\" title=\"\" onclick=\"javascript:appendCode(\'<{$images[i].rxcode}>\');\" title=\"\"><img src=\"<{xoAppUrl images/alignright.gif}>\" alt=\"Right\" /></a></td>\r\n    </tr>\r\n    <{/section}>\r\n  </table>\r\n  <{else}>\r\n  <div id=\"welcomenot\"></div>\r\n  <{/if}>\r\n\r\n  <div id=\"pagenav\"><{$pagenav}></div>\r\n\r\n  <div id=\"footer\">\r\n    <input value=\"<{$lang_close}>\" type=\"button\" onclick=\"javascript:window.close();\" />\r\n  </div>\r\n\r\n  </body>\r\n</html>'),
(2,	'<!DOCTYPE html PUBLIC \'-//W3C//DTD XHTML 1.0 Transitional//EN\' \'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\'>\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"<{$xoops_langcode}>\" lang=\"<{$xoops_langcode}>\">\r\n<head>\r\n<meta http-equiv=\"content-type\" content=\"text/html; charset=<{$xoops_charset}>\" />\r\n<meta http-equiv=\"content-language\" content=\"<{$xoops_langcode}>\" />\r\n<title><{$xoops_sitename}> <{$lang_imgmanager}></title>\r\n<{$image_form.javascript}>\r\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"<{xoAppUrl xoops.css}>\" />\r\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"<{xoAppUrl modules/system/css/imagemanager.css}>\" />\r\n\r\n<{php}> \r\n$language = $GLOBALS[\'xoopsConfig\'][\'language\'];\r\nif(file_exists(XOOPS_ROOT_PATH.\'/language/\'.$language.\'/style.css\')){ \r\necho \"<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"language/$language/style.css\" />\";\r\n}\r\n<{/php}>\r\n\r\n</head>\r\n\r\n<body onload=\"window.resizeTo(<{$xsize}>, <{$ysize}>);\">\r\n   <table cellspacing=\"0\" id=\"imagenav\">\r\n    <tr>\r\n      <td id=\"addimage\" class=\"txtleft\"><a href=\"<{$xoops_url}>/imagemanager.php?target=<{$target}>&amp;cat_id=<{$show_cat}>\" title=\"<{$lang_imgmanager}>\"><{$lang_imgmanager}></a></td>\r\n    </tr>\r\n  </table>\r\n\r\n  <form name=\"<{$image_form.name}>\" id=\"<{$image_form.name}>\" action=\"<{$image_form.action}>\" method=\"<{$image_form.method}>\" <{$image_form.extra}>>\r\n    <table id=\"imageform\" cellspacing=\"\">\r\n    <!-- start of form elements loop -->\r\n    <{foreach item=element from=$image_form.elements}>\r\n      <{if $element.hidden != true}>\r\n      <tr class=\"aligntop\">\r\n        <td class=\"caption\"><{$element.caption}></td>\r\n        <td class=\"body\"><{$element.body}></td>\r\n      </tr>\r\n      <{else}>\r\n      <{$element.body}>\r\n      <{/if}>\r\n    <{/foreach}>\r\n    <!-- end of form elements loop -->\r\n    </table>\r\n  </form>\r\n\r\n\r\n  <div id=\"footer\">\r\n    <input value=\"<{$lang_close}>\" type=\"button\" onclick=\"javascript:window.close();\" />\r\n  </div>\r\n\r\n  </body>\r\n</html>'),
(3,	'<{if $user_ownpage == true}>\r\n\r\n<form name=\"usernav\" action=\"user.php\" method=\"post\">\r\n\r\n<br /><br />\r\n\r\n<table class=\"width70 aligncenter bnone\">\r\n  <tr class=\"txtcenter\">\r\n    <td><input type=\"button\" value=\"<{$lang_editprofile}>\" onclick=\"location=\'edituser.php\'\" />\r\n    <input type=\"button\" value=\"<{$lang_avatar}>\" onclick=\"location=\'edituser.php?op=avatarform\'\" />\r\n    <input type=\"button\" value=\"<{$lang_inbox}>\" onclick=\"location=\'viewpmsg.php\'\" />\r\n\r\n    <{if $user_candelete == true}>\r\n    <input type=\"button\" value=\"<{$lang_deleteaccount}>\" onclick=\"location=\'user.php?op=delete\'\" />\r\n    <{/if}>\r\n\r\n    <input type=\"button\" value=\"<{$lang_logout}>\" onclick=\"location=\'user.php?op=logout\'\" /></td>\r\n  </tr>\r\n</table>\r\n</form>\r\n\r\n<br /><br />\r\n<{elseif $xoops_isadmin != false}>\r\n\r\n<br /><br />\r\n\r\n<table class=\"width70 aligncenter bnone\">\r\n  <tr class=\"txtcenter\">\r\n    <td><input type=\"button\" value=\"<{$lang_editprofile}>\" onclick=\"location=\'<{$xoops_url}>/modules/system/admin.php?fct=users&amp;uid=<{$user_uid}>&amp;op=modifyUser\'\" />\r\n    <input type=\"button\" value=\"<{$lang_deleteaccount}>\" onclick=\"location=\'<{$xoops_url}>/modules/system/admin.php?fct=users&amp;op=delUser&amp;uid=<{$user_uid}>\'\" />\r\n  </tr>\r\n</table>\r\n\r\n<br /><br />\r\n<{/if}>\r\n\r\n<table class=\"width100 bnone\" cellspacing=\"5\">\r\n  <tr class=\"aligntop\">\r\n    <td class=\"width50\">\r\n      <table class=\"outer width100\" cellpadding=\"4\" cellspacing=\"1\">\r\n        <tr>\r\n          <th colspan=\"2\" class=\"txtcenter\"><{$lang_allaboutuser}></th>\r\n        </tr>\r\n        <{if $user_avatarurl}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_avatar}></td>\r\n          <td class=\"even txt center\"><img src=\"<{$user_avatarurl}>\" alt=\"Avatar\" /></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_realname}>\r\n        <tr>\r\n          <td class=\"head\"><{$lang_realname}></td>\r\n          <td class=\"odd center\"><{$user_realname}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_websiteurl}>\r\n        <tr>\r\n          <td class=\"head\"><{$lang_website}></td>\r\n          <td class=\"even\"><{$user_websiteurl}></td>\r\n        </tr>\r\n\r\n        <{/if}>\r\n        <{if $user_email}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_email}></td>\r\n          <td class=\"odd\"><{$user_email}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if !$user_ownpage == true}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_privmsg}></td>\r\n          <td class=\"even\"><{$user_pmlink}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_icq}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_icq}></td>\r\n          <td class=\"odd\"><{$user_icq}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_aim}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_aim}></td>\r\n          <td class=\"even\"><{$user_aim}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_yim}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_yim}></td>\r\n          <td class=\"odd\"><{$user_yim}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_msnm}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_msnm}></td>\r\n          <td class=\"even\"><{$user_msnm}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_location}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_location}></td>\r\n          <td class=\"odd\"><{$user_location}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_occupation}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_occupation}></td>\r\n          <td class=\"even\"><{$user_occupation}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_interest}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_interest}></td>\r\n          <td class=\"odd\"><{$user_interest}></td>\r\n        </tr>\r\n        <{/if}>\r\n        <{if $user_extrainfo}>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_extrainfo}></td>\r\n          <td class=\"even\"><{$user_extrainfo}></td>\r\n        </tr>\r\n        <{/if}>\r\n      </table>\r\n    </td>\r\n    <td class=\"width50\">\r\n      <table class=\"outer width100\" cellpadding=\"4\" cellspacing=\"1\">\r\n        <tr class=\"aligntop\">\r\n          <th class=\"txtcenter\" colspan=\"2\"><{$lang_statistics}></th>\r\n        </tr>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_membersince}></td>\r\n          <td class=\"even txtcenter\"><{$user_joindate}></td>\r\n        </tr>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_rank}></td>\r\n          <td class=\"odd txtcenter\"><{$user_rankimage}><br /><{$user_ranktitle}></td>\r\n        </tr>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_posts}></td>\r\n          <td class=\"even txtcenter\"><{$user_posts}></td>\r\n        </tr>\r\n    <tr class=\"aligntop\">\r\n          <td class=\"head\"><{$lang_lastlogin}></td>\r\n          <td class=\"odd center\"><{$user_lastlogin}></td>\r\n        </tr>\r\n      </table>\r\n      <{if $user_signature}>\r\n      <br />\r\n      <table class=\"outer width100\" cellpadding=\"4\" cellspacing=\"1\">\r\n        <tr class=\"aligntop\">\r\n          <th colspan=\"2\" class=\"txtcenter\"><{$lang_signature}></th>\r\n        </tr>\r\n        <tr class=\"aligntop\">\r\n          <td class=\"even\"><{$user_signature}></td>\r\n        </tr>\r\n      </table>\r\n      <{/if}>\r\n    </td>\r\n  </tr>\r\n</table>\r\n\r\n<!-- start module search results loop -->\r\n<{foreach item=module from=$modules}>\r\n\r\n<br class=\"clear\" />\r\n<h4><{$module.name}></h4>\r\n\r\n  <!-- start results item loop -->\r\n  <{foreach item=result from=$module.results}>\r\n\r\n  <img src=\"<{$result.image}>\" alt=\"<{$module.name}>\" /><strong><a href=\"<{$result.link}>\" title=\"<{$result.title}>\"><{$result.title}></a></strong><br /><span class=\"x-small\">(<{$result.time}>)</span><br />\r\n\r\n  <{/foreach}>\r\n  <!-- end results item loop -->\r\n\r\n<{$module.showall_link}>\r\n\r\n\r\n<{/foreach}>\r\n<!-- end module search results loop -->'),
(4,	'<fieldset class=\"pad10\">\r\n  <legend class=\"bold\"><{$lang_login}></legend>\r\n  <form action=\"user.php\" method=\"post\">\r\n    <{$lang_username}> <input type=\"text\" name=\"uname\" size=\"26\" maxlength=\"25\" value=\"<{$usercookie}>\" /><br /><br />\r\n    <{$lang_password}> <input type=\"password\" name=\"pass\" size=\"21\" maxlength=\"32\" /><br /><br />\r\n    <{if isset($lang_rememberme)}>\r\n        <input type=\"checkbox\" name=\"rememberme\" value=\"On\" checked /> <{$lang_rememberme}><br /><br />\r\n    <{/if}>\r\n    \r\n    <input type=\"hidden\" name=\"op\" value=\"login\" />\r\n    <input type=\"hidden\" name=\"xoops_redirect\" value=\"<{$redirect_page}>\" />\r\n    <input type=\"submit\" value=\"<{$lang_login}>\" />\r\n  </form>\r\n  <br />\r\n  <a name=\"lost\"></a>\r\n  <div><{$lang_notregister}><br /></div>\r\n</fieldset>\r\n\r\n<br />\r\n\r\n<fieldset class=\"pad10\">\r\n  <legend class=\"bold\"><{$lang_lostpassword}></legend>\r\n  <div><br /><{$lang_noproblem}></div>\r\n  <form action=\"lostpass.php\" method=\"post\">\r\n    <{$lang_youremail}> <input type=\"text\" name=\"email\" size=\"26\" maxlength=\"60\" />&nbsp;&nbsp;<input type=\"hidden\" name=\"op\" value=\"mailpasswd\" /><input type=\"hidden\" name=\"t\" value=\"<{$mailpasswd_token}>\" /><input type=\"submit\" value=\"<{$lang_sendpassword}>\" />\r\n  </form>\r\n</fieldset>'),
(5,	'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n<rss version=\"2.0\">\r\n  <channel>\r\n    <title><{$channel_title}></title>\r\n    <link><{$channel_link}></link>\r\n    <description><{$channel_desc}></description>\r\n    <lastBuildDate><{$channel_lastbuild}></lastBuildDate>\r\n    <docs>http://backend.userland.com/rss/</docs>\r\n    <generator><{$channel_generator}></generator>\r\n    <category><{$channel_category}></category>\r\n    <managingEditor><{$channel_editor}></managingEditor>\r\n    <webMaster><{$channel_webmaster}></webMaster>\r\n    <language><{$channel_language}></language>\r\n    <{if $image_url != \"\"}>\r\n    <image>\r\n      <title><{$channel_title}></title>\r\n      <url><{$image_url}></url>\r\n      <link><{$channel_link}></link>\r\n      <width><{$image_width}></width>\r\n      <height><{$image_height}></height>\r\n    </image>\r\n    <{/if}>\r\n    <{foreach item=item from=$items}>\r\n    <item>\r\n      <title><{$item.title}></title>\r\n      <link><{$item.link}></link>\r\n      <description><{$item.description}></description>\r\n      <pubDate><{$item.pubdate}></pubDate>\r\n      <guid><{$item.guid}></guid>\r\n    </item>\r\n    <{/foreach}>\r\n  </channel>\r\n</rss>'),
(6,	'<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html>\r\n<head>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=<{$xoops_charset}>\" />\r\n<meta http-equiv=\"Refresh\" content=\"<{$time}>; url=<{$url}>\" />\r\n<meta name=\"generator\" content=\"XOOPS\" />\r\n<link rel=\"shortcut icon\" type=\"image/ico\" href=\"<{xoAppUrl favicon.ico}>\" />\r\n<title><{$xoops_sitename}></title>\r\n<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" href=\"<{$xoops_themecss}>\" />\r\n</head>\r\n<body>\r\n<div class=\"center bold\" style=\"background-color: #ebebeb; border-top: 1px solid #fff; border-left: 1px solid #fff; border-right: 1px solid #aaa; border-bottom: 1px solid #aaa;\">\r\n  <h4><{$message}></h4>\r\n  <p><{$lang_ifnotreload}></p>\r\n</div>\r\n<{if $xoops_logdump != \'\'}><div><{$xoops_logdump}></div><{/if}>\r\n</body>\r\n</html>'),
(7,	'<!-- start comment post -->\r\n        <tr>\r\n          <td class=\"head\"><a id=\"comment<{$comment.id}>\"></a> <{$comment.poster.uname}></td>\r\n          <td class=\"head\"><div class=\"comDate\"><span class=\"comDateCaption\"><{$lang_posted}>:</span> <{$comment.date_posted}>&nbsp;&nbsp;<span class=\"comDateCaption\"><{$lang_updated}>:</span> <{$comment.date_modified}></div></td>\r\n        </tr>\r\n        <tr>\r\n\r\n          <{if $comment.poster.id != 0}>\r\n\r\n          <td class=\"odd\">\r\n			<div class=\"comUserRank\">\r\n				<div class=\"comUserRankText\"><{$comment.poster.rank_title}></div>\r\n				<img class=\"comUserRankImg\" src=\"<{$xoops_upload_url}>/<{$comment.poster.rank_image}>\" alt=\"\" />\r\n			</div>\r\n			<img class=\"comUserImg\" src=\"<{$xoops_upload_url}>/<{$comment.poster.avatar}>\" alt=\"\" />\r\n			<div class=\"comUserStat\"><span class=\"comUserStatCaption\"><{$lang_joined}>:</span> <{$comment.poster.regdate}></div>\r\n			<div class=\"comUserStat\"><span class=\"comUserStatCaption\"><{$lang_from}>:</span> <{$comment.poster.from}></div>\r\n			<div class=\"comUserStat\"><span class=\"comUserStatCaption\"><{$lang_posts}>:</span> <{$comment.poster.postnum}></div>\r\n			<div class=\"comUserStatus\"><{$comment.poster.status}></div></td>\r\n\r\n          <{else}>\r\n\r\n          <td class=\"odd\"> </td>\r\n\r\n          <{/if}>\r\n\r\n          <td class=\"odd\">\r\n            <div class=\"comTitle\"><{$comment.image}><{$comment.title}></div>\r\n			<div class=\"comText\"><{$comment.text}></div>\r\n          </td>\r\n        </tr>\r\n        <tr>\r\n          <td class=\"even\"></td>\r\n\r\n          <{if $xoops_iscommentadmin == true}>\r\n\r\n          <td class=\"even txtright\">\r\n            <a href=\"<{$editcomment_link}>&amp;com_id=<{$comment.id}>\" title=\"<{$lang_edit}>\"><img src=\"<{$xoops_url}>/images/icons/edit.gif\" alt=\"<{$lang_edit}>\" /></a>\r\n			<a href=\"<{$deletecomment_link}>&amp;com_id=<{$comment.id}>\" title=\"<{$lang_delete}>\"><img src=\"<{$xoops_url}>/images/icons/delete.gif\" alt=\"<{$lang_delete}>\" /></a>\r\n			<a href=\"<{$replycomment_link}>&amp;com_id=<{$comment.id}>\" title=\"<{$lang_reply}>\"><img src=\"<{$xoops_url}>/images/icons/reply.gif\" alt=\"<{$lang_reply}>\" /></a>\r\n          </td>\r\n\r\n          <{elseif $xoops_isuser == true && $xoops_userid == $comment.poster.id}>\r\n\r\n          <td class=\"even txtright\">\r\n            <a href=\"<{$editcomment_link}>&amp;com_id=<{$comment.id}>\" title=\"<{$lang_edit}>\"><img src=\"<{$xoops_url}>/images/icons/edit.gif\" alt=\"<{$lang_edit}>\" /></a>\r\n			<a href=\"<{$replycomment_link}>&amp;com_id=<{$comment.id}>\" title=\"<{$lang_reply}>\"><img src=\"<{$xoops_url}>/images/icons/reply.gif\" alt=\"<{$lang_reply}>\" /></a>\r\n          </td>\r\n\r\n          <{elseif $xoops_isuser == true || $anon_canpost == true}>\r\n\r\n          <td class=\"even txtright\">\r\n            <a href=\"<{$replycomment_link}>&amp;com_id=<{$comment.id}>\"><img src=\"<{$xoops_url}>/images/icons/reply.gif\" alt=\"<{$lang_reply}>\" /></a>\r\n          </td>\r\n\r\n          <{else}>\r\n\r\n          <td class=\"even\"> </td>\r\n\r\n          <{/if}>\r\n\r\n        </tr>\r\n<!-- end comment post -->'),
(8,	'<table class=\"outer\" cellpadding=\"5\" cellspacing=\"1\">\r\n  <tr>\r\n    <th class=\"width20\"><{$lang_poster}></th>\r\n    <th><{$lang_thread}></th>\r\n  </tr>\r\n  <{foreach item=comment from=$comments}>\r\n    <{include file=\"db:system_comment.html\" comment=$comment}>\r\n  <{/foreach}>\r\n</table>\r\n<{if $commentform}><div class=\"commentform\"><{$commentform}></div><{/if}>'),
(9,	'<{section name=i loop=$comments}>\r\n<br />\r\n<table cellspacing=\"1\" class=\"outer\">\r\n  <tr>\r\n    <th class=\"width20\"><{$lang_poster}></th>\r\n    <th><{$lang_thread}></th>\r\n  </tr>\r\n  <{include file=\"db:system_comment.html\" comment=$comments[i]}>\r\n</table>\r\n\r\n<{if $show_threadnav == true}>\r\n<div class=\"txtleft marg3 pad5\">\r\n<a href=\"<{$comment_url}>\" title=\"<{$lang_top}>\"><{$lang_top}></a> | <a href=\"<{$comment_url}>&amp;com_id=<{$comments[i].pid}>&amp;com_rootid=<{$comments[i].rootid}>#newscomment<{$comments[i].pid}>\"><{$lang_parent}></a>\r\n</div>\r\n<{/if}>\r\n\r\n<{if $comments[i].show_replies == true}>\r\n<!-- start comment tree -->\r\n<br />\r\n<table cellspacing=\"1\" class=\"outer\">\r\n  <tr>\r\n    <th class=\"width50\"><{$lang_subject}></th>\r\n    <th class=\"width20 txtcenter\"><{$lang_poster}></th>\r\n    <th class=\"txtright\"><{$lang_posted}></th>\r\n  </tr>\r\n  <{foreach item=reply from=$comments[i].replies}>\r\n  <tr>\r\n    <td class=\"even\"><{$reply.prefix}> <a href=\"<{$comment_url}>&amp;com_id=<{$reply.id}>&amp;com_rootid=<{$reply.root_id}>\" title=\"\"><{$reply.title}></a></td>\r\n    <td class=\"odd txtcenter\"><{$reply.poster.uname}></td>\r\n    <td class=\"even right\"><{$reply.date_posted}></td>\r\n  </tr>\r\n  <{/foreach}>\r\n</table>\r\n<!-- end comment tree -->\r\n<{/if}>\r\n\r\n<{/section}>\r\n<{if $commentform}><div class=\"commentform\"><{$commentform}></div><{/if}>'),
(10,	'<{section name=i loop=$comments}>\r\n<br />\r\n<table cellspacing=\"1\" class=\"outer\">\r\n  <tr>\r\n    <th class=\"width20\"><{$lang_poster}></th>\r\n    <th><{$lang_thread}></th>\r\n  </tr>\r\n  <{include file=\"db:system_comment.html\" comment=$comments[i]}>\r\n</table>\r\n\r\n<!-- start comment replies -->\r\n<{foreach item=reply from=$comments[i].replies}>\r\n<br />\r\n<table class=\"bnone collapse\">\r\n  <tr>\r\n    <td width=\"<{$reply.prefix}>\"></td>\r\n    <td>\r\n      <table class=\"outer\" cellspacing=\"1\">\r\n        <tr>\r\n          <th class=\"width20\"><{$lang_poster}></th>\r\n          <th><{$lang_thread}></th>\r\n        </tr>\r\n        <{include file=\"db:system_comment.html\" comment=$reply}>\r\n      </table>\r\n    </td>\r\n  </tr>\r\n</table>\r\n<{/foreach}>\r\n<!-- end comment tree -->\r\n<{/section}>\r\n<{if $commentform}><div class=\"commentform\"><{$commentform}></div><{/if}>'),
(11,	'<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"<{$xoops_langcode}>\" lang=\"<{$xoops_langcode}>\">\r\n<head>\r\n	<meta http-equiv=\"content-type\" content=\"text/html; charset=<{$xoops_charset}>\" />\r\n	<meta http-equiv=\"content-language\" content=\"<{$xoops_langcode}>\" />\r\n	<title><{$xoops_sitename}> - <{$xoops_slogan}></title>\r\n	<meta name=\"robots\" content=\"<{$xoops_meta_robots}>\" />\r\n	<meta name=\"keywords\" content=\"<{$xoops_meta_keywords}>\" />\r\n	<meta name=\"description\" content=\"<{$xoops_meta_description}>\" />\r\n	<meta name=\"rating\" content=\"<{$xoops_meta_rating}>\" />\r\n	<meta name=\"author\" content=\"<{$xoops_meta_author}>\" />\r\n	<meta name=\"copyright\" content=\"<{$xoops_meta_copyright}>\" />\r\n	<meta name=\"generator\" content=\"XOOPS\" />\r\n	\r\n	<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"<{xoAppUrl browse.php?xoops.css}>\" />\r\n	<link rel=\"shortcut icon\" type=\"image/ico\" href=\"<{xoAppUrl favicon.ico}>\" />\r\n	\r\n</head>\r\n<body>\r\n  <table class=\"collapse\">\r\n    <tr id=\"header\">\r\n      <td class=\"alignmiddle txtcenter\" style=\"width: 150px; background-color: #2F5376;\"><a href=\"<{xoAppUrl }>\" title=\"\"><img src=\"<{xoAppUrl images/logo.gif}>\" alt=\"\" /></a></td>\r\n      <td class=\"width100 alignmiddle txtcenter\" style=\"background-color: #2F5376;\">&nbsp;</td>\r\n    </tr>\r\n    <tr>\r\n      <td style=\"height: 8px; border-bottom: 1px solid silver; background-color: #ddd;\" colspan=\"2\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n\r\n  <table class=\"width80 txtcenter bnone\" cellspacing=\"1\" cellpadding=\"10\">\r\n    <tr>\r\n      <td class=\"txtcenter\"><div class=\"txtcenter bold\" style=\"background-color: #DDFFDF; color: #136C99; border-top: 1px solid #DDDDFF; border-left: 1px solid #DDDDFF; border-right: 1px solid #aaa; border-bottom: 1px solid #aaa; padding: 10px;\"><{$lang_siteclosemsg}></div></td>\r\n    </tr>\r\n  </table>\r\n  \r\n  <form action=\"<{xoAppUrl user.php}>\" method=\"post\">\r\n    <table class=\"collapse txtcenter solidsilver\" style=\"width: 200px;\">\r\n      <tr>\r\n        <th class=\"alignmiddle pad2 white\" style=\"background-color: #2F5376;\" colspan=\"2\"><{$lang_login}></th>\r\n      </tr>\r\n      <tr>\r\n        <td class=\"pad2\"><{$lang_username}></td><td class=\"pad2\"><input type=\"text\" name=\"uname\" size=\"12\" value=\"\" /></td>\r\n      </tr>\r\n      <tr>\r\n        <td class=\"pad2\"><{$lang_password}></td><td class=\"pad2\"><input type=\"password\" name=\"pass\" size=\"12\" /></td>\r\n      </tr>\r\n      <tr>\r\n        <td class=\"pad2\">&nbsp;</td>\r\n        <td class=\"pad2\">\r\n        	<input type=\"hidden\" name=\"xoops_redirect\" value=\"<{$xoops_requesturi}>\" />\r\n        	<input type=\"hidden\" name=\"xoops_login\" value=\"1\" />\r\n        	<input type=\"submit\" value=\"<{$lang_login}>\" /></td>\r\n      </tr>\r\n    </table>\r\n  </form>\r\n\r\n  <table class=\"collapse width100\">\r\n    <tr>\r\n      <td style=\"height:8px; border-bottom: 1px solid silver; border-top: 1px solid silver; background-color: #ddd;\" colspan=\"2\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n\r\n  </body>\r\n</html>'),
(12,	'<{$dummy_content}>'),
(13,	'<h4><{$lang_activenotifications}></h4>\r\n<form name=\"notificationlist\" action=\"notifications.php\" method=\"post\">\r\n<table class=\"outer\">\r\n  <tr>\r\n	<th><input name=\"allbox\" id=\"allbox\" onclick=\"xoopsCheckAll(\'notificationlist\', \'allbox\');\" type=\"checkbox\" value=\"<{$lang_checkall}>\" /></th>\r\n    <th><{$lang_event}></th>\r\n    <th><{$lang_category}></th>\r\n    <th><{$lang_itemid}></th>\r\n    <th><{$lang_itemname}></th>\r\n  </tr>\r\n  <{foreach item=module from=$modules}>\r\n  <tr>\r\n    <td class=\"head\"><input name=\"del_mod[<{$module.id}>]\" id=\"del_mod[]\" onclick=\"xoopsCheckGroup(\'notificationlist\', \'del_mod[<{$module.id}>]\', \'del_not[<{$module.id}>][]\');\" type=\"checkbox\" value=\"<{$module.id}>\" /></td>\r\n    <td class=\"head\" colspan=\"4\"><{$lang_module}>: <{$module.name}></td>\r\n  </tr>\r\n  <{foreach item=category from=$module.categories}>\r\n  <{foreach item=item from=$category.items}>\r\n  <{foreach item=notification from=$item.notifications}>\r\n  <tr>\r\n    <{cycle values=odd,even assign=class}>\r\n    <td class=\"<{$class}>\"><input type=\"checkbox\" name=\"del_not[<{$module.id}>][]\" id=\"del_not[<{$module.id}>]\" value=\"<{$notification.id}>\" /></td>\r\n    <td class=\"<{$class}>\"><{$notification.event_title}></td>\r\n    <td class=\"<{$class}>\"><{$notification.category_title}></td>\r\n    <td class=\"<{$class}>\"><{if $item.id != 0}><{$item.id}><{/if}></td>\r\n    <td class=\"<{$class}>\"><{if $item.id != 0}><{if $item.url != \'\'}><a href=\"<{$item.url}>\" title=\"<{$item.name}>\"><{/if}><{$item.name}><{if $item.url != \'\'}></a><{/if}><{/if}></td>\r\n  </tr>\r\n  <{/foreach}>\r\n  <{/foreach}>\r\n  <{/foreach}>\r\n  <{/foreach}>\r\n  <tr>\r\n    <td class=\"foot\" colspan=\"5\">\r\n      <input type=\"submit\" name=\"delete_cancel\" value=\"<{$lang_cancel}>\" />\r\n      <input type=\"reset\" name=\"delete_reset\" value=\"<{$lang_clear}>\" />\r\n      <input type=\"submit\" name=\"delete\" value=\"<{$lang_delete}>\" />\r\n      <input type=\"hidden\" name=\"XOOPS_TOKEN_REQUEST\" value=\"<{$notification_token}>\" />\r\n    </td>\r\n  </tr>\r\n</table>\r\n</form>'),
(14,	'<{if $xoops_notification.show}>\r\n	<form name=\"notification_select\" action=\"<{$xoops_notification.target_page}>\" method=\"post\">\r\n		<h4 class=\"txtcenter\"><{$lang_activenotifications}></h4>\r\n		<input type=\"hidden\" name=\"not_redirect\" value=\"<{$xoops_notification.redirect_script}>\" />\r\n		<input type=\"hidden\" name=\"XOOPS_TOKEN_REQUEST\" value=\"<{php}>echo $GLOBALS[\'xoopsSecurity\']->createToken();<{/php}>\" />\r\n		<table class=\"outer\">\r\n		  <tr><th colspan=\"3\"><{$lang_notificationoptions}></th></tr>\r\n		  <tr>\r\n			<td class=\"head\"><{$lang_category}></td>\r\n			<td class=\"head\"><input name=\"allbox\" id=\"allbox\" onclick=\"xoopsCheckAll(\'notification_select\',\'allbox\');\" type=\"checkbox\" value=\"<{$lang_checkall}>\" /></td>\r\n			<td class=\"head\"><{$lang_events}></td>\r\n		  </tr>\r\n		  <{foreach name=outer item=category from=$xoops_notification.categories}>\r\n		  <{foreach name=inner item=event from=$category.events}>\r\n		  <tr>\r\n			<{if $smarty.foreach.inner.first}>\r\n			<td class=\"even\" rowspan=\"<{$smarty.foreach.inner.total}>\"><{$category.title}></td>\r\n			<{/if}>\r\n			<td class=\"odd\">\r\n			<{counter assign=index}>\r\n			<input type=\"hidden\" name=\"not_list[<{$index}>][params]\" value=\"<{$category.name}>,<{$category.itemid}>,<{$event.name}>\" />\r\n			<input type=\"checkbox\" id=\"not_list[]\" name=\"not_list[<{$index}>][status]\" value=\"1\" <{if $event.subscribed}>checked=\"checked\"<{/if}> />\r\n			</td>\r\n			<td class=\"odd\"><{$event.caption}></td>\r\n		  </tr>\r\n		  <{/foreach}>\r\n		  <{/foreach}>\r\n		  <tr>\r\n			<td class=\"foot txtcenter\" colspan=\"3\"><input type=\"submit\" name=\"not_submit\" value=\"<{$lang_updatenow}>\" /></td>\r\n		  </tr>\r\n		</table>\r\n		<div class=\"txtcenter\">\r\n		<{$lang_notificationmethodis}>:&nbsp;<{$user_method}>&nbsp;&nbsp;[<a href=\"<{$editprofile_url}>\" title=\"<{$lang_change}>\"><{$lang_change}></a>]\r\n		</div>\r\n	</form>\r\n<{/if}>'),
(15,	'<{$block.content}>'),
(16,	'\n'),
(17,	'<div id=\"login_window\">\r\n<h2 class=\'content_title\'><{$smarty.const._BANNERS_LOGIN_TITLE}></h2>\r\n<form method=\'post\' action=\'banners.php\' class=\'login_form\'>\r\n <div class=\'credentials\'>\r\n  <label for=\'login_form-login\'><{$smarty.const._BANNERS_LOGIN_LOGIN}></label>\r\n  <input type=\'text\' name=\'login\' id=\'login_form-login\' value=\'\' /><br />\r\n  <label for=\'login_form-password\'><{$smarty.const._BANNERS_LOGIN_PASS}></label>\r\n  <input type=\'password\' name=\'pass\' id=\'login_form-password\' value=\'\' /><br />\r\n </div>\r\n <div class=\'actions\'>\r\n 	<input type=\'hidden\' name=\'op\' value=\'list\' />\r\n	<button type=\'submit\'><{$smarty.const._BANNERS_LOGIN_OK}></button></div>\r\n <div class=\'login_info\'><{$smarty.const._BANNERS_LOGIN_INFO}></div>\r\n <{$TOKEN}>\r\n</form>\r\n</div>'),
(18,	'<h1><{$smarty.const._BANNERS_MANAGEMENT}></h1>\r\n<h5><{$welcomeuser}></h5>\r\n<div class=\"txtcenter\"><a href=\"banners.php?op=logout\" title=\"<{$smarty.const._BANNERS_LOGOUT}>\"><{$smarty.const._BANNERS_LOGOUT}></a></div>\r\n<h4 class=\"content_title\"><{$smarty.const._BANNERS_TITLE}></h4>\r\n<table cellpadding=\"2\" cellspacing=\"1\" summary=\"\" class=\"outer\">\r\n	<tr class=\"txtcenter\">\r\n		<th><{$smarty.const._BANNERS_NO}></th>\r\n		<th><{$smarty.const._BANNERS_IMP_MADE}></th>\r\n		<th><{$smarty.const._BANNERS_IMP_TOTAL}></th>\r\n		<th><{$smarty.const._BANNERS_IMP_LEFT}></th>\r\n		<th><{$smarty.const._BANNERS_CLICKS}></th>\r\n		<th><{$smarty.const._BANNERS_PER_CLICKS}></th>\r\n		<th><{$smarty.const._BANNERS_FUNCTIONS}></th>\r\n	</tr>\r\n	<{if $bcount}>\r\n		<{foreach item=banner from=$banners}>\r\n			<tr class=\"even txtcenter\">\r\n				<td><{$banner.bid}></td>\r\n			    <td><{$banner.impmade}></td>\r\n			    <td><{$banner.imptotal}></td>\r\n			    <td><{$banner.left}></td>\r\n			    <td><{$banner.clicks}></td>\r\n			    <td><{$banner.percent}>%</td>\r\n			    <td>\r\n					<a href=\"banners.php?op=banner_email&amp;cid=<{$banner.cid}>&amp;bid=<{$banner.bid}>\" title=\"<{$smarty.const._BANNERS_STATS}>\"><{$smarty.const._BANNERS_STATS}></a>\r\n			        <a href=\"banners.php?op=banner_display&amp;cid=<{$banner.cid}>\" title=\"<{$banner.bid}>\"><{$smarty.const._BANNERS_SHOWBANNER}></a>\r\n				</td>\r\n			</tr>\r\n		<{/foreach}>\r\n	<{else}>\r\n		<tr>\r\n			<td class=\"even txtcenter\" colspan=\"7\"><{$smarty.const._BANNERS_NOTHINGFOUND}></td>\r\n		</tr>\r\n	<{/if}>\r\n	<tr>\r\n		<td class=\"head\" colspan=\"7\">&nbsp;</td>\r\n	</tr>\r\n</table><br /><br />\r\n\r\n<h4 class=\"content_title\"><{$smarty.const._BANNERS_FINISHED}></h4>\r\n\r\n<table cellpadding=\"2\" cellspacing=\"1\" summary=\"\" class=\"outer\">\r\n	<tr class=\"txtcenter\">\r\n		<th><{$smarty.const._BANNERS_NO}></th>\r\n		<th><{$smarty.const._BANNERS_IMP_MADE}></th>\r\n		<th><{$smarty.const._BANNERS_CLICKS}></th>\r\n		<th><{$smarty.const._BANNERS_PER_CLICKS}></th>\r\n		<th><{$smarty.const._BANNERS_STARTED}></th>\r\n		<th><{$smarty.const._BANNERS_ENDED}></th>\r\n	</tr>\r\n	<{if $bcount}>\r\n		<{foreach item=ebanner from=$ebanners}>\r\n			<tr class=\"even txtcenter\">\r\n				<td><{$ebanner.bid}></td>\r\n			    <td><{$ebanner.impressions}></td>\r\n			    <td><{$ebanner.clicks}></td>\r\n			    <td><{$ebanner.percent}></td>\r\n			    <td><{$ebanner.datestart}></td>\r\n			    <td><{$ebanner.dateend}>%</td>\r\n			</tr>\r\n		<{/foreach}>\r\n	<{else}>\r\n		<tr>\r\n			<td class=\"even txtcenter\" colspan=\"7\"><{$smarty.const._BANNERS_NOTHINGFOUND}></td>\r\n		</tr>\r\n	<{/if}>\r\n	<tr>\r\n		<td class=\"head\" colspan=\"7\">&nbsp;</td>\r\n	</tr>\r\n</table><br />'),
(19,	'<h1><{$smarty.const._BANNERS_MANAGEMENT}></h1>\r\n<h5><{$welcomeuser}></h5>\r\n<div class=\"txtcenter\"><a href=\"banners.php?op=logout\" title=\"<{$smarty.const._BANNERS_LOGOUT}>\"><{$smarty.const._BANNERS_LOGOUT}></a></div>\r\n<div class=\"txtcenter\"><a href=\"banners.php?op=list\" title=\"<{$smarty.const._BANNERS_BACK}>\"><{$smarty.const._BANNERS_BACK}></a></div>\r\n<div><{$banneractive}></div><br />\r\n<{if $count}>\r\n	<{foreach item=banner from=$banners}>\r\n		<form action=\"banners.php\" method=\"post\">\r\n			<table cellspacing=\"1\" class=\"outer width100\">\r\n				<th colspan=\"2\"><{$smarty.const._BANNERS_ID}> <{$banner.bid}></th>\r\n				<tr>\r\n					<td class=\"head width50\">\r\n					<div><{$banner.sendstats}></div>\r\n					<div><{$banner.bannerpoints}></div>\r\n					<{if !$banner.htmlbanner}>\r\n					<div></div>\r\n					<div><{$smarty.const._BANNERS_URL}>\r\n						<input type=\"text\" name=\"url\" size=\"50\" maxlength=\"200\" value=\"<{$banner.clickurl}>\" />\r\n						<input type=\"hidden\" name=\"bid\" value=\"<{$banner.bid}>\" />\r\n						<input type=\"hidden\" name=\"cid\" value=\"<{$banner.cid}>\" />\r\n						<input type=\"submit\" name=\"op\" value=\"save\" />\r\n						<{$TOKEN}>\r\n					</div>\r\n					<{/if}>\r\n					</td>\r\n					<td class=\"even txtcenter\"><{$banner.banner_url}></td>\r\n				</tr>\r\n				<tr>\r\n					<td class=\"head\" colspan=\"2\">&nbsp;</td>\r\n				</tr>\r\n			</table>\r\n			<br />\r\n		</form>\r\n	<{/foreach}>\r\n<{/if}>'),
(20,	'<ul id=\"xo-breadcrumb\" class=\"ui-corner-all\" style=\"background-image:url(\'<{xoAdminNav bc_bg.png}>\'); \">\r\n    <{foreach item=breadcrumb from=$xo_sys_breadcrumb}>\r\n        <{if $breadcrumb.home}>\r\n            <li><a class=\"tooltip\" href=\"<{$breadcrumb.link}>\" title=\"<{$breadcrumb.title}>\" style=\"background-image:url(\'<{xoAdminNav bc_separator.png}>\');\"><img  class=\"home\" src=\"<{xoAdminNav home.png}>\" alt=\"<{$breadcrumb.title}>\" /></a></li>\r\n        <{else}>\r\n            <{if $breadcrumb.link}>\r\n            <li><a class=\"tooltip\" href=\"<{$breadcrumb.link}>\" title=\"<{$breadcrumb.title}>\" style=\"background-image:url(\'<{xoAdminNav bc_separator.png}>\');\"><{$breadcrumb.title}></a></li>\r\n            <{else}>\r\n            <li><{$breadcrumb.title}></li>\r\n            <{/if}>\r\n        <{/if}>\r\n    <{/foreach}>\r\n    <{if $xo_sys_help}>\r\n    <li class=\"xo-help\">\r\n        <a class=\"cursorhelp tooltip help_view\" title=\"<{$smarty.const._AM_SYSTEM_HELP_VIEW}>\" style=\"background-image:url(\'<{xoAdminNav bc_separator_end.png}>\'); display: visible;\"><img src=\"<{xoAdminIcons help.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_HELP_VIEW}>\" /></a>\r\n        <a class=\"cursorhelp tooltip help_hide\" title=\"<{$smarty.const._AM_SYSTEM_HELP_HIDE}>\" style=\"background-image:url(\'<{xoAdminNav bc_separator_end.png}>\'); display: none;\"><img src=\"<{xoAdminIcons help.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_HELP_HIDE}>\" /></a>\r\n    </li>\r\n    <{/if}>\r\n</ul>\r\n<{if $help_content}>\r\n<div class=\"hide\" id=\"xo-system-help\">\r\n<{includeq file=\"$help_content\"}>\r\n</div>\r\n<{/if}>\r\n<{if $xo_sys_tips}>\r\n<div class=\"tips ui-corner-all\">\r\n    <img class=\"floatleft tooltip\" src=\"<{xoAdminIcons tips.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_TIPS}>\" title=\"<{$smarty.const._AM_SYSTEM_TIPS}>\" />\r\n    <div class=\"floatleft\"><{$xo_sys_tips}></div>\r\n    <div class=\"clear\">&nbsp;</div>\r\n</div>\r\n<{else}>\r\n<br />\r\n<{/if}>'),
(21,	'<{includeq file=\"db:system_header.html\"}>\r\n<!--Banner-->\r\n<table class=\'width100 bnone\' cellspacing=\'1\'>\r\n	<tr>\r\n        <{if $banner_count == true}>\r\n		<td>\r\n			<h4><{$smarty.const._AM_SYSTEM_BANNERS_CURACTBNR}></h4>\r\n		</td>\r\n        <{/if}>\r\n		<td>\r\n			<div class=\"floatright\">\r\n                <div class=\"xo-buttons\">\r\n    				<a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=banners&amp;op=new_banner\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_ADDNWBNR}>\">\r\n    				    <img src=\"<{xoAdminIcons attach.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_ADDNWBNR}>\" />\r\n    					<{$smarty.const._AM_SYSTEM_BANNERS_ADDNWBNR}>\r\n    				</a>\r\n    				<a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=banners&amp;op=new_client\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_ADDCLI}>\">\r\n    				    <img src=\"<{xoAdminIcons user_add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_ADDCLI}>\" />\r\n    					<{$smarty.const._AM_SYSTEM_BANNERS_ADDCLI}>\r\n    				</a>\r\n				</div>\r\n			</div>\r\n		</td>\r\n	</tr>\r\n</table>\r\n<{if $banner_count == true}>\r\n<table id=\"xo-bannerslist-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n	<tr>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_IMPRESION}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_IMPLEFT}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CLICKS}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_NCLICKS}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CLINAME}></th>\r\n		<th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_BANNERS_FUNCTION}></th>\r\n	</tr>\r\n	</thead>\r\n	<tbody>\r\n	<{foreach item=banner from=$banner}>\r\n	<tr class=\"<{cycle values=\'even,odd\'}>\">\r\n		<td class=\"txtcenter\"><{$banner.impmade}></td>\r\n		<td class=\"txtcenter\"><{$banner.left}></td>\r\n		<td class=\"txtcenter\"><{$banner.clicks}></td>\r\n		<td class=\"txtcenter\"><{$banner.percent}>%</td>\r\n		<td class=\"txtcenter\"><{$banner.name}></td>\r\n		<td class=\"xo-actions txtcenter\">\r\n            <img class=\"tooltip\" onclick=\"display_dialog(<{$banner.bid}>, true, true, \'slide\', \'slide\', 200, 520);\" src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_VIEW}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_VIEW}>\" />\r\n            <a class=\"tooltip\" href=\"admin.php?fct=banners&amp;op=banner_edit&amp;bid=<{$banner.bid}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_EDIT}>\" />\r\n            </a>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=banners&amp;op=banner_delete&amp;bid=<{$banner.bid}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\" />\r\n            </a>\r\n        </td>\r\n	</tr>\r\n	<{/foreach}>\r\n	</tbody>\r\n</table>\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu_banner}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu_banner}></div><div class=\"clear spacer\"></div>\r\n<{/if}>\r\n<!--Pop-pup-->\r\n<{foreach item=banner from=$popup_banner}>\r\n<div id=\"dialog<{$banner.bid}>\" title=\"<{$banner.name}>\" style=\'display:none;\'>\r\n	<{$banner.imageurl}>\r\n</div>\r\n<{/foreach}>\r\n<!--Pop-pup-->\r\n<{/if}>\r\n\r\n<!--Banner Finish-->\r\n<{if $banner_finish_count == true}>\r\n<h4><{$smarty.const._AM_SYSTEM_BANNERS_FINISHBNR}></h4>\r\n<table id=\"xo-bannersfinish-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n	<tr>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_IMPD}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CLICKS}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_NCLICKS}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_STARTDATE}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_ENDDATE}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CLINAME}></th>\r\n		<th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_BANNERS_FUNCTION}></th>\r\n	</tr>\r\n	</thead>\r\n	<tbody>\r\n	<{foreach item=banner_finish from=$banner_finish}>\r\n	<tr class=\"<{cycle values=\'even,odd\'}>\">\r\n		<td class=\"txtcenter\"><{$banner_finish.impressions}></td>\r\n		<td class=\"txtcenter\"><{$banner_finish.clicks}></td>\r\n		<td class=\"txtcenter\"><{$banner_finish.percent}>%</td>\r\n		<td class=\"txtcenter\"><{$banner_finish.datestart}></td>\r\n		<td class=\"txtcenter\"><{$banner_finish.dateend}></td>\r\n		<td class=\"txtcenter\"><{$banner_finish.name}></td>\r\n		<td class=\"xo-actions txtcenter\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=banners&amp;op=banner_finish_delete&amp;bid=<{$banner_finish.bid}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\" />\r\n            </a>\r\n        </td>\r\n	</tr>\r\n	<{/foreach}>\r\n	</tbody>\r\n</table>\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu_bannerF}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu_bannerF}></div>\r\n<div class=\"clear spacer\"></div>\r\n<{/if}>\r\n\r\n<{/if}>\r\n<!--Banner Client-->\r\n<{if $banner_client_count == true}>\r\n<h4><{$smarty.const._AM_SYSTEM_BANNERS_ADVCLI}></h4>\r\n<table id=\"xo-bannersclient-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n	<tr>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CLINAME}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_ACTIVEBNR}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CONTNAME}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_BANNERS_CONTMAIL}></th>\r\n		<th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_BANNERS_FUNCTION}></th>\r\n	</tr>\r\n	</thead>\r\n	<tbody>\r\n	<{foreach item=banner_client from=$banner_client}>\r\n	<tr class=\"<{cycle values=\'even,odd\'}>\">\r\n		<td class=\"txtcenter\"><{$banner_client.name}></td>\r\n		<td class=\"txtcenter\"><{$banner_client.banner_active}></td>\r\n		<td class=\"txtcenter\"><{$banner_client.contact}></td>\r\n		<td class=\"txtcenter\"><{$banner_client.email}></td>\r\n		<td class=\"xo-actions txtcenter\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=banners&amp;op=banner_client_edit&amp;cid=<{$banner_client.cid}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_EDIT}>\" />\r\n            </a>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=banners&amp;op=banner_client_delete&amp;cid=<{$banner_client.cid}>\" title=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BANNERS_DELETE}>\" />\r\n            </a>\r\n        </td>\r\n	</tr>\r\n	<{/foreach}>\r\n	</tbody>\r\n</table>\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu_client}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu_client}></div>\r\n<div class=\"clear spacer\"></div>\r\n<{/if}>\r\n<{/if}>\r\n<br />\r\n<!-- Display Avatar form (add,edit) -->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>'),
(22,	'<{includeq file=\"db:system_header.html\"}>\r\n<{if $install_mods}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<div class=\"floatleft\">\r\n    <img class=\"cursorpointer tooltip\" onclick=\"system_moduleLargeView();\" src=\"<{xoAdminIcons view_large.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLARGE}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLARGE}>\" />\r\n    <img class=\"cursorpointer tooltip\" onclick=\"system_moduleListView();\" src=\"<{xoAdminIcons view_small.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLINE}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLINE}>\" />\r\n</div>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=modulesadmin&amp;op=installlist\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_TOINSTALL}>\">\r\n            <img src=\"<{xoAdminIcons install.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_TOINSTALL}>\" />\r\n            <{$smarty.const._AM_SYSTEM_MODULES_TOINSTALL}>&nbsp;<span class=\"red\">(<{$toinstall_nb}>)</span>\r\n        </a>\r\n    </div>\r\n</div>\r\n<div class=\"clear spacer\"></div>\r\n<form action=\"admin.php\" method=\"post\" name=\"moduleadmin\">\r\n    <table id=\"xo-module-sort\" class=\"outer\" cellspacing=\"1\">\r\n        <thead>\r\n            <tr class=\"txtcenter\">\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_MODULE}></th>\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_VERSION}></th>\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_LASTUP}></th>\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_ACTIVE}></th>\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_MENU}></th>\r\n                <th><{$smarty.const._AM_SYSTEM_MODULES_ACTION}></th>\r\n            </tr>\r\n        </thead>\r\n        <tbody>\r\n            <{foreach item=row from=$install_mods}>\r\n            <{if $row.dirname == \'system\'}>\r\n            <tr class=\"txtcenter foot\">\r\n                <td>\r\n                    <a class=\"xo-logonormal tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                        <img src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" />\r\n                    </a>\r\n                    <div class=\"spacer xo-modsimages\">\r\n                        <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                            <img class=\"xo-mods hide\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                        </a>\r\n                        <input type=\"text\" name=\"newname[<{$row.mid}>]\" value=\"<{$row.name}>\" maxlength=\"150\" size=\"20\" />\r\n                        <input type=\"hidden\" name=\"oldname[<{$row.mid}>]\" value=\"<{$row.name}>\" />\r\n                    </div>\r\n                </td>\r\n                <td>\r\n                    <{if $row.warning_update == 1}>\r\n                        <strong class=\"red\"><{$row.version}></strong>\r\n                    <{else}>\r\n                        <{$row.version}> <{$row.module_status}>\r\n                    <{/if}>\r\n                </td>\r\n                <td><{$row.last_update}></td>\r\n                <td class=\"xo-modsimages\"></td>\r\n                <td class=\"xo-modsimages\"></td>\r\n                <td class=\"xo-modsimages\">\r\n                    <{if $row.isactive == 1}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=update&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\">\r\n                        <{if $row.warning_update == 1}>\r\n                        <img src=\"<{xoAdminIcons messagebox_warning.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\" />\r\n                        <{else}>\r\n                        <img src=\"<{xoAdminIcons reload.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\" />\r\n                        <{/if}>\r\n                    </a>\r\n                    <{/if}>\r\n                    <img class=\"cursorpointer tooltip\" onclick=\"display_dialog(<{$row.mid}>, true, true, \'slide\', \'slide\', 240, 450);\" src=\"<{xoAdminIcons info.png}>\" alt=\"<{$smarty.const._INFO}>\" title=\"<{$smarty.const._INFO}>\" />\r\n                    <input type=\"hidden\" name=\"module[]\" value=\"<{$row.mid}>\" />\r\n                </td>\r\n            </tr>\r\n            <{/if}>\r\n            <{/foreach}>\r\n            <tr class=\"head\"><td colspan=\"6\"></td></tr>\r\n        </tbody>\r\n        <tbody class=\"xo-module\">\r\n            <{foreach item=row from=$install_mods}>\r\n            <{if $row.dirname != \'system\' && $row.hasmain}>\r\n            <tr id=\"mod_<{$row.mid}>\" class=\"<{if $row.dirname == \'system\'}>xo-system <{/if}>txtcenter <{cycle values=\'odd, even\'}>\">\r\n                <td>\r\n                    <{if $row.hasadmin == 1 && $row.isactive == 1}>\r\n                    <a class=\"xo-logonormal tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                        <img src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" />\r\n                    </a>\r\n                    <{else}>\r\n                    <img class=\"xo-logonormal tooltip\" src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                    <{/if}>\r\n                    <div class=\"spacer xo-modsimages\">\r\n                        <{if $row.hasadmin == 1 && $row.isactive == 1}>\r\n                        <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                            <img class=\"xo-mods hide\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                        </a>\r\n                        <{else}>\r\n                        <img class=\"xo-mods hide tooltip\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                        <{/if}>\r\n                        <input type=\"text\" name=\"newname[<{$row.mid}>]\" value=\"<{$row.name}>\" maxlength=\"150\" size=\"20\" />\r\n                        <input type=\"hidden\" name=\"oldname[<{$row.mid}>]\" value=\"<{$row.name}>\" />\r\n                    </div>\r\n                </td>\r\n                <td>\r\n                    <{if $row.warning_update == 1}>\r\n                        <a class=\"tooltip maxi\" style=\"color:red;\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=update&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\"><{$row.version}></a><br /><{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\r\n                    <{else}>\r\n                        <{$row.version}> <{$row.module_status}>\r\n                    <{/if}>\r\n                </td>\r\n                <td><{$row.last_update}></td>\r\n                <td class=\"xo-modsimages\">\r\n                    <img id=\"loading_active<{$row.mid}>\" src=\"images/spinner.gif\" style=\"display:none;\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" />\r\n                    <img class=\"cursorpointer tooltip\" id=\"active<{$row.mid}>\" onclick=\"system_setStatus( { fct: \'modulesadmin\', op: \'display\', mid: <{$row.mid}> }, \'active<{$row.mid}>\', \'admin.php\' )\" src=\"<{if $row.isactive}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $row.isactive}><{$smarty.const._AM_SYSTEM_MODULES_DEACTIVATE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_ACTIVATE}><{/if}>\" title=\"<{if $row.isactive}><{$smarty.const._AM_SYSTEM_MODULES_DEACTIVATE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_ACTIVATE}><{/if}>\" />\r\n                </td>\r\n                <td class=\"xo-modsimages\">\r\n                    <img id=\"loading_menu<{$row.mid}>\" src=\"images/spinner.gif\" style=\"display:none;\" title=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" />\r\n                    <img class=\"cursorpointer tooltip\" id=\"menu<{$row.mid}>\" onclick=\"system_setStatus( { fct: \'modulesadmin\', op: \'display_in_menu\', mid: <{$row.mid}> }, \'menu<{$row.mid}>\', \'admin.php\' )\" src=\"<{if $row.weight != 0}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $row.weight != 0}><{$smarty.const._AM_SYSTEM_MODULES_HIDE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_SHOW}><{/if}>\" title=\"<{if $row.weight != 0}><{$smarty.const._AM_SYSTEM_MODULES_HIDE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_SHOW}><{/if}>\" />\r\n                </td>\r\n                <td class=\"xo-modsimages\">\r\n                    <{if $row.isactive == 1}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=update&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\">\r\n                        <{if $row.warning_update == 1}>\r\n                        <img src=\"<{xoAdminIcons messagebox_warning.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\" />\r\n                        <{else}>\r\n                        <img src=\"<{xoAdminIcons reload.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\" />\r\n                        <{/if}>\r\n                    </a>\r\n                    <{/if}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=uninstall&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UNINSTALL}>\">\r\n                        <img src=\"<{xoAdminIcons uninstall.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UNINSTALL}>\" />\r\n                    </a>\r\n                    <img class=\"cursorpointer tooltip\" onclick=\"display_dialog(<{$row.mid}>, true, true, \'slide\', \'slide\', 240, 450);\" src=\"<{xoAdminIcons info.png}>\" alt=\"<{$smarty.const._INFO}>\" title=\"<{$smarty.const._INFO}>\" />\r\n                    <input type=\"hidden\" name=\"module[]\" value=\"<{$row.mid}>\" />\r\n                </td>\r\n            </tr>\r\n            <{/if}>\r\n            <{/foreach}>\r\n        </tbody>\r\n        <tbody>\r\n            <tr class=\"head\"><td colspan=\"6\"></td></tr>\r\n            <{foreach item=row from=$install_mods}>\r\n            <{if $row.dirname != \'system\' && !$row.hasmain}>\r\n            <tr class=\"txtcenter foot\">\r\n                <td>\r\n                    <a class=\"xo-logonormal tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                        <img src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" />\r\n                    </a>\r\n                    <div class=\"spacer xo-modsimages\">\r\n                        <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                            <img class=\"xo-mods hide\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                        </a>\r\n                        <input type=\"text\" name=\"newname[<{$row.mid}>]\" value=\"<{$row.name}>\" maxlength=\"150\" size=\"20\" />\r\n                        <input type=\"hidden\" name=\"oldname[<{$row.mid}>]\" value=\"<{$row.name}>\" />\r\n                    </div>\r\n                </td>\r\n                <td>\r\n                    <{if $row.warning_update == 1}>\r\n                        <a class=\"tooltip maxi\" style=\"color:red;\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=update&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\"><{$row.version}></a><br /><{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\r\n                    <{else}>\r\n                        <{$row.version}> <{$row.module_status}>\r\n                    <{/if}>\r\n                </td>\r\n                <td><{$row.last_update}></td>\r\n                <td class=\"xo-modsimages\"><img id=\"loading_mid<{$row.mid}>\" src=\"images/spinner.gif\" style=\"display:none;\" title=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"cursorpointer tooltip\" id=\"mid<{$row.mid}>\" onclick=\"system_setStatus( { fct: \'modulesadmin\', op: \'display\', mid: <{$row.mid}> }, \'mid<{$row.mid}>\', \'admin.php\' )\" src=\"<{if $row.isactive}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $row.isactive}><{$smarty.const._AM_SYSTEM_MODULES_DEACTIVATE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_ACTIVATE}><{/if}>\" title=\"<{if $row.isactive}><{$smarty.const._AM_SYSTEM_MODULES_DEACTIVATE}><{else}><{$smarty.const._AM_SYSTEM_MODULES_ACTIVATE}><{/if}>\" />\r\n                </td>\r\n                <td class=\"xo-modsimages\"></td>\r\n                <td class=\"xo-modsimages\">\r\n                    <{if $row.isactive == 1}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=update&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\">\r\n                        <img src=\"<{xoAdminIcons reload.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UPDATE}>\" />\r\n                    </a>\r\n                    <{/if}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=uninstall&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_UNINSTALL}>\">\r\n                        <img src=\"<{xoAdminIcons uninstall.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_UNINSTALL}>\" />\r\n                    </a>\r\n                    <img class=\"cursorpointer tooltip\" onclick=\"display_dialog(<{$row.mid}>, true, true, \'slide\', \'slide\', 240, 450);\" src=\"<{xoAdminIcons info.png}>\" alt=\"<{$smarty.const._INFO}>\" title=\"<{$smarty.const._INFO}>\" />\r\n                    <input type=\"hidden\" name=\"module[]\" value=\"<{$row.mid}>\" />\r\n                </td>\r\n            </tr>\r\n            <{/if}>\r\n            <{/foreach}>\r\n        </tbody>\r\n        <tfoot>\r\n            <tr class=\"txtcenter foot\">\r\n                <td colspan=\"6\">\r\n                    <input type=\"hidden\" name=\"fct\" value=\"modulesadmin\" />\r\n                    <input type=\"hidden\" name=\"op\" value=\"confirm\" />\r\n                    <input class=\"xo-formbuttons\" type=\"submit\" name=\"submit\" value=\"<{$smarty.const._AM_SYSTEM_MODULES_SUBMIT}>\" />\r\n                </td>\r\n            </tr>\r\n        </tfoot>\r\n    </table>\r\n    <{php}>echo $GLOBALS[\'xoopsSecurity\']->getTokenHTML();<{/php}>\r\n</form>\r\n<{/if}>\r\n\r\n<{if $toinstall_mods}>\r\n<div class=\"floatleft\">\r\n    <img class=\"cursorpointer tooltip\" onclick=\"system_moduleLargeView();\" src=\"<{xoAdminIcons view_large.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLARGE}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLARGE}>\" />\r\n    <img class=\"cursorpointer tooltip\" onclick=\"system_moduleListView();\" src=\"<{xoAdminIcons view_small.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLINE}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_VIEWLINE}>\" />\r\n</div>\r\n<div class=\"clear spacer\"></div>\r\n<table class=\"outer\" cellspacing=\"1\">\r\n    <thead>\r\n        <tr class=\"txtcenter\">\r\n            <th><{$smarty.const._AM_SYSTEM_MODULES_MODULE}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_MODULES_VERSION}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_MODULES_ACTION}></th>\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <{foreach item=row from=$toinstall_mods}>\r\n        <tr class=\"txtcenter <{cycle values=\'odd, even\'}>\">\r\n            <td>\r\n                <img class=\"xo-logonormal\" src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                <div class=\"spacer xo-modsimages\">\r\n                    <{if $row.hasadmin == 1 && $row.isactive == 1}>\r\n                    <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.adminindex}>\" title=\"<{$row.name}>\">\r\n                        <img class=\"xo-mods hide\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                    </a>\r\n                    <{else}>\r\n                    <img class=\"xo-mods hide tooltip\" src=\"<{xoAdminIcons applications.png}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n                    <{/if}>\r\n                    <span class=\"spacer bold\"><{$row.name}></span>\r\n                </div>\r\n            </td>\r\n            <td><{$row.version}> <{$row.module_status}></td>\r\n            <td class=\"xo-modsimages\">\r\n                <a class=\"tooltip\" href=\"<{$xoops_url}>/modules/system/admin.php?fct=modulesadmin&amp;op=install&amp;module=<{$row.dirname}>\" title=\"<{$smarty.const._AM_SYSTEM_MODULES_INSTALL}>\">\r\n                    <img src=\"<{xoAdminIcons install.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_MODULES_INSTALL}>\" />\r\n                </a>\r\n                <img class=\"cursorpointer tooltip\" onclick=\"display_dialog(<{$row.mid}>, true, true, \'slide\', \'slide\', 240, 450);\" src=\"<{xoAdminIcons info.png}>\" alt=\"<{$smarty.const._INFO}>\" title=\"<{$smarty.const._INFO}>\" />\r\n            </td>\r\n        </tr>\r\n        <{/foreach}>\r\n    </tbody>\r\n</table>\r\n<{/if}>\r\n<!--Pop-pup-->\r\n<{foreach item=row from=$mods_popup}>\r\n<div id=\"dialog<{$row.mid}>\" title=\"<{$row.name}>\" style=\'display:none;\'>\r\n    <table>\r\n        <tr>\r\n            <td class=\"width10 aligntop\">\r\n                <img src=\"<{$xoops_url}>/modules/<{$row.dirname}>/<{$row.image}>\" alt=\"<{$row.name}>\" title=\"<{$row.name}>\" />\r\n            </td>\r\n            <td>\r\n                <ul class=\"xo-moduleinfos\">\r\n                    <li><span class=\"bold\"><{$smarty.const._VERSION}></span>&nbsp;:&nbsp;<{$row.version}> <{$row.module_status}></li>\r\n                    <li><span class=\"bold\"><{$smarty.const._AUTHOR}></span>&nbsp;:&nbsp;<{$row.author}></li>\r\n                    <li><span class=\"bold\"><{$smarty.const._CREDITS}></span>&nbsp;:&nbsp;<{$row.credits}></li>\r\n                    <li><span class=\"bold\"><{$smarty.const._LICENCE}></span>&nbsp;:&nbsp;<{$row.license}> </li>\r\n                </ul>\r\n            </td>\r\n        </tr>\r\n    </table>\r\n    <p><{$row.description}></p>\r\n</div>\r\n<{/foreach}>\r\n<!--Pop-pup-->'),
(23,	'<{includeq file=\"db:system_header.html\"}>\r\n<{if $modifs_mods}>\r\n<form action=\"admin.php\" method=\"post\">\r\n  <table class=\"outer\" cellspacing=\"1\">\r\n    <thead>\r\n      <tr class=\"txtcenter\">\r\n        <th><{$smarty.const._AM_SYSTEM_MODULES_MODULE}></th>\r\n        <th><{$smarty.const._AM_SYSTEM_MODULES_ACTION}></th>\r\n        <th><{$smarty.const._AM_SYSTEM_MODULES_ORDER}></th>\r\n      </tr>\r\n    </thead>\r\n    <tbody>\r\n      <{foreach item=row from=$modifs_mods}>\r\n      <tr class=\"txtcenter <{cycle values=\'odd, even\'}>\">\r\n        <td>\r\n          <{$row.oldname}>\r\n          <{if $row.oldname != $row.newname}>\r\n          <span class=\"bold red\">&nbsp;&raquo;&raquo;&nbsp;<{$row.newname}></span>\r\n          <{/if}>\r\n        </td>\r\n        <td>\r\n          <{if $row.oldstatus != $row.newstatus}>\r\n          <{if $row.newstatus == 1}>\r\n          <div class=\"bold red\"><{$smarty.const._AM_SYSTEM_MODULES_ACTIVATE}></div>\r\n          <{else}>\r\n          <div class=\"bold red\"><{$smarty.const._AM_SYSTEM_MODULES_DEACTIVATE}></div>\r\n          <{/if}>\r\n          <{else}>\r\n          <{$smarty.const._AM_SYSTEM_MODULES_NOCHANGE}>\r\n          <{/if}>\r\n        </td>\r\n        <td>\r\n          <{if $row.oldweight != $row.weight}>\r\n          <div class=\"bold red\"><{$row.weight}></div>\r\n          <{else}>\r\n          <{$row.weight}>\r\n          <{/if}>\r\n          <input type=\"hidden\" name=\"module[]\" value=\"<{$row.mid}>\" />\r\n          <input type=\"hidden\" name=\"oldname[<{$row.mid}>]\" value=\"<{$row.oldname}>\" />\r\n          <input type=\"hidden\" name=\"newname[<{$row.mid}>]\" value=\"<{$row.newname}>\" />\r\n          <input type=\"hidden\" name=\"oldstatus[<{$row.mid}>]\" value=\"<{$row.oldstatus}>\" />\r\n          <input type=\"hidden\" name=\"newstatus[<{$row.mid}>]\" value=\"<{$row.newstatus}>\" />\r\n          <input type=\"hidden\" name=\"oldweight[<{$row.mid}>]\" value=\"<{$row.oldweight}>\" />\r\n          <input type=\"hidden\" name=\"weight[<{$row.mid}>]\" value=\"<{$row.weight}>\" />\r\n        </td>\r\n      </tr>\r\n      <{/foreach}>\r\n    </tbody>\r\n    <tfoot>\r\n      <tr class=\"txtcenter foot\">\r\n        <td colspan=\"3\">\r\n          <input class=\"formButton\" type=\"submit\" value=\"<{$smarty.const._AM_SYSTEM_MODULES_SUBMIT}>\" />&nbsp;\r\n          <input class=\"formButton\" type=\"button\" value=\"<{$smarty.const._AM_SYSTEM_MODULES_CANCEL}>\" onclick=\"location=\'admin.php?fct=modulesadmin\'\" />\r\n          <input type=\"hidden\" name=\"fct\" value=\"modulesadmin\" />\r\n          <input type=\"hidden\" name=\"op\" value=\"submit\" />\r\n          <{$input_security}>\r\n        </td>\r\n      </tr>\r\n    </tfoot>\r\n  </table>\r\n</form>\r\n<{else}>\r\n<div id=\"xo-module-log\">\r\n    <{if $result}>\r\n    <div class=\"logger\">\r\n        <{foreach item=row from=$result}>\r\n        <div class=\"spacer\"><{$row}></div>\r\n        <{/foreach}>\r\n    </div>\r\n    <{/if}>\r\n    <a href=\"admin.php?fct=modulesadmin\"><{$smarty.const._AM_SYSTEM_MODULES_BTOMADMIN}></a>\r\n</div>\r\n<{/if}>'),
(24,	'<!-- Header -->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<{if $view_cat}>\r\n<!-- Display Avatar header for switch between system & custom category -->\r\n<table class=\"outer\" cellspacing=\"1\">\r\n    <thead>\r\n        <tr>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_AVATAR_SYSTEM}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_AVATAR_CUSTOM}></th>\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <tr class=\"odd\">\r\n            <td class=\"txtcenter\">\r\n                <a class=\"tooltip\" href=\"admin.php?fct=avatars&amp;op=listavt&amp;type=s\" title=\"<{$smarty.const._AM_SYSTEM_AVATAR_SYSTEM}>\">\r\n                    <img src=\"<{xoAdminIcons avatar_system.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_AVATAR_SYSTEM}>\" />\r\n                </a>\r\n                <div class=\"spacer\"><{$smarty.const._AM_SYSTEM_AVATAR_SYSTEM}>&nbsp;:&nbsp;<strong><{$count_system}></strong></div>\r\n            </td>\r\n            <td class=\"txtcenter\">\r\n                <a class=\"tooltip\" href=\"admin.php?fct=avatars&amp;op=listavt&amp;type=c\" title=\"<{$smarty.const._AM_SYSTEM_AVATAR_CUSTOM}>\">\r\n                    <img src=\"<{xoAdminIcons avatar_custom.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_AVATAR_CUSTOM}>\" />\r\n                </a>\r\n                <div class=\"spacer\"><{$smarty.const._AM_SYSTEM_AVATAR_CUSTOM}>&nbsp;:&nbsp;<strong><{$count_custom}></strong></div>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>\r\n<br />\r\n<{/if}>\r\n<!-- Display Avatar list for each category -->\r\n<{if $avatars_list}>\r\n<{foreach item=avatar from=$avatars_list}>\r\n<div class=\"floatleft\">\r\n    <div class=\"ui-corner-all xo-thumb txtcenter\">\r\n        <div class=\"xo-thumbimg\">\r\n            <img class=\"tooltip\" src=\"<{$xoops_url}>/image.php?src=<{$xoops_url}>/uploads/<{$avatar.avatar_file}>&amp;height=120&amp;width=120\" alt=\"<{$avatar.avatar_name}>\" title=\"<{$avatar.avatar_name}>\" />\r\n        </div>\r\n        <div class=\"xo-actions txtcenter\">\r\n            <div class=\"spacer bold\"><{$avatar.avatar_name}></div>\r\n            <img id=\"loading_avt<{$avatar.avatar_id}>\" src=\"images/spinner.gif\" style=\"display:none;\" title=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"tooltip\" id=\"avt<{$avatar.avatar_id}>\" onclick=\"system_setStatus( { fct: \'avatars\', op: \'display\', avatar_id: <{$avatar.avatar_id}> }, \'avt<{$avatar.avatar_id}>\', \'admin.php\' )\" src=\"<{if $avatar.avatar_display}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{$smarty.const._IMGDISPLAY}>\" title=\"<{$smarty.const._IMGDISPLAY}>\" />\r\n            <{if $avatar.type == \'c\'}>\r\n            <a href=\"<{$xoops_url}>/modules/profile/userinfo.php?uid=<{$avatar.user}>\" title=\"<{$smarty.const._AM_SYSTEM_AVATAR_USERS}>\">\r\n                <img src=\"<{xoAdminIcons user_edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_AVATAR_USERS}>\" />\r\n            </a>\r\n            <{else}>\r\n            <img class=\"cursorhelp tooltip\" src=\"<{xoAdminIcons forum.png}>\" alt=\"<{$avatar.count}> <{$smarty.const._AM_SYSTEM_AVATAR_USERS}>\" title=\"<{$avatar.count}> <{$smarty.const._AM_SYSTEM_AVATAR_USERS}>\" />\r\n            <{/if}>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=avatars&amp;op=edit&amp;avatar_id=<{$avatar.avatar_id}>\" title=\"<{$smarty.const._EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._EDIT}>\" />\r\n            </a>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=avatars&amp;op=delfile&amp;avatar_id=<{$avatar.avatar_id}>\" title=\"<{$smarty.const._DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._DELETE}>\" />\r\n            </a>\r\n        </div>\r\n    </div>\r\n</div>\r\n<{/foreach}>\r\n<!-- Display Avatars navigation -->\r\n<div class=\"clear\">&nbsp;</div>\r\n<{if $nav_menu}><div class=\"xo-pagenav floatright\"><{$nav_menu}></div><div class=\"clear spacer\"></div><{/if}>\r\n<{/if}>\r\n<!-- Display Avatar form (add,edit) -->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>\r\n<!-- Display Avatar images on edit page -->'),
(25,	'<!--smilies-->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<{if $smilies_count == true}>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=smilies&amp;op=new_smilie\" title=\"<{$smarty.const._AM_SYSTEM_SMILIES_ADD}>\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_SMILIES_ADD}>\" />\r\n            <{$smarty.const._AM_SYSTEM_SMILIES_ADD}>\r\n        </a>\r\n    </div>\r\n</div>\r\n<table id=\"xo-smilies-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n	<tr>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_SMILIES_CODE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_SMILIES_SMILIE}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_SMILIES_DESCRIPTION}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_SMILIES_DISPLAY}></th>\r\n		<th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_SMILIES_ACTION}></th>\r\n	</tr>\r\n	</thead>\r\n	<tbody>\r\n	<{foreach item=smilies from=$smilies}>\r\n	<tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n		<td class=\"txtcenter width5\"><{$smilies.code}></td>\r\n        <td class=\"txtcenter width5\"><{$smilies.image}></td>\r\n		<td class=\"txtcenter width50\"><{$smilies.emotion}></td>\r\n		<td class=\"xo-actions txtcenter width10\">\r\n            <img id=\"loading_sml<{$smilies.smilies_id}>\" src=\"images/spinner.gif\" style=\"display:none;\" title=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"cursorpointer tooltip\" id=\"sml<{$smilies.smilies_id}>\" onclick=\"system_setStatus( { fct: \'smilies\', op: \'smilies_update_display\', smilies_id: <{$smilies.smilies_id}> }, \'sml<{$smilies.smilies_id}>\', \'admin.php\' )\" src=\"<{if $smilies.display}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $smilies.display}><{$smarty.const._AM_SYSTEM_SMILIES_OFF}><{else}><{$smarty.const._AM_SYSTEM_SMILIES_ON}><{/if}>\" title=\"<{if $smilies.display}><{$smarty.const._AM_SYSTEM_SMILIES_OFF}><{else}><{$smarty.const._AM_SYSTEM_SMILIES_ON}><{/if}>\" />\r\n        </td>\r\n		<td class=\"xo-actions txtcenter width10\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=smilies&amp;op=edit_smilie&amp;smilies_id=<{$smilies.smilies_id}>\" title=\"<{$smarty.const._AM_SYSTEM_SMILIES_EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_SMILIES_EDIT}>\" />\r\n            </a>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=smilies&amp;op=smilies_delete&amp;smilies_id=<{$smilies.smilies_id}>\" title=\"<{$smarty.const._AM_SYSTEM_SMILIES_DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_SMILIES_DELETE}>\" />\r\n            </a>\r\n        </td>\r\n	</tr>\r\n	<{/foreach}>\r\n	</tbody>\r\n</table>\r\n<!-- Display smilies navigation -->\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu}></div>\r\n<div class=\"clear spacer\"></div>\r\n<{/if}>\r\n<{/if}>\r\n<!-- Display smilies form (add,edit) -->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>'),
(26,	'<!-- Breadcrumb Header -->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<{if $filterform}>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <button id=\"xo-add-btn\" class=\"ui-corner-all\" onclick=\"self.location.href=\'admin.php?fct=blocksadmin&amp;op=add\';\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BLOCKS_ADD}>\" />\r\n            <{$smarty.const._AM_SYSTEM_BLOCKS_ADD}>\r\n        </button>\r\n    </div>\r\n</div>\r\n<div class=\"clear\"></div>\r\n<div id=\"xo-block-dragndrop\">\r\n    <table class=\"outer\">\r\n        <tr>\r\n            <th>\r\n                <form name=\"<{$filterform.name}>\" id=\"<{$filterform.name}>\" action=\"<{$filterform.action}>\" method=\"<{$filterform.method}>\" <{$filterform.extra}> >\r\n                    <div class=\"xo-blocksfilter\">\r\n                    <{foreach item=element from=$filterform.elements}>\r\n                    <{if $element.hidden != true}>\r\n                    \r\n                    <div class=\"xo-caption\"><{$element.caption}></div>\r\n                    <div class=\"xo-element\"><{$element.body}></div>\r\n                    <{else}>\r\n                    <{$element.body}>\r\n                    <{/if}>\r\n                    <{/foreach}>\r\n                    </div>\r\n                </form>\r\n            </th>\r\n        </tr>\r\n        <tr>\r\n            <td>\r\n                <table id=\"xo-block-managment\">\r\n                    <tr>\r\n                        <td side=\"0\" class=\"xo-blocksection\" rowspan=\"3\" id=\"xo-leftcolumn\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDELEFT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=0}>\r\n                        </td>\r\n                        <td side=\"3\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDETOPLEFT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=3}>\r\n                        </td>\r\n                        <td side=\"5\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDETOPCENTER}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=5}>\r\n                        </td>\r\n                        <td side=\"4\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDETOPRIGHT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=4}>\r\n                        </td>\r\n                        <td side=\"1\" class=\"xo-blocksection\" rowspan=\"3\" id=\"xo-rightcolumn\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDERIGHT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=1}>\r\n                        </td>\r\n                    </tr>\r\n                    <tr style=\"height:30px;\">\r\n                        <td colspan=\"3\" class=\"xo-blockContent width5\">&nbsp;</td>\r\n                    </tr>\r\n                    <tr>\r\n                        <td side=\"7\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDEBOTTOMLEFT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=7}>\r\n                        </td>\r\n                        <td side=\"9\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDEBOTTOMCENTER}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=9}>\r\n                        </td>\r\n                        <td side=\"8\" class=\"xo-blocksection\">\r\n                            <div class=\"xo-title\"><{$smarty.const._AM_SYSTEM_BLOCKS_SIDEBOTTOMRIGHT}></div>\r\n                            <{includeq file=\"db:system_blocks_item.html\" blocks=$blocks side=8}>\r\n                        </td>\r\n                    </tr>\r\n                </table>\r\n            </td>\r\n        </tr>\r\n    </table>\r\n</div>\r\n<{/if}>\r\n<div id=\"xo-block-add\" <{if $filterform}>class=\"hide\"<{/if}>>\r\n    <{if !$filterform}><br /><{/if}>\r\n    <{$blockform}>\r\n</div>\r\n<!-- Preview block -->\r\n<div id=\"xo-preview-block\" class=\"hide\"></div>'),
(27,	'<{foreach item=item from=$blocks}>\r\n<{if $item.side == $side}>\r\n<div id=\"blk_<{$item.bid}>\" bid=\"<{$item.bid}>\" side=\"<{$item.side}>\" order=\"<{$item.weight}>\" class=\"xo-block ui-widget ui-widget-content ui-corner-all\">\r\n    <div class=\"xo-blocktitle ui-corner-all\">\r\n        <span class=\"spacer\">\r\n            <img class=\"xo-imgmini\" src=\"<{xoAdminIcons block.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BLOCKS_DRAG}>\" title=\"<{$smarty.const._AM_SYSTEM_BLOCKS_DRAG}>\" />\r\n        </span>\r\n        <{$item.title}>\r\n    </div>\r\n    <div class=\"xo-blockaction xo-actions\"><img id=\"loading_img<{$item.bid}>\" src=\"./images/mimetypes/spinner.gif\" style=\"display:none;\" title=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"tooltip\" id=\"img<{$item.bid}>\" onclick=\"system_setStatus( { fct: \'blocksadmin\', op: \'display\', bid: <{$item.bid}>, visible: <{if $item.visible}>0<{else}>1<{/if}> }, \'img<{$item.bid}>\', \'admin.php\' )\" src=\"<{if $item.visible}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $item.visible}><{$smarty.const._AM_SYSTEM_BLOCKS_HIDE}><{else}><{$smarty.const._AM_SYSTEM_BLOCKS_DISPLAY}><{/if}><{$item.name}>\" title=\"<{if $item.visible}><{$smarty.const._AM_SYSTEM_BLOCKS_HIDE}><{else}><{$smarty.const._AM_SYSTEM_BLOCKS_DISPLAY}><{/if}><{$item.name}>\" />\r\n        <a class=\"tooltip\" href=\"admin.php?fct=blocksadmin&amp;op=edit&amp;bid=<{$item.bid}>\" title=\"<{$smarty.const._EDIT}>\">\r\n            <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._EDIT}>\" />\r\n        </a>\r\n        <{if $item.block_type != \'S\'}>\r\n        <a class=\"tooltip\" href=\"admin.php?fct=blocksadmin&amp;op=delete&amp;bid=<{$item.bid}>\" title=\"<{$smarty.const._DELETE}>\">\r\n            <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._DELETE}>\" />\r\n        </a>\r\n        <{/if}>\r\n        <a class=\"tooltip\" href=\"admin.php?fct=blocksadmin&amp;op=clone&amp;bid=<{$item.bid}>\" title=\"<{$smarty.const._AM_SYSTEM_BLOCKS_CLONE}>\">\r\n            <img src=\"<{xoAdminIcons clone.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_BLOCKS_CLONE}>\" />\r\n        </a>\r\n    </div>\r\n</div>\r\n<{/if}>\r\n<{/foreach}>'),
(28,	'<{includeq file=\"db:system_header.html\"}>\r\n<!--Comments-->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{else}>\r\n<div class=\"floatleft\"><{$form_sort}></div>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <button class=\"ui-corner-all\" onclick=\"self.location.href=\'admin.php?fct=comments&amp;op=comments_form_purge\'\">\r\n            <img src=\"<{xoAdminIcons clear.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_COMMENTS_FORM_PURGE}>\" />\r\n            <{$smarty.const._AM_SYSTEM_COMMENTS_FORM_PURGE}>\r\n        </button>\r\n    </div>\r\n</div>\r\n<div class=\"clear\"></div>\r\n<table id=\"xo-comment-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n    <tr>\r\n        <th class=\"txtcenter width5\"><input name=\'allbox\' id=\'allbox\' onclick=\'xoopsCheckAll(\"commentslist\", \"allbox\");\'  type=\'checkbox\' value=\'Check All\' /></th>\r\n        <th class=\"txtcenter width5\"></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_COMMENTS_TITLE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_COMMENTS_POSTED}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_COMMENTS_IP}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._DATE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_COMMENTS_MODULE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_COMMENTS_STATUS}></th>\r\n        <th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_COMMENTS_ACTION}></th>\r\n    </tr>\r\n    </thead>\r\n    <form name=\'commentslist\' id=\'commentslist\' action=\'<{$php_selft}>\' method=\"post\">\r\n    <tbody>\r\n    <{foreach item=comments from=$comments}>\r\n    <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n        <td class=\"txtcenter\"><input type=\'checkbox\' name=\'commentslist_id[]\' id=\'commentslist_id[]\' value=\'<{$comments.comments_id}>\'/></td>	\r\n        <td class=\"txtcenter\"><{$comments.comments_icon}></td>\r\n        <td><{$comments.comments_title}></td>\r\n        <td class=\"txtcenter\"><{$comments.comments_poster}></td>\r\n        <td class=\"txtcenter\"><{$comments.comments_ip}></td>\r\n        <td class=\"txtcenter\"><{$comments.comments_date}></td>\r\n        <td class=\"txtcenter\"><{$comments.comments_modid}></td>\r\n        <td class=\"txtcenter\"><{$comments.comments_status}></td>\r\n        <td class=\"xo-actions txtcenter\">\r\n            <img class=\"cursorpointer\" onclick=\"display_dialog(\'<{$comments.comments_id}>\', true, true, \'slide\', \'slide\', 300, 500);\" src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_COMMENTS_VIEW}>\" title=\"<{$smarty.const._AM_SYSTEM_COMMENTS_VIEW}>\" />\r\n            <a href=\"admin/comments/comment_edit.php?com_id=<{$comments.comments_id}>\" title=\"<{$smarty.const._EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._EDIT}>\">\r\n            </a>\r\n            <a href=\"admin/comments/comment_delete.php?com_id=<{$comments.comments_id}>\" title=\"<{$smarty.const._DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._DELETE}>\">\r\n            </a>\r\n        </td>\r\n    </tr>\r\n    <{/foreach}>\r\n    </tbody>\r\n    <tr>\r\n        <td><input type=\'submit\' name=\'<{$smarty.const._DELETE}>\' value=\'<{$smarty.const._DELETE}>\' /></td>\r\n        <td colspan=\"7\">&nbsp;</td>\r\n    </tr>\r\n    </form>\r\n</table>\r\n<{foreach item=comments from=$comments_popup}>\r\n<!--Pop-pup-->\r\n<div id=\'dialog<{$comments.comments_id}>\' title=\'<{$comments.comments_icon}>&nbsp;&nbsp;<{$comments.comments_title}>\' style=\'display:none;\'>\r\n    <img src=\"<{xoAdminIcons comment.png}>\" alt=\"comments\" title=\"comments\" class=\"xo-commentsimg\" />\r\n    <p><{$comments.comments_text}></p>\r\n</div>\r\n<{/foreach}>\r\n<!--Pop-pup-->\r\n<div class=\"txtright\"><{$nav}></div>\r\n<{/if}>'),
(29,	'<{includeq file=\"db:system_header.html\"}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<!--User rank-->\r\n<{if $userrank_count == true}>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=userrank&amp;op=userrank_new\" title=\"<{$smarty.const._AM_SYSTEM_USERRANK_ADD}>\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERRANK_ADD}>\" />\r\n            <{$smarty.const._AM_SYSTEM_USERRANK_ADD}>\r\n        </a>\r\n    </div>\r\n</div>\r\n<table id=\"xo-rank-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n    <tr>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERRANK_IMAGE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERRANK_TITLE}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERRANK_MINPOST}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERRANK_MAXPOST}></th>\r\n        <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERRANK_SPECIAL}></th>\r\n        <th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_USERRANK_ACTION}></th>\r\n    </tr>\r\n    </thead>\r\n    <tbody>\r\n    <{foreach item=userrank from=$userrank}>\r\n    <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n        <td class=\"txtcenter\"><{$userrank.rank_image}></td>\r\n        <td class=\"txtcenter\"><{$userrank.rank_title}></td>\r\n        <td class=\"txtcenter\"><{$userrank.rank_min}></td>\r\n        <td class=\"txtcenter\"><{$userrank.rank_max}></td>\r\n        <td class=\"xo-actions txtcenter\"><img id=\"loading_sml<{$userrank.rank_id}>\" src=\"images/spinner.gif\" style=\"display:none;\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"cursorpointer tooltip\" id=\"sml<{$userrank.rank_id}>\" onclick=\"system_setStatus( { fct: \'userrank\', op: \'userrank_update_special\', rank_id: <{$userrank.rank_id}> }, \'sml<{$userrank.rank_id}>\', \'admin.php\' )\" src=\"<{if $userrank.rank_special}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{if $userrank.rank_special}><{$smarty.const._AM_SYSTEM_USERRANK_OFF}><{else}><{$smarty.const._AM_SYSTEM_USERRANK_ON}><{/if}>\" title=\"<{if $userrank.rank_special}><{$smarty.const._AM_SYSTEM_USERRANK_OFF}><{else}><{$smarty.const._AM_SYSTEM_USERRANK_ON}><{/if}>\" />\r\n        </td>\r\n        <td class=\"xo-actions txtcenter\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=userrank&amp;op=userrank_edit&amp;rank_id=<{$userrank.rank_id}>\" title=\"<{$smarty.const._AM_SYSTEM_USERRANK_EDIT}>\">\r\n                <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERRANK_EDIT}>\" />\r\n            </a>\r\n            <a class=\"tooltip\" href=\"admin.php?fct=userrank&amp;op=userrank_delete&amp;rank_id=<{$userrank.rank_id}>\" title=\"<{$smarty.const._AM_SYSTEM_USERRANK_DELETE}>\">\r\n                <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERRANK_DELETE}>\" />\r\n            </a>\r\n        </td>\r\n    </tr>\r\n    <{/foreach}>\r\n    </tbody>\r\n</table>\r\n<!-- Display rank navigation -->\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu}></div>\r\n<div class=\"clear spacer\"></div>\r\n<{/if}>\r\n<{/if}>\r\n<!--Display rank form (add,edit)-->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>'),
(30,	'<{includeq file=\"db:system_header.html\"}>\r\n\r\n<{if $users_display == true}>\r\n<!--Display form sort-->\r\n<div class=\"xo-headercontent\">\r\n    <div class=\"floatleft\"><{$form_sort}></div>\r\n    <div class=\"floatright\">\r\n        <div class=\"xo-buttons\">\r\n            <a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=users&amp;op=users_synchronize&amp;status=2\" title=\"<{$smarty.const._AM_SYSTEM_USERS_SYNCHRONIZE}>\">\r\n                <img src=\"<{xoAdminIcons reload.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_SYNCHRONIZE}>\" />\r\n                <{$smarty.const._AM_SYSTEM_USERS_SYNCHRONIZE}>\r\n            </a>\r\n            <a class=\"ui-corner-all tooltip\" href=\"admin.php?fct=users&amp;op=users_add\" title=\"<{$smarty.const._AM_SYSTEM_USERS_ADDUSER}>\">\r\n                <img src=\"<{xoAdminIcons user_add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_ADDUSER}>\" />\r\n                <{$smarty.const._AM_SYSTEM_USERS_ADDUSER}>\r\n            </a>\r\n        </div>\r\n    </div>\r\n</div>\r\n<div class=\"clear\">&nbsp;</div>\r\n    <table id=\"xo-users-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n        <thead>\r\n        <tr>\r\n            <th class=\"txtcenter width3\"><input name=\'allbox\' id=\'allbox\' onclick=\'xoopsCheckAll(\"memberslist\", \"allbox\");\'  type=\'checkbox\' value=\'Check All\' /></th>\r\n            <th class=\"txtcenter width5\"><{$smarty.const._AM_SYSTEM_USERS_STATUS}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_UNAME}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_EMAIL}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_REG_DATE}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_LAST_LOGIN}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_POSTS}></th>\r\n            <th class=\"txtcenter\" width=\'11%\'><{$smarty.const._AM_SYSTEM_USERS_ACTION}></th>\r\n        </tr>\r\n        </thead>\r\n        <!--Display data-->\r\n        <{if $users_count == true}>\r\n        <form name=\'memberslist\' id=\'memberslist\' action=\'<{$php_selft}>\' method=\'POST\'>\r\n        <tbody>\r\n        <{foreach item=users from=$users}>\r\n        <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n            <td class=\"txtcenter\"><{if $users.checkbox_user}><input type=\'checkbox\' name=\'memberslist_id[]\' id=\'memberslist_id[]\' value=\'<{$users.uid}>\' /><{/if}></td>\r\n            <td class=\"txtcenter\"><img class=\"xo-imgmini\" src=\"<{$users.group}>\" alt=\"\" /></td>\r\n            <td class=\"txtcenter\"><a title=\"<{$users.uname}>\" href=\"<{$xoops_url}>/userinfo.php?uid=<{$users.uid}>\" ><{$users.uname}></a></td>\r\n            <td class=\"txtcenter\"><{$users.email}></td>\r\n            <td class=\"txtcenter\"><{$users.reg_date}></td>\r\n            <td class=\"txtcenter\"><{$users.last_login}></td>\r\n            <td class=\"txtcenter\"><div id=\"display_post_<{$users.uid}>\"><{$users.posts}></div><div id=\'loading_<{$users.uid}>\' class=\"txtcenter\" style=\"display:none;\"><img src=\"./images/mimetypes/spinner.gif\" title=\"Loading\" alt=\"Loading\" width=\"12px\"/></div></td>\r\n            <td class=\"xo-actions txtcenter\">\r\n                <{if $users.user_level > 0}>\r\n                <img class=\"tooltip\" onclick=\"display_post(\'<{$users.uid}>\');\" src=\"<{xoAdminIcons reload.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_SYNCHRONIZE}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_SYNCHRONIZE}>\" />\r\n                <img class=\"tooltip\" onclick=\"display_dialog(\'<{$users.uid}>\', true, true, \'slide\', \'slide\', 300, 400);\" src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_VIEW}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_VIEW}>\" />\r\n                <a class=\"tooltip\" href=\"admin.php?fct=users&amp;op=users_edit&amp;uid=<{$users.uid}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_EDIT}>\">\r\n                    <img src=\"<{xoAdminIcons user_edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_EDIT}>\" />\r\n                </a>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=users&amp;op=users_delete&amp;uid=<{$users.uid}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_DEL}>\">\r\n                    <img src=\"<{xoAdminIcons user_delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_DEL}>\" />\r\n                </a>\r\n                <{else}>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=users&amp;op=users_active&amp;uid=<{$users.uid}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_ACTIVE}>\">\r\n                    <img src=\"<{xoAdminIcons xoops/active_user.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_ACTIVE}>\" />\r\n                </a>\r\n                <img class=\"tooltip\" onclick=\"display_dialog(\'<{$users.uid}>\', true, true, \'slide\', \'slide\', 300, 400);\" src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_VIEW}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_VIEW}>\" />\r\n                <a class=\"tooltip\" href=\"admin.php?fct=users&amp;op=users_edit&amp;uid=<{$users.uid}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_EDIT}>\">\r\n                    <img src=\"<{xoAdminIcons user_edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_EDIT}>\" />\r\n                </a>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=users&amp;op=users_delete&amp;uid=<{$users.uid}>\" title=\"<{$smarty.const._AM_SYSTEM_USERS_DEL}>\">\r\n                    <img src=\"<{xoAdminIcons user_delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_USERS_DEL}>\" />\r\n                </a>\r\n                <{/if}>\r\n            </td>\r\n        </tr>\r\n        <{/foreach}>\r\n        </tbody>\r\n        <tr>\r\n            <td class=\'txtleft\' colspan=\'6\'>\r\n                <select name=\'fct\' onChange=\'changeDisplay (this.value, \"groups\", \"edit_group\")\'>\r\n                    <option value=\'\'>---------</option>\r\n                    <option value=\'mailusers\'><{$smarty.const._AM_SYSTEM_USERS_SENDMAIL}></option>\r\n                    <option value=\'groups\'><{$smarty.const._AM_SYSTEM_USERS_EDIT_GROUPS}></option>\r\n                    <option value=\'users\'><{$smarty.const._AM_SYSTEM_USERS_DELETE}></option>\r\n                </select>&nbsp;\r\n                <select name=\'edit_group\' id=\'edit_group\' onChange=\'changeDisplay (this.value, this.value, \"selgroups\")\' style=\"display:none;\">\r\n                    <option value=\'\'>---------</option>\r\n                    <option value=\'add_group\'><{$smarty.const._AM_SYSTEM_USERS_ADD_GROUPS}></option>\r\n                    <option value=\'delete_group\'><{$smarty.const._AM_SYSTEM_USERS_DELETE_GROUPS}></option>\r\n                </select>\r\n                <{$form_select_groups}>\r\n                <input type=\"hidden\" name=\"op\" value=\"action_group\">\r\n                <input type=\'submit\' name=\'Submit\' />\r\n            </td>\r\n        </tr>\r\n        </form>\r\n        <{/if}>\r\n        <!--No found-->\r\n        <{if $users_no_found == true}>\r\n        <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n            <td colspan=\'8\' class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USERS_NO_FOUND}></td>\r\n        </tr>\r\n        <{/if}>\r\n    </table>\r\n    <!--Pop-pup-->\r\n    <{if $users_count == true}>\r\n        <{foreach item=users from=$users_popup}>\r\n            <div id=\"dialog<{$users.uid}>\" title=\"<{$users.uname}>\" style=\'display:none;\'>\r\n                <table>\r\n                    <tr>\r\n                        <td class=\"txtcenter\">\r\n                            <img src=\"<{$users.user_avatar}>\" alt=\"<{$users.uname}>\" title=\"<{$users.uname}>\" />\r\n                        </td>\r\n                        <td class=\"txtcenter\">\r\n                            <a href=\'mailto:<{$users.email}>\'><img src=\"<{xoAdminIcons mail_send.png}>\" alt=\"\" title=<{$smarty.const._AM_SYSTEM_USERS_EMAIL}> /></a>\r\n                            <a href=\'javascript:openWithSelfMain(\"<{$xoops_url}>/pmlite.php?send2=1&amp;to_userid=<{$users.uid}>\",\"pmlite\",450,370);\'><img src=\"<{xoAdminIcons pm.png}>\" alt=\"\" title=<{$smarty.const._AM_SYSTEM_USERS_PM}> /></a>\r\n                            <a href=\'<{$users.url}>\' rel=\'external\'><img src=\"<{xoAdminIcons url.png}>\" alt=\"\" title=<{$smarty.const._AM_SYSTEM_USERS_URL}> ></a>\r\n                        </td>\r\n                    </tr>\r\n                    <tr>\r\n                        <td colspan=\"2\">\r\n                            <ul style=\"border: 1px solid #666; padding: 8px;\">\r\n                                <{if $users.user_name}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_NAME}></span>&nbsp;:&nbsp;<{$users.name}></li><{/if}>\r\n                                <li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_UNAME}></span>&nbsp;:&nbsp;<{$users.uname}></li>\r\n                                <li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_EMAIL}></span>&nbsp;:&nbsp;<{$users.email}></li>\r\n                                <{if $users.user_url}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_URL}></span>&nbsp;:&nbsp;<{$users.url}> </li><{/if}>\r\n                                <{if $users.user_icq}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_ICQ}></span>&nbsp;:&nbsp;<{$users.user_icq}></li><{/if}>\r\n                                <{if $users.user_aim}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_AIM}></span>&nbsp;:&nbsp;<{$users.user_aim}></li><{/if}>\r\n                                <{if $users.user_yim}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_YIM}></span>&nbsp;:&nbsp;<{$users.user_yim}></li><{/if}>\r\n                                <{if $users.user_msnm}><li><span class=\"bold\"><{$smarty.const._AM_SYSTEM_USERS_MSNM}></span>&nbsp;:&nbsp;<{$users.user_msnm}> </li><{/if}>\r\n                            </ul>\r\n                        </td>\r\n                    </tr>\r\n                </table>\r\n            </div>\r\n        <{/foreach}>\r\n    <{/if}>\r\n    <!--Pop-pup-->\r\n    <div class=\'txtright\'><{$nav}></div>\r\n<{/if}>\r\n<br />\r\n<!-- Display Avatar form (add,edit) -->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>'),
(31,	'<{if $breadcrumb}>\r\n<{includeq file=\"db:system_header.html\"}>\r\n<{/if}>\r\n<!--Preferences-->\r\n<{if $menu}>\r\n<div class=\"xo-catsetting\">\r\n	<{foreach item=preferences from=$preferences}>\r\n	<a class=\"tooltip\" href=\"admin.php?fct=preferences&amp;op=show&amp;confcat_id=<{$preferences.id}>\" title=\"<{$preferences.name}>\">\r\n        <img src=\"<{$preferences.image}>\" alt=\"<{$preferences.name}>\" />\r\n        <span><{$preferences.name}></span>\r\n    </a>	\r\n	<{/foreach}>\r\n	<a class=\"tooltip\" href=\"admin.php?fct=preferences&amp;op=showmod&amp;mod=1\" title=\"<{$smarty.const._AM_SYSTEM_PREFERENCES_SETTINGS}>\">\r\n        <img src=\"<{xoAdminIcons xoops/system_mods.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_PREFERENCES_SETTINGS}>\" />\r\n        <span><{$smarty.const._AM_SYSTEM_PREFERENCES_SETTINGS}></span>\r\n    </a>	\r\n</div>\r\n<{/if}>\r\n<div class=\"clear\">&nbsp;</div>\r\n<br />'),
(32,	'<!--smilies-->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<!-- Display mailusers form  -->\r\n<br />\r\n<{if $form}>\r\n    <div class=\"spacer\"><{$form}></div>\r\n<{/if}>\r\n<{$Sucess}>\r\n<{$Errors}>'),
(33,	'<!--groups-->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<{if $groups_count == true}>\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <button class=\"ui-corner-all\" onclick=\"self.location.href=\'admin.php?fct=groups&amp;op=groups_add\'\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_GROUPS_ADD}>\" />\r\n            <{$smarty.const._AM_SYSTEM_GROUPS_ADD}>\r\n        </button>\r\n    </div>\r\n</div>\r\n<table id=\"xo-group-sorter\" cellspacing=\"1\" class=\"outer tablesorter\">\r\n    <thead>\r\n	<tr>\r\n		<th class=\"txtcenter width5\"><{$smarty.const._AM_SYSTEM_GROUPS_ID}></th>\r\n        <th class=\"txtcenter width20\"><{$smarty.const._AM_SYSTEM_GROUPS_NAME}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_GROUPS_DESCRIPTION}></th>\r\n		<th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_GROUPS_NB_USERS_BY_GROUPS}></th>\r\n		<th class=\"txtcenter width10\"><{$smarty.const._AM_SYSTEM_GROUPS_ACTION}></th>\r\n	</tr>\r\n	</thead>\r\n	<tbody>\r\n	<{foreach item=groups from=$groups}>\r\n	<tr class=\"<{cycle values=\'odd, even\'}> alignmiddle\">\r\n		<td class=\"txtcenter\"><{$groups.groups_id}></td>\r\n        <td class=\"txtleft\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=groups&amp;op=groups_edit&amp;groups_id=<{$groups.groups_id}>\" title=\"<{$smarty.const._AM_SYSTEM_GROUPS_EDIT}>\">\r\n                <{$groups.name}>\r\n            </a>\r\n        </td>\r\n		<td class=\"txtleft\"><{$groups.description}></td>\r\n		<td class=\"txtcenter width25\">\r\n            <a href=\"./admin.php?fct=users&amp;selgroups=<{$groups.groups_id}>\"><{$groups.nb_users_by_groups}></a>\r\n        </td>\r\n		<td class=\"xo-actions txtcenter\">\r\n			<a class=\"tooltip\" href=\"admin.php?fct=groups&amp;op=groups_edit&amp;groups_id=<{$groups.groups_id}>\" title=\"<{$smarty.const._AM_SYSTEM_GROUPS_EDIT}>\">\r\n				<img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_GROUPS_EDIT}>\" />\r\n			</a>\r\n			<{if $groups.delete}>\r\n			<a class=\"tooltip\" href=\"admin.php?fct=groups&amp;op=groups_delete&amp;groups_id=<{$groups.groups_id}>\" title=\"<{$smarty.const._AM_SYSTEM_GROUPS_DELETE}>\">\r\n				<img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_GROUPS_DELETE}>\" />\r\n			</a>\r\n			<{/if}>\r\n        </td>\r\n	</tr>\r\n	<{/foreach}>\r\n	</tbody>\r\n</table>\r\n<!-- Display groups navigation -->\r\n<div class=\"clear spacer\"></div>\r\n<{if $nav_menu}>\r\n<div class=\"xo-avatar-pagenav floatright\"><{$nav_menu}></div><div class=\"clear spacer\"></div>\r\n<{/if}>\r\n<{/if}>\r\n<!-- Display groups form (add,edit) -->\r\n<{if $form}>\r\n<div class=\"spacer\"><{$form}></div>\r\n<{/if}>'),
(34,	'<!-- Header -->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<!-- Buttons -->\r\n<div class=\"floatright\">\r\n    <div class=\"xo-buttons\">\r\n        <{if !$edit_form && !$listimg}>\r\n        <button id=\"xo-addcat-btn\" class=\"ui-corner-all tooltip\" onclick=\"xo_toggle(\'div#xo-category-add\');\" title=\"<{$smarty.const._AM_SYSTEM_IMAGES_ADDCAT}>\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_IMAGES_ADDCAT}>\" />\r\n            <{$smarty.const._AM_SYSTEM_IMAGES_ADDCAT}>\r\n        </button>\r\n        <{/if}>\r\n        <{if $cat_img || $listimg}>\r\n        <button id=\"xo-addimg-btn\" class=\"ui-corner-all tooltip\" onclick=\"xo_toggle(\'div#xo-images-add\');\" title=\"<{$smarty.const._AM_SYSTEM_IMAGES_ADDIMG}>\">\r\n            <img src=\"<{xoAdminIcons add.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_IMAGES_ADDIMG}>\" />\r\n            <{$smarty.const._AM_SYSTEM_IMAGES_ADDIMG}>\r\n        </button>\r\n        <{/if}>\r\n    </div>\r\n</div>\r\n<!-- Category List -->\r\n<{if !$edit_form && !$listimg}>\r\n<table class=\"outer\" cellspacing=\"1\">\r\n    <thead>\r\n        <tr>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_NAME}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_NBIMAGES}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_MAXSIZE}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_MAXWIDTH}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_MAXHEIGHT}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_DISPLAY}></th>\r\n            <th><{$smarty.const._AM_SYSTEM_IMAGES_ACTIONS}></th>\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <{foreach item=cat from=$cat_img}>\r\n        <tr class=\"<{cycle values=\'odd, even\'}> txtcenter\">\r\n            <td>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=listimg&amp;imgcat_id=<{$cat.id}>\" title=\"<{$smarty.const._AM_SYSTEM_IMAGES_VIEW}>\">\r\n                    <{$cat.name}>\r\n                </a>\r\n            </td>\r\n            <td><{$cat.count}></td>\r\n            <td><{$cat.maxsize}></td>\r\n            <td><{$cat.maxwidth}></td>\r\n            <td><{$cat.maxheight}></td>\r\n            <td class=\"xo-actions\"><img id=\"loading_cat<{$cat.id}>\" src=\"./images/spinner.gif\" style=\"display:none;\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"cursorpointer tooltip\" id=\"cat<{$cat.id}>\" onclick=\"system_setStatus( { fct: \'images\', op: \'display_cat\', imgcat_id: <{$cat.id}> }, \'cat<{$cat.id}>\', \'admin.php\' )\" src=\"<{if $cat.display}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"\" title=\"<{if $cat.display}><{$smarty.const._AM_SYSTEM_IMAGES_OFF}><{else}><{$smarty.const._AM_SYSTEM_IMAGES_ON}><{/if}>\" />\r\n            </td>\r\n            <td class=\"xo-actions txtcenter\">\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=listimg&amp;imgcat_id=<{$cat.id}>\" title=\"<{$smarty.const._AM_SYSTEM_IMAGES_VIEW}>\">\r\n                    <img src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_IMAGES_VIEW}>\" />\r\n                </a>\r\n                <{if $xoops_isadmin}>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=editcat&amp;imgcat_id=<{$cat.id}>\" title=\"<{$smarty.const._EDIT}>\">\r\n                    <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._EDIT}>\" />\r\n                </a>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=delcat&amp;imgcat_id=<{$cat.id}>\" title=\"<{$smarty.const._EDIT}>\">\r\n                    <img src=\"<{xoAdminIcons delete.png}>\" alt=\"\" />\r\n                </a>\r\n                <{/if}>\r\n            </td>\r\n        </tr>\r\n        <{/foreach}>\r\n        <{if !$cat_img}>\r\n        <tr>\r\n            <td class=\"txtcenter bold odd\" colspan=\"7\"><{$smarty.const._AM_SYSTEM_IMAGES_NOCAT}></td>\r\n        </tr>\r\n        <{/if}>\r\n    </tbody>\r\n</table>\r\n<!-- Nav menu -->\r\n<{if $nav_menu}><div class=\"xo-avatar-pagenav floatright\"><{$nav_menu}></div><div class=\"clear spacer\"></div><{/if}>\r\n<{/if}>\r\n<{if $images}>\r\n<!-- Image list -->\r\n<div id=\"xo-category-add\" class=\"\">\r\n    <{foreach item=img from=$images}>\r\n    <div class=\"floatleft\">\r\n        <div class=\"ui-corner-all xo-thumb txtcenter\">\r\n            <div class=\"xo-thumbimg\">\r\n                <img class=\"tooltip\" src=\"<{$xoops_url}>/image.php?id=<{$img.image_id}>&amp;width=120&amp;height=120\" alt=\"<{$img.image_nicename}>\" title=\"<{$img.image_nicename}>\" style=\"max-width:120px; max-height:120px;\" />\r\n            </div>\r\n            <div class=\"xo-actions txtcenter\">\r\n                <div class=\"spacer bold\"><{$img.image_nicename}></div>\r\n                    <img id=\"loading_img<{$img.image_id}>\" src=\"./images/spinner.gif\" style=\"display:none;\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" /><img class=\"cursorpointer tooltip\" id=\"img<{$img.image_id}>\" onclick=\"system_setStatus( { fct: \'images\', op: \'display_img\', image_id: <{$img.image_id}> }, \'img<{$img.image_id}>\', \'admin.php\' )\" src=\"<{if $img.image_display}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{$smarty.const._IMGDISPLAY}>\" title=\"<{$smarty.const._IMGDISPLAY}>\" />\r\n                    <{if !$db_store}>\r\n                    <a class=\"lightbox tooltip\" href=\"<{$xoops_upload_url}>/<{$img.image_name}>\" title=\"<{$smarty.const._PREVIEW}>\">\r\n                    <{else}>\r\n                    <a class=\"lightbox tooltip\" href=\"<{$xoops_url}>/image.php?id=<{$img.image_id}>\" title=\"<{$smarty.const._PREVIEW}>\">\r\n                    <{/if}>\r\n                        <img src=\"<{xoAdminIcons display.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_IMAGES_VIEW}>\" />\r\n                    </a>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=editimg&amp;image_id=<{$img.image_id}>\" title=\"<{$smarty.const._EDIT}>\">\r\n                    <img src=\"<{xoAdminIcons edit.png}>\" alt=\"<{$smarty.const._EDIT}>\" />\r\n                </a>\r\n                <a class=\"tooltip\" href=\"admin.php?fct=images&amp;op=delfile&amp;image_id=<{$img.image_id}>\" title=\"<{$smarty.const._DELETE}>\">\r\n                    <img src=\"<{xoAdminIcons delete.png}>\" alt=\"<{$smarty.const._DELETE}>\" />\r\n                </a>\r\n                 <img class=\"tooltip\" onclick=\"display_dialog(<{$img.image_id}>, true, true, \'slide\', \'slide\', 120, 350);\" src=\"<{xoAdminIcons url.png}>\" alt=\"<{$smarty.const._AM_SYSTEM_IMAGES_URL}>\" title=\"<{$smarty.const._AM_SYSTEM_IMAGES_URL}>\" />\r\n            </div>\r\n        </div>\r\n    </div>\r\n    \r\n    <div id=\"dialog<{$img.image_id}>\" title=\"<{$img.image_nicename}>\" style=\'display:none;\'>\r\n          <div class=\"center\">\r\n              <{if !$db_store}>\r\n              <{$xoops_upload_url}>/<{$img.image_name}>\r\n              <{else}>\r\n              <{$xoops_url}>/image.php?id=<{$img.image_id}>\r\n              <{/if}>\r\n          </div>\r\n    </div>\r\n\r\n    <{/foreach}>\r\n    <div class=\"clear\"></div>\r\n</div>\r\n<{if $nav_menu}><div class=\"xo-avatar-pagenav floatright\"><{$nav_menu}></div><div class=\"clear spacer\"></div><{/if}>\r\n<{else}>\r\n<div id=\"xo-category-add\" class=\"\">\r\n    <div class=\"clear\"></div>\r\n</div>\r\n<{/if}>\r\n\r\n<!-- Add Image form -->\r\n<div id=\"xo-images-add\" class=\"hide\">\r\n    <br />\r\n    <{$image_form.javascript}>\r\n    <form name=\"<{$image_form.name}>\" id=\"<{$image_form.name}>\" action=\"<{$image_form.action}>\" method=\"<{$image_form.method}>\" <{$image_form.extra}> >\r\n    <table class=\"outer\">\r\n        <tr>\r\n            <th colspan=\"2\"><{$image_form.title}></th>\r\n        </tr>\r\n        <{foreach item=element from=$image_form.elements}>\r\n        <{if $element.hidden != true && $element.body != \'\'}>\r\n        <tr>\r\n            <td class=\"odd aligntop\">\r\n                <div class=\"spacer bold\"><{$element.caption}><{if $element.required}><span class=\"red\">&nbsp;*</span><{/if}></div>\r\n                <div class=\"spacer\"><{$element.description}></div>\r\n            </td>\r\n            <td class=\"even\"><{$element.body}></td>\r\n        </tr>\r\n        <{else}>\r\n        <{$element.body}>\r\n        <{/if}>\r\n        <{/foreach}>\r\n    </table>\r\n    </form>\r\n</div>\r\n<!-- Add Category form -->\r\n<div id=\"xo-category-add\" class=\"hide\">\r\n    <br />\r\n    <{$imagecat_form.javascript}>\r\n    <form name=\"<{$imagecat_form.name}>\" id=\"<{$imagecat_form.name}>\" action=\"<{$imagecat_form.action}>\" method=\"<{$imagecat_form.method}>\" <{$imagecat_form.extra}> >\r\n    <table class=\"outer\">\r\n        <tr>\r\n            <th colspan=\"2\"><{$imagecat_form.title}></th>\r\n        </tr>\r\n        <{foreach item=element from=$imagecat_form.elements}>\r\n        <{if $element.hidden != true && $element.body != \'\'}>\r\n        <tr>\r\n            <td class=\"odd aligntop\">\r\n                <div class=\"spacer bold\"><{$element.caption}><{if $element.required}><span class=\"red\">&nbsp;*</span><{/if}></div>\r\n                <div class=\"spacer\"><{$element.description}></div>\r\n            </td>\r\n            <td class=\"even\"><{$element.body}></td>\r\n        </tr>\r\n        <{else}>\r\n        <{$element.body}>\r\n        <{/if}>\r\n        <{/foreach}>\r\n    </table>\r\n    </form>\r\n</div>\r\n<!-- Edit form image -->\r\n<{if $edit_form}>\r\n<div id=\"xo-images-add\" class=\"\">\r\n    <{$edit_thumbs}>\r\n    <br />\r\n    <{$edit_form.javascript}>\r\n    <form name=\"<{$edit_form.name}>\" id=\"<{$edit_form.name}>\" action=\"<{$edit_form.action}>\" method=\"<{$edit_form.method}>\" <{$edit_form.extra}> >\r\n    <table class=\"outer\">\r\n        <tr>\r\n            <th colspan=\"2\"><{$edit_form.title}></th>\r\n        </tr>\r\n        <{foreach item=element from=$edit_form.elements}>\r\n        <{if $element.hidden != true && $element.body != \'\'}>\r\n        <tr>\r\n            <td class=\"odd aligntop\">\r\n                <div class=\"spacer bold\"><{$element.caption}><{if $element.required}><span class=\"red\">&nbsp;*</span><{/if}></div>\r\n                <div class=\"spacer\"><{$element.description}></div>\r\n            </td>\r\n            <td class=\"even\"><{$element.body}></td>\r\n        </tr>\r\n        <{else}>\r\n        <{$element.body}>\r\n        <{/if}>\r\n        <{/foreach}>\r\n    </table>\r\n    </form>\r\n</div>\r\n<{/if}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n\r\n    $(\'.lightbox\').lightBox({\r\n        imageLoading:\'language/<{$xoops_language}>/images/lightbox-ico-loading.gif\',\r\n        imageBtnClose:\'language/<{$xoops_language}>/images/lightbox-btn-close.gif\',\r\n        imageBtnNext:\'language/<{$xoops_language}>/images/lightbox-btn-next.gif\',\r\n        imageBtnPrev:\'language/<{$xoops_language}>/images/lightbox-btn-prev.gif\',\r\n        imageBlank:\'language/<{$xoops_language}>/images/lightbox-blank.gif\'\r\n    });\r\n\r\n\r\n</script>'),
(35,	'<{includeq file=\"db:system_header.html\"}>\r\n\r\n<{if $index}>    \r\n<br class=\"clear\" />\r\n<div class=\"spacer\">\r\n    <table class=\"outer ui-corner-all\" cellspacing=\"1\">\r\n        <tr>\r\n            <th><{$smarty.const._AM_SYSTEM_TEMPLATES_YOUR_THEMES}></th>\r\n            <th>&nbsp;</th>\r\n        </tr>\r\n		<tr>\r\n			<td class=\"aligntop width10\"><div id=\"fileTree\" class=\"display_folder\"></div></td>\r\n			<td class=\"aligntop\">\r\n				<div id=\"display_form\"><{$form}></div>\r\n				<div id=\"display_contenu\"></div>\r\n				<div id=\'display_message\' class=\"txtcenter\" style=\"display:none;\"></div>\r\n				<div id=\'loading\' class=\"txtcenter\" style=\"display:none;\"><br /><br /><img src=\"images/loading.gif\" title=\"Loading\" alt=\"Loading\" /></div>\r\n			</td>\r\n		</tr>\r\n    </table>\r\n\r\n<br class=\"clear\" />\r\n</div>\r\n<{else}>\r\n    <br />\r\n    <{if $verif}>\r\n        <{$infos}>\r\n    <{else}>\r\n        <div class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_TEMPLATES_NOT_CREATED}></div>\r\n    <{/if}>\r\n<{/if}>'),
(36,	'<{includeq file=\"db:system_header.html\"}>\r\n<script type=\"text/javascript\">\r\n    IMG_ON = \'<{xoAdminIcons success.png}>\';\r\n    IMG_OFF = \'<{xoAdminIcons cancel.png}>\';\r\n</script>\r\n<table cellspacing=\"1\" class=\"outer\">\r\n    <thead>\r\n        <tr>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_SECTION}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_DESC}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_USAGE}></th>\r\n            <th class=\"txtcenter\"><{$smarty.const._AM_SYSTEM_ACTIVE}></th>\r\n        </tr>\r\n    </thead>\r\n\r\n    <tbody>\r\n    <{foreach item=menu from=$menu}>\r\n    <{if $menu.title}>\r\n    <tr class=\"<{cycle values=\'even,odd\'}>\">\r\n        <td class=\"bold width15\">\r\n            <a class=\"tooltip\" href=\"admin.php?fct=<{$menu.file}>\" title=\"<{$smarty.const._AM_SYSTEM_GO}>: <{$menu.title}>\">\r\n                <img class=\"xo-imgmini\" src=\'<{$theme_icons}>/<{$menu.icon}>\' alt=\"<{$menu.title}>\" />\r\n                <{$menu.title}>\r\n            </a>\r\n        </td>\r\n        <td class=\"\"><{$menu.desc}></td>\r\n        <td class=\"width15\"><{$menu.infos}></td>\r\n        <td class=\"xo-actions width2\">\r\n            <{if $menu.used}>\r\n                <img id=\"loading_<{$menu.file}>\" src=\"images/spinner.gif\" style=\"display:none;\" alt=\"<{$smarty.const._AM_SYSTEM_LOADING}>\" />\r\n                <img class=\"tooltip\" id=\"<{$menu.file}>\" onclick=\"system_setStatus( { op: \'system_activate\', type: \'<{$menu.file}>\' }, \'<{$menu.file}>\', \'admin.php\' )\" src=\"<{if $menu.status}><{xoAdminIcons success.png}><{else}><{xoAdminIcons cancel.png}><{/if}>\" alt=\"<{$smarty.const._AM_SYSTEM_STATUS}>\" title=\"<{$smarty.const._AM_SYSTEM_STATUS}>\" />\r\n            <{/if}>\r\n        </td>\r\n    </tr>\r\n    <{/if}>\r\n    <{/foreach}>\r\n    </tbody>\r\n</table>'),
(37,	'<!--maintenance-->\r\n<{includeq file=\"db:system_header.html\"}>\r\n<!-- Display mailusers form  -->\r\n<br />\r\n<{if $form_maintenance}>\r\n    <div class=\"spacer\"><{$form_maintenance}></div><br />\r\n	<div class=\"spacer\"><{$form_dump}></div>\r\n<{elseif $maintenance}>\r\n	<{if $verif_cache || $verif_session || $verif_avatar}>\r\n		<table class=\"outer ui-corner-all\" cellspacing=\"1\">\r\n			<tr>\r\n				<th><{$smarty.const._AM_SYSTEM_MAINTENANCE}></th>\r\n				<th><{$smarty.const._AM_SYSTEM_MAINTENANCE_RESULT}></th>\r\n			</tr>\r\n			<{if $verif_cache}>\r\n				<tr>\r\n					<td class=\"aligntop txtcenter\"><{$smarty.const._AM_SYSTEM_MAINTENANCE_RESULT_CACHE}></td>\r\n					<td class=\"aligntop txtcenter\"><{if $result_cache}><img width=\"16\" src=\"<{xoAdminIcons success.png}>\" /><{else}><img style=\"width:16px;\" src=\"<{xoAdminIcons cancel.png}>\" alt=\"Cancel\"/><{/if}></td>\r\n				</tr>\r\n			<{/if}>\r\n\r\n			<{if $verif_session}>\r\n				<tr>\r\n					<td class=\"aligntop\" align=\"center\"><{$smarty.const._AM_SYSTEM_MAINTENANCE_RESULT_SESSION}></td>\r\n					<td class=\"aligntop\" align=\"center\"><{if $result_session}><img style=\"width:16px;\" src=\"<{xoAdminIcons success.png}>\" alt=\"Success\"/><{else}><img style=\"width:16px;\" src=\"<{xoAdminIcons cancel.png}>\" alt=\"Cancel\"/><{/if}></td>\r\n				</tr>\r\n			<{/if}>\r\n\r\n			<{if $verif_avatar}>\r\n				<tr>\r\n					<td class=\"aligntop\" align=\"center\"><{$smarty.const._AM_SYSTEM_MAINTENANCE_RESULT_AVATAR}></td>\r\n					<td class=\"aligntop\" align=\"center\"><{if $result_avatar}><img style=\"width:16px;\" src=\"<{xoAdminIcons success.png}>\" alt=\"Success\"/><{else}><img style=\"width:16px;\" src=\"<{xoAdminIcons cancel.png}>\" alt=\"Cancel\"/><{/if}></td>\r\n				</tr>\r\n			<{/if}>\r\n		</table><br />\r\n	<{/if}>\r\n	<{if $verif_maintenance}>\r\n		<{$result_maintenance}>\r\n	<{/if}>\r\n<{else}>\r\n	<{$result_dump}>\r\n<{/if}>'),
(38,	'<{includeq file=\"db:system_header.html\"}>\r\n<table>\r\n	<tr>\r\n		<td class=\"width20\">\r\n			<{if $help}>\r\n				<div class=\"xo-help-menu\">\r\n					<h2 class=\"head\"><{$modname}></h2>\r\n					<{foreach item=help from=$help}>\r\n						<div class=\"<{cycle values=\'odd, even\'}>\"><a href=\"<{$help.link}>\"><{$help.name}></a></div>\r\n					<{/foreach}>\r\n				</div>\r\n			<{/if}>\r\n			<{if $list_mods}>\r\n				<div class=\"xo-help-menu\">\r\n					<{foreach item=row from=$list_mods}>\r\n						<h2 class=\"head\"><{$row.name}></h2>\r\n						<{foreach item=list from=$row.help_page}>\r\n							<div class=\"<{cycle values=\'odd, even\'}>\" title=\"<{$list.name}>\"><a href=\"<{$list.link}>\"><{$list.name}></a></div>\r\n						<{/foreach}>\r\n					<{/foreach}>\r\n				</div>\r\n			<{/if}>\r\n		</td>\r\n		<td>\r\n			<div id=\"help-content\">\r\n	         <{$helpcontent}>\r\n			</div>\r\n		</td>\r\n	</tr>\r\n</table>'),
(39,	'<div id=\"usermenu\">\r\n  <{if $xoops_isadmin}>\r\n	<a class=\"menuTop\" href=\"<{xoAppUrl admin.php}>\" title=\"<{$block.lang_adminmenu}>\"><{$block.lang_adminmenu}></a>\r\n	<a href=\"<{xoAppUrl user.php}>\" title=\"<{$block.lang_youraccount}>\"><{$block.lang_youraccount}></a>\r\n  <{else}>\r\n	<a class=\"menuTop\" href=\"<{xoAppUrl user.php}>\" title=\"<{$block.lang_youraccount}>\"><{$block.lang_youraccount}></a>\r\n  <{/if}>\r\n  <a href=\"<{xoAppUrl edituser.php}>\" title=\"<{$block.lang_editaccount}>\"><{$block.lang_editaccount}></a>\r\n  <a href=\"<{xoAppUrl notifications.php}>\" title=\"<{$block.lang_notifications}>\"><{$block.lang_notifications}></a>\r\n  <{if $block.new_messages > 0}>\r\n	<a class=\"highlight\" href=\"<{xoAppUrl viewpmsg.php}>\" title=\"<{$block.lang_inbox}>\"><{$block.lang_inbox}> (<strong><{$block.new_messages}></strong>)</a>\r\n  <{else}>\r\n	<a href=\"<{xoAppUrl viewpmsg.php}>\" title=\"<{$block.lang_inbox}>\"><{$block.lang_inbox}></a>\r\n  <{/if}>\r\n  <a href=\"<{xoAppUrl user.php?op=logout}>\" title=\"<{$block.lang_logout}>\"><{$block.lang_logout}></a>\r\n</div>'),
(40,	'<div class=\"txtcenter\">\r\n	<form style=\"margin-top: 0;\" action=\"<{xoAppUrl user.php}>\" method=\"post\">\r\n		<{$block.lang_username}><br />\r\n		<input type=\"text\" name=\"uname\" size=\"12\" value=\"<{$block.unamevalue}>\" maxlength=\"25\" /><br />\r\n		<{$block.lang_password}><br />\r\n		<input type=\"password\" name=\"pass\" size=\"12\" maxlength=\"32\" /><br />\r\n		<{if isset($block.lang_rememberme)}>\r\n			<input type=\"checkbox\" name=\"rememberme\" value=\"On\" class =\"formButton\" /><{$block.lang_rememberme}><br />\r\n		<{/if}>\r\n		<br />\r\n		<input type=\"hidden\" name=\"xoops_redirect\" value=\"<{$xoops_requesturi}>\" />\r\n		<input type=\"hidden\" name=\"op\" value=\"login\" />\r\n		<input type=\"submit\" value=\"<{$block.lang_login}>\" /><br />\r\n		<{$block.sslloginlink}>\r\n	</form>\r\n	<br />\r\n	<a href=\"<{xoAppUrl user.php#lost}>\" title=\"<{$block.lang_lostpass}>\"><{$block.lang_lostpass}></a>\r\n	<br /><br />\r\n	<a href=\"<{xoAppUrl register.php}>\" title=\"<{$block.lang_registernow}>\"><{$block.lang_registernow}></a>\r\n</div>'),
(41,	'<div class=\"txtcenter\">\r\n<form style=\"margin-top: 0;\" action=\"<{xoAppUrl search.php}>\" method=\"get\">\r\n  <input type=\"text\" name=\"query\" size=\"14\" />\r\n  <input type=\"hidden\" name=\"action\" value=\"results\" /><br />\r\n  <input type=\"submit\" value=\"<{$block.lang_search}>\" />\r\n</form>\r\n<a href=\"<{xoAppUrl search.php}>\" title=\"<{$block.lang_advsearch}>\"><{$block.lang_advsearch}></a>\r\n</div>'),
(42,	'<ul>\r\n  <{foreach item=module from=$block.modules}>\r\n  <li><a href=\"<{$module.adminlink}>\" title=\"<{$module.lang_linkname}>\"><{$module.lang_linkname}></a>: <{$module.pendingnum}></li>\r\n  <{/foreach}>\r\n</ul>'),
(43,	'<div id=\"mainmenu\">\r\n    <a class=\"menuTop <{if !$block.nothome}>maincurrent<{/if}>\" href=\"<{xoAppUrl }>\" title=\"<{$block.lang_home}>\"><{$block.lang_home}></a>\r\n    <!-- start module menu loop -->\r\n    <{foreach item=module from=$block.modules}>\r\n		<a class=\"menuMain <{if $module.highlight}>maincurrent<{/if}>\" href=\"<{$xoops_url}>/modules/<{$module.directory}>/\" title=\"<{$module.name}>\"><{$module.name}></a>\r\n		<{foreach item=sublink from=$module.sublinks}>\r\n			<a class=\"menuSub\" href=\"<{$sublink.url}>\" title=\"<{$sublink.name}>\"><{$sublink.name}></a>\r\n		<{/foreach}>\r\n    <{/foreach}>\r\n    <!-- end module menu loop -->\r\n</div>'),
(44,	'<table class=\"outer collapse\">\r\n\r\n  <{if $block.showgroups == true}>\r\n\r\n  <!-- start group loop -->\r\n  <{foreach item=group from=$block.groups}>\r\n  <tr>\r\n    <th colspan=\"2\"><{$group.name}></th>\r\n  </tr>\r\n\r\n  <!-- start group member loop -->\r\n  <{foreach item=user from=$group.users}>\r\n  <tr>\r\n    <td class=\"even txtcenter alignmiddle\">\r\n        <img style=\"width:32px;\" src=\"<{$user.avatar}>\" alt=\"<{$user.name}>\" /><br />\r\n        <a href=\"<{$xoops_url}>/userinfo.php?uid=<{$user.id}>\" title=\"<{$user.name}>\"><{$user.name}></a>\r\n    </td>\r\n    <td class=\"odd width20 txtright alignmiddle\">\r\n        <{$user.msglink}>\r\n    </td>\r\n  </tr>\r\n  <{/foreach}>\r\n  <!-- end group member loop -->\r\n\r\n  <{/foreach}>\r\n  <!-- end group loop -->\r\n  <{/if}>\r\n</table>\r\n\r\n<br />\r\n\r\n<div class=\"txtcenter marg3\">\r\n  <img src=\"<{$block.logourl}>\" alt=\"\" /><br /><{$block.recommendlink}>\r\n</div>'),
(45,	'<{$block.online_total}>\r\n<br /><br />\r\n<{$block.lang_members}>: <{$block.online_members}>\r\n<br />\r\n<{$block.lang_guests}>: <{$block.online_guests}>\r\n<br /><br />\r\n<{$block.online_names}>\r\n<a href=\"javascript:openWithSelfMain(\'<{$xoops_url}>/misc.php?action=showpopups&amp;type=online\',\'Online\',420,350);\" title=\"<{$block.lang_more}>\">\r\n    <{$block.lang_more}>\r\n</a>'),
(46,	'<table cellspacing=\"1\" class=\"outer\">\r\n  <{foreach item=user from=$block.users}>\r\n  <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n    <td><{$user.rank}></td>\r\n    <td class=\"txtcenter\">\r\n      <{if $user.avatar != \"\"}>\r\n      <img style=\"width:32px;\" src=\"<{$user.avatar}>\" alt=\"<{$user.name}>\" /><br />\r\n      <{/if}>\r\n      <a href=\"<{$xoops_url}>/userinfo.php?uid=<{$user.id}>\" title=\"<{$user.name}>\"><{$user.name}></a>\r\n    </td>\r\n    <td class=\"txtcenter\"><{$user.posts}></td>\r\n  </tr>\r\n  <{/foreach}>\r\n</table>'),
(47,	'<table cellspacing=\"1\" class=\"outer\">\r\n  <{foreach item=user from=$block.users}>\r\n    <tr class=\"<{cycle values=\'even,odd\'}> alignmiddle\">\r\n      <td class=\"txtcenter\">\r\n      <{if $user.avatar != \"\"}>\r\n      <img style=\"width:32px;\" src=\"<{$user.avatar}>\" alt=\"<{$user.name}>\" /><br />\r\n      <{/if}>\r\n      <a href=\"<{$xoops_url}>/userinfo.php?uid=<{$user.id}>\" title=\"<{$user.name}>\"><{$user.name}></a>\r\n      </td>\r\n      <td class=\"txtcenter\"><{$user.joindate}></td>\r\n    </tr>\r\n  <{/foreach}>\r\n</table>'),
(48,	'<table cellspacing=\"1\" class=\"outer width100\">\r\n  <{foreach item=comment from=$block.comments}>\r\n  <tr class=\"<{cycle values=\'even,odd\'}>\">\r\n    <td class=\"txtcenter\"><img src=\"<{$xoops_url}>/images/subject/<{$comment.icon}>\" alt=\"\" /></td>\r\n    <td><{$comment.title}></td>\r\n    <td class=\"txtcenter\"><{$comment.module}></td>\r\n    <td class=\"txtcenter\"><{$comment.poster}></td>\r\n    <td class=\"txtright\"><{$comment.time}></td>\r\n  </tr>\r\n  <{/foreach}>\r\n</table>'),
(49,	'<form action=\"<{$block.target_page}>\" method=\"post\">\r\n<table class=\"outer\">\r\n  <{foreach item=category from=$block.categories}>\r\n  <{foreach name=inner item=event from=$category.events}>\r\n  <{if $smarty.foreach.inner.first}>\r\n  <tr>\r\n    <td class=\"head\" colspan=\"2\"><{$category.title}></td>\r\n  </tr>\r\n  <{/if}>\r\n  <tr>\r\n    <td class=\"odd\">\r\n		<{counter assign=index}>\r\n		<input type=\"hidden\" name=\"not_list[<{$index}>][params]\" value=\"<{$category.name}>,<{$category.itemid}>,<{$event.name}>\" />\r\n		<input type=\"checkbox\" name=\"not_list[<{$index}>][status]\" value=\"1\" <{if $event.subscribed}>checked=\"checked\"<{/if}> />\r\n	</td>\r\n    <td class=\"odd\"><{$event.caption}></td>\r\n  </tr>\r\n  <{/foreach}>\r\n  <{/foreach}>\r\n  <tr>\r\n    <td class=\"foot\" colspan=\"2\">\r\n		<input type=\"hidden\" name=\"not_redirect\" value=\"<{$block.redirect_script}>\">\r\n		<input type=\"hidden\" value=\"<{$block.notification_token}>\" name=\"XOOPS_TOKEN_REQUEST\" />\r\n		<input type=\"submit\" name=\"not_submit\" value=\"<{$block.submit_button}>\" />\r\n	</td>\r\n  </tr>\r\n</table>\r\n</form>'),
(50,	'<div class=\"txtcenter\">\r\n<form action=\"<{xoAppUrl index.php}>\" method=\"post\">\r\n<{$block.theme_select}>\r\n</form>\r\n</div>'),
(179,	'<h2><{$version}></h2>\r\n<form action=\"main.php\" method=\"post\">\r\n  <table class=\"table\">\r\n  <tr>\r\n    <th><{$smarty.const._MA_TT_THEMES}></th>\r\n    <th><{$smarty.const._MA_TT_THEMES_KIND}></th>\r\n    <th><{$smarty.const._MA_TT_NEED_BOOTSTRAP}></th>\r\n    <th><{$smarty.const._MA_TT_BOOTSTRAP_COLOR}></th>\r\n  </tr>\r\n  <{foreach item=theme from=$themes}>\r\n    <tr>\r\n      <td <{$theme.color}>>\r\n        <{$theme.theme_name}>\r\n      </td>\r\n      <td <{$theme.color}>>\r\n        <{$theme.theme_kind}>\r\n          <input type=\"hidden\" name=\"tt_theme_kind[<{$theme.theme_name}>]\" value=\"<{$theme.theme_kind}>\">\r\n      </td>\r\n      <td <{$theme.color}>>\r\n        <{if $theme.tad_theme==1}>\r\n          <{$smarty.const._MA_TT_TAD_THEMES}>\r\n          <input type=\"hidden\" name=\"tt_use_bootstrap[<{$theme.theme_name}>]\" value=\"0\">\r\n        <{else}>\r\n          <select name=\"tt_use_bootstrap[<{$theme.theme_name}>]\" class=\"span2\">\r\n            <option value=\"\" <{if $theme.use_bootstrap==\"\"}>selected<{/if}>><{$smarty.const._MA_TT_EMPTY_CONFIG}></option>\r\n            <option value=\"1\" <{if $theme.use_bootstrap==\"1\"}>selected<{/if}>><{$smarty.const._YES}></option>\r\n            <option value=\"0\" <{if $theme.use_bootstrap==\"0\"}>selected<{/if}>><{$smarty.const._NO}></option>\r\n          </select>\r\n        <{/if}>\r\n      </td>\r\n      <td <{$theme.color}>>\r\n          <select name=\"tt_bootstrap_color[<{$theme.theme_name}>]\" class=\"span4\">\r\n            <{foreach from=$theme.bootstrap_theme item=color}>\r\n              <option value=\"<{$color.theme_path}>\" <{if $theme.bootstrap_color==$color.theme}>selected<{/if}>><{$color.theme}> (<{if $color.kind}><{$color.kind}>-<{/if}><{$color.color}>)</option>\r\n            <{/foreach}>\r\n          </select>\r\n      </td>\r\n    </tr>\r\n  <{/foreach}>\r\n  </table>\r\n  <p class=\"text-center\">\r\n    <input type=\"hidden\" name=\"op\" value=\"save\">\r\n    <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TT_SAVE}></button>\r\n  </p>\r\n</form>'),
(192,	'<h2><{$version}></h2>\r\n<form action=\"main.php\" method=\"post\">\r\n  <table class=\"table\">\r\n    <tr>\r\n      <th><{$smarty.const._MA_TT_THEMES}></th>\r\n      <th><{$smarty.const._MA_TT_THEMES_KIND}></th>\r\n      <th><{$smarty.const._MA_TT_NEED_BOOTSTRAP}></th>\r\n      <th><{$smarty.const._MA_TT_BOOTSTRAP_COLOR}></th>\r\n    </tr>\r\n    <{foreach item=theme from=$themes}>\r\n      <tr>\r\n        <td <{$theme.color}> class=\"col-md-3\">\r\n          <{$theme.theme_name}>\r\n        </td>\r\n        <td <{$theme.color}> class=\"col-md-2\">\r\n          <{$theme.theme_kind}>\r\n            <input type=\"hidden\" name=\"tt_theme_kind[<{$theme.theme_name}>]\" value=\"<{$theme.theme_kind}>\">\r\n        </td>\r\n        <td <{$theme.color}> class=\"col-md-3\">\r\n          <{if $theme.tad_theme==1}>\r\n            <{$smarty.const._MA_TT_TAD_THEMES}>\r\n            <input type=\"hidden\" name=\"tt_use_bootstrap[<{$theme.theme_name}>]\" value=\"0\">\r\n          <{else}>\r\n            <select name=\"tt_use_bootstrap[<{$theme.theme_name}>]\" class=\"form-control\">\r\n              <option value=\"\" <{if $theme.use_bootstrap==\"\"}>selected<{/if}>><{$smarty.const._MA_TT_EMPTY_CONFIG}></option>\r\n              <option value=\"1\" <{if $theme.use_bootstrap==\"1\"}>selected<{/if}>><{$smarty.const._YES}></option>\r\n              <option value=\"0\" <{if $theme.use_bootstrap==\"0\"}>selected<{/if}>><{$smarty.const._NO}></option>\r\n            </select>\r\n          <{/if}>\r\n        </td>\r\n        <td <{$theme.color}> class=\"col-md-4\">\r\n            <select name=\"tt_bootstrap_color[<{$theme.theme_name}>]\" class=\"form-control\">\r\n              <{foreach from=$theme.bootstrap_theme item=color}>\r\n                <option value=\"<{$color.theme_path}>\" <{if $theme.bootstrap_color==$color.theme}>selected<{/if}>><{$color.theme}> (<{if $color.kind}><{$color.kind}>-<{/if}><{$color.color}>)</option>\r\n              <{/foreach}>\r\n            </select>\r\n        </td>\r\n      </tr>\r\n    <{/foreach}>\r\n  </table>\r\n  <p class=\"text-center\">\r\n    <input type=\"hidden\" name=\"op\" value=\"save\">\r\n    <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TT_SAVE}></button>\r\n  </p>\r\n</form>'),
(177,	'<div class=\"container-fluid\">\r\n  <{$jquery}>\r\n  <{$mColorPicker_code}>\r\n  <script type=\"text/javascript\">\r\n\r\n    $(document).ready(function(){\r\n\r\n      change_css();\r\n      preview_img(\"bg\",\"<{$bg_img}>\");\r\n      $(\"#tad-themes-tabs\").tabs({\r\n       activate: function (e, ui) {\r\n           $.cookie(\'selected-tab\', ui.newTab.index(), { path: \'/\' });\r\n       },\r\n       active: $.cookie(\'selected-tab\'),\r\n       collapsible: false\r\n      });\r\n      $(\"#bt_tabs\").tabs({\r\n        activate: function (e, ui) {\r\n            $.cookie(\'selected-tab\', ui.newTab.index(), { path: \'/\' });\r\n        },\r\n        active: $.cookie(\'selected-tab\')\r\n      }).addClass( \"ui-tabs-vertical ui-helper-clearfix\" );\r\n      $(\"#bt_tabs li\").removeClass( \"ui-corner-top\" ).addClass( \"ui-corner-left\" );\r\n\r\n      <{if $logo_position==\"page\"}>\r\n        $(\"#logo_place_setup\").hide();\r\n      <{else}>\r\n        $(\"#logo_place_setup\").show();\r\n      <{/if}>\r\n\r\n    });\r\n\r\n\r\n    function logo_place_setup(logo_position){\r\n      if(logo_position==\"page\"){\r\n        $(\"#logo_place_setup\").hide();\r\n      }else{\r\n        $(\"#logo_place_setup\").show();\r\n      }\r\n    }\r\n\r\n    function preview_img(kind,imgSrc){\r\n      var newimgSrc=imgSrc.replace(kind+\"/\", kind+\"/thumbs/\");\r\n      var newImg = new Image();\r\n      newImg.src = imgSrc;\r\n      var height = newImg.height * 1;\r\n      if(height > 90){\r\n        $(\"#preview_zone\").css(\"background-image\",\"url(\"+newimgSrc+\")\");\r\n      }else{\r\n        $(\"#preview_zone\").css(\"background-image\",\"url(\"+imgSrc+\")\");\r\n      }\r\n    }\r\n\r\n    <{$chang_css}>\r\n\r\n\r\n    function delete_tad_themes_config(theme_id){\r\n      var sure = window.confirm(\"<{$smarty.const._MA_TADTHEMES_DEL_CONFIRM}>\");\r\n      if (!sure)  return;\r\n      location.href=\"main.php?op=delete_tad_themes&theme_id=\" + theme_id;\r\n    }\r\n  </script>\r\n\r\n  <style>\r\n    .ui-tabs-vertical { width: 100%; }\r\n    .ui-tabs-vertical .ui-tabs-nav { padding: .2em .1em .2em .2em; float: left; width: 20%; }\r\n    .ui-tabs-vertical .ui-tabs-nav li { clear: left; width: 100%; border-bottom-width: 1px !important; border-right-width: 0 !important; margin: 0 -1px .2em 0; }\r\n    .ui-tabs-vertical .ui-tabs-nav li a { display:block; }\r\n    .ui-tabs-vertical .ui-tabs-nav li.ui-tabs-active { padding-bottom: 0; padding-right: .1em; border-right-width: 1px; border-right-width: 1px; }\r\n    .ui-tabs-vertical .ui-tabs-panel { padding: 1em; float: right; width: 72%;}\r\n  </style>\r\n\r\n  <{$formValidator_code}>\r\n\r\n  <form action=\"main.php\" method=\"post\" id=\"myForm\" enctype=\"multipart/form-data\">\r\n    <div class=\"row-fluid\">\r\n      <div class=\"span8\">\r\n        <div class=\"row-fluid\">\r\n          <label style=\"font-size:24px;font-weight:bold;\">\r\n            <{$theme_name}><{$smarty.const._MA_TAD_THEMES_FORM}>\r\n\r\n            <a href=\"javascript:delete_tad_themes_config(<{$theme_id}>)\" class=\"btn btn-danger\"><{$smarty.const._MA_TADTHEMES_TO_DEFAULT}></a>\r\n          </label>\r\n\r\n          <div class=\"alert\">\r\n            <{$smarty.const._MA_TADTHEMES_CHANGE_KIND_DESC}>\r\n          </div>\r\n\r\n          <{if $theme_change}>\r\n            <{foreach from=$theme_kind_arr item=kind}>\r\n              <div class=\"radio\">\r\n                <label>\r\n                  <input type=\"radio\" name=\"theme_kind\" value=\"<{$kind}>\" <{if $theme_kind==$kind}>checked<{/if}>>\r\n                  <b><{$kind}></b>\r\n                  <{$theme_kind_txt_arr.$kind}>\r\n                </label>\r\n              </div>\r\n            <{/foreach}>\r\n\r\n            <input type=\"hidden\" name=\"old_theme_kind\" value=\"<{$theme_kind}>\">\r\n          <{else}>\r\n            <{$theme_kind}><{$theme_kind_txt}>\r\n            <input type=\"hidden\" name=\"theme_kind\" value=\"<{$theme_kind}>\">\r\n          <{/if}>\r\n        </div>\r\n\r\n        <div class=\"row-fluid\">\r\n          <div id=\"tad-themes-tabs\">\r\n            <ul>\r\n              <{if $config_tabs.1}>\r\n                <li><a href=\"#tabs-1\"><{$smarty.const._MA_TADTHEMES_THEME_BASE}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.2}>\r\n                <li><a href=\"#tabs-2\"><{$smarty.const._MA_TADTHEMES_BG_IMG}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.3}>\r\n                <li><a href=\"#tabs-3\"><{$smarty.const._MA_TAD_THEMES_HEAD}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.4}>\r\n                <li><a href=\"#tabs-4\"><{$smarty.const._MA_TADTHEMES_LOGO_IMG}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.5}>\r\n                <li><a href=\"#tabs-5\"><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.6}>\r\n                <li><a href=\"#tabs-6\"><{$smarty.const._MA_TADTHEMES_NAVBAR}></a></li>\r\n              <{/if}>\r\n              <!--額外設定-->\r\n              <{if $config2}>\r\n              <li><a href=\"#tabs-7\"><{$smarty.const._MA_TADTHEMES_CONFIG2}></a></li>\r\n              <{/if}>\r\n            </ul>\r\n\r\n            <{if $config_tabs.1}>\r\n              <div id=\"tabs-1\">\r\n                <!--版面基本設定-->\r\n                <!--佈景類型-->\r\n                <div class=\"row-fluid\">\r\n                  <!--版面類型-->\r\n                  <{if $enable.theme_type}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_THEME_TYPE}></div>\r\n                    <div class=\"span2\">\r\n                      <select name=\"theme_type\" id=\"theme_type\" class=\"span12<{$validate.theme_type}>\" onChange=\"change_css();\">\r\n                        <option value=\"theme_type_1\" <{if $theme_type==\"theme_type_1\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE1}></option>\r\n                        <option value=\"theme_type_2\" <{if $theme_type==\"theme_type_2\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE2}></option>\r\n                        <option value=\"theme_type_3\" <{if $theme_type==\"theme_type_3\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE3}></option>\r\n                        <option value=\"theme_type_4\" <{if $theme_type==\"theme_type_4\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE4}></option>\r\n                        <option value=\"theme_type_5\" <{if $theme_type==\"theme_type_5\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE5}></option>\r\n                        <option value=\"theme_type_6\" <{if $theme_type==\"theme_type_6\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE6}></option>\r\n                        <option value=\"theme_type_7\" <{if $theme_type==\"theme_type_7\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE7}></option>\r\n                        <option value=\"theme_type_8\" <{if $theme_type==\"theme_type_8\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE8}></option>\r\n                      </select>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"theme_type\" id=\"theme_type\" value=\"<{$theme_type}>\">\r\n                  <{/if}>\r\n\r\n                  <!--版面寬度-->\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_THEME_WIDTH}></div>\r\n                    <div class=\"span2\">\r\n                      <{if $enable.theme_width}>\r\n                        <input type=\"text\" name=\"theme_width\" class=\"span8 <{$validate.theme_width}>\" value=\"<{$theme_width}>\" id=\"theme_width\">\r\n                        <{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"theme_width\" id=\"theme_width\" value=\"<{$theme_width}>\"><{$theme_width}><{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                      <{/if}>\r\n                    </div>\r\n\r\n                  <!--內容區顏色-->\r\n                  <{if $enable.base_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_BASE_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"base_color\" class=\"span8<{$validate.base_color}>\" value=\"<{$base_color}>\" id=\"base_color\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"base_color\" id=\"base_color\" value=\"<{$base_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row-fluid\">\r\n                  <!--左區塊顏色-->\r\n                  <{if $enable.lb_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_LB_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"lb_color\" id=\"lb_color\" value=\"<{$lb_color}>\" class=\"span8<{$validate.lb_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"lb_color\" id=\"lb_color\" value=\"<{$lb_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--中區塊顏色-->\r\n                  <{if $enable.cb_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_CB_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"cb_color\" id=\"cb_color\" value=\"<{$cb_color}>\" class=\"span8<{$validate.cb_color}>\"  data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"cb_color\" id=\"cb_color\" value=\"<{$cb_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--右區塊顏色-->\r\n                  <{if $enable.rb_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_RB_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"rb_color\" id=\"rb_color\" value=\"<{$rb_color}>\" class=\"span8<{$validate.rb_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"rb_color\" id=\"rb_color\" value=\"<{$rb_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row-fluid\">\r\n                  <!--左區塊寬度-->\r\n                  <{if $enable.lb_width}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_LB_WIDTH}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"lb_width\" class=\"span8<{$validate.lb_width}>\" value=\"<{$lb_width}>\" id=\"lb_width\" onChange=\"change_css();\">\r\n                      <{$theme_unit}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"lb_width\" id=\"lb_width\" value=\"<{$lb_width}>\">\r\n                  <{/if}>\r\n\r\n                  <!--中區塊寬度-->\r\n                  <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_CB_WIDTH}></div>\r\n                  <div class=\"span2\">\r\n                    <div id=\"cb_width\"></div>\r\n                  </div>\r\n\r\n                  <!--右區塊寬度-->\r\n                  <{if $enable.rb_width}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_RB_WIDTH}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"rb_width\" class=\"span8<{$validate.rb_width}>\" value=\"<{$rb_width}>\" id=\"rb_width\" onChange=\"change_css();\">\r\n                      <{$theme_unit}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"rb_width\" id=\"rb_width\" value=\"<{$rb_width}>\">\r\n                  <{/if}>\r\n\r\n                </div>\r\n\r\n\r\n                <div class=\"row-fluid\">\r\n\r\n                  <!--文字大小-->\r\n                  <{if $enable.font_size}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_FONT_SIZE}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"font_size\" class=\"span8<{$validate.font_size}>\" value=\"<{$font_size}>\" id=\"font_size\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"font_size\" id=\"font_size\" value=\"<{$font_size}>\">\r\n                  <{/if}>\r\n\r\n                  <!--離上邊界距離-->\r\n                  <{if $enable.margin_top}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_MARGIN_TOP}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"margin_top\" class=\"span8<{$validate.margin_top}>\" value=\"<{$margin_top}>\" id=\"margin_top\"  onChange=\"change_css();\">px\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"margin_top\" id=\"margin_top\" value=\"<{$margin_top}>\">\r\n                  <{/if}>\r\n\r\n                  <!--離下邊界距離-->\r\n                  <{if $enable.margin_bottom}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_MARGIN_BOTTOM}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"margin_bottom\" class=\"span8<{$validate.margin_bottom}>\" value=\"<{$margin_bottom}>\" id=\"margin_bottom\"  onChange=\"change_css();\">px\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"margin_bottom\" id=\"margin_bottom\" value=\"<{$margin_bottom}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n                <div class=\"row-fluid\">\r\n\r\n                  <!--文字顏色-->\r\n                  <{if $enable.font_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_FONT_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"font_color\" id=\"font_color\" value=\"<{$font_color}>\" class=\"span8<{$validate.font_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"font_color\" id=\"font_color\" value=\"<{$font_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--連結顏色-->\r\n                  <{if $enable.link_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_LINK_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"link_color\" id=\"link_color\" value=\"<{$link_color}>\" class=\"span8<{$validate.link_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"link_color\" id=\"link_color\" value=\"<{$link_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--滑鼠移到連結顏色-->\r\n                  <{if $enable.hover_color}>\r\n                    <div class=\"span2 text-right\"><{$smarty.const._MA_TADTHEMES_HOVER_COLOR}></div>\r\n                    <div class=\"span2\">\r\n                      <input type=\"text\" name=\"hover_color\" id=\"hover_color\" value=\"<{$hover_color}>\" class=\"span8<{$validate.hover_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"hover_color\" id=\"hover_color\" value=\"<{$hover_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"theme_type\" name=\"theme_type\" value=\"<{$theme_type}>\">\r\n              <input type=\"hidden\" id=\"theme_width\" name=\"theme_width\" value=\"<{$theme_width}>\">\r\n              <input type=\"hidden\" id=\"base_color\" name=\"base_color\" value=\"<{$base_color}>\">\r\n              <input type=\"hidden\" id=\"lb_color\" name=\"lb_color\" value=\"<{$lb_color}>\">\r\n              <input type=\"hidden\" id=\"cb_color\" name=\"cb_color\" value=\"<{$cb_color}>\">\r\n              <input type=\"hidden\" id=\"rb_color\" name=\"rb_color\" value=\"<{$rb_color}>\">\r\n              <input type=\"hidden\" id=\"lb_width\" name=\"lb_width\" value=\"<{$lb_width}>\">\r\n              <input type=\"hidden\" id=\"rb_width\" name=\"rb_width\" value=\"<{$rb_width}>\">\r\n              <input type=\"hidden\" id=\"clb_width\" name=\"clb_width\" value=\"<{$clb_width}>\">\r\n              <input type=\"hidden\" id=\"crb_width\" name=\"crb_width\" value=\"<{$crb_width}>\">\r\n              <input type=\"hidden\" id=\"margin_top\" name=\"margin_top\" value=\"<{$margin_top}>\">\r\n              <input type=\"hidden\" id=\"font_size\" name=\"font_size\" value=\"<{$font_size}>\">\r\n              <input type=\"hidden\" id=\"margin_bottom\" name=\"margin_bottom\" value=\"<{$margin_bottom}>\">\r\n              <input type=\"hidden\" id=\"font_color\" name=\"font_color\" value=\"<{$font_color}>\">\r\n              <input type=\"hidden\" id=\"link_color\" name=\"link_color\" value=\"<{$link_color}>\">\r\n              <input type=\"hidden\" id=\"hover_color\" name=\"hover_color\" value=\"<{$hover_color}>\">\r\n            <{/if}>\r\n\r\n            <!--背景圖-->\r\n            <{if $config_tabs.2}>\r\n              <div id=\"tabs-2\">\r\n                <div class=\"row-fluid\">\r\n                  <div class=\"span5\">\r\n                    <{if $enable.bg_img}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 上傳 背景圖-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                          <{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <{$upform_bg}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_img\" id=\"bg_img\" value=\"<{$bg_img}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_color}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 背景顏色-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_COLOR}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <input type=\"text\" name=\"bg_color\" id=\"bg_color\" value=\"<{$bg_color}>\" class=\"span6<{$validate.bg_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_color\" id=\"bg_color\" value=\"<{$bg_color}>\">\r\n                    <{/if}>\r\n\r\n                    <{if $enable.bg_repeat}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 背景重複-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_REPEAT}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <select name=\"bg_repeat\" id=\"bg_repeat\" class=\"span12<{$validate.bg_repeat}>\" onChange=\"change_css();\">\r\n                            <option value=\"repeat\" <{if $bg_repeat==\"repeat\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_NORMAL}></option>\r\n                            <option value=\"repeat-x\" <{if $bg_repeat==\"repeat-x\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_X}></option>\r\n                            <option value=\"repeat-y\" <{if $bg_repeat==\"repeat-y\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_Y}></option>\r\n                            <option value=\"no-repeat\" <{if $bg_repeat==\"no-repeat\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_NO_REPEAT}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_repeat\" id=\"bg_repeat\" value=\"<{$bg_repeat}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_attachment}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 背景模式-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <select name=\"bg_attachment\" id=\"bg_attachment\" class=\"span12<{$validate.bg_attachment}>\" onChange=\"change_css();\">\r\n                            <option value=\"scroll\" <{if $bg_attachment==\"scroll\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT_SCROLL}></option>\r\n                            <option value=\"fixed\" <{if $bg_attachment==\"fixed\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT_FIXED}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_attachment\" id=\"bg_attachment\" value=\"<{$bg_attachment}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_position}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 背景位置-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_POSITION}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <select name=\"bg_position\" id=\"bg_position\" class=\"span12<{$validate.bg_position}>\" onChange=\"change_css();\">\r\n                            <option value=\"\" <{if $bg_position==\"left top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LT}></option>\r\n                            <option value=\"right top\" <{if $bg_position==\"right top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RT}></option>\r\n                            <option value=\"left bottom\" <{if $bg_position==\"left bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LB}></option>\r\n                            <option value=\"right bottom\" <{if $bg_position==\"right bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RB}></option>\r\n                            <option value=\"center center\" <{if $bg_position==\"center center\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CC}></option>\r\n                            <option value=\"center top\" <{if $bg_position==\"center top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CT}></option>\r\n                            <option value=\"center bottom\" <{if $bg_position==\"center bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CB}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_position\" id=\"bg_position\" value=\"<{$bg_position}>\">\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <!--選擇預設 背景圖-->\r\n                  <div class=\"span7\">\r\n                    <{if $all_bg and $enable.bg_img==\"1\"}>\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"bg_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"bg_img\" id=\"bg_img0\" onChange=\"$(\'.del_img_box\').show(); preview_img(\'bg\',$(this).val());\" value=\"\" <{if $bg_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                        </label>\r\n                      </div>\r\n                      <{foreach from=$all_bg item=bg}>\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"bg_img<{$bg.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$bg.tb_path}>);background-position:center center;border:1px solid gray;\" >\r\n                            <input type=\"radio\" name=\"bg_img\" id=\"bg_img<{$bg.files_sn}>\" onChange=\"$(\'.del_img_box\').show(); $(\'#del_img<{$bg.files_sn}>\').hide(); preview_img(\'bg\',$(this).val());\" value=\"<{$bg.path}>\" <{if $bg_img==$bg.path}>checked<{/if}>>\r\n                          </label>\r\n                          <label class=\"checkbox del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$bg.files_sn}>\">\r\n                            <input type=\"checkbox\" value=\"<{$bg.files_sn}>\" name=\"del_file[<{$bg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                          </label>\r\n                        </div>\r\n                      <{/foreach}>\r\n                    <{/if}>\r\n                  </div>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"bg_img\" name=\"bg_img\" value=\"<{$bg_img}>\">\r\n              <input type=\"hidden\" id=\"bg_color\" name=\"bg_color\" value=\"<{$bg_color}>\">\r\n              <input type=\"hidden\" id=\"bg_repeat\" name=\"bg_repeat\" value=\"<{$bg_repeat}>\">\r\n              <input type=\"hidden\" id=\"bg_attachment\" name=\"bg_attachment\" value=\"<{$bg_attachment}>\">\r\n              <input type=\"hidden\" id=\"bg_position\" name=\"bg_position\" value=\"<{$bg_position}>\">\r\n            <{/if}>\r\n\r\n            <!--滑動圖片高度-->\r\n            <{if $config_tabs.3}>\r\n              <div id=\"tabs-3\">\r\n                <div class=\"row-fluid\">\r\n\r\n                  <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\"}>\r\n                    <div class=\"span5\">\r\n\r\n                      <!--滑動圖片寬度-->\r\n                      <{if $enable.slide_width==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_SLIDE_WIDTH}>\r\n                          </div>\r\n                          <div class=\"span8\">\r\n                            <input type=\"text\" name=\"slide_width\" class=\"span8<{$validate.slide_width}>\" value=\"<{$slide_width}>\" id=\"slide_width\" onChange=\"change_css();\">\r\n                            <{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"slide_width\" id=\"slide_width\" value=\"<{$slide_width}>\">\r\n                      <{/if}>\r\n\r\n                      <!--滑動圖片高度-->\r\n                      <{if $enable.slide_height==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_SLIDE_HEIGHT}>\r\n                          </div>\r\n                          <div class=\"span8\">\r\n                            <input type=\"text\" name=\"slide_height\" class=\"span8<{$validate.slide_height}>\" value=\"<{$slide_height}>\" id=\"slide_height\" onChange=\"change_css();\"> px\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"slide_height\" id=\"slide_height\" value=\"<{$slide_height}>\">\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" id=\"slide_width\" name=\"slide_width\" value=\"<{$slide_width}>\">\r\n                    <input type=\"hidden\" id=\"slide_height\" name=\"slide_height\" value=\"<{$slide_height}>\">\r\n                  <{/if}>\r\n\r\n                  <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\" or $enable.use_slide==\"1\"}>\r\n                    <div class=\"span7\">\r\n                      <div class=\"span12 alert alert-success\">\r\n                        <{$smarty.const._MA_TADTHEMES_SLIDE_DESC}>\r\n                      </div>\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n                <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\" or $enable.use_slide==\"1\"}>\r\n                  <div class=\"row-fluid\">\r\n                    <!-- 背景模式-->\r\n                    <div class=\"span2 text-right\">\r\n                      <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                      <{$smarty.const._MA_TAD_THEMES_HEAD}>\r\n                    </div>\r\n                    <div class=\"span10\">\r\n                      <{$upform_slide}>\r\n                    </div>\r\n                  </div>\r\n                <{/if}>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"slide_width\" name=\"slide_width\" value=\"<{$slide_width}>\">\r\n              <input type=\"hidden\" id=\"slide_height\" name=\"slide_height\" value=\"<{$slide_height}>\">\r\n            <{/if}>\r\n\r\n            <!--logo圖-->\r\n            <{if $config_tabs.4}>\r\n              <div id=\"tabs-4\">\r\n                <div class=\"row-fluid\">\r\n                  <div class=\"span5\">\r\n\r\n                    <!-- 上傳logo圖-->\r\n                    <{if $enable.logo_img==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_LOGO_IMG}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <{$upform_logo}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"logo_img\" id=\"logo_img\" value=\"<{$logo_img}>\">\r\n                    <{/if}>\r\n\r\n                    <!-- logo圖位置-->\r\n                    <{if $enable.logo_position==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_LOGO_POSITION}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <label class=\"radio\">\r\n                            <input type=\"radio\" name=\"logo_position\" onClick=\"logo_place_setup(this.value)\" value=\"slide\" <{if $logo_position==\"slide\"}>checked<{/if}>><{$smarty.const._MA_TADTHEMES_LOGO_SLIDE}>\r\n                          </label>\r\n                          <label class=\"radio\">\r\n                            <input type=\"radio\" name=\"logo_position\" onClick=\"logo_place_setup(this.value)\" class=\"logo_position\" value=\"page\" <{if $logo_position==\"page\"}>checked<{/if}>><{$smarty.const._MA_TADTHEMES_LOGO_PAGE}>\r\n                          </label>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"logo_position\" id=\"logo_position\" value=\"<{$logo_position}>\">\r\n                    <{/if}>\r\n\r\n\r\n\r\n                    <!-- 選擇預設logo圖-->\r\n                    <{if $enable.logo_top==\"1\" or  $enable.logo_right==\"1\" or $enable.logo_left==\"1\" or $enable.logo_bottom==\"1\"}>\r\n                      <div class=\"row-fluid\" id=\"logo_place_setup\">\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_LOGO_PLACE}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <{if $enable.logo_top==\"1\"}>\r\n                            <div class=\"row-fluid\">\r\n                              <div class=\"span4 offset4\">\r\n                                <input type=\"text\" name=\"logo_top\" class=\"span8<{$validate.logo_top}>\" value=\"<{$logo_top}>\" id=\"logo_top\" onChange=\"if(this.value > 0){$(\'#logo_bottom\').val(0);}\"> px\r\n                              </div>\r\n                            </div>\r\n                          <{else}>\r\n                            <input type=\"hidden\" name=\"logo_top\" id=\"logo_top\" value=\"<{$logo_top}>\">\r\n                          <{/if}>\r\n\r\n                          <div class=\"row-fluid\">\r\n                            <{if $enable.logo_left==\"1\"}>\r\n                              <div class=\"span4\">\r\n                                <input type=\"text\" name=\"logo_left\" class=\"span8<{$validate.logo_left}>\" value=\"<{$logo_left}>\" id=\"logo_left\" onChange=\"if(this.value > 0){$(\'#logo_right\').val(0);}\"> px\r\n                              </div>\r\n                            <{else}>\r\n                              <input type=\"hidden\" name=\"logo_left\" id=\"logo_left\" value=\"<{$logo_left}>\">\r\n                            <{/if}>\r\n\r\n                            <{if $enable.logo_right==\"1\"}>\r\n                              <div class=\"span4 offset4\">\r\n                                <input type=\"text\" name=\"logo_right\" class=\"span8<{$validate.logo_right}>\" value=\"<{$logo_right}>\" id=\"logo_right\" onChange=\"if(this.value > 0){$(\'#logo_left\').val(0);}\"> px\r\n                              </div>\r\n                            <{else}>\r\n                              <input type=\"hidden\" name=\"logo_right\" id=\"logo_right\" value=\"<{$logo_right}>\">\r\n                            <{/if}>\r\n                          </div>\r\n\r\n                          <{if $enable.logo_bottom==\"1\"}>\r\n                            <div class=\"row-fluid\">\r\n                              <div class=\"span4 offset4\">\r\n                                <input type=\"text\" name=\"logo_bottom\" class=\"span8<{$validate.logo_bottom}>\" value=\"<{$logo_bottom}>\" id=\"logo_bottom\" onChange=\"if(this.value > 0){$(\'#logo_top\').val(0);}\"> px\r\n                              </div>\r\n                            </div>\r\n                          <{else}>\r\n                            <input type=\"hidden\" name=\"logo_bottom\" id=\"logo_bottom\" value=\"<{$logo_bottom}>\">\r\n                          <{/if}>\r\n                        </div>\r\n                      </div>\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <{if $enable.logo_img==\"1\"}>\r\n                    <div class=\"span7\">\r\n                      <!-- 選擇預設logo圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"logo_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"logo_img\" id=\"logo_img0\" value=\"\" <{if $logo_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_LOGO_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_logo}>\r\n                        <{foreach from=$all_logo item=logo}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"logo_img<{$logo.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$logo.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"logo_img\" id=\"logo_img<{$logo.files_sn}>\" value=\"<{$logo.path}>\" <{if $logo_img==$logo.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"checkbox del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$logo.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$logo.files_sn}>\" name=\"del_file[<{$logo.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"logo_img\" name=\"logo_img\" value=\"<{$logo_img}>\">\r\n              <input type=\"hidden\" id=\"logo_position\" name=\"logo_position\" value=\"<{$logo_position}>\">\r\n              <input type=\"hidden\" id=\"logo_top\" name=\"logo_top\" value=\"<{$logo_top}>\">\r\n              <input type=\"hidden\" id=\"logo_right\" name=\"logo_right\" value=\"<{$logo_right}>\">\r\n              <input type=\"hidden\" id=\"logo_bottom\" name=\"logo_bottom\" value=\"<{$logo_bottom}>\">\r\n              <input type=\"hidden\" id=\"logo_left\" name=\"logo_left\" value=\"<{$logo_left}>\">\r\n            <{/if}>\r\n\r\n            <!--區塊標題列背景圖-->\r\n            <{if $config_tabs.5}>\r\n              <div id=\"tabs-5\">\r\n\r\n                <div id=\"bt_tabs\">\r\n                  <ul class=\"nav nav-tabs\">\r\n                    <{foreach from=$blocks_values item=block}>\r\n                      <li><a href=\"#bp_<{$block.block_position}>\"><{$block.title}></a></li>\r\n                    <{/foreach}>\r\n                  </ul>\r\n\r\n                  <{foreach from=$blocks_values item=block}>\r\n                    <div id=\"bp_<{$block.block_position}>\">\r\n                      <div style=\"font-size:1.5em;margin:0px 0px 10px;font-weight:bold;\">\r\n                        <{$block.title}>\r\n                      <label class=\"checkbox inline\">\r\n                        <input type=\"checkbox\" name=\"apply_to_all\" value=\"<{$block.block_position}>\">\r\n                        <{$smarty.const._MA_TADTHEMES_BLOCK_ALL_POSITION}>\r\n                      </label></div>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 區塊標題文字大小-->\r\n                        <{if $enable.bt_text_size==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_SIZE}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <input type=\"text\" name=\"bt_text_size[<{$block.block_position}>]\" class=\"span6<{$validate.bt_text_size}>\" value=\"<{$block.bt_text_size}>\" id=\"bt_text_size_<{$block.block_position}>\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text_size\" id=\"bt_text_size\" value=\"<{$bt_text_size}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題文字縮排-->\r\n                        <{if $enable.bt_text_padding==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_PADDING}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <input type=\"text\" name=\"bt_text_padding[<{$block.block_position}>]\" class=\"span6<{$validate.bt_text_padding}>\" value=\"<{$block.bt_text_padding}>\" id=\"bt_text_padding_<{$block.block_position}>\">px\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text_padding\" id=\"bt_text_padding\" value=\"<{$bt_text_padding}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 區塊標題列文字顏色-->\r\n                        <{if $enable.bt_text==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_FONT_COLOR}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <input type=\"text\" name=\"bt_text[<{$block.block_position}>]\" id=\"bt_text_<{$block.block_position}>\" value=\"<{$block.bt_text}>\" class=\"span6<{$validate.bt_text}>\" data-hex=\"true\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text\" id=\"bt_text\" value=\"<{$bt_text}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題列背景顏色-->\r\n                        <{if $enable.bt_bg_color==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BG_COLOR}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <input type=\"text\" name=\"bt_bg_color[<{$block.block_position}>]\" id=\"bt_bg_color_<{$block.block_position}>\" value=\"<{$block.bt_bg_color}>\" class=\"span6<{$validate.bt_bg_color}>\" data-hex=\"true\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_color\" id=\"bt_bg_color\" value=\"<{$bt_bg_color}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row-fluid\">\r\n\r\n                        <!-- 區塊標題圓角設定-->\r\n                        <{if $enable.bt_radius==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS}>\r\n                          </div>\r\n\r\n                          <div class=\"span4\">\r\n                            <select name=\"bt_radius[<{$block.block_position}>]\" id=\"bt_radius_<{$block.block_position}>\" class=\"span12<{$validate.bt_radius}>\">\r\n                              <option value=\"1\" <{if $block.bt_radius==\"1\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS_Y}></option>\r\n                              <option value=\"0\" <{if $block.bt_radius==\"0\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS_N}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_radius\" id=\"bt_radius\" value=\"<{$bt_radius}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題工具按鈕-->\r\n                        <{if $enable.block_config==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_BUTTOM}>\r\n                          </div>\r\n\r\n                          <div class=\"span4\">\r\n                            <select name=\"block_config[<{$block.block_position}>]\" id=\"block_config_<{$block.block_position}>\" class=\"span12<{$validate.block_config}>\">\r\n                              <option value=\"right\" <{if $block.block_config==\"right\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RT}></option>\r\n                              <option value=\"left\" <{if $block.block_config==\"left\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LT}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_config\" id=\"block_config\" value=\"<{$block_config}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 上傳區塊標題列背景圖-->\r\n                        <{if $enable.bt_bg_img==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                            <{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <{$block.upform_bt_bg}>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_img\" id=\"bt_bg_img\" value=\"<{$bt_bg_img}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題列背景重複-->\r\n                        <{if $enable.bt_bg_repeat==\"1\"}>\r\n                          <div class=\"span2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BG_REPEAT}>\r\n                          </div>\r\n                          <div class=\"span4\">\r\n                            <select name=\"bt_bg_repeat[<{$block.block_position}>]\" id=\"bt_bg_repeat_<{$block.block_position}>\" class=\"span12<{$validate.bt_bg_repeat}>\">\r\n                              <option value=\"1\" <{if $block.bt_bg_repeat==\"1\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_NORMAL}></option>\r\n                              <option value=\"0\" <{if $block.bt_bg_repeat==\"0\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_NO_REPEAT}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_repeat\" id=\"bt_bg_repeat\" value=\"<{$bt_bg_repeat}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n\r\n                      <!-- 選擇預設區塊標題列背景圖-->\r\n                      <{if $block.all_bt_bg and $enable.bt_bg_img==\'1\'}>\r\n                        <div class=\"row-fluid\">\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"bt_bg_img0_<{$block.block_position}>\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                              <input type=\"radio\" name=\"bt_bg_img[<{$block.block_position}>]\" id=\"bt_bg_img0_<{$block.block_position}>\" onChange=\"$(\'.del_img_box_<{$block.block_position}>\').show();\" value=\"\" <{if $block.bt_bg_img==\"\"}>checked<{/if}>>\r\n                              <{$smarty.const._MA_TADTHEMES_NONE}>\r\n                            </label>\r\n                          </div>\r\n                          <{foreach from=$block.all_bt_bg item=bt_bg}>\r\n                            <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                              <label for=\"bt_bg_img<{$bt_bg.files_sn}>_<{$block.block_position}>\" style=\"width:60px; height:60px; background:#000000 url(<{$bt_bg.tb_path}>);background-position:left center;border:1px solid gray;\" >\r\n                                <input type=\"radio\" name=\"bt_bg_img[<{$block.block_position}>]\" id=\"bt_bg_img<{$bt_bg.files_sn}>_<{$block.block_position}>\" onChange=\"$(\'.del_img_box_<{$block.block_position}>\').show(); $(\'#del_img<{$bt_bg.files_sn}>_<{$block.block_position}>\').hide(); \" value=\"<{$bt_bg.path}>\" <{if $block.bt_bg_img==$bt_bg.path}>checked<{/if}>>\r\n                              </label>\r\n                              <label class=\"checkbox del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$bt_bg.files_sn}>_<{$block.block_position}>\">\r\n                                <input type=\"checkbox\" value=\"<{$bt_bg.files_sn}>\" name=\"del_file[<{$bt_bg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                              </label>\r\n                            </div>\r\n                          <{/foreach}>\r\n                        </div>\r\n                      <{/if}>\r\n\r\n\r\n\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 區塊整體樣式-->\r\n                        <{if $enable.block_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_style[<{$block.block_position}>]\" id=\"block_style_<{$block.block_position}>\" class=\"span12<{$validate.block_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_style\" id=\"block_style\" value=\"<{$block_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 區塊標題樣式-->\r\n                        <{if $enable.block_title_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> .blockTitle {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_title_style[<{$block.block_position}>]\" id=\"block_title_style_<{$block.block_position}>\" class=\"span12<{$validate.block_title_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_title_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_title_style\" id=\"block_title_style\" value=\"<{$block_title_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 區塊內容樣式-->\r\n                        <{if $enable.block_content_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_CONTENT_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> .blockContent {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_content_style[<{$block.block_position}>]\" id=\"block_content_style_<{$block.block_position}>\" class=\"span12<{$validate.block_content_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_content_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_content_style\" id=\"block_content_style\" value=\"<{$block_content_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                    </div>\r\n                  <{/foreach}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"bt_text_size\" name=\"bt_text_size\" value=\"<{$bt_text_size}>\">\r\n              <input type=\"hidden\" id=\"bt_text_padding\" name=\"bt_text_padding\" value=\"<{$bt_text_padding}>\">\r\n              <input type=\"hidden\" id=\"bt_text\" name=\"bt_text\" value=\"<{$bt_text}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_color\" name=\"bt_bg_color\" value=\"<{$bt_bg_color}>\">\r\n              <input type=\"hidden\" id=\"bt_radius\" name=\"bt_radius\" value=\"<{$bt_radius}>\">\r\n              <input type=\"hidden\" id=\"block_config\" name=\"block_config\" value=\"<{$block_config}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_img\" name=\"bt_bg_img\" value=\"<{$bt_bg_img}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_repeat\" name=\"bt_bg_repeat\" value=\"<{$bt_bg_repeat}>\">\r\n              <input type=\"hidden\" id=\"block_style\" name=\"block_style\" value=\"<{$block_style}>\">\r\n              <input type=\"hidden\" id=\"block_title_style\" name=\"block_title_style\" value=\"<{$block_title_style}>\">\r\n              <input type=\"hidden\" id=\"block_content_style\" name=\"block_content_style\" value=\"<{$block_content_style}>\">\r\n            <{/if}>\r\n\r\n            <!--navbar-->\r\n            <{if $config_tabs.6}>\r\n              <div id=\"tabs-6\">\r\n                <div class=\"row-fluid\">\r\n                  <{if $enable.navbar_pos==\"1\" or $enable.navbar_bg_top==\"1\" or  $enable.navbar_bg_bottom==\"1\" or $enable.navbar_hover==\"1\"}>\r\n                    <div class=\"span6\">\r\n                      <!--導覽工具列位置-->\r\n                      <{if $enable.navbar_pos==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4\"><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION}></div>\r\n                          <div class=\"span8\">\r\n                            <select name=\"navbar_pos\" id=\"navbar_pos\" class=\"span12<{$validate.navbar_pos}>\">\r\n                              <option value=\"navbar-fixed-top\" <{if $navbar_pos==\"navbar-fixed-top\"}>selected<{/if}>>\r\n                              <{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_1}></option>\r\n                              <option value=\"navbar-fixed-bottom\" <{if $navbar_pos==\"navbar-fixed-bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_2}></option>\r\n                              <option value=\"navbar-static-top\" <{if $navbar_pos==\"navbar-static-top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_3}></option>\r\n                              <option value=\"navbar-static-bottom\" <{if $navbar_pos==\"navbar-static-bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_6}></option>\r\n                              <option value=\"default\" <{if $navbar_pos==\"default\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_4}></option>\r\n                              <option value=\"not-use\" <{if $navbar_pos==\"not-use\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_5}></option>\r\n                            </select>\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_pos\" id=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 漸層顏色(top) -->\r\n                      <{if $enable.navbar_bg_top==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_BG_COLOR}>(top)\r\n                          </div>\r\n                          <div class=\"span8\">\r\n                            <input type=\"text\" name=\"navbar_bg_top\" id=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\" class=\"span6<{$validate.navbar_bg_top}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_bg_top\" id=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 漸層顏色(bottom)-->\r\n                      <{if $enable.navbar_bg_bottom==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_BG_COLOR}>(bottom)\r\n                          </div>\r\n                          <div class=\"span8\">\r\n                            <input type=\"text\" name=\"navbar_bg_bottom\" id=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\" class=\"span6<{$validate.navbar_bg_bottom}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_bg_bottom\" id=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 連結區塊底色-->\r\n                      <{if $enable.navbar_hover==\"1\"}>\r\n                        <div class=\"row-fluid\">\r\n                          <div class=\"span4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_HOVER_COLOR}>\r\n                          </div>\r\n                          <div class=\"span8\">\r\n                            <input type=\"text\" name=\"navbar_hover\" id=\"navbar_hover\" value=\"<{$navbar_hover}>\" class=\"span6<{$validate.navbar_hover}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_hover\" id=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" id=\"navbar_pos\" name=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n                    <input type=\"hidden\" id=\"navbar_bg_top\" name=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n                    <input type=\"hidden\" id=\"navbar_bg_bottom\" name=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n                    <input type=\"hidden\" id=\"navbar_hover\" name=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n                  <{/if}>\r\n\r\n                  <div class=\"span6\">\r\n                    <!--導覽工具列 文字顏色-->\r\n                    <{if $enable.navbar_color==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <div class=\"span4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_COLOR}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <input type=\"text\" name=\"navbar_color\" id=\"navbar_color\" value=\"<{$navbar_color}>\" class=\"span6<{$validate.navbar_color}>\" data-hex=\"true\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_color\" id=\"navbar_color\" value=\"<{$navbar_color}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <!--導覽工具列 文字移過顏色-->\r\n                    <{if $enable.navbar_color_hover==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <div class=\"span4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_COLOR_HOVER}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <input type=\"text\" name=\"navbar_color_hover\" id=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\" class=\"span6<{$validate.navbar_color_hover}>\" data-hex=\"true\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_color_hover\" id=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\">\r\n                    <{/if}>\r\n\r\n                    <!--導覽工具列 圖示顏色-->\r\n                    <{if $enable.navbar_icon==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <div class=\"span4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_COLOR}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <label for=\"navbar_icon_white\">\r\n                            <input type=\"radio\" name=\"navbar_icon\" id=\"navbar_icon_white\" value=\"icon-white\" <{if $navbar_icon==\"icon-white\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_WHITE}>\r\n                          </label>\r\n                          <label for=\"navbar_icon_black\">\r\n                            <input type=\"radio\" name=\"navbar_icon\" id=\"navbar_icon_black\" value=\"\" <{if $navbar_icon==\"\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_BLACK}>\r\n                          </label>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_icon\" id=\"navbar_icon\" value=\"<{$navbar_icon}>\">\r\n                    <{/if}>\r\n                  </div>\r\n                </div>\r\n\r\n\r\n                <div class=\"row-fluid\">\r\n                  <div class=\"span5\">\r\n                    <{if $enable.navbar_img==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 上傳navbar_img圖-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_NAVBAR_IMG}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <{$upform_navbar_img}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_img\" id=\"navbar_img\" value=\"<{$navbar_img}>\">\r\n                    <{/if}>\r\n\r\n                  </div>\r\n\r\n                  <{if $enable.navbar_img==\"1\"}>\r\n                    <div class=\"span7\">\r\n                      <!-- 選擇預設導覽列navbar_img圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"navbar_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"navbar_img\" id=\"navbar_img0\" onChange=\"$(\'.del_img_box\').show();\" value=\"\" <{if $navbar_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_NAVBAR_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_navbar_img}>\r\n                        <{foreach from=$all_navbar_img item=navbarbg}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"navbar_img<{$navbarbg.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$navbarbg.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"navbar_img\" id=\"navbar_img<{$navbarbg.files_sn}>\" onChange=\"$(\'.del_img_box\').show(); $(\'#del_img<{$navbarbg.files_sn}>\').hide();\" value=\"<{$navbarbg.path}>\" <{if $navbar_img==$navbarbg.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"checkbox del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$navbarbg.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$navbarbg.files_sn}>\" name=\"del_file[<{$navbarbg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row-fluid\">\r\n                  <div class=\"span5\">\r\n\r\n                    <{if $enable.navlogo_img==\"1\"}>\r\n                      <div class=\"row-fluid\">\r\n                        <!-- 上傳logo圖-->\r\n                        <div class=\"span4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_NAVLOGO_IMG}>\r\n                        </div>\r\n                        <div class=\"span8\">\r\n                          <{$upform_navlogo}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navlogo_img\" id=\"navlogo_img\" value=\"<{$navlogo_img}>\">\r\n                    <{/if}>\r\n\r\n                  </div>\r\n\r\n                  <{if $enable.navlogo_img==\"1\"}>\r\n                    <div class=\"span7\">\r\n                      <!-- 選擇預設導覽列navlogo圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"navlogo_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"navlogo_img\" id=\"navlogo_img0\" value=\"\" <{if $navlogo_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_NAVLOGO_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_navlogo}>\r\n                        <{foreach from=$all_navlogo item=navlogo}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"logo_img<{$navlogo.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$navlogo.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"navlogo_img\" id=\"navlogo_img<{$navlogo.files_sn}>\" value=\"<{$navlogo.path}>\" <{if $navlogo_img==$navlogo.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"checkbox del_navimg_box\" style=\"font-size:11px;\"  id=\"del_navimg<{$navlogo.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$navlogo.files_sn}>\" name=\"del_file[<{$navlogo.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"navbar_pos\" name=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n              <input type=\"hidden\" id=\"navbar_bg_top\" name=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n              <input type=\"hidden\" id=\"navbar_bg_bottom\" name=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n              <input type=\"hidden\" id=\"navbar_hover\" name=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n              <input type=\"hidden\" id=\"navbar_img\" name=\"navbar_img\" value=\"<{$navbar_img}>\">\r\n              <input type=\"hidden\" id=\"navbar_color\" name=\"navbar_color\" value=\"<{$navbar_color}>\">\r\n              <input type=\"hidden\" id=\"navbar_color_hover\" name=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\">\r\n              <input type=\"hidden\" id=\"navbar_icon\" name=\"navbar_icon\" value=\"<{$navbar_icon}>\">\r\n              <input type=\"hidden\" id=\"navlogo_img\" name=\"navlogo_img\" value=\"<{$navlogo_img}>\">\r\n            <{/if}>\r\n\r\n            <!--額外設定-->\r\n            <{if $config2}>\r\n            <div id=\"tabs-7\">\r\n              <input type=\"hidden\" name=\"config2\" value=\"1\">\r\n              <{foreach from=$theme_config item=config}>\r\n                <div class=\"row-fluid\">\r\n                  <div class=\"span2 text-right\">\r\n                    <{$config.text}>\r\n                  </div>\r\n                  <div class=\"span5\">\r\n                    <{if $config.type==\"text\"}>\r\n                      <input type=\"text\" name=\"<{$config.name}>\" value=\"<{$config.value}>\" class=\"span12\">\r\n                    <{elseif $config.type==\"color\"}>\r\n                      <input type=\"text\" name=\"<{$config.name}>\" id=\"<{$config.name}>\" value=\"<{$config.value}>\" class=\"span8\" data-hex=\"true\" >\r\n                    <{elseif $config.type==\"array\"}>\r\n                      <textarea name=\"<{$config.name}>\" class=\"span12\" rows=4 style=\"font-size:0.8em;\"><{$config.value}></textarea>\r\n                    <{elseif $config.type==\"textarea\"}>\r\n                      <textarea name=\"<{$config.name}>\" class=\"span12\" rows=4 style=\"font-size:0.8em;\"><{$config.value}></textarea>\r\n                    <{elseif $config.type==\"yesno\"}>\r\n                      <label class=\"radio inline\">\r\n                        <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>1\" value=\"1\" <{if $config.value==1}>checked<{/if}> ><{$smarty.const._YES}>\r\n                      </label>\r\n                      <label class=\"radio inline\">\r\n                        <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>0\" value=\"0\" <{if $config.value==0}>checked<{/if}> ><{$smarty.const._NO}>\r\n                      </label>\r\n                    <{elseif $config.type==\"file\"}>\r\n                      <{$config.form}>\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <{if $config.type==\"file\"}>\r\n                    <div class=\"span5\">\r\n                      <{if $config.list}>\r\n\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"<{$config.name}>0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                            <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>0\" value=\"\" <{if $config.value==\"\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NONE}>\r\n                          </label>\r\n                        </div>\r\n\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"<{$config.name}>\" style=\"width:60px; height:60px; background:#000000 url(<{$config.default}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;background-size: cover;\" >\r\n                            <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}><{$file.files_sn}>\" value=\"<{$config.default}>\"  <{if $config.value==$config.default}>checked<{/if}>>\r\n                          </label>\r\n                            <label class=\"checkbox\" style=\"font-size:11px;\">\r\n                              <{$smarty.const._MA_TADTHEMES_DEFAULT}>\r\n                            </label>\r\n\r\n                        </div>\r\n\r\n                        <{foreach from=$config.list item=file}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"<{$config.name}><{$file.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$file.tb_path}>);background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}><{$file.files_sn}>\" value=\"<{$file.path}>\" onChange=\"$(\'.del_<{$config.name}>\').show(); $(\'#del_<{$config.name}><{$file.files_sn}>\').hide();\" <{if $config.value==$file.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"checkbox del_<{$config.name}>\" style=\"font-size:11px;\" id=\"del_<{$config.name}><{$file.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$file.files_sn}>\" name=\"del_file[<{$file.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                        <div style=\"clear:both;\"></div>\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <div class=\"span5 alert alert-info\">\r\n                      <{$config.desc}>\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n              <{/foreach}>\r\n            </div>\r\n            <{/if}>\r\n          </div>\r\n        </div>\r\n\r\n      </div>\r\n\r\n\r\n\r\n      <div class=\"span4\">\r\n        <!--預覽-->\r\n        <div class=\"row-fluid\">\r\n          <div class=\"span12 text-center\">\r\n            <div id=\'preview_zone\' class=\"span12\">\r\n              <div id=\'theme_demo\' style=\'border:1px solid gray;background-color:white;margin:0px auto;\'>\r\n                <div id=\'theme_head\' style=\'border:1px solid #E0E0E0;background-color:#F0F0F0;margin:4px auto 2px auto;font-size:11px;text-align:center;\'><{$smarty.const._MA_TAD_THEMES_HEAD}></div>\r\n                <div id=\'left_block\' style=\'border:1px solid #E0E0E0;background-color:#99CCFF;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'center_block\' style=\'border:1px solid #E0E0E0;background-color:#CCFF66;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'right_block\' style=\'border:1px solid #E0E0E0;background-color:#FFCC66;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'theme_foot\' style=\'clear:both;border:1px solid #E0E0E0;height:30px;line-height:30px;background-color:#F0F0F0;margin:4px auto;font-size:11px;text-align:center;\'><{$smarty.const._MA_TAD_THEMES_FOOT}></div>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n\r\n        <div class=\"row-fluid\">\r\n          <div class=\"text-center\">\r\n            <!--中左區塊寬度-->\r\n            <input type=\"hidden\" name=\"clb_width\" value=\"<{$clb_width}>\" id=\"clb_width\" >\r\n            <!--中右區塊寬度-->\r\n            <input type=\"hidden\" name=\"crb_width\" value=\"<{$crb_width}>\" id=\"crb_width\" >\r\n            <input type=\"hidden\" name=\"theme_id\" value=\"<{$theme_id}>\">\r\n            <input type=\"hidden\" name=\"theme_name\" value=\"<{$theme_name}>\">\r\n\r\n            <!--佈景圖片寬度-->\r\n            <input type=\"hidden\" name=\"op\" value=\"<{$op}>\">\r\n            <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._TAD_SAVE}></button>\r\n          </div>\r\n        </div>\r\n\r\n        <div class=\"row-fluid\">\r\n          <div class=\"span12 alert alert-info\">\r\n            <{if $theme_kind!=\"bootstrap\" and $theme_kind!=\"bootstrap3\"}><{$smarty.const._MA_TADTHEMES_NOTICE}><{/if}>\r\n            <{$smarty.const._MA_TADTHEMES_NOTICE2}>\r\n          </div>\r\n        </div>\r\n\r\n      </div>\r\n    </div>\r\n  </form>\r\n</div>'),
(60,	'<{$block}>'),
(172,	'<div class=\"container-fluid\">\r\n  <{if $now_op==\"login_form\"}>\r\n    <div class=\"row-fluid\">\r\n      <div class=\"span6\">\r\n        <h2><{$smarty.const._MA_TADADM_SSH_ID}></h2>\r\n        <div class=\"well\">\r\n          <form action=\"main.php\" method=\"post\">\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_SSH_HOST}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"text\" name=\"ssh_host\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_HOST}>\" value=\"<{$tad_adm_ssh_host}>\" class=\"span12\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_SSH_ID}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"text\" name=\"ssh_id\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_ID}>\" class=\"span12\" value=\"<{$tad_adm_ssh_id}>\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_SSH_PASS}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"password\" name=\"ssh_passwd\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_PASS}>\" class=\"span12\" value=\"<{$tad_adm_ssh_passwd}>\">\r\n              </div>\r\n            </div>\r\n\r\n            <div class=\"text-center\">\r\n              <input type=\"hidden\" name=\"file_link\" value=\"<{$file_link}>\">\r\n              <input type=\"hidden\" name=\"dirname\" value=\"<{$dirname}>\">\r\n              <input type=\"hidden\" name=\"act\" value=\"<{$act}>\">\r\n              <input type=\"hidden\" name=\"kind_dir\" value=\"<{$kind_dir}>\">\r\n              <input type=\"hidden\" name=\"update_sn\" value=\"<{$update_sn}>\">\r\n              <input type=\"hidden\" name=\"op\" value=\"ssh_login\">\r\n              <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TADADM_LOGIN}>SSH</button>\r\n            </div>\r\n          </form>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"span6\">\r\n        <h2><{$smarty.const._MA_TADADM_FTP_ID}></h2>\r\n        <div class=\"well\">\r\n          <form action=\"main.php\" method=\"post\">\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_FTP_HOST}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"text\" name=\"ftp_host\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_HOST}>\" value=\"<{$tad_adm_ftp_host}>\" class=\"span12\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_FTP_ID}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"text\" name=\"ftp_id\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_ID}>\" class=\"span12\" value=\"<{$tad_adm_ftp_id}>\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row-fluid\">\r\n              <label class=\"span5 text-right\"><{$smarty.const._MA_TADADM_FTP_PASS}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"span7\">\r\n                <input type=\"password\" name=\"ftp_passwd\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_PASS}>\" class=\"span12\" value=\"<{$tad_adm_ftp_passwd}>\">\r\n                <{$smarty.const._MA_TADADM_FTP_NOTE}>\r\n              </div>\r\n            </div>\r\n\r\n            <div class=\"text-center\">\r\n              <input type=\"hidden\" name=\"file_link\" value=\"<{$file_link}>\">\r\n              <input type=\"hidden\" name=\"dirname\" value=\"<{$dirname}>\">\r\n              <input type=\"hidden\" name=\"act\" value=\"<{$act}>\">\r\n              <input type=\"hidden\" name=\"kind_dir\" value=\"<{$kind_dir}>\">\r\n              <input type=\"hidden\" name=\"update_sn\" value=\"<{$update_sn}>\">\r\n              <input type=\"hidden\" name=\"op\" value=\"ftp_login\">\r\n              <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TADADM_LOGIN}>FTP</button>\r\n            </div>\r\n          </form>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  <{elseif $all_data}>\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/lib/jquery.mousewheel-3.0.6.pack.js\"></script>\r\n    <script type=\"text/javascript\" language=\"javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/jquery.fancybox.js?v=2.1.4\"></script>\r\n    <link rel=\"stylesheet\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/jquery.fancybox.css?v=2.1.4\" type=\"text/css\" media=\"screen\" />\r\n    <link rel=\"stylesheet\" type=\"text/css\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-buttons.css?v=1.0.5\" />\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-buttons.js?v=1.0.5\"></script>\r\n    <link rel=\"stylesheet\" type=\"text/css\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7\" />\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7\"></script>\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-media.js?v=1.0.5\"></script>\r\n\r\n    <script type=\"text/javascript\">\r\n    $(document).ready(function(){\r\n      $(\".modulesadmin\").fancybox({\r\n        fitToView : true,\r\n        width   : \'640px\',\r\n        height    : \'400px\',\r\n        autoSize  : true,\r\n        closeClick  : false,\r\n        openEffect  : \'none\',\r\n        closeEffect : \'none\',\r\n        afterClose  :function () {\r\n          window.location.reload();\r\n        }\r\n      });\r\n    });\r\n    </script>\r\n\r\n\r\n    <table class=\"table table-striped table-bordered table-hover\">\r\n      <tr>\r\n      <th nowrap><{$smarty.const._MA_TADADM_KIND}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NAME}></th>\r\n      <th nowrap><{$smarty.const._TAD_FUNCTION}></th>\r\n      <th><{$smarty.const._MA_TADADM_MOD_UPDATE_DESC}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_DIRNAME}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_FUNCTION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_VERSION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_LAST_UPDATE}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NEW_VERSION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NEW_LAST_UPDATE}></th>\r\n      </tr>\r\n        <{foreach from=$all_data item=mod}>\r\n          <tr>\r\n            <td nowrap>\r\n              <{if $mod.kind==\"module\"}>\r\n                <span class=\"label label-info\"><{$smarty.const._MA_TADADM_MODULE}></span>\r\n              <{elseif $mod.kind==\"theme\"}>\r\n                <span class=\"label label-important\"><{$smarty.const._MA_TADADM_THEME}></span>\r\n              <{elseif $mod.kind==\"fix\"}>\r\n                <span class=\"label label-warning\"><{$smarty.const._MA_TADADM_FIX}></span>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap><a href=\"http://120.115.2.90/modules/tad_modules/index.php?module_sn=<{$mod.module_sn}>\" target=\"_blank\"><{$mod.name}></a></td>\r\n            <td nowrap style=\"text-align:center;\">\r\n              <{if $mod.function==\'install\'}>\r\n                <a href=\"main.php?op=install_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-mini btn-primary modulesadmin\" data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_INSTALL_MODULE}></a>\r\n              <{elseif $mod.function==\'update\'}>\r\n                <a href=\"main.php?op=update_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-mini btn-danger modulesadmin\"  data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_UPDATE_MODULE}> <{$mod.new_version}></a>\r\n              <{elseif $mod.function==\'update_theme\'}>\r\n                  <a href=\"main.php?op=update_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-mini btn-danger\" ><{$smarty.const._MA_TADADM_MOD_UPDATE_THEME}> <{$mod.new_version}></a>\r\n              <{elseif $mod.function==\'install_theme\'}>\r\n                  <a href=\"main.php?op=install_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-mini btn-primary\" ><{$smarty.const._MA_TADADM_MOD_INSTALL_THEME}></a>\r\n              <{elseif $mod.function==\'last_mod\'}>\r\n                <a href=\"main.php?op=update_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"modulesadmin\"  data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_LATEST}></a>\r\n              <{elseif $mod.function==\'last_theme\'}>\r\n                  <a href=\"main.php?op=update_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" ><{$smarty.const._MA_TADADM_MOD_LATEST}></a>\r\n              <{elseif $mod.new_last_update}>\r\n                <{$smarty.const._MA_TADADM_MOD_LATEST}>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap style=\"text-align:center;\">\r\n              <{if $mod.descript}>\r\n                <a id=\"view_well<{$mod.module_sn}>\" class=\"btn btn-mini btn-success\" href=\"javascript:alert(\'<{$mod.descript}>\')\"><{if $mod.version}><{$smarty.const._MA_TADADM_MOD_UPDATE_DESC}><{else}><{$smarty.const._MA_TADADM_MOD_ABOUT_MOD}><{/if}></a>\r\n              <{/if}>\r\n            </td>\r\n\r\n            <td nowrap>\r\n              <{if $mod.version}>\r\n                <a href=\"<{$xoops_url}>/modules/<{$mod.dirname}>/admin/index.php\" title=\"<{$mod.dirname}><{$smarty.const._MA_TADADM_MOD_ADMIN}>\" target=\"_blank\"><{$mod.dirname}></a>\r\n              <{else}>\r\n                <{$mod.dirname}>\r\n              <{/if}>\r\n              </td>\r\n            <td nowrap>\r\n              <{if $mod.version}>\r\n                <a href=\"<{$xoops_url}>/modules/system/admin.php?fct=blocksadmin&op=list&filter=1&selgen=<{$mod.mid}>&selmod=-2&selgrp=-1&selvis=-1\" target=\"_blank\"><{$smarty.const._MA_TADADM_MOD_BLOCK}></a>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap><{$mod.version}></td>\r\n            <td nowrap><{$mod.last_update}></td>\r\n            <td nowrap><{$mod.new_version}></td>\r\n            <td nowrap><{$mod.new_last_update}></td>\r\n          </tr>\r\n        <{/foreach}>\r\n      </table>\r\n  <{/if}>\r\n</div>'),
(65,	'<{$block}>'),
(173,	'<div class=\"container-fluid\">\r\n  <ol style=\"padding:20px;\">\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><a href=\"spam.php?op=all\"><{$smarty.const._MA_TADADM_AUTO_CHECK}></a><{$_MA_TADADM_AUTO_CHECK_DESC}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC1}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC2}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC3}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC4}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC5}></li>\r\n  	<li style=\"line-height:180%;list-style: decimal outside none;\"><{$_MA_TADADM_WORKTIME}></li>\r\n  </ol>\r\n\r\n  <{if $op==\"spam\"}>\r\n\r\n  	<form action=\"spam.php\" method=\"post\">\r\n      <table class=\"table table-striped table-bordered table-hover\">\r\n      <tr><td colspan=10><{$bar}></td></tr>\r\n      <tr>\r\n      <th>uid</th>\r\n      <th><{$smarty.const._MA_TADADM_UNAME}></th>\r\n      <th><{$smarty.const._MA_TADADM_COUNT}></th>\r\n      <th><{$smarty.const._MA_TADADM_EMAIL}></th>\r\n      <th><{$smarty.const._MA_TADADM_SPAM}></th>\r\n      <th><{$smarty.const._MA_TADADM_REGIST}></th>\r\n      <th><{$smarty.const._MA_TADADM_LASTLOGIN}></th>\r\n      <th style=\"width:200px;\"><{$smarty.const._MA_TADADM_SIGN}></th>\r\n      </tr>\r\n          <{foreach from=$all_data item=spam}>\r\n            <tr style=\"color:<{$spam.color}>;background-color:<{$spam.bgcolor}>;\">\r\n              <td>\r\n                <label class=\"checkbox inline\">\r\n                  <input type=\"checkbox\" name=\"uid[]\" value=\"<{$spam.uid}>\" <{$spam.checked}> id=\"uid_<{$spam.uid}>\" class=\"uid\"><{$spam.uid}>\r\n                </label>\r\n\r\n              </td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.uname}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.name}></label></div></td>\r\n              <td><{$spam.posts}></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.email}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.url}></label></div></td>\r\n              <td><{$spam.appears}></td>\r\n              <td><{$spam.user_regdate}><div><{$spam.last_login}></div></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.days_between}></label></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.user_sig}></label></td>\r\n            </tr>\r\n          <{/foreach}>\r\n      <tr><td colspan=10><{$bar}></td></tr>\r\n      </table>\r\n      \"<{$_MA_TADADM_TOTAL}>\r\n        <input type=\"hidden\" name=\"g2p\" value=\"<{$g2p}>\">\r\n        <input type=\"hidden\" name=\"op\" value=\"del_user\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_DEL_CONFIRM}>\">\r\n    </form>\r\n  <{else}>\r\n\r\n    <script type=\"text/javascript\">\r\n    $().ready(function(){\r\n      $(\"#clickAll\").click(function() {\r\n        if($(\"#clickAll\").attr(\"checked\")){\r\n          $(\"input[name=\'uid[]\']\").each(function() {\r\n          $(this).attr(\"checked\", true);\r\n        });\r\n      }else{\r\n       $(\"input[name=\'uid[]\']\").each(function() {\r\n           $(this).attr(\"checked\", false);\r\n       });\r\n      }\r\n      });\r\n    });\r\n    </script>\r\n\r\n    <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_NEVERSTART_DAY}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byNeverStartDays\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n      <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_NEVERLOGIN_DAY}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byNeverLoginDays\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n      <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_BY_EMAIL}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byEmail\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n\r\n      <form action=\"spam.php\" method=\"post\">\r\n      <table class=\"table table-striped table-bordered table-hover\">\r\n        <tr><td colspan=10><{$bar}></td></tr>\r\n        <tr><td colspan=10>\r\n        <label class=\"checkbox inline\">\r\n          <input type=\"checkbox\" value=\"\" id=\"clickAll\">  <{$smarty.const._MA_TADADM_SELECT_ALL}>\r\n        </label>\r\n        </td></tr>\r\n        <tr>\r\n        <th>uid</th>\r\n        <th><{$smarty.const._MA_TADADM_UNAME}></th>\r\n        <th><{$smarty.const._MA_TADADM_COUNT}></th>\r\n        <th><{$smarty.const._MA_TADADM_EMAIL}></th>\r\n        <th><{$smarty.const._MA_TADADM_SPAM}></th>\r\n        <th><{$smarty.const._MA_TADADM_REGIST}></th>\r\n        <th><{$smarty.const._MA_TADADM_LASTLOGIN}></th>\r\n        <th style=\"width:200px;\"><{$smarty.const._MA_TADADM_SIGN}></th>\r\n        </tr>\r\n          <{foreach from=$all_data item=spam}>\r\n            <tr style=\"color:<{$spam.color}>;background-color:<{$spam.bgcolor}>;\">\r\n              <td>\r\n                <label class=\"checkbox inline\">\r\n                  <input type=\"checkbox\" name=\"uid[]\" value=\"<{$spam.uid}>\" <{$spam.checked}> id=\"uid_<{$spam.uid}>\" class=\"uid\"><{$spam.uid}>\r\n                </label>\r\n\r\n              </td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.uname}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.name}></label></div></td>\r\n              <td><{$spam.posts}></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.email}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.url}></label></div></td>\r\n              <td><{$spam.appears}></td>\r\n              <td><{$spam.user_regdate}><div><{$spam.last_login}></div></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.days_between}></label></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.user_sig}></label></td>\r\n            </tr>\r\n          <{/foreach}>\r\n        <tr><td colspan=10><{$bar}></td></tr>\r\n        </table>\r\n        <{$_MA_TADADM_TOTAL}>\r\n        <input type=\"hidden\" name=\"g2p\" value=\"<{$g2p}>\">\r\n        <input type=\"hidden\" name=\"op\" value=\"del_user\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_DEL_CONFIRM}>\">\r\n      </form>\r\n  <{/if}>\r\n</div>'),
(190,	'<div class=\"container-fluid\">\r\n  <ol style=\"padding:20px;\">\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><a href=\"spam.php?op=all\"><{$smarty.const._MA_TADADM_AUTO_CHECK}></a><{$_MA_TADADM_AUTO_CHECK_DESC}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC1}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC2}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC3}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC4}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$smarty.const._MA_TADADM_AUTO_CHECK_DESC5}></li>\r\n    <li style=\"line-height:180%;list-style: decimal outside none;\"><{$_MA_TADADM_WORKTIME}></li>\r\n  </ol>\r\n\r\n  <{if $op==\"spam\"}>\r\n\r\n    <form action=\"spam.php\" method=\"post\">\r\n      <table class=\"table table-striped table-bordered table-hover\">\r\n      <tr><td colspan=10><{$bar}></td></tr>\r\n      <tr>\r\n      <th>uid</th>\r\n      <th><{$smarty.const._MA_TADADM_UNAME}></th>\r\n      <th><{$smarty.const._MA_TADADM_COUNT}></th>\r\n      <th><{$smarty.const._MA_TADADM_EMAIL}></th>\r\n      <th><{$smarty.const._MA_TADADM_SPAM}></th>\r\n      <th><{$smarty.const._MA_TADADM_REGIST}></th>\r\n      <th><{$smarty.const._MA_TADADM_LASTLOGIN}></th>\r\n      <th style=\"width:200px;\"><{$smarty.const._MA_TADADM_SIGN}></th>\r\n      </tr>\r\n          <{foreach from=$all_data item=spam}>\r\n            <tr style=\"color:<{$spam.color}>;background-color:<{$spam.bgcolor}>;\">\r\n              <td>\r\n                <label class=\"checkbox-inline\">\r\n                  <input type=\"checkbox\" name=\"uid[]\" value=\"<{$spam.uid}>\" <{$spam.checked}> id=\"uid_<{$spam.uid}>\" class=\"uid\"><{$spam.uid}>\r\n                </label>\r\n\r\n              </td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.uname}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.name}></label></div></td>\r\n              <td><{$spam.posts}></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.email}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.url}></label></div></td>\r\n              <td><{$spam.appears}></td>\r\n              <td><{$spam.user_regdate}><div><{$spam.last_login}></div></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.days_between}></label></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.user_sig}></label></td>\r\n            </tr>\r\n          <{/foreach}>\r\n      <tr><td colspan=10><{$bar}></td></tr>\r\n      </table>\r\n      \"<{$_MA_TADADM_TOTAL}>\r\n        <input type=\"hidden\" name=\"g2p\" value=\"<{$g2p}>\">\r\n        <input type=\"hidden\" name=\"op\" value=\"del_user\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_DEL_CONFIRM}>\">\r\n    </form>\r\n  <{else}>\r\n\r\n    <script type=\"text/javascript\">\r\n    $().ready(function(){\r\n      $(\"#clickAll\").click(function() {\r\n        if($(\"#clickAll\").attr(\"checked\")){\r\n          $(\"input[name=\'uid[]\']\").each(function() {\r\n          $(this).attr(\"checked\", true);\r\n        });\r\n      }else{\r\n       $(\"input[name=\'uid[]\']\").each(function() {\r\n           $(this).attr(\"checked\", false);\r\n       });\r\n      }\r\n      });\r\n    });\r\n    </script>\r\n\r\n    <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_NEVERSTART_DAY}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byNeverStartDays\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n      <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_NEVERLOGIN_DAY}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byNeverLoginDays\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n      <form action=\"spam.php\" method=\"get\">\r\n        <{$_MA_TADADM_BY_EMAIL}>\r\n        <input type=\"hidden\" name=\"op\" value=\"byEmail\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_GO}>\">\r\n      </form>\r\n\r\n      <form action=\"spam.php\" method=\"post\">\r\n      <table class=\"table table-striped table-bordered table-hover\">\r\n        <tr><td colspan=10><{$bar}></td></tr>\r\n        <tr><td colspan=10>\r\n        <label class=\"checkbox-inline\">\r\n          <input type=\"checkbox\" value=\"\" id=\"clickAll\">  <{$smarty.const._MA_TADADM_SELECT_ALL}>\r\n        </label>\r\n        </td></tr>\r\n        <tr>\r\n        <th>uid</th>\r\n        <th><{$smarty.const._MA_TADADM_UNAME}></th>\r\n        <th><{$smarty.const._MA_TADADM_COUNT}></th>\r\n        <th><{$smarty.const._MA_TADADM_EMAIL}></th>\r\n        <th><{$smarty.const._MA_TADADM_SPAM}></th>\r\n        <th><{$smarty.const._MA_TADADM_REGIST}></th>\r\n        <th><{$smarty.const._MA_TADADM_LASTLOGIN}></th>\r\n        <th style=\"width:200px;\"><{$smarty.const._MA_TADADM_SIGN}></th>\r\n        </tr>\r\n          <{foreach from=$all_data item=spam}>\r\n            <tr style=\"color:<{$spam.color}>;background-color:<{$spam.bgcolor}>;\">\r\n              <td>\r\n                <label class=\"checkbox-inline\">\r\n                  <input type=\"checkbox\" name=\"uid[]\" value=\"<{$spam.uid}>\" <{$spam.checked}> id=\"uid_<{$spam.uid}>\" class=\"uid\"><{$spam.uid}>\r\n                </label>\r\n\r\n              </td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.uname}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.name}></label></div></td>\r\n              <td><{$spam.posts}></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.email}></label><div><label for=\"uid_<{$spam.uid}>\"><{$spam.url}></label></div></td>\r\n              <td><{$spam.appears}></td>\r\n              <td><{$spam.user_regdate}><div><{$spam.last_login}></div></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.days_between}></label></td>\r\n              <td><label for=\"uid_<{$spam.uid}>\"><{$spam.user_sig}></label></td>\r\n            </tr>\r\n          <{/foreach}>\r\n        <tr><td colspan=10><{$bar}></td></tr>\r\n        </table>\r\n        <{$_MA_TADADM_TOTAL}>\r\n        <input type=\"hidden\" name=\"g2p\" value=\"<{$g2p}>\">\r\n        <input type=\"hidden\" name=\"op\" value=\"del_user\">\r\n        <input type=\"submit\" value=\"<{$smarty.const._TAD_DEL_CONFIRM}>\">\r\n      </form>\r\n  <{/if}>\r\n</div>'),
(174,	'<div class=\"container-fluid\">\r\n  <h3><{$php_ini_path}> <{$smarty.const._MA_TADADM_MODULES_PHP_INI_PATH}></h3>\r\n\r\n  <table class=\"table table-striped table-bordered table-hover\">\r\n  <tr>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM_VAL}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ADV}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM_DESC}></th>\r\n  </tr>\r\n\r\n  <{foreach from=$main item=php}>\r\n    <tr>\r\n      <td><{$php.k}></td>\r\n      <td style=\"color:<{$php.color}>\">\r\n        <{$php.global_value}>\r\n      </td>\r\n      <td><{$php.adv}></td>\r\n      <td><div style=\"line-height:150%\"><{$php.ini}></div></td>\r\n    </tr>\r\n  <{/foreach}>\r\n  </table>\r\n</div>'),
(191,	'<div class=\"container-fluid\">\r\n  <h3><{$php_ini_path}><{$smarty.const._MA_TADADM_MODULES_PHP_INI_PATH}></h3>\r\n\r\n  <table class=\"table table-striped table-bordered table-hover\">\r\n  <tr>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM_VAL}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ADV}></th>\r\n    <th><{$smarty.const._MA_TADADM_PHPINI_ITEM_DESC}></th>\r\n  </tr>\r\n\r\n  <{foreach from=$main item=php}>\r\n    <tr>\r\n      <td><{$php.k}></td>\r\n      <td style=\"color:<{$php.color}>\">\r\n        <{$php.global_value}>\r\n      </td>\r\n      <td><{$php.adv}></td>\r\n      <td><div style=\"line-height:150%\"><{$php.ini}></div></td>\r\n    </tr>\r\n  <{/foreach}>\r\n  </table>\r\n</div>'),
(178,	'<{$jquery}>\r\n<{$fancybox_code}>\r\n<{$treetable_code}>\r\n\r\n<style>\r\n  li{list-style:none;}\r\n</style>\r\n\r\n\r\n\r\n<script type=\"text/javascript\">\r\n  function delete_tad_themes_menu_func(menuid){\r\n    var sure = window.confirm(\"<{$smarty.const._TAD_DEL_CONFIRM}>\");\r\n    if (!sure)  return;\r\n    location.href=\"dropdown.php?op=delete_tad_themes_menu&menuid=\" + menuid;\r\n  }\r\n\r\n  function delete_tad_themes_pic(del_type , menuid){\r\n    var sure = window.confirm(\"<{$smarty.const._TAD_DEL_CONFIRM}>\");\r\n    if (!sure)  return;\r\n    location.href=\"dropdown.php?op=del_pic&type=\" + del_type + \"&menuid=\" + menuid;\r\n  }\r\n</script>\r\n\r\n\r\n<div class=\"container-fluid\">\r\n  <div class=\"row-fluid\">\r\n    <a href=\"dropdown.php?op=import\" class=\"btn btn-info\"><{$smarty.const._MA_TADTHEMES_IMPORT_MENU}></a>\r\n\r\n    <div id=\"save_msg\"></div>\r\n\r\n    <table id=\"tbl\" class=\"table table-striped table-hover\" style=\"width:auto;\">\r\n      <tr data-tt-id=\"0\" id=\"node-_0\">\r\n        <td colspan=2 style=\"font-size:20px;\">\r\n          <a href=\"dropdown.php?op=add_tad_themes_menu&of_level=0\" class=\"edit_dropdown\" data-fancybox-type=\"iframe\"  style=\"letter-spacing: 0em;\"><img src=\"../images/001_01.gif\" align=\"absmiddle\" alt=\"<{$add_item}>\" title=\"<{$add_item}>\" class=\'folder\'><{$add_item}></a>\r\n        </td>\r\n      <tr>\r\n      <{if $all}>\r\n        <tbody class=\"sort\">\r\n          <{$all}>\r\n          <{$option}>\r\n        </tbody>\r\n      <{/if}>\r\n    </table>\r\n  </div>\r\n</div>'),
(195,	'<{$jquery}>\r\n<{$fancybox_code}>\r\n<{$treetable_code}>\r\n\r\n<style>\r\n  li{list-style:none;}\r\n</style>\r\n\r\n\r\n\r\n<script type=\"text/javascript\">\r\n  function delete_tad_themes_menu_func(menuid){\r\n    var sure = window.confirm(\"<{$smarty.const._TAD_DEL_CONFIRM}>\");\r\n    if (!sure)  return;\r\n    location.href=\"dropdown.php?op=delete_tad_themes_menu&menuid=\" + menuid;\r\n  }\r\n\r\n  function delete_tad_themes_pic(del_type , menuid){\r\n    var sure = window.confirm(\"<{$smarty.const._TAD_DEL_CONFIRM}>\");\r\n    if (!sure)  return;\r\n    location.href=\"dropdown.php?op=del_pic&type=\" + del_type + \"&menuid=\" + menuid;\r\n  }\r\n</script>\r\n\r\n\r\n<div class=\"container-fluid\">\r\n  <div class=\"row\">\r\n    <a href=\"dropdown.php?op=import\" class=\"btn btn-info\"><{$smarty.const._MA_TADTHEMES_IMPORT_MENU}></a>\r\n\r\n    <div id=\"save_msg\"></div>\r\n\r\n    <table id=\"tbl\" class=\"table table-striped table-hover\" style=\"width:auto;\">\r\n      <tr data-tt-id=\"0\" id=\"node-_0\">\r\n        <td colspan=2 style=\"font-size:20px;\">\r\n          <a href=\"dropdown.php?op=add_tad_themes_menu&of_level=0\" class=\"edit_dropdown\" data-fancybox-type=\"iframe\"  style=\"letter-spacing: 0em;\"><img src=\"../images/001_01.gif\" align=\"absmiddle\" alt=\"<{$add_item}>\" title=\"<{$add_item}>\" class=\'folder\'><{$add_item}></a>\r\n        </td>\r\n      <tr>\r\n      <{if $all}>\r\n        <tbody class=\"sort\">\r\n          <{$all}>\r\n          <{$option}>\r\n        </tbody>\r\n      <{/if}>\r\n    </table>\r\n  </div>\r\n</div>'),
(184,	'<style >\r\nul#tad_themes_top_navigation {\r\n  position: fixed;\r\n  margin: 0px;\r\n  padding: 0px;\r\n  top: 0px;\r\n  right: 10px;\r\n  list-style: none;\r\n  z-index:999999;\r\n  width:<{$block.width}>px;\r\n}\r\nul#tad_themes_top_navigation li {\r\n  width: 103px;\r\n  display:inline;\r\n  float:left;\r\n}\r\nul#tad_themes_top_navigation li a {\r\n  display: block;\r\n  float:left;\r\n  margin-top: -2px;\r\n  width: 100px;\r\n  height: 25px;\r\n  background-color:#E7F2F9;\r\n  background-repeat:no-repeat;\r\n  background-position:50% 10px;\r\n  border:1px solid #BDDCEF;\r\n  -moz-border-radius:0px 0px 10px 10px;\r\n  -webkit-border-bottom-right-radius: 10px;\r\n  -webkit-border-bottom-left-radius: 10px;\r\n  -khtml-border-bottom-right-radius: 10px;\r\n  -khtml-border-bottom-left-radius: 10px;\r\n  text-decoration:none;\r\n  text-align:center;\r\n  padding-top:80px;\r\n  opacity: 0.9;\r\n  filter:progid:DXImageTransform.Microsoft.Alpha(opacity=90);\r\n}\r\nul#tad_themes_top_navigation li a:hover{\r\n  background-color:#CAE3F2;\r\n}\r\nul#tad_themes_top_navigation li a span{\r\n  letter-spacing:2px;\r\n  font-size:11px;\r\n  color:#60ACD8;\r\n  text-shadow: 0 -1px 1px #fff;\r\n}\r\n</style>\r\n\r\n<{$block.jquery}>\r\n\r\n<ul id=\"tad_themes_top_navigation\">\r\n  <li><a href=\"<{$xoops_url}>\" style=\"background-image: url(<{$xoops_url}>/modules/tad_themes/images/home.png);\"><span>Home</span></a></li>\r\n  <{foreach from=$block.menu item=menu}>\r\n    <li><a href=\"<{$menu.itemurl}>\" target=\"<{$menu.target}>\" style=\"background-image: url(<{$menu.icon}>);\"><span><{$menu.itemname}></span></a></li>\r\n  <{/foreach}>\r\n</ul>\r\n\r\n<script type=\"text/javascript\">\r\n    $(function() {\r\n        var d=300;\r\n        $(\'#tad_themes_top_navigation a\').each(function(){\r\n            $(this).stop().animate({\r\n                \'marginTop\':\'-80px\'\r\n            },d+=150);\r\n        });\r\n\r\n        $(\'#tad_themes_top_navigation > li\').hover(\r\n        function () {\r\n            $(\'a\',$(this)).stop().animate({\r\n                \'marginTop\':\'-2px\'\r\n            },200);\r\n        },\r\n        function () {\r\n            $(\'a\',$(this)).stop().animate({\r\n                \'marginTop\':\'-80px\'\r\n            },200);\r\n        }\r\n    );\r\n    });\r\n</script>'),
(185,	'<{if $block.menu}>\r\n  <style>\r\n  ul.vertical_bootstrap_menu {\r\n    position:relative;\r\n    background:#fff;\r\n    width:100%;\r\n    margin:auto;\r\n    padding:0;\r\n    list-style: none;\r\n    overflow:hidden;\r\n\r\n    -webkit-border-radius: 5px;\r\n    -moz-border-radius: 5px;\r\n    border-radius: 5px;\r\n\r\n    -webkit-box-shadow: 1px 1px 10px rgba(0, 0, 0, 0.1);\r\n    -moz-box-shadow: 1px 1px 10px rgba(0, 0, 0, 0.1);\r\n    box-shadow:  1px 1px 10px rgba(0, 0, 0, 0.1);\r\n  }\r\n\r\n  .vertical_bootstrap_menu li a {\r\n    width:96%;\r\n    padding-left:20px;\r\n    height:40px;\r\n    line-height:40px;\r\n    display:block;\r\n    overflow:hidden;\r\n    position:relative;\r\n    text-decoration:none;\r\n    text-transform:uppercase;\r\n    font-size:14px;\r\n    color:#686868;\r\n\r\n    -webkit-transition:all 0.2s linear;\r\n    -moz-transition:all 0.2s linear;\r\n    -o-transition:all 0.2s linear;\r\n    transition:all 0.2s linear;\r\n  }\r\n\r\n  .vertical_bootstrap_menu li a:hover {\r\n    background:#efefef;\r\n  }\r\n\r\n\r\n  .vertical_bootstrap_menu li:first-child a:hover, .vertical_bootstrap_menu li:first-child a {\r\n    -webkit-border-radius: 5px 5px 0 0;\r\n    -moz-border-radius: 5px 5px 0 0;\r\n    border-radius: 5px 5px 0 0;\r\n  }\r\n\r\n  .vertical_bootstrap_menu li:last-child a:hover, .vertical_bootstrap_menu li:last-child a {\r\n    -webkit-border-radius: 0 0 5px 5px;\r\n    -moz-border-radius: 0 0 5px 5px;\r\n    border-radius: 0 0 5px 5px;\r\n  }\r\n\r\n  .vertical_bootstrap_menu li a:hover i {\r\n    color:#ea4f35;\r\n  }\r\n\r\n  .vertical_bootstrap_menu i {\r\n    margin-right:15px;\r\n\r\n    -webkit-transition:all 0.2s linear;\r\n    -moz-transition:all 0.2s linear;\r\n    -o-transition:all 0.2s linear;\r\n    transition:all 0.2s linear;\r\n  }\r\n\r\n  .vertical_bootstrap_menu em {\r\n    font-size: 10px;\r\n    background: #ea4f35;\r\n    padding: 3px 5px;\r\n    -webkit-border-radius: 10px;\r\n    -moz-border-radius: 10px;\r\n    border-radius: 10px;\r\n    font-style: normal;\r\n    color: #fff;\r\n    margin-top: 17px;\r\n    margin-right: 15px;\r\n    line-height: 10px;\r\n    height: 10px;\r\n    float:right;\r\n  }\r\n\r\n  .vertical_bootstrap_menu li.selected a {\r\n    background:#efefef;\r\n  }\r\n\r\n</style>\r\n\r\n\r\n\r\n  <{$block.jquery}>\r\n  <ul class=\"vertical_bootstrap_menu\">\r\n    <li><a style=\"border-left:5px solid #008747;\" href=\"<{$xoops_url}>\"><i class=\"icon-home\"></i><{$smarty.const._YOURHOME}></a></li>\r\n    <{foreach from=$block.menu item=menu key=i}>\r\n      <{if $menu.itemname!=\"\"}>\r\n      <li><a style=\"border-left:5px solid <{$menu.color}>;\" href=\"<{$menu.itemurl}>\" target=\"<{$menu.target}>\"><i class=\"fa <{$menu.bootstrap_icon}>\"></i> <{$menu.itemname}></a></li>\r\n      <{/if}>\r\n    <{/foreach}>\r\n  </ul>\r\n<{/if}>'),
(186,	'<{if $block.menu}>\r\n  <style>\r\n  ul.vertical_menu {\r\n    position:relative;\r\n    background:transparent;\r\n    width:100%;\r\n    margin:auto;\r\n    padding:0;\r\n    list-style: none;\r\n    overflow:hidden;\r\n    z-index: 999;\r\n  }\r\n\r\n  .vertical_menu li a {\r\n    width:100%;\r\n    height:40px;\r\n    line-height:40px;\r\n    display:block;\r\n    overflow:hidden;\r\n    position:relative;\r\n    text-decoration:none;\r\n    text-transform:uppercase;\r\n    font-size:14px;\r\n    color:#686868;\r\n\r\n    -webkit-transition:all 0.2s linear;\r\n    -moz-transition:all 0.2s linear;\r\n    -o-transition:all 0.2s linear;\r\n    transition:all 0.2s linear;\r\n  }\r\n\r\n  .vertical_menu li a:hover {\r\n    background:#efefef;\r\n  }\r\n\r\n\r\n  .vertical_menu li a:hover i {\r\n    color:#ea4f35;\r\n  }\r\n\r\n  .vertical_menu i {\r\n    -webkit-transition:all 0.2s linear;\r\n    -moz-transition:all 0.2s linear;\r\n    -o-transition:all 0.2s linear;\r\n    transition:all 0.2s linear;\r\n  }\r\n\r\n  .vertical_menu em {\r\n    font-size: 10px;\r\n    background: #ea4f35;\r\n    padding: 3px 5px;\r\n    -webkit-border-radius: 10px;\r\n    -moz-border-radius: 10px;\r\n    border-radius: 10px;\r\n    font-style: normal;\r\n    color: #fff;\r\n    margin-top: 17px;\r\n    margin-right: 15px;\r\n    line-height: 10px;\r\n    height: 10px;\r\n    float:right;\r\n  }\r\n\r\n  .vertical_menu li.selected a {\r\n    background:#efefef;\r\n  }\r\n\r\n  </style>\r\n\r\n  <{$block.jquery}>\r\n  <ul class=\"vertical_menu\">\r\n    <li>\r\n      <a style=\"border-bottom:1px dotted #cfcfcf;\" href=\"<{$xoops_url}>\">\r\n        <i class=\"icon-home\"></i>\r\n        <{$smarty.const._YOURHOME}>\r\n      </a>\r\n    </li>\r\n\r\n    <{foreach from=$block.menu item=menu key=i}>\r\n      <{if $menu.itemname!=\"\"}>\r\n      <li>\r\n        <a style=\"border-bottom:1px dotted #cfcfcf;\" href=\"<{$menu.itemurl}>\" target=\"<{$menu.target}>\">\r\n          <i class=\"fa <{$menu.bootstrap_icon}>\"></i>\r\n          <{$menu.itemname}>\r\n        </a>\r\n      </li>\r\n      <{/if}>\r\n    <{/foreach}>\r\n\r\n  </ul>\r\n<{/if}>'),
(196,	'<{if $block.bootstrap_version==\'3\'}>\r\n  <!-- for bootstrap3-->\r\n  <div class=\"row\">\r\n    <div class=\"col-md-2\"></div>\r\n    <div class=\"col-md-8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"col-md-2\"></div>\r\n  </div>\r\n<{else}>\r\n   <!-- for bootstrap2-->\r\n  <div class=\"row-fluid\">\r\n    <div class=\"span2\"></div>\r\n    <div class=\"span8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"span2\"></div>\r\n  </div>\r\n<{/if}>'),
(197,	'<{if $block.bootstrap_version==\'3\'}>\r\n  <!-- for bootstrap3-->\r\n  <div class=\"row\">\r\n    <div class=\"col-md-2\"></div>\r\n    <div class=\"col-md-8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"col-md-2\"></div>\r\n  </div>\r\n<{else}>\r\n   <!-- for bootstrap2-->\r\n  <div class=\"row-fluid\">\r\n    <div class=\"span2\"></div>\r\n    <div class=\"span8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"span2\"></div>\r\n  </div>\r\n<{/if}>'),
(189,	'<div class=\"container-fluid\">\r\n  <{if $now_op==\"login_form\"}>\r\n    <div class=\"row\">\r\n      <div class=\"col-md-6\">\r\n        <h2><{$smarty.const._MA_TADADM_SSH_ID}></h2>\r\n        <div class=\"well\">\r\n          <form action=\"main.php\" method=\"post\">\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_SSH_HOST}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"text\" name=\"ssh_host\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_HOST}>\" value=\"<{$tad_adm_ssh_host}>\" class=\"col-md-12\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_SSH_ID}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"text\" name=\"ssh_id\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_ID}>\" class=\"col-md-12\" value=\"<{$tad_adm_ssh_id}>\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_SSH_PASS}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"password\" name=\"ssh_passwd\" placeholder=\"<{$smarty.const._MA_TADADM_SSH_PASS}>\" class=\"col-md-12\" value=\"<{$tad_adm_ssh_passwd}>\">\r\n              </div>\r\n            </div>\r\n\r\n            <div class=\"text-center\">\r\n              <input type=\"hidden\" name=\"file_link\" value=\"<{$file_link}>\">\r\n              <input type=\"hidden\" name=\"dirname\" value=\"<{$dirname}>\">\r\n              <input type=\"hidden\" name=\"act\" value=\"<{$act}>\">\r\n              <input type=\"hidden\" name=\"kind_dir\" value=\"<{$kind_dir}>\">\r\n              <input type=\"hidden\" name=\"update_sn\" value=\"<{$update_sn}>\">\r\n              <input type=\"hidden\" name=\"op\" value=\"ssh_login\">\r\n              <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TADADM_LOGIN}>SSH</button>\r\n            </div>\r\n          </form>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"col-md-6\">\r\n        <h2><{$smarty.const._MA_TADADM_FTP_ID}></h2>\r\n        <div class=\"well\">\r\n          <form action=\"main.php\" method=\"post\">\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_FTP_HOST}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"text\" name=\"ftp_host\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_HOST}>\" value=\"<{$tad_adm_ftp_host}>\" class=\"col-md-12\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_FTP_ID}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"text\" name=\"ftp_id\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_ID}>\" class=\"col-md-12\" value=\"<{$tad_adm_ftp_id}>\">\r\n              </div>\r\n            </div>\r\n            <div class=\"row\">\r\n              <label class=\"col-md-5 text-right\"><{$smarty.const._MA_TADADM_FTP_PASS}><{$smarty.const._TAD_FOR}></label>\r\n              <div class=\"col-md-7\">\r\n                <input type=\"password\" name=\"ftp_passwd\" placeholder=\"<{$smarty.const._MA_TADADM_FTP_PASS}>\" class=\"col-md-12\" value=\"<{$tad_adm_ftp_passwd}>\">\r\n                <{$smarty.const._MA_TADADM_FTP_NOTE}>\r\n              </div>\r\n            </div>\r\n\r\n            <div class=\"text-center\">\r\n              <input type=\"hidden\" name=\"file_link\" value=\"<{$file_link}>\">\r\n              <input type=\"hidden\" name=\"dirname\" value=\"<{$dirname}>\">\r\n              <input type=\"hidden\" name=\"act\" value=\"<{$act}>\">\r\n              <input type=\"hidden\" name=\"kind_dir\" value=\"<{$kind_dir}>\">\r\n              <input type=\"hidden\" name=\"update_sn\" value=\"<{$update_sn}>\">\r\n              <input type=\"hidden\" name=\"op\" value=\"ftp_login\">\r\n              <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._MA_TADADM_LOGIN}>FTP</button>\r\n            </div>\r\n          </form>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  <{elseif $all_data}>\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/lib/jquery.mousewheel-3.0.6.pack.js\"></script>\r\n    <script type=\"text/javascript\" language=\"javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/jquery.fancybox.js?v=2.1.4\"></script>\r\n    <link rel=\"stylesheet\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/jquery.fancybox.css?v=2.1.4\" type=\"text/css\" media=\"screen\" />\r\n    <link rel=\"stylesheet\" type=\"text/css\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-buttons.css?v=1.0.5\" />\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-buttons.js?v=1.0.5\"></script>\r\n    <link rel=\"stylesheet\" type=\"text/css\" href=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-thumbs.css?v=1.0.7\" />\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-thumbs.js?v=1.0.7\"></script>\r\n    <script type=\"text/javascript\" src=\"<{$xoops_url}>/modules/tadtools/fancyBox/source/helpers/jquery.fancybox-media.js?v=1.0.5\"></script>\r\n\r\n    <script type=\"text/javascript\">\r\n    $(document).ready(function(){\r\n      $(\".modulesadmin\").fancybox({\r\n        fitToView : true,\r\n        width   : \'640px\',\r\n        height    : \'400px\',\r\n        autoSize  : true,\r\n        closeClick  : false,\r\n        openEffect  : \'none\',\r\n        closeEffect : \'none\',\r\n        afterClose  :function () {\r\n          window.location.reload();\r\n        }\r\n      });\r\n    });\r\n    </script>\r\n\r\n\r\n    <table class=\"table table-striped table-bordered table-hover\">\r\n      <tr>\r\n      <th nowrap><{$smarty.const._MA_TADADM_KIND}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NAME}></th>\r\n      <th nowrap><{$smarty.const._TAD_FUNCTION}></th>\r\n      <th><{$smarty.const._MA_TADADM_MOD_UPDATE_DESC}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_DIRNAME}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_FUNCTION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_VERSION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_LAST_UPDATE}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NEW_VERSION}></th>\r\n      <th nowrap><{$smarty.const._MA_TADADM_MOD_NEW_LAST_UPDATE}></th>\r\n      </tr>\r\n        <{foreach from=$all_data item=mod}>\r\n          <tr>\r\n            <td nowrap>\r\n              <{if $mod.kind==\"module\"}>\r\n                <span class=\"label label-info\"><{$smarty.const._MA_TADADM_MODULE}></span>\r\n              <{elseif $mod.kind==\"theme\"}>\r\n                <span class=\"label label-danger\"><{$smarty.const._MA_TADADM_THEME}></span>\r\n              <{elseif $mod.kind==\"fix\"}>\r\n                <span class=\"label label-warning\"><{$smarty.const._MA_TADADM_FIX}></span>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap><a href=\"http://120.115.2.90/modules/tad_modules/index.php?module_sn=<{$mod.module_sn}>\" target=\"_blank\"><{$mod.name}></a></td>\r\n            <td nowrap style=\"text-align:center;\">\r\n              <{if $mod.function==\'install\'}>\r\n                <a href=\"main.php?op=install_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-xs btn-primary modulesadmin\" data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_INSTALL_MODULE}></a>\r\n              <{elseif $mod.function==\'update\'}>\r\n                <a href=\"main.php?op=update_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-xs btn-danger modulesadmin\"  data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_UPDATE_MODULE}> <{$mod.new_version}></a>\r\n              <{elseif $mod.function==\'update_theme\'}>\r\n                  <a href=\"main.php?op=update_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-xs btn-danger\" ><{$smarty.const._MA_TADADM_MOD_UPDATE_THEME}> <{$mod.new_version}></a>\r\n              <{elseif $mod.function==\'install_theme\'}>\r\n                  <a href=\"main.php?op=install_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"btn btn-xs btn-primary\" ><{$smarty.const._MA_TADADM_MOD_INSTALL_THEME}></a>\r\n              <{elseif $mod.function==\'last_mod\'}>\r\n                <a href=\"main.php?op=update_module&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" class=\"modulesadmin\"  data-fancybox-type=\"iframe\"><{$smarty.const._MA_TADADM_MOD_LATEST}></a>\r\n              <{elseif $mod.function==\'last_theme\'}>\r\n                  <a href=\"main.php?op=update_theme&dirname=<{$mod.dirname}>&file_link=<{$mod.file_link}>&update_sn=<{$mod.update_sn}>\" ><{$smarty.const._MA_TADADM_MOD_LATEST}></a>\r\n              <{elseif $mod.new_last_update}>\r\n                <{$smarty.const._MA_TADADM_MOD_LATEST}>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap style=\"text-align:center;\">\r\n              <{if $mod.descript}>\r\n                <a id=\"view_well<{$mod.module_sn}>\" class=\"btn btn-xs btn-success\" href=\"javascript:alert(\'<{$mod.descript}>\')\"><{if $mod.version}><{$smarty.const._MA_TADADM_MOD_UPDATE_DESC}><{else}><{$smarty.const._MA_TADADM_MOD_ABOUT_MOD}><{/if}></a>\r\n              <{/if}>\r\n            </td>\r\n\r\n            <td nowrap>\r\n              <{if $mod.version}>\r\n                <a href=\"<{$xoops_url}>/modules/<{$mod.dirname}>/admin/index.php\" title=\"<{$mod.dirname}><{$smarty.const._MA_TADADM_MOD_ADMIN}>\" target=\"_blank\"><{$mod.dirname}></a>\r\n              <{else}>\r\n                <{$mod.dirname}>\r\n              <{/if}>\r\n              </td>\r\n            <td nowrap>\r\n              <{if $mod.version}>\r\n                <a href=\"<{$xoops_url}>/modules/system/admin.php?fct=blocksadmin&op=list&filter=1&selgen=<{$mod.mid}>&selmod=-2&selgrp=-1&selvis=-1\" target=\"_blank\"><{$smarty.const._MA_TADADM_MOD_BLOCK}></a>\r\n              <{/if}>\r\n            </td>\r\n            <td nowrap><{$mod.version}></td>\r\n            <td nowrap><{$mod.last_update}></td>\r\n            <td nowrap><{$mod.new_version}></td>\r\n            <td nowrap><{$mod.new_last_update}></td>\r\n          </tr>\r\n        <{/foreach}>\r\n      </table>\r\n  <{/if}>\r\n</div>'),
(193,	'<{if $block.bootstrap_version==\'3\'}>\r\n  <!-- for bootstrap3-->\r\n  <div class=\"row\">\r\n    <div class=\"col-md-2\"></div>\r\n    <div class=\"col-md-8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"col-md-2\"></div>\r\n  </div>\r\n<{else}>\r\n   <!-- for bootstrap2-->\r\n  <div class=\"row-fluid\">\r\n    <div class=\"span2\"></div>\r\n    <div class=\"span8\">\r\n      <img src=\"http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl=<{$block.url}>&chld=H|0\" alt=\"QR Code\" class=\"img-responsive\">\r\n    </div>\r\n    <div class=\"span2\"></div>\r\n  </div>\r\n<{/if}>'),
(194,	'<div class=\"container-fluid\">\r\n  <{$jquery}>\r\n  <{$mColorPicker_code}>\r\n  <script type=\"text/javascript\">\r\n\r\n    $(document).ready(function(){\r\n\r\n      change_css();\r\n      preview_img(\"bg\",\"<{$bg_img}>\");\r\n      $(\"#tad-themes-tabs\").tabs({\r\n       activate: function (e, ui) {\r\n           $.cookie(\'selected-tab\', ui.newTab.index(), { path: \'/\' });\r\n       },\r\n       active: $.cookie(\'selected-tab\'),\r\n       collapsible: false\r\n      });\r\n      $(\"#bt_tabs\").tabs({\r\n        activate: function (e, ui) {\r\n            $.cookie(\'selected-tab\', ui.newTab.index(), { path: \'/\' });\r\n        },\r\n        active: $.cookie(\'selected-tab\')\r\n      }).addClass( \"ui-tabs-vertical ui-helper-clearfix\" );\r\n      $(\"#bt_tabs li\").removeClass( \"ui-corner-top\" ).addClass( \"ui-corner-left\" );\r\n\r\n      <{if $logo_position==\"page\"}>\r\n        $(\"#logo_place_setup\").hide();\r\n      <{else}>\r\n        $(\"#logo_place_setup\").show();\r\n      <{/if}>\r\n\r\n    });\r\n\r\n\r\n    function logo_place_setup(logo_position){\r\n      if(logo_position==\"page\"){\r\n        $(\"#logo_place_setup\").hide();\r\n      }else{\r\n        $(\"#logo_place_setup\").show();\r\n      }\r\n    }\r\n\r\n    function preview_img(kind,imgSrc){\r\n      var newimgSrc=imgSrc.replace(kind+\"/\", kind+\"/thumbs/\");\r\n      var newImg = new Image();\r\n      newImg.src = imgSrc;\r\n      var height = newImg.height * 1;\r\n      if(height > 90){\r\n        $(\"#preview_zone\").css(\"background-image\",\"url(\"+newimgSrc+\")\");\r\n      }else{\r\n        $(\"#preview_zone\").css(\"background-image\",\"url(\"+imgSrc+\")\");\r\n      }\r\n    }\r\n\r\n    <{$chang_css}>\r\n\r\n\r\n    function delete_tad_themes_config(theme_id){\r\n      var sure = window.confirm(\"<{$smarty.const._MA_TADTHEMES_DEL_CONFIRM}>\");\r\n      if (!sure)  return;\r\n      location.href=\"main.php?op=delete_tad_themes&theme_id=\" + theme_id;\r\n    }\r\n  </script>\r\n\r\n  <style>\r\n    .ui-tabs-vertical { width: 100%; }\r\n    .ui-tabs-vertical .ui-tabs-nav { padding: .2em .1em .2em .2em; float: left; width: 20%; }\r\n    .ui-tabs-vertical .ui-tabs-nav li { clear: left; width: 100%; border-bottom-width: 1px !important; border-right-width: 0 !important; margin: 0 -1px .2em 0; }\r\n    .ui-tabs-vertical .ui-tabs-nav li a { display:block; }\r\n    .ui-tabs-vertical .ui-tabs-nav li.ui-tabs-active { padding-bottom: 0; padding-right: .1em; border-right-width: 1px; border-right-width: 1px; }\r\n    .ui-tabs-vertical .ui-tabs-panel { padding: 1em; float: right; width: 72%;}\r\n  </style>\r\n\r\n  <{$formValidator_code}>\r\n\r\n  <form action=\"main.php\" method=\"post\" id=\"myForm\" enctype=\"multipart/form-data\" role=\"form\">\r\n    <div class=\"row\">\r\n      <div class=\"col-md-8\">\r\n        <h1>\r\n          <{$theme_name}><{$smarty.const._MA_TAD_THEMES_FORM}>\r\n\r\n          <a href=\"javascript:delete_tad_themes_config(<{$theme_id}>)\" class=\"btn btn-danger\"><{$smarty.const._MA_TADTHEMES_TO_DEFAULT}></a>\r\n        </h1>\r\n        <div class=\"alert alert-info\">\r\n          <{$smarty.const._MA_TADTHEMES_CHANGE_KIND_DESC}>\r\n        </div>\r\n          <{if $theme_change}>\r\n            <{foreach from=$theme_kind_arr item=kind}>\r\n              <div class=\"radio\">\r\n                <label>\r\n                  <input type=\"radio\" name=\"theme_kind\" value=\"<{$kind}>\" <{if $theme_kind==$kind}>checked<{/if}>>\r\n                  <b><{$kind}></b>\r\n                  <{$theme_kind_txt_arr.$kind}>\r\n                </label>\r\n              </div>\r\n            <{/foreach}>\r\n\r\n            <input type=\"hidden\" name=\"old_theme_kind\" value=\"<{$theme_kind}>\">\r\n          <{else}>\r\n            <{$theme_kind}><{$theme_kind_txt}>\r\n            <input type=\"hidden\" name=\"theme_kind\" value=\"<{$theme_kind}>\">\r\n          <{/if}>\r\n\r\n        <div class=\"row\">\r\n          <div id=\"tad-themes-tabs\">\r\n            <ul>\r\n              <{if $config_tabs.1}>\r\n                <li><a href=\"#tabs-1\"><{$smarty.const._MA_TADTHEMES_THEME_BASE}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.2}>\r\n                <li><a href=\"#tabs-2\"><{$smarty.const._MA_TADTHEMES_BG_IMG}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.3}>\r\n                <li><a href=\"#tabs-3\"><{$smarty.const._MA_TAD_THEMES_HEAD}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.4}>\r\n                <li><a href=\"#tabs-4\"><{$smarty.const._MA_TADTHEMES_LOGO_IMG}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.5}>\r\n                <li><a href=\"#tabs-5\"><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE}></a></li>\r\n              <{/if}>\r\n              <{if $config_tabs.6}>\r\n                <li><a href=\"#tabs-6\"><{$smarty.const._MA_TADTHEMES_NAVBAR}></a></li>\r\n              <{/if}>\r\n              <!--額外設定-->\r\n              <{if $config2}>\r\n              <li><a href=\"#tabs-7\"><{$smarty.const._MA_TADTHEMES_CONFIG2}></a></li>\r\n              <{/if}>\r\n            </ul>\r\n\r\n            <{if $config_tabs.1}>\r\n              <div id=\"tabs-1\">\r\n                <!--版面基本設定-->\r\n                <!--佈景類型-->\r\n                <div class=\"row\">\r\n                  <!--版面類型-->\r\n                  <{if $enable.theme_type}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_THEME_TYPE}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <select name=\"theme_type\" id=\"theme_type\" class=\"<{$validate.theme_type}>\" onChange=\"change_css();\">\r\n                        <option value=\"theme_type_1\" <{if $theme_type==\"theme_type_1\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE1}></option>\r\n                        <option value=\"theme_type_2\" <{if $theme_type==\"theme_type_2\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE2}></option>\r\n                        <option value=\"theme_type_3\" <{if $theme_type==\"theme_type_3\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE3}></option>\r\n                        <option value=\"theme_type_4\" <{if $theme_type==\"theme_type_4\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE4}></option>\r\n                        <option value=\"theme_type_5\" <{if $theme_type==\"theme_type_5\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE5}></option>\r\n                        <option value=\"theme_type_6\" <{if $theme_type==\"theme_type_6\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE6}></option>\r\n                        <option value=\"theme_type_7\" <{if $theme_type==\"theme_type_7\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE7}></option>\r\n                        <option value=\"theme_type_8\" <{if $theme_type==\"theme_type_8\"}>selected<{/if}>><{$smarty.const._MA_TAD_THEMES_TYPE8}></option>\r\n                      </select>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"theme_type\" id=\"theme_type\" value=\"<{$theme_type}>\">\r\n                  <{/if}>\r\n\r\n                  <!--版面寬度-->\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_THEME_WIDTH}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <{if $enable.theme_width}>\r\n                        <input type=\"text\" name=\"theme_width\" class=\"col-md-8 <{$validate.theme_width}>\" value=\"<{$theme_width}>\" id=\"theme_width\">\r\n                        <{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"theme_width\" id=\"theme_width\" value=\"<{$theme_width}>\"><{$theme_width}><{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                      <{/if}>\r\n                    </div>\r\n\r\n                  <!--內容區顏色-->\r\n                  <{if $enable.base_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_BASE_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"base_color\" class=\"col-md-8<{$validate.base_color}>\" value=\"<{$base_color}>\" id=\"base_color\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"base_color\" id=\"base_color\" value=\"<{$base_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row\">\r\n                  <!--左區塊顏色-->\r\n                  <{if $enable.lb_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_LB_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"lb_color\" id=\"lb_color\" value=\"<{$lb_color}>\" class=\"col-md-8<{$validate.lb_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"lb_color\" id=\"lb_color\" value=\"<{$lb_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--中區塊顏色-->\r\n                  <{if $enable.cb_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_CB_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"cb_color\" id=\"cb_color\" value=\"<{$cb_color}>\" class=\"col-md-8<{$validate.cb_color}>\"  data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"cb_color\" id=\"cb_color\" value=\"<{$cb_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--右區塊顏色-->\r\n                  <{if $enable.rb_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_RB_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"rb_color\" id=\"rb_color\" value=\"<{$rb_color}>\" class=\"col-md-8<{$validate.rb_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"rb_color\" id=\"rb_color\" value=\"<{$rb_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row\">\r\n                  <!--左區塊寬度-->\r\n                  <{if $enable.lb_width}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_LB_WIDTH}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"lb_width\" class=\"col-md-8<{$validate.lb_width}>\" value=\"<{$lb_width}>\" id=\"lb_width\" onChange=\"change_css();\">\r\n                      <{$theme_unit}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"lb_width\" id=\"lb_width\" value=\"<{$lb_width}>\">\r\n                  <{/if}>\r\n\r\n                  <!--中區塊寬度-->\r\n                  <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_CB_WIDTH}></div>\r\n                  <div class=\"col-md-2\">\r\n                    <div id=\"cb_width\"></div>\r\n                  </div>\r\n\r\n                  <!--右區塊寬度-->\r\n                  <{if $enable.rb_width}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_RB_WIDTH}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"rb_width\" class=\"col-md-8<{$validate.rb_width}>\" value=\"<{$rb_width}>\" id=\"rb_width\" onChange=\"change_css();\">\r\n                      <{$theme_unit}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"rb_width\" id=\"rb_width\" value=\"<{$rb_width}>\">\r\n                  <{/if}>\r\n\r\n                </div>\r\n\r\n\r\n                <div class=\"row\">\r\n                  <!--文字大小-->\r\n                  <{if $enable.font_size}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_FONT_SIZE}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"font_size\" class=\"col-md-8<{$validate.font_size}>\" value=\"<{$font_size}>\" id=\"font_size\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"font_size\" id=\"font_size\" value=\"<{$font_size}>\">\r\n                  <{/if}>\r\n\r\n                  <!--離上邊界距離-->\r\n                  <{if $enable.margin_top}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_MARGIN_TOP}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"margin_top\" class=\"col-md-8<{$validate.margin_top}>\" value=\"<{$margin_top}>\" id=\"margin_top\"  onChange=\"change_css();\">px\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"margin_top\" id=\"margin_top\" value=\"<{$margin_top}>\">\r\n                  <{/if}>\r\n\r\n                  <!--離下邊界距離-->\r\n                  <{if $enable.margin_bottom}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_MARGIN_BOTTOM}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"margin_bottom\" class=\"col-md-8<{$validate.margin_bottom}>\" value=\"<{$margin_bottom}>\" id=\"margin_bottom\"  onChange=\"change_css();\">px\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"margin_bottom\" id=\"margin_bottom\" value=\"<{$margin_bottom}>\">\r\n                  <{/if}>\r\n                </div>\r\n\r\n                <div class=\"row\">\r\n\r\n                  <!--文字顏色-->\r\n                  <{if $enable.font_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_FONT_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"font_color\" id=\"font_color\" value=\"<{$font_color}>\" class=\"col-md-8<{$validate.font_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"font_color\" id=\"font_color\" value=\"<{$font_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--連結顏色-->\r\n                  <{if $enable.link_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_LINK_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"link_color\" id=\"link_color\" value=\"<{$link_color}>\" class=\"col-md-8<{$validate.link_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"link_color\" id=\"link_color\" value=\"<{$link_color}>\">\r\n                  <{/if}>\r\n\r\n                  <!--滑鼠移到連結顏色-->\r\n                  <{if $enable.hover_color}>\r\n                    <div class=\"col-md-2 text-right\"><{$smarty.const._MA_TADTHEMES_HOVER_COLOR}></div>\r\n                    <div class=\"col-md-2\">\r\n                      <input type=\"text\" name=\"hover_color\" id=\"hover_color\" value=\"<{$hover_color}>\" class=\"col-md-8<{$validate.hover_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" name=\"hover_color\" id=\"hover_color\" value=\"<{$hover_color}>\">\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"theme_type\" name=\"theme_type\" value=\"<{$theme_type}>\">\r\n              <input type=\"hidden\" id=\"theme_width\" name=\"theme_width\" value=\"<{$theme_width}>\">\r\n              <input type=\"hidden\" id=\"base_color\" name=\"base_color\" value=\"<{$base_color}>\">\r\n              <input type=\"hidden\" id=\"lb_color\" name=\"lb_color\" value=\"<{$lb_color}>\">\r\n              <input type=\"hidden\" id=\"cb_color\" name=\"cb_color\" value=\"<{$cb_color}>\">\r\n              <input type=\"hidden\" id=\"rb_color\" name=\"rb_color\" value=\"<{$rb_color}>\">\r\n              <input type=\"hidden\" id=\"lb_width\" name=\"lb_width\" value=\"<{$lb_width}>\">\r\n              <input type=\"hidden\" id=\"rb_width\" name=\"rb_width\" value=\"<{$rb_width}>\">\r\n              <input type=\"hidden\" id=\"clb_width\" name=\"clb_width\" value=\"<{$clb_width}>\">\r\n              <input type=\"hidden\" id=\"crb_width\" name=\"crb_width\" value=\"<{$crb_width}>\">\r\n              <input type=\"hidden\" id=\"margin_top\" name=\"margin_top\" value=\"<{$margin_top}>\">\r\n              <input type=\"hidden\" id=\"font_size\" name=\"font_size\" value=\"<{$font_size}>\">\r\n              <input type=\"hidden\" id=\"margin_bottom\" name=\"margin_bottom\" value=\"<{$margin_bottom}>\">\r\n              <input type=\"hidden\" id=\"font_color\" name=\"font_color\" value=\"<{$font_color}>\">\r\n              <input type=\"hidden\" id=\"link_color\" name=\"link_color\" value=\"<{$link_color}>\">\r\n              <input type=\"hidden\" id=\"hover_color\" name=\"hover_color\" value=\"<{$hover_color}>\">\r\n            <{/if}>\r\n\r\n            <!--背景圖-->\r\n            <{if $config_tabs.2}>\r\n              <div id=\"tabs-2\">\r\n                <div class=\"row\">\r\n                  <div class=\"col-md-5\">\r\n                    <{if $enable.bg_img}>\r\n                      <div class=\"row\">\r\n                        <!-- 上傳 背景圖-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                          <{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <{$upform_bg}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_img\" id=\"bg_img\" value=\"<{$bg_img}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_color}>\r\n                      <div class=\"row\">\r\n                        <!-- 背景顏色-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_COLOR}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <input type=\"text\" name=\"bg_color\" id=\"bg_color\" value=\"<{$bg_color}>\" class=\"col-md-6<{$validate.bg_color}>\" data-hex=\"true\" onChange=\"change_css();\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_color\" id=\"bg_color\" value=\"<{$bg_color}>\">\r\n                    <{/if}>\r\n\r\n                    <{if $enable.bg_repeat}>\r\n                      <div class=\"row\">\r\n                        <!-- 背景重複-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_REPEAT}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <select name=\"bg_repeat\" id=\"bg_repeat\" class=\"col-md-12<{$validate.bg_repeat}>\" onChange=\"change_css();\">\r\n                            <option value=\"repeat\" <{if $bg_repeat==\"repeat\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_NORMAL}></option>\r\n                            <option value=\"repeat-x\" <{if $bg_repeat==\"repeat-x\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_X}></option>\r\n                            <option value=\"repeat-y\" <{if $bg_repeat==\"repeat-y\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_Y}></option>\r\n                            <option value=\"no-repeat\" <{if $bg_repeat==\"no-repeat\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_NO_REPEAT}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_repeat\" id=\"bg_repeat\" value=\"<{$bg_repeat}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_attachment}>\r\n                      <div class=\"row\">\r\n                        <!-- 背景模式-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <select name=\"bg_attachment\" id=\"bg_attachment\" class=\"col-md-12<{$validate.bg_attachment}>\" onChange=\"change_css();\">\r\n                            <option value=\"scroll\" <{if $bg_attachment==\"scroll\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT_SCROLL}></option>\r\n                            <option value=\"fixed\" <{if $bg_attachment==\"fixed\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_ATTACHMENT_FIXED}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_attachment\" id=\"bg_attachment\" value=\"<{$bg_attachment}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <{if $enable.bg_position}>\r\n                      <div class=\"row\">\r\n                        <!-- 背景位置-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_BG_POSITION}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <select name=\"bg_position\" id=\"bg_position\" class=\"col-md-12<{$validate.bg_position}>\" onChange=\"change_css();\">\r\n                            <option value=\"\" <{if $bg_position==\"left top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LT}></option>\r\n                            <option value=\"right top\" <{if $bg_position==\"right top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RT}></option>\r\n                            <option value=\"left bottom\" <{if $bg_position==\"left bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LB}></option>\r\n                            <option value=\"right bottom\" <{if $bg_position==\"right bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RB}></option>\r\n                            <option value=\"center center\" <{if $bg_position==\"center center\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CC}></option>\r\n                            <option value=\"center top\" <{if $bg_position==\"center top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CT}></option>\r\n                            <option value=\"center bottom\" <{if $bg_position==\"center bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_CB}></option>\r\n                          </select>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"bg_position\" id=\"bg_position\" value=\"<{$bg_position}>\">\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <!--選擇預設 背景圖-->\r\n                  <div class=\"col-md-7\">\r\n                    <{if $all_bg and $enable.bg_img==\"1\"}>\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"bg_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"bg_img\" id=\"bg_img0\" onChange=\"$(\'.del_img_box\').show(); preview_img(\'bg\',$(this).val());\" value=\"\" <{if $bg_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                        </label>\r\n                      </div>\r\n                      <{foreach from=$all_bg item=bg}>\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"bg_img<{$bg.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$bg.tb_path}>);background-position:center center;border:1px solid gray;\" >\r\n                            <input type=\"radio\" name=\"bg_img\" id=\"bg_img<{$bg.files_sn}>\" onChange=\"$(\'.del_img_box\').show(); $(\'#del_img<{$bg.files_sn}>\').hide(); preview_img(\'bg\',$(this).val());\" value=\"<{$bg.path}>\" <{if $bg_img==$bg.path}>checked<{/if}>>\r\n                          </label>\r\n\r\n                          <label class=\"del_img_box\" style=\"font-size:12px;\" id=\"del_img<{$bg.files_sn}>\">\r\n                            <input type=\"checkbox\" value=\"<{$bg.files_sn}>\" name=\"del_file[<{$bg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                          </label>\r\n                        </div>\r\n                      <{/foreach}>\r\n                    <{/if}>\r\n                  </div>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"bg_img\" name=\"bg_img\" value=\"<{$bg_img}>\">\r\n              <input type=\"hidden\" id=\"bg_color\" name=\"bg_color\" value=\"<{$bg_color}>\">\r\n              <input type=\"hidden\" id=\"bg_repeat\" name=\"bg_repeat\" value=\"<{$bg_repeat}>\">\r\n              <input type=\"hidden\" id=\"bg_attachment\" name=\"bg_attachment\" value=\"<{$bg_attachment}>\">\r\n              <input type=\"hidden\" id=\"bg_position\" name=\"bg_position\" value=\"<{$bg_position}>\">\r\n            <{/if}>\r\n\r\n            <!--滑動圖片高度-->\r\n            <{if $config_tabs.3}>\r\n              <div id=\"tabs-3\">\r\n                <div class=\"row\">\r\n\r\n                  <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\"}>\r\n                    <div class=\"col-md-5\">\r\n\r\n                      <!--滑動圖片寬度-->\r\n                      <{if $enable.slide_width==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_SLIDE_WIDTH}>\r\n                          </div>\r\n                          <div class=\"col-md-8\">\r\n                            <input type=\"text\" name=\"slide_width\" class=\"col-md-8<{$validate.slide_width}>\" value=\"<{$slide_width}>\" id=\"slide_width\" onChange=\"change_css();\">\r\n                            <{if $theme_kind==\"mix\"}>px<{else}><{$theme_unit}><{/if}>\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"slide_width\" id=\"slide_width\" value=\"<{$slide_width}>\">\r\n                      <{/if}>\r\n\r\n                      <!--滑動圖片高度-->\r\n                      <{if $enable.slide_height==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_SLIDE_HEIGHT}>\r\n                          </div>\r\n                          <div class=\"col-md-8\">\r\n                            <input type=\"text\" name=\"slide_height\" class=\"col-md-8<{$validate.slide_height}>\" value=\"<{$slide_height}>\" id=\"slide_height\" onChange=\"change_css();\"> px\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"slide_height\" id=\"slide_height\" value=\"<{$slide_height}>\">\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" id=\"slide_width\" name=\"slide_width\" value=\"<{$slide_width}>\">\r\n                    <input type=\"hidden\" id=\"slide_height\" name=\"slide_height\" value=\"<{$slide_height}>\">\r\n                  <{/if}>\r\n\r\n                  <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\" or $enable.use_slide==\"1\"}>\r\n                    <div class=\"col-md-7\">\r\n                      <div class=\"col-md-12 alert alert-success\">\r\n                        <{$smarty.const._MA_TADTHEMES_SLIDE_DESC}>\r\n                      </div>\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n                <{if $enable.slide_width==\"1\" or $enable.slide_height==\"1\" or $enable.use_slide==\"1\"}>\r\n                  <div class=\"row\">\r\n                    <!-- 背景模式-->\r\n                    <div class=\"col-md-2 text-right\">\r\n                      <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                      <{$smarty.const._MA_TAD_THEMES_HEAD}>\r\n                    </div>\r\n                    <div class=\"col-md-10\">\r\n                      <{$upform_slide}>\r\n                    </div>\r\n                  </div>\r\n                <{/if}>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"slide_width\" name=\"slide_width\" value=\"<{$slide_width}>\">\r\n              <input type=\"hidden\" id=\"slide_height\" name=\"slide_height\" value=\"<{$slide_height}>\">\r\n            <{/if}>\r\n\r\n            <!--logo圖-->\r\n            <{if $config_tabs.4}>\r\n              <div id=\"tabs-4\">\r\n                <div class=\"row\">\r\n                  <div class=\"col-md-5\">\r\n\r\n                    <!-- 上傳logo圖-->\r\n                    <{if $enable.logo_img==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_LOGO_IMG}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <{$upform_logo}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"logo_img\" id=\"logo_img\" value=\"<{$logo_img}>\">\r\n                    <{/if}>\r\n\r\n                    <!-- logo圖位置-->\r\n                    <{if $enable.logo_position==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_LOGO_POSITION}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <div class=\"radio\">\r\n                            <label>\r\n                              <input type=\"radio\" name=\"logo_position\" onClick=\"logo_place_setup(this.value)\" value=\"slide\" <{if $logo_position==\"slide\"}>checked<{/if}>><{$smarty.const._MA_TADTHEMES_LOGO_SLIDE}>\r\n                            </label>\r\n                          </div>\r\n                          <div class=\"radio\">\r\n                            <label class=\"radio\">\r\n                              <input type=\"radio\" name=\"logo_position\" onClick=\"logo_place_setup(this.value)\" class=\"logo_position\" value=\"page\" <{if $logo_position==\"page\"}>checked<{/if}>><{$smarty.const._MA_TADTHEMES_LOGO_PAGE}>\r\n                            </label>\r\n                          </div>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"logo_position\" id=\"logo_position\" value=\"<{$logo_position}>\">\r\n                    <{/if}>\r\n\r\n\r\n\r\n                    <!-- 選擇預設logo圖-->\r\n                    <{if $enable.logo_top==\"1\" or  $enable.logo_right==\"1\" or $enable.logo_left==\"1\" or $enable.logo_bottom==\"1\"}>\r\n                      <div class=\"row\" id=\"logo_place_setup\">\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TADTHEMES_LOGO_PLACE}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <{if $enable.logo_top==\"1\"}>\r\n                            <div class=\"row\">\r\n                              <div class=\"col-md-4 col-md-offset-4\">\r\n                                <input type=\"text\" name=\"logo_top\" class=\"col-md-8<{$validate.logo_top}>\" value=\"<{$logo_top}>\" id=\"logo_top\" onChange=\"if(this.value > 0){$(\'#logo_bottom\').val(0);}\"> px\r\n                              </div>\r\n                            </div>\r\n                          <{else}>\r\n                            <input type=\"hidden\" name=\"logo_top\" id=\"logo_top\" value=\"<{$logo_top}>\">\r\n                          <{/if}>\r\n\r\n                          <div class=\"row\">\r\n                            <{if $enable.logo_left==\"1\"}>\r\n                              <div class=\"col-md-4\">\r\n                                <input type=\"text\" name=\"logo_left\" class=\"col-md-8<{$validate.logo_left}>\" value=\"<{$logo_left}>\" id=\"logo_left\" onChange=\"if(this.value > 0){$(\'#logo_right\').val(0);}\"> px\r\n                              </div>\r\n                            <{else}>\r\n                              <input type=\"hidden\" name=\"logo_left\" id=\"logo_left\" value=\"<{$logo_left}>\">\r\n                            <{/if}>\r\n\r\n                            <{if $enable.logo_right==\"1\"}>\r\n                              <div class=\"col-md-4 col-md-offset-4\">\r\n                                <input type=\"text\" name=\"logo_right\" class=\"col-md-8<{$validate.logo_right}>\" value=\"<{$logo_right}>\" id=\"logo_right\" onChange=\"if(this.value > 0){$(\'#logo_left\').val(0);}\"> px\r\n                              </div>\r\n                            <{else}>\r\n                              <input type=\"hidden\" name=\"logo_right\" id=\"logo_right\" value=\"<{$logo_right}>\">\r\n                            <{/if}>\r\n                          </div>\r\n\r\n                          <{if $enable.logo_bottom==\"1\"}>\r\n                            <div class=\"row\">\r\n                              <div class=\"col-md-4 col-md-offset-4\">\r\n                                <input type=\"text\" name=\"logo_bottom\" class=\"col-md-8<{$validate.logo_bottom}>\" value=\"<{$logo_bottom}>\" id=\"logo_bottom\" onChange=\"if(this.value > 0){$(\'#logo_top\').val(0);}\"> px\r\n                              </div>\r\n                            </div>\r\n                          <{else}>\r\n                            <input type=\"hidden\" name=\"logo_bottom\" id=\"logo_bottom\" value=\"<{$logo_bottom}>\">\r\n                          <{/if}>\r\n                        </div>\r\n                      </div>\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <{if $enable.logo_img==\"1\"}>\r\n                    <div class=\"col-md-7\">\r\n                      <!-- 選擇預設logo圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"logo_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"logo_img\" id=\"logo_img0\" value=\"\" <{if $logo_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_LOGO_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_logo}>\r\n                        <{foreach from=$all_logo item=logo}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"logo_img<{$logo.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$logo.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"logo_img\" id=\"logo_img<{$logo.files_sn}>\" value=\"<{$logo.path}>\" <{if $logo_img==$logo.path}>checked<{/if}>>\r\n                            </label>\r\n\r\n                            <label class=\"del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$logo.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$logo.files_sn}>\" name=\"del_file[<{$logo.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"logo_img\" name=\"logo_img\" value=\"<{$logo_img}>\">\r\n              <input type=\"hidden\" id=\"logo_position\" name=\"logo_position\" value=\"<{$logo_position}>\">\r\n              <input type=\"hidden\" id=\"logo_top\" name=\"logo_top\" value=\"<{$logo_top}>\">\r\n              <input type=\"hidden\" id=\"logo_right\" name=\"logo_right\" value=\"<{$logo_right}>\">\r\n              <input type=\"hidden\" id=\"logo_bottom\" name=\"logo_bottom\" value=\"<{$logo_bottom}>\">\r\n              <input type=\"hidden\" id=\"logo_left\" name=\"logo_left\" value=\"<{$logo_left}>\">\r\n            <{/if}>\r\n\r\n            <!--區塊標題列背景圖-->\r\n            <{if $config_tabs.5}>\r\n              <div id=\"tabs-5\">\r\n\r\n                <div id=\"bt_tabs\">\r\n                  <ul class=\"nav nav-tabs\">\r\n                    <{foreach from=$blocks_values item=block}>\r\n                      <li><a href=\"#bp_<{$block.block_position}>\"><{$block.title}></a></li>\r\n                    <{/foreach}>\r\n                  </ul>\r\n\r\n                  <{foreach from=$blocks_values item=block}>\r\n                    <div id=\"bp_<{$block.block_position}>\">\r\n                      <div style=\"font-size:1.5em;margin:0px 0px 10px;font-weight:bold;\">\r\n                        <{$block.title}>\r\n                      <label class=\"checkbox-inline\">\r\n                        <input type=\"checkbox\" name=\"apply_to_all\" value=\"<{$block.block_position}>\">\r\n                        <{$smarty.const._MA_TADTHEMES_BLOCK_ALL_POSITION}>\r\n                      </label></div>\r\n                      <div class=\"row\">\r\n                        <!-- 區塊標題文字大小-->\r\n                        <{if $enable.bt_text_size==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_SIZE}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <input type=\"text\" name=\"bt_text_size[<{$block.block_position}>]\" class=\"col-md-6<{$validate.bt_text_size}>\" value=\"<{$block.bt_text_size}>\" id=\"bt_text_size_<{$block.block_position}>\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text_size\" id=\"bt_text_size\" value=\"<{$bt_text_size}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題文字縮排-->\r\n                        <{if $enable.bt_text_padding==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_PADDING}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <input type=\"text\" name=\"bt_text_padding[<{$block.block_position}>]\" class=\"col-md-6<{$validate.bt_text_padding}>\" value=\"<{$block.bt_text_padding}>\" id=\"bt_text_padding_<{$block.block_position}>\">px\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text_padding\" id=\"bt_text_padding\" value=\"<{$bt_text_padding}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row\">\r\n                        <!-- 區塊標題列文字顏色-->\r\n                        <{if $enable.bt_text==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_FONT_COLOR}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <input type=\"text\" name=\"bt_text[<{$block.block_position}>]\" id=\"bt_text_<{$block.block_position}>\" value=\"<{$block.bt_text}>\" class=\"col-md-6<{$validate.bt_text}>\" data-hex=\"true\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_text\" id=\"bt_text\" value=\"<{$bt_text}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題列背景顏色-->\r\n                        <{if $enable.bt_bg_color==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BG_COLOR}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <input type=\"text\" name=\"bt_bg_color[<{$block.block_position}>]\" id=\"bt_bg_color_<{$block.block_position}>\" value=\"<{$block.bt_bg_color}>\" class=\"col-md-6<{$validate.bt_bg_color}>\" data-hex=\"true\">\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_color\" id=\"bt_bg_color\" value=\"<{$bt_bg_color}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row\">\r\n\r\n                        <!-- 區塊標題圓角設定-->\r\n                        <{if $enable.bt_radius==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS}>\r\n                          </div>\r\n\r\n                          <div class=\"col-md-4\">\r\n                            <select name=\"bt_radius[<{$block.block_position}>]\" id=\"bt_radius_<{$block.block_position}>\" class=\"col-md-12<{$validate.bt_radius}>\">\r\n                              <option value=\"1\" <{if $block.bt_radius==\"1\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS_Y}></option>\r\n                              <option value=\"0\" <{if $block.bt_radius==\"0\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_RADIUS_N}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_radius\" id=\"bt_radius\" value=\"<{$bt_radius}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題工具按鈕-->\r\n                        <{if $enable.block_config==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_BUTTOM}>\r\n                          </div>\r\n\r\n                          <div class=\"col-md-4\">\r\n                            <select name=\"block_config[<{$block.block_position}>]\" id=\"block_config_<{$block.block_position}>\" class=\"col-md-12<{$validate.block_config}>\">\r\n                              <option value=\"right\" <{if $block.block_config==\"right\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_RT}></option>\r\n                              <option value=\"left\" <{if $block.block_config==\"left\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_POSITION_LT}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_config\" id=\"block_config\" value=\"<{$block_config}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n                      <div class=\"row\">\r\n                        <!-- 上傳區塊標題列背景圖-->\r\n                        <{if $enable.bt_bg_img==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TAD_THEMES_UPLOAD}>\r\n                            <{$smarty.const._MA_TADTHEMES_BG_IMG}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <{$block.upform_bt_bg}>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_img\" id=\"bt_bg_img\" value=\"<{$bt_bg_img}>\">\r\n                        <{/if}>\r\n\r\n                        <!-- 區塊標題列背景重複-->\r\n                        <{if $enable.bt_bg_repeat==\"1\"}>\r\n                          <div class=\"col-md-2 text-right\">\r\n                            <{$smarty.const._MA_TADTHEMES_BG_REPEAT}>\r\n                          </div>\r\n                          <div class=\"col-md-4\">\r\n                            <select name=\"bt_bg_repeat[<{$block.block_position}>]\" id=\"bt_bg_repeat_<{$block.block_position}>\" class=\"col-md-12<{$validate.bt_bg_repeat}>\">\r\n                              <option value=\"1\" <{if $block.bt_bg_repeat==\"1\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_REPEAT_NORMAL}></option>\r\n                              <option value=\"0\" <{if $block.bt_bg_repeat==\"0\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_BG_NO_REPEAT}></option>\r\n                            </select>\r\n                          </div>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"bt_bg_repeat\" id=\"bt_bg_repeat\" value=\"<{$bt_bg_repeat}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n\r\n                      <!-- 選擇預設區塊標題列背景圖-->\r\n                      <{if $block.all_bt_bg and $enable.bt_bg_img==\'1\'}>\r\n                        <div class=\"row\">\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"bt_bg_img0_<{$block.block_position}>\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                              <input type=\"radio\" name=\"bt_bg_img[<{$block.block_position}>]\" id=\"bt_bg_img0_<{$block.block_position}>\" onChange=\"$(\'.del_img_box_<{$block.block_position}>\').show();\" value=\"\" <{if $block.bt_bg_img==\"\"}>checked<{/if}>>\r\n                              <{$smarty.const._MA_TADTHEMES_NONE}>\r\n                            </label>\r\n                          </div>\r\n                          <{foreach from=$block.all_bt_bg item=bt_bg}>\r\n                            <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                              <label for=\"bt_bg_img<{$bt_bg.files_sn}>_<{$block.block_position}>\" style=\"width:60px; height:60px; background:#000000 url(<{$bt_bg.tb_path}>);background-position:left center;border:1px solid gray;\" >\r\n                                <input type=\"radio\" name=\"bt_bg_img[<{$block.block_position}>]\" id=\"bt_bg_img<{$bt_bg.files_sn}>_<{$block.block_position}>\" onChange=\"$(\'.del_img_box_<{$block.block_position}>\').show(); $(\'#del_img<{$bt_bg.files_sn}>_<{$block.block_position}>\').hide(); \" value=\"<{$bt_bg.path}>\" <{if $block.bt_bg_img==$bt_bg.path}>checked<{/if}>>\r\n                              </label>\r\n                              <label class=\"del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$bt_bg.files_sn}>_<{$block.block_position}>\">\r\n                                <input type=\"checkbox\" value=\"<{$bt_bg.files_sn}>\" name=\"del_file[<{$bt_bg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                              </label>\r\n                            </div>\r\n                          <{/foreach}>\r\n                        </div>\r\n                      <{/if}>\r\n\r\n\r\n\r\n                      <div class=\"row\">\r\n                        <!-- 區塊整體樣式-->\r\n                        <{if $enable.block_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_style[<{$block.block_position}>]\" id=\"block_style_<{$block.block_position}>\" class=\"col-md-12<{$validate.block_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_style\" id=\"block_style\" value=\"<{$block_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                      <div class=\"row\">\r\n                        <!-- 區塊標題樣式-->\r\n                        <{if $enable.block_title_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_TITLE_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> .blockTitle {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_title_style[<{$block.block_position}>]\" id=\"block_title_style_<{$block.block_position}>\" class=\"col-md-12<{$validate.block_title_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_title_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_title_style\" id=\"block_title_style\" value=\"<{$block_title_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                      <div class=\"row\">\r\n                        <!-- 區塊內容樣式-->\r\n                        <{if $enable.block_content_style==\"1\"}>\r\n                          <div>\r\n                            <{$smarty.const._MA_TADTHEMES_BLOCK_CONTENT_STYLE}>\r\n                            <span style=\"font-size:12px;color:#0000DC;white-space:nowrap; \">.<{$block.block_position}> .blockContent {<span style=\"color:#DE1212;\"><{$smarty.const._MA_TADTHEMES_YOUR_STYLE}></span>}</span>\r\n                          </div>\r\n                          <textarea name=\"block_content_style[<{$block.block_position}>]\" id=\"block_content_style_<{$block.block_position}>\" class=\"col-md-12<{$validate.block_content_style}>\" style=\"font-size:11px;height:50px;\"><{$block.block_content_style}></textarea>\r\n                        <{else}>\r\n                          <input type=\"hidden\" name=\"block_content_style\" id=\"block_content_style\" value=\"<{$block_content_style}>\">\r\n                        <{/if}>\r\n                      </div>\r\n\r\n\r\n                    </div>\r\n                  <{/foreach}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"bt_text_size\" name=\"bt_text_size\" value=\"<{$bt_text_size}>\">\r\n              <input type=\"hidden\" id=\"bt_text_padding\" name=\"bt_text_padding\" value=\"<{$bt_text_padding}>\">\r\n              <input type=\"hidden\" id=\"bt_text\" name=\"bt_text\" value=\"<{$bt_text}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_color\" name=\"bt_bg_color\" value=\"<{$bt_bg_color}>\">\r\n              <input type=\"hidden\" id=\"bt_radius\" name=\"bt_radius\" value=\"<{$bt_radius}>\">\r\n              <input type=\"hidden\" id=\"block_config\" name=\"block_config\" value=\"<{$block_config}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_img\" name=\"bt_bg_img\" value=\"<{$bt_bg_img}>\">\r\n              <input type=\"hidden\" id=\"bt_bg_repeat\" name=\"bt_bg_repeat\" value=\"<{$bt_bg_repeat}>\">\r\n              <input type=\"hidden\" id=\"block_style\" name=\"block_style\" value=\"<{$block_style}>\">\r\n              <input type=\"hidden\" id=\"block_title_style\" name=\"block_title_style\" value=\"<{$block_title_style}>\">\r\n              <input type=\"hidden\" id=\"block_content_style\" name=\"block_content_style\" value=\"<{$block_content_style}>\">\r\n            <{/if}>\r\n\r\n            <!--navbar-->\r\n            <{if $config_tabs.6}>\r\n              <div id=\"tabs-6\">\r\n                <div class=\"row\">\r\n                  <{if $enable.navbar_pos==\"1\" or $enable.navbar_bg_top==\"1\" or  $enable.navbar_bg_bottom==\"1\" or $enable.navbar_hover==\"1\"}>\r\n                    <div class=\"col-md-6\">\r\n                      <!--導覽工具列位置-->\r\n                      <{if $enable.navbar_pos==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4\"><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION}></div>\r\n                          <div class=\"col-md-8\">\r\n                            <select name=\"navbar_pos\" id=\"navbar_pos\" class=\"col-md-12<{$validate.navbar_pos}>\">\r\n                              <option value=\"navbar-fixed-top\" <{if $navbar_pos==\"navbar-fixed-top\"}>selected<{/if}>>\r\n                              <{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_1}></option>\r\n                              <option value=\"navbar-fixed-bottom\" <{if $navbar_pos==\"navbar-fixed-bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_2}></option>\r\n                              <option value=\"navbar-static-top\" <{if $navbar_pos==\"navbar-static-top\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_3}></option>\r\n                              <option value=\"navbar-static-bottom\" <{if $navbar_pos==\"navbar-static-bottom\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_6}></option>\r\n                              <option value=\"default\" <{if $navbar_pos==\"default\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_4}></option>\r\n                              <option value=\"not-use\" <{if $navbar_pos==\"not-use\"}>selected<{/if}>><{$smarty.const._MA_TADTHEMES_NAVBAR_POSITION_5}></option>\r\n                            </select>\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_pos\" id=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 漸層顏色(top) -->\r\n                      <{if $enable.navbar_bg_top==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_BG_COLOR}>(top)\r\n                          </div>\r\n                          <div class=\"col-md-8\">\r\n                            <input type=\"text\" name=\"navbar_bg_top\" id=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\" class=\"col-md-6<{$validate.navbar_bg_top}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_bg_top\" id=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 漸層顏色(bottom)-->\r\n                      <{if $enable.navbar_bg_bottom==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_BG_COLOR}>(bottom)\r\n                          </div>\r\n                          <div class=\"col-md-8\">\r\n                            <input type=\"text\" name=\"navbar_bg_bottom\" id=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\" class=\"col-md-6<{$validate.navbar_bg_bottom}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_bg_bottom\" id=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n                      <{/if}>\r\n\r\n                      <!--導覽工具列 連結區塊底色-->\r\n                      <{if $enable.navbar_hover==\"1\"}>\r\n                        <div class=\"row\">\r\n                          <div class=\"col-md-4\">\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_HOVER_COLOR}>\r\n                          </div>\r\n                          <div class=\"col-md-8\">\r\n                            <input type=\"text\" name=\"navbar_hover\" id=\"navbar_hover\" value=\"<{$navbar_hover}>\" class=\"col-md-6<{$validate.navbar_hover}>\" data-hex=\"true\">\r\n                          </div>\r\n                        </div>\r\n                      <{else}>\r\n                        <input type=\"hidden\" name=\"navbar_hover\" id=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <input type=\"hidden\" id=\"navbar_pos\" name=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n                    <input type=\"hidden\" id=\"navbar_bg_top\" name=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n                    <input type=\"hidden\" id=\"navbar_bg_bottom\" name=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n                    <input type=\"hidden\" id=\"navbar_hover\" name=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n                  <{/if}>\r\n\r\n                  <div class=\"col-md-6\">\r\n                    <!--導覽工具列 文字顏色-->\r\n                    <{if $enable.navbar_color==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <div class=\"col-md-4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_COLOR}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <input type=\"text\" name=\"navbar_color\" id=\"navbar_color\" value=\"<{$navbar_color}>\" class=\"col-md-6<{$validate.navbar_color}>\" data-hex=\"true\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_color\" id=\"navbar_color\" value=\"<{$navbar_color}>\">\r\n                    <{/if}>\r\n\r\n\r\n                    <!--導覽工具列 文字移過顏色-->\r\n                    <{if $enable.navbar_color_hover==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <div class=\"col-md-4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_COLOR_HOVER}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <input type=\"text\" name=\"navbar_color_hover\" id=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\" class=\"col-md-6<{$validate.navbar_color_hover}>\" data-hex=\"true\">\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_color_hover\" id=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\">\r\n                    <{/if}>\r\n\r\n                    <!--導覽工具列 圖示顏色-->\r\n                    <{if $enable.navbar_icon==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <div class=\"col-md-4\">\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR}>\r\n                          <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_COLOR}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <label for=\"navbar_icon_white\">\r\n                            <input type=\"radio\" name=\"navbar_icon\" id=\"navbar_icon_white\" value=\"icon-white\" <{if $navbar_icon==\"icon-white\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_WHITE}>\r\n                          </label>\r\n                          <label for=\"navbar_icon_black\">\r\n                            <input type=\"radio\" name=\"navbar_icon\" id=\"navbar_icon_black\" value=\"\" <{if $navbar_icon==\"\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NAVBAR_ICON_BLACK}>\r\n                          </label>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_icon\" id=\"navbar_icon\" value=\"<{$navbar_icon}>\">\r\n                    <{/if}>\r\n                  </div>\r\n                </div>\r\n\r\n\r\n                <div class=\"row\">\r\n                  <div class=\"col-md-5\">\r\n                    <{if $enable.navbar_img==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <!-- 上傳navbar_img圖-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_NAVBAR_IMG}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <{$upform_navbar_img}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navbar_img\" id=\"navbar_img\" value=\"<{$navbar_img}>\">\r\n                    <{/if}>\r\n\r\n                  </div>\r\n\r\n                  <{if $enable.navbar_img==\"1\"}>\r\n                    <div class=\"col-md-7\">\r\n                      <!-- 選擇預設導覽列navbar_img圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"navbar_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"navbar_img\" id=\"navbar_img0\" onChange=\"$(\'.del_img_box\').show();\" value=\"\" <{if $navbar_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_NAVBAR_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_navbar_img}>\r\n                        <{foreach from=$all_navbar_img item=navbarbg}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"navbar_img<{$navbarbg.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$navbarbg.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"navbar_img\" id=\"navbar_img<{$navbarbg.files_sn}>\" onChange=\"$(\'.del_img_box\').show(); $(\'#del_img<{$navbarbg.files_sn}>\').hide();\" value=\"<{$navbarbg.path}>\" <{if $navbar_img==$navbarbg.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"del_img_box\" style=\"font-size:11px;\"  id=\"del_img<{$navbarbg.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$navbarbg.files_sn}>\" name=\"del_file[<{$navbarbg.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n                <div class=\"row\">\r\n                  <div class=\"col-md-5\">\r\n\r\n                    <{if $enable.navlogo_img==\"1\"}>\r\n                      <div class=\"row\">\r\n                        <!-- 上傳logo圖-->\r\n                        <div class=\"col-md-4 text-right\">\r\n                          <{$smarty.const._MA_TAD_THEMES_UPLOAD}><{$smarty.const._MA_TADTHEMES_NAVLOGO_IMG}>\r\n                        </div>\r\n                        <div class=\"col-md-8\">\r\n                          <{$upform_navlogo}>\r\n                        </div>\r\n                      </div>\r\n                    <{else}>\r\n                      <input type=\"hidden\" name=\"navlogo_img\" id=\"navlogo_img\" value=\"<{$navlogo_img}>\">\r\n                    <{/if}>\r\n\r\n                  </div>\r\n\r\n                  <{if $enable.navlogo_img==\"1\"}>\r\n                    <div class=\"col-md-7\">\r\n                      <!-- 選擇預設導覽列navlogo圖-->\r\n                      <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                        <label for=\"navlogo_img0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                          <input type=\"radio\" name=\"navlogo_img\" id=\"navlogo_img0\" value=\"\" <{if $navlogo_img==\"\"}>checked<{/if}>>\r\n                          <{$smarty.const._MA_TADTHEMES_NONE}><{$smarty.const._MA_TADTHEMES_NAVLOGO_IMG}>\r\n                        </label>\r\n                      </div>\r\n\r\n                      <{if $all_navlogo}>\r\n                        <{foreach from=$all_navlogo item=navlogo}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"logo_img<{$navlogo.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$navlogo.tb_path}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"navlogo_img\" id=\"navlogo_img<{$navlogo.files_sn}>\" value=\"<{$navlogo.path}>\" <{if $navlogo_img==$navlogo.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"del_navimg_box\" style=\"font-size:11px;\"  id=\"del_navimg<{$navlogo.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$navlogo.files_sn}>\" name=\"del_file[<{$navlogo.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                      <{/if}>\r\n\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n              </div>\r\n            <{else}>\r\n              <input type=\"hidden\" id=\"navbar_pos\" name=\"navbar_pos\" value=\"<{$navbar_pos}>\">\r\n              <input type=\"hidden\" id=\"navbar_bg_top\" name=\"navbar_bg_top\" value=\"<{$navbar_bg_top}>\">\r\n              <input type=\"hidden\" id=\"navbar_bg_bottom\" name=\"navbar_bg_bottom\" value=\"<{$navbar_bg_bottom}>\">\r\n              <input type=\"hidden\" id=\"navbar_hover\" name=\"navbar_hover\" value=\"<{$navbar_hover}>\">\r\n              <input type=\"hidden\" id=\"navbar_img\" name=\"navbar_img\" value=\"<{$navbar_img}>\">\r\n              <input type=\"hidden\" id=\"navbar_color\" name=\"navbar_color\" value=\"<{$navbar_color}>\">\r\n              <input type=\"hidden\" id=\"navbar_color_hover\" name=\"navbar_color_hover\" value=\"<{$navbar_color_hover}>\">\r\n              <input type=\"hidden\" id=\"navbar_icon\" name=\"navbar_icon\" value=\"<{$navbar_icon}>\">\r\n              <input type=\"hidden\" id=\"navlogo_img\" name=\"navlogo_img\" value=\"<{$navlogo_img}>\">\r\n            <{/if}>\r\n\r\n            <!--額外設定-->\r\n            <{if $config2}>\r\n            <div id=\"tabs-7\">\r\n              <input type=\"hidden\" name=\"config2\" value=\"1\">\r\n              <{foreach from=$theme_config item=config}>\r\n                <div class=\"row\">\r\n                  <div class=\"col-md-2 text-right\">\r\n                    <{$config.text}>\r\n                  </div>\r\n                  <div class=\"col-md-5\">\r\n                    <{if $config.type==\"text\"}>\r\n                      <input type=\"text\" name=\"<{$config.name}>\" value=\"<{$config.value}>\" class=\"col-md-12\">\r\n                    <{elseif $config.type==\"color\"}>\r\n                      <input type=\"text\" name=\"<{$config.name}>\" id=\"<{$config.name}>\" value=\"<{$config.value}>\" class=\"col-md-8\" data-hex=\"true\" >\r\n                    <{elseif $config.type==\"array\"}>\r\n                      <textarea name=\"<{$config.name}>\" class=\"col-md-12\" rows=4 style=\"font-size:0.8em;\"><{$config.value}></textarea>\r\n                    <{elseif $config.type==\"textarea\"}>\r\n                      <textarea name=\"<{$config.name}>\" class=\"col-md-12\" rows=4 style=\"font-size:0.8em;\"><{$config.value}></textarea>\r\n                    <{elseif $config.type==\"yesno\"}>\r\n                      <label class=\"radio-inline\">\r\n                        <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>1\" value=\"1\" <{if $config.value==1}>checked<{/if}> ><{$smarty.const._YES}>\r\n                      </label>\r\n                      <label class=\"radio-inline\">\r\n                        <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>0\" value=\"0\" <{if $config.value==0}>checked<{/if}> ><{$smarty.const._NO}>\r\n                      </label>\r\n                    <{elseif $config.type==\"file\"}>\r\n                      <{$config.form}>\r\n                    <{/if}>\r\n                  </div>\r\n\r\n                  <{if $config.type==\"file\"}>\r\n                    <div class=\"col-md-5\">\r\n                      <{if $config.list}>\r\n\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"<{$config.name}>0\" style=\"width:60px; height:60px;border:1px dotted gray;\" >\r\n                            <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}>0\" value=\"\" <{if $config.value==\"\"}>checked<{/if}>>\r\n                            <{$smarty.const._MA_TADTHEMES_NONE}>\r\n                          </label>\r\n                        </div>\r\n\r\n                        <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                          <label for=\"<{$config.name}>\" style=\"width:60px; height:60px; background:#000000 url(<{$config.default}>);background-repeat:no-repeat;background-position:left center;border:1px solid gray;background-size: cover;\" >\r\n                            <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}><{$file.files_sn}>\" value=\"<{$config.default}>\"  <{if $config.value==$config.default}>checked<{/if}>>\r\n                          </label>\r\n                            <label style=\"font-size:11px;\">\r\n                              <{$smarty.const._MA_TADTHEMES_DEFAULT}>\r\n                            </label>\r\n\r\n                        </div>\r\n\r\n                        <{foreach from=$config.list item=file}>\r\n                          <div style=\"width:60px; height:86px; display:inline-block; margin:4px;\">\r\n                            <label for=\"<{$config.name}><{$file.files_sn}>\" style=\"width:60px; height:60px; background:#000000 url(<{$file.tb_path}>);background-position:left center;border:1px solid gray;\" >\r\n                              <input type=\"radio\" name=\"<{$config.name}>\" id=\"<{$config.name}><{$file.files_sn}>\" value=\"<{$file.path}>\" onChange=\"$(\'.del_<{$config.name}>\').show(); $(\'#del_<{$config.name}><{$file.files_sn}>\').hide();\" <{if $config.value==$file.path}>checked<{/if}>>\r\n                            </label>\r\n                            <label class=\"del_<{$config.name}>\" style=\"font-size:11px;\" id=\"del_<{$config.name}><{$file.files_sn}>\">\r\n                              <input type=\"checkbox\" value=\"<{$file.files_sn}>\" name=\"del_file[<{$file.files_sn}>]\"> <{$smarty.const._TAD_DEL}>\r\n                            </label>\r\n                          </div>\r\n                        <{/foreach}>\r\n                        <div style=\"clear:both;\"></div>\r\n                      <{/if}>\r\n                    </div>\r\n                  <{else}>\r\n                    <div class=\"col-md-5 alert alert-info\">\r\n                      <{$config.desc}>\r\n                    </div>\r\n                  <{/if}>\r\n                </div>\r\n\r\n\r\n              <{/foreach}>\r\n            </div>\r\n            <{/if}>\r\n          </div>\r\n        </div>\r\n\r\n      </div>\r\n\r\n\r\n\r\n      <div class=\"col-md-4\">\r\n        <!--預覽-->\r\n        <div class=\"row\">\r\n          <div class=\"col-md-12 text-center\">\r\n            <div id=\'preview_zone\' class=\"col-md-12\">\r\n              <div id=\'theme_demo\' style=\'border:1px solid gray;background-color:white;margin:0px auto;\'>\r\n                <div id=\'theme_head\' style=\'border:1px solid #E0E0E0;background-color:#F0F0F0;margin:4px auto 2px auto;font-size:11px;text-align:center;\'><{$smarty.const._MA_TAD_THEMES_HEAD}></div>\r\n                <div id=\'left_block\' style=\'border:1px solid #E0E0E0;background-color:#99CCFF;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'center_block\' style=\'border:1px solid #E0E0E0;background-color:#CCFF66;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'right_block\' style=\'border:1px solid #E0E0E0;background-color:#FFCC66;font-size:11px;text-align:center;\'></div>\r\n                <div id=\'theme_foot\' style=\'clear:both;border:1px solid #E0E0E0;height:30px;line-height:30px;background-color:#F0F0F0;margin:4px auto;font-size:11px;text-align:center;\'><{$smarty.const._MA_TAD_THEMES_FOOT}></div>\r\n              </div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n\r\n        <div class=\"row\">\r\n          <div class=\"text-center\">\r\n            <!--中左區塊寬度-->\r\n            <input type=\"hidden\" name=\"clb_width\" value=\"<{$clb_width}>\" id=\"clb_width\" >\r\n            <!--中右區塊寬度-->\r\n            <input type=\"hidden\" name=\"crb_width\" value=\"<{$crb_width}>\" id=\"crb_width\" >\r\n            <input type=\"hidden\" name=\"theme_id\" value=\"<{$theme_id}>\">\r\n            <input type=\"hidden\" name=\"theme_name\" value=\"<{$theme_name}>\">\r\n\r\n            <!--佈景圖片寬度-->\r\n            <input type=\"hidden\" name=\"op\" value=\"<{$op}>\">\r\n            <button type=\"submit\" class=\"btn btn-primary\"><{$smarty.const._TAD_SAVE}></button>\r\n          </div>\r\n        </div>\r\n\r\n        <div class=\"row\">\r\n          <div class=\"col-md-12 alert alert-info\">\r\n            <{if $theme_kind!=\"bootstrap\" and $theme_kind!=\"bootstrap3\"}><{$smarty.const._MA_TADTHEMES_NOTICE}><{/if}>\r\n            <{$smarty.const._MA_TADTHEMES_NOTICE2}>\r\n          </div>\r\n        </div>\r\n\r\n      </div>\r\n    </div>\r\n  </form>\r\n</div>');

DROP TABLE IF EXISTS `xx_users`;
CREATE TABLE `xx_users` (
  `uid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL DEFAULT '',
  `uname` varchar(25) NOT NULL DEFAULT '',
  `email` varchar(60) NOT NULL DEFAULT '',
  `url` varchar(100) NOT NULL DEFAULT '',
  `user_avatar` varchar(30) NOT NULL DEFAULT 'blank.gif',
  `user_regdate` int(10) unsigned NOT NULL DEFAULT '0',
  `user_icq` varchar(15) NOT NULL DEFAULT '',
  `user_from` varchar(100) NOT NULL DEFAULT '',
  `user_sig` tinytext,
  `user_viewemail` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `actkey` varchar(8) NOT NULL DEFAULT '',
  `user_aim` varchar(18) NOT NULL DEFAULT '',
  `user_yim` varchar(25) NOT NULL DEFAULT '',
  `user_msnm` varchar(100) NOT NULL DEFAULT '',
  `pass` varchar(32) NOT NULL DEFAULT '',
  `posts` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `attachsig` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `level` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `theme` varchar(100) NOT NULL DEFAULT '',
  `timezone_offset` float(3,1) NOT NULL DEFAULT '8.0',
  `last_login` int(10) unsigned NOT NULL DEFAULT '0',
  `umode` varchar(10) NOT NULL DEFAULT '',
  `uorder` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `notify_method` tinyint(1) NOT NULL DEFAULT '1',
  `notify_mode` tinyint(1) NOT NULL DEFAULT '0',
  `user_occ` varchar(100) NOT NULL DEFAULT '',
  `bio` tinytext,
  `user_intrest` varchar(150) NOT NULL DEFAULT '',
  `user_mailok` tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`uid`),
  KEY `uname` (`uname`),
  KEY `email` (`email`),
  KEY `uiduname` (`uid`,`uname`),
  KEY `unamepass` (`uname`,`pass`),
  KEY `level` (`level`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `xx_users` (`uid`, `name`, `uname`, `email`, `url`, `user_avatar`, `user_regdate`, `user_icq`, `user_from`, `user_sig`, `user_viewemail`, `actkey`, `user_aim`, `user_yim`, `user_msnm`, `pass`, `posts`, `attachsig`, `rank`, `level`, `theme`, `timezone_offset`, `last_login`, `umode`, `uorder`, `notify_method`, `notify_mode`, `user_occ`, `bio`, `user_intrest`, `user_mailok`) VALUES
(1,	'管理員',	'admin',	'tad0616@gmail.com',	'',	'avatars/blank.gif',	1431395694,	'',	'',	'',	1,	'',	'',	'',	'',	'26818d3fc1446e295c08048ff2d9a66b',	0,	0,	7,	5,	'school2015',	8.0,	1436803999,	'flat',	0,	1,	0,	'',	'',	'',	0);

DROP TABLE IF EXISTS `xx_xoopscomments`;
CREATE TABLE `xx_xoopscomments` (
  `com_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `com_pid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `com_rootid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `com_modid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `com_itemid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `com_icon` varchar(25) NOT NULL DEFAULT '',
  `com_created` int(10) unsigned NOT NULL DEFAULT '0',
  `com_modified` int(10) unsigned NOT NULL DEFAULT '0',
  `com_uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `com_user` varchar(60) NOT NULL,
  `com_email` varchar(60) NOT NULL,
  `com_url` varchar(60) NOT NULL,
  `com_ip` varchar(15) NOT NULL DEFAULT '',
  `com_title` varchar(255) NOT NULL DEFAULT '',
  `com_text` text,
  `com_sig` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `com_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `com_exparams` varchar(255) NOT NULL DEFAULT '',
  `dohtml` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dosmiley` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `doxcode` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `doimage` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `dobr` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`com_id`),
  KEY `com_pid` (`com_pid`),
  KEY `com_itemid` (`com_itemid`),
  KEY `com_uid` (`com_uid`),
  KEY `com_title` (`com_title`(40)),
  KEY `com_status` (`com_status`),
  KEY `com_user` (`com_user`),
  KEY `com_email` (`com_email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `xx_xoopsnotifications`;
CREATE TABLE `xx_xoopsnotifications` (
  `not_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `not_modid` smallint(5) unsigned NOT NULL DEFAULT '0',
  `not_itemid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `not_category` varchar(30) NOT NULL DEFAULT '',
  `not_event` varchar(30) NOT NULL DEFAULT '',
  `not_uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `not_mode` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`not_id`),
  KEY `not_modid` (`not_modid`),
  KEY `not_itemid` (`not_itemid`),
  KEY `not_class` (`not_category`),
  KEY `not_uid` (`not_uid`),
  KEY `not_event` (`not_event`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

